#!/usr/bin/perl
# <plaintext>  just in case you look at this via a browser

#########################################################################
####                                                                #####
####               URL MAPPING - DOCUMENTS STATS                    #####
####                                                                #####
####                                                                #####
####    domisse@w3perl.com                   version 01/11/2007     #####
####                                                                #####
#########################################################################

$debug = 0;

# $L{'Protected_files'}
# Adding bmp support
# Lister les repertoires/fichiers proteges.

$version = "3.01";
$verdate = "01/11/07";

$dirjs = "js";
$dircss = "css";

$sorttablejs = "sorttable.js";
$helpjs = "help.js";

$css_w3perl = "w3perl.css";
$css_help = "help.css";

$baudrate = 3;
$baudrate *= 1024;

$readme = ".w3perl";

############ script to launch when you want (weekly for me) ##########

## valeur a modifier par fixperlpath.pl

# modif REM a la fin a oter
require "flush.pl";
require "/var/www/cgi-bin/w3perl/libw3perl.pl";

if ($logfile_format eq "FTP" || $logfile_format eq "Exim" || $logfile_format eq "Sendmail" || $logfile_format eq "Postfix") {
    &error_exit("No document stats can be done for FTP or SMTP logfile\n");
}

$pos = rindex($conf_file,$dirsep);
$vtmp = substr($conf_file,$pos+1,length($conf_file));
$pos = rindex($0,"-");
$vtmp .= substr($0,$pos+1,length($0));
$vtmp =~ s/$plext//g;

#if ($#extension == 0 && $extension[0] eq "rm") {
#    print "This script cannot be run for RealServer\n\n";
#    exit;
#}

&flush(STDOUT);
$|=1;

$starttime = time();
print "Document stats : $version\n";
print "<P>" if ($ENV{'REQUEST_METHOD'} eq "GET");

#$yesterday = &yesterday_date($day,$countmonth,$year);

### today date

#$month_number = $month_equiv{$month};
#$month_number--;
#$today = $day." ".$month." ".$year;

$today =~ s/\// /g;

# calculer le temps mis pour le calcul
$startrun = "$hour:$minute:$second";

$countdoc = 0;
$totaref = 0;
$divsize = 0;
$countdiv = 0;

#$notitle = "notitle".$htmlext;
$frame = "frames".$htmlext;
$doublons = "doublons".$htmlext;
$nofile = "nofile".$htmlext;
$fileabsolute = "absolute".$htmlext;
$filelinksym = "symbolic".$htmlext;
$new = "newdoc".$htmlext;
$docimage = "docimage".$htmlext;
$doclien = "doclien".$htmlext;
$docsize = "docsize".$htmlext;
$docrepert = "docrepert".$htmlext;
$tree = "tree".$htmlext;
$useless = "useless".$htmlext;
$imawidth = "width".$htmlext;
$imaalt = "alt".$htmlext;
$cdrom = "cdrom".$htmlext;
$fileunread = "unread".$htmlext;
#$dirdocs2 = $dirdocs;
#$dirdocs2 =~ s/$dirsepurl/$dirsep/g;

# / dans la racine 
$pos = rindex($pathserver,$dirsep);
while ($pos != -1) {
    $slash_pathserver++;
    $pos = rindex($pathserver,$dirsep,$pos-1);
}
$slash_pathserver++; # affichage des sous repertoires uniquement

$car = substr($pathserver,1,1);
$nt = 1 if ($car eq ':');

$tmp1 = "tmp1";
$tmp2 = "tmp2";
$tmp3 = "tmp3";
$tmp4 = "tmp4";

$nowidth = 0;
$countwidth = 0;
$uniqwidth = 0;
$gif = 0;
$jpg = 0;
$xbm = 0;
$png = 0;
$pnm = 0;

# Define marker types
#$M_SOF0  = "\xC0";        $M_SOF3  = "\xC3";
#$M_SOF5  = "\xC5";        $M_SOF7  = "\xC3";
#$M_SOF9  = "\xC9";        $M_SOF11 = "\xCB";
#$M_SOF13 = "\xCD";        $M_SOF15 = "\xCF";
#$M_SOI   = "\xD8";        $M_EOI   = "\xD9";
#$M_SOS   = "\xDA";        $FF      = "\xFF";
 
# Define socket
$AF_INET = 2;
$sockaddr = 'S n a4 x8';
chop($hostname = `hostname`);

#%FailStatusMsgs = (-1,"Could Not Look Up Server",
#                   -2,"Could Not Open Socket",
#                   -3,"Could Not Bind Socket",
#                   -4,"Could Not Connect",
#                   301,"Found, But Moved",
#	           302,"Found, But Data Resides Under a Different URL",
#	           303,"Method",304,"Not Modified",
#	           400,"Bad Request",
#	           401,"Unauthorized",
#	           402,"Payment Required",
#	           403,"Forbidden",
#	           404,"Not Found",
#          	   500,"Internal Error",
#          	   501,"Not Implemented",
#          	   502,"Service Temporarily Overloaded",
#          	   503,"Gateway Timeout",
#          	   600,"Bad Request",601,"Not Implemented",
#          	   602,"Connection Failed",
#          	   603,"Timed Out");

$tripart = $tri;
$tmpdirsep = 0;
$pos = length($tripart);
while (($pos = rindex($tripart,$dirsepurl,$pos)) >= 0) {
	$tmpdirsep++;
	$pos--;
	}
$tmpdirsep--;
	          
$pathserver2 = $pathserver;
chop($pathserver2);
chop($tripart);

$pathserver2 =~ s/\$/\\\$/;  # Acorn

#chop($pathserver2) if ($type_serveur == 1);

$defaulthomepage =~ s/\//\./;

#################################################################
###            parsing the command line option                ###
#################################################################

$modifjour = 7; # 7 jours

if ($opt_h == 1) {
      print STDOUT "Usage : \n";
      print STDOUT "        -a                    : checking external links\n";      
      print STDOUT "        -c <file>             : load configuration file\n";      
      print STDOUT "        -d <nbdays>           : find files newest than nbdays days\n";
      print STDOUT "        -g <";
      for ($i=0;$i<$#graphic;$i++) {
      print STDOUT "$graphic[$i] ";
      } 
      print STDOUT "$graphic[$#graphic]";
      print STDOUT "> : graphic output (choose one)\n";
      print STDOUT "        -l <";
      for ($i=0;$i<$#lang;$i++) {
      print STDOUT "$lang[$i],";
      } 
      print STDOUT "$lang[$#lang]";
      print STDOUT ">            : language output (comma split)\n";      
      print STDOUT "        -t <toplist>          : display only toplist files\n";
      print STDOUT "        -x                    : show default value for flag options\n";
      print STDOUT "        -v                    : version\n";
      print STDOUT "\n";
      exit;
}

if ($opt_v == 1) {
      print STDOUT "cron-url.pl version $version $verdate\n";
      exit;
}

if ($opt_x == 1) {
      print STDOUT "Default : \n";
      print STDOUT "          -a            : ";
      &id($opt_a);
      print STDOUT "          -c            : $configfile\n";      
      print STDOUT "          -d <nbdays>   : $modifjour\n";
      print STDOUT "          -g <graphic>  : $graphic[0]\n";
      print STDOUT "          -l <language> : ";
      for ($i=0;$i<$#lang;$i++) {
      print STDOUT "$lang[$i],";
      }
      print STDOUT "$lang[$#lang]\n";      
      print STDOUT "          -t <toplist>  : $topten\n";
      print STDOUT "          -v            : $version\n";
      exit;
}

if ($opt_d ne '') {
$modifjour = $opt_d;
}

if ($opt_t ne '') {
$topten = $opt_t;
}

if ($opt_l ne '') {
  @lang = split(/, /,$opt_l);
  for ($i=0;$i<=$#lang;$i++) {
      $tmp = $dirress.$dirsep."lang".$dirsep.$lang[$i].$plext;
      $tmp = $pathinit.$tmp;
      require "$tmp";
  }
  if ($lang[0] eq '') {
      print STDERR "\nNone of your language choices have been yet translated !\n";
      exit; 
      }
}

if ($opt_g ne '') {
  if ($opt_g eq "3d")  {
      $bargraph = 1;
      $linegraph = 0;
      $tridim = 1;
  }
  if ($opt_g eq "fill") {
      $bargraph = 0;
      $linegraph = 1;
      $fillgraph = 1;
  }
  if ($opt_g eq "line") {
      $bargraph = 0;
      $linegraph = 1;
  }
  if ($opt_g eq "bar") {
      $bargraph = 1;
      $linegraph = 0;
      $tridim = 0;
  }
}

#if ($titlename == 0) {
#exit;
#}

#################################################################
####          debut de l'initialisation                   #######
#################################################################

$lienfile = $path.$dirgraph.$dirsep."lien".$gifext;
$lienfilex = $path.$dirgraph.$dirsep."lienx".$gifext;
$lienfiley = $path.$dirgraph.$dirsep."lieny".$gifext;

$linklienfile = "..".$dirsepurl."..".$dirsepurl.$dirgraph.$dirsepurl."lien".$gifext;
$linklienfilex = "..".$dirsepurl."..".$dirsepurl.$dirgraph.$dirsepurl."lienx".$gifext;
$linklienfiley = "..".$dirsepurl."..".$dirsepurl.$dirgraph.$dirsepurl."lieny".$gifext;

$imafile = $path.$dirgraph.$dirsep."ima".$gifext;
$imafilex = $path.$dirgraph.$dirsep."imax".$gifext;
$imafiley = $path.$dirgraph.$dirsep."imay".$gifext;

$linkimafile = "..".$dirsepurl."..".$dirsepurl.$dirgraph.$dirsepurl."ima".$gifext;
$linkimafilex = "..".$dirsepurl."..".$dirsepurl.$dirgraph.$dirsepurl."imax".$gifext;
$linkimafiley = "..".$dirsepurl."..".$dirsepurl.$dirgraph.$dirsepurl."imay".$gifext;

$sizefilegraph = $path.$dirgraph.$dirsep."size".$gifext;
$sizefilegraphx = $path.$dirgraph.$dirsep."sizex".$gifext;
$sizefilegraphy = $path.$dirgraph.$dirsep."sizey".$gifext;

$linksizefilegraph = "..".$dirsepurl."..".$dirsepurl.$dirgraph.$dirsepurl."size".$gifext;
$linksizefilegraphx = "..".$dirsepurl."..".$dirsepurl.$dirgraph.$dirsepurl."sizex".$gifext;
$linksizefilegraphy = "..".$dirsepurl."..".$dirsepurl.$dirgraph.$dirsepurl."sizey".$gifext;

$recentfile = $path.$dirgraph.$dirsep."recent".$gifext;
$recentfilex = $path.$dirgraph.$dirsep."recentx".$gifext;
$recentfiley = $path.$dirgraph.$dirsep."recenty".$gifext;

$linkrecentfile = "..".$dirsepurl."..".$dirsepurl.$dirgraph.$dirsepurl."recent".$gifext;
$linkrecentfilex = "..".$dirsepurl."..".$dirsepurl.$dirgraph.$dirsepurl."recentx".$gifext;
$linkrecentfiley = "..".$dirsepurl."..".$dirsepurl.$dirgraph.$dirsepurl."recenty".$gifext;

for ($i=0;$i<=$#extension;$i++) {
$search .= "\\.".$extension[$i]."\$|";
}
chop($search);


for ($i=0;$i<=$#extensionimage;$i++) {
$searchima .= "\\.".$extensionimage[$i]."\$|";
}
chop($searchima);

chop($pathserver);
#chop($pathserver) if ($type_serveur == 1);

### create directory


&MakeDirectories;

$timeweek = 60*60*24*$modifjour;

#################################################################
####                   date de ce jour                    #######
#################################################################


### date il y a $modifjour jours

if ($modifjour != 0 ) {

#    print "TOTO - $today\n";
    ($day,$month_number,$year) = split(/\s+/,$today);
    $month_number = $month_equiv{$month_number}-1;

#    print "TOTO : $day $month_number - $year\n";

    $pastday = $day  - $modifjour;
    $pastyear = $year;
    $pastmonth = $month_nb[$month_number];

    while ($pastday < 1) {
	$month_number--;
	if ($month_number < 0) {
	    $pastyear--;
	    $month_number = 11;
	}
	$pastmonth = $month_nb[$month_number];
	$pastday = $pastday + $month_of_year{$pastmonth};
    }

    $pasttoday = $pastday." ".$pastmonth." ".$pastyear;
#    print "TOTO $today - $pasttoday\n";
}

#print "Aujourd'hui nous sommes le $today\n";
#print "il y a $modifjour jours , nous etions le $pasttoday\n";

if ($type_serveur != 1) {
while (index($excluderepert,'~') >= 0) {
$excluderepert =~ s/~(\w+)\/(.*)/$1\/$tildealias\/$2/;
}

$pos = index($tripart,'~');
if ($pos >= 0) {
$tripart =~ s/~//;
$tripart = $tripart.$dirsep if (rindex($tripart,$dirsep,length($tripart))+1 != length($tripart));
$tripart = $tripart.$tildealias.$dirsep;
#print STDOUT "$opt_r is know now as $tripart\n";
}
}

$excluderepert =~ s/\//$dirsep$dirsep/g if ($type_serveur == 1);

#################################################################
####                  Scanning your web                   #######
#################################################################

print "Scanning your web...\n";

open(TMPWIDTH,">$path$dirtmp$dirsep$vtmp$tmp1") || die &error_exit("Error, unable to open $path$dirtmp$dirsep$vtmp$tmp1");
open(TMPWIDTH2,">$path$dirtmp$dirsep$vtmp$tmp2") || die &error_exit("Error, unable to open $path$dirtmp$dirsep$vtmp$tmp2");
open(TMPWIDTH3,">$path$dirtmp$dirsep$vtmp$tmp3") || die &error_exit("Error, unable to open $path$dirtmp$dirsep$vtmp$tmp3");
open(TMP4,">$path$dirtmp$dirsep$vtmp$tmp4") || die &error_exit("Error, unable to open $path$dirtmp$dirsep$vtmp$tmp4");
open(FILEFRAME,">$path$dirdata$dirsep$dirframe") || die &error_exit("Error, unable to open $path$dirdata$dirsep$dirframe");

open(OUTFILE,">$path$dirdata$dirsep$fileurl");
chdir($pathserver);
print "<BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");

&dodir($pathserver);
close (OUTFILE);

close(TMPWIDTH);
close(TMPWIDTH2);
close(TMPWIDTH3);
close(TMP4);
close(FILEFRAME);

#################################################################
####                  Query SPIP Database                 #######
#################################################################

if ($spip == 1) {

    require DBI;

    $dbSpip = "DBI:mysql:spip";

    $tblArticles    = "spip_articles";
    $tblRubriques    = "spip_rubriques";
    $tblBreves    = "spip_breves";

    print "Scanning SPIP database\n";

    open(OUTFILE,">>$path$dirdata$dirsep$fileurl");
    
    $dbh = DBI->connect("$dbSpip:$dbSpipHost:$dbSpipPort",$dbSpipUser,$dbSpipPass);

    # Articles

    $sql_query = "SELECT id_article,titre,soustitre FROM $tblArticles";
    $sth = $dbh->prepare( "$sql_query" );
    $sth->execute;
    while (@row = $sth->fetchrow) {
	$spip_article_id = $row[0];
	$spip_article_titre = $row[1];
	$spip_article_sstitre = $row[2];
	$spip_article_url =  "/article.php?id_article=".$spip_article_id;
	print OUTFILE "$spip_article_url \"$spip_article_titre\"\n";
    }

    # Rubriques

    $sql_query = "SELECT id_rubrique,titre,descriptif FROM $tblRubriques";
    $sth = $dbh->prepare( "$sql_query" );
    $sth->execute;
    while (@row = $sth->fetchrow) {
	$spip_rubrique_id = $row[0];
	$spip_rubrique_titre = $row[1];
	$spip_rubrique_sstitre = $row[2];
	$spip_rubrique_url =  "/rubrique.php?id_rubrique=".$spip_rubrique_id;
	print OUTFILE "$spip_rubrique_url \"$spip_rubrique_titre\"\n";
    }

    # Breves

    $sql_query = "SELECT id_breve,titre,lien_titre FROM $tblBreves";
    $sth = $dbh->prepare( "$sql_query" );
    $sth->execute;
    while (@row = $sth->fetchrow) {
	$spip_breve_id = $row[0];
	$spip_breve_titre = $row[1];
	$spip_breve_sstitre = $row[2];
	$spip_breve_url =  "/breve.php?id_breve=".$spip_breve_id;
	print OUTFILE "$spip_breve_url \"$spip_breve_titre\"\n";
    }

    $sth->finish;

close (OUTFILE);

}

#################################################################
####                    HTML framed pages                 #######
#################################################################

if ($url_frame == 1 && $#framed != -1) {
    print "Finding framed pages\n";
    print "<BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");

    for ($nblang=0;$nblang<=$#lang;$nblang++) {
	open(FRAMED,">$path$lang[$nblang]$dirsep$dirdocument$dirsep$frame") || die &error_exit("Error, unable to open $path$lang[$nblang]$dirsep$dirdocument$dirsep$frame");
	&Framed(*FRAMED, eval($Lang{$lang[$nblang]}));
	close (FRAMED);
    }
}

sub Framed {
    local(*FOUT,*L) = @_;
	
    print FOUT "$doctype\n";
    print FOUT "<HTML><HEAD>\n";
    print FOUT "$charset\n";
    print FOUT "<TITLE>$L{'HTML_files'} - $L{'Frames'}</TITLE>\n";
    print FOUT "<!-- Page generated by w3perl - cron-url.pl $version - $today $hourdate -->\n";
    print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$helpjs\"></script>\n";
    print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$sorttablejs\"></script>\n";
    print FOUT "<link rel=\"stylesheet\" type=\"text/css\" href=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dircss$dirsepurl$css_w3perl\">\n";
    print FOUT "<link rel=\"stylesheet\" type=\"text/css\" href=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dircss$dirsepurl$css_help\">\n";
    print FOUT "</HEAD>\n";
    print FOUT "<BODY $backgrd TEXT=\"$custom_text\" LINK=\"$custom_link\" VLINK=\"$custom_vlink\">\n";
    print FOUT "<H1> $L{'HTML_files'} - $L{'Frames'}</H1>\n";
    print FOUT "<P><HR>\n";

    for ($i=0;$i<=$#framed;$i++) {
	print FOUT "<A HREF=\"$linkpathserver$framed[$i]\" TARGET=\"_top\">$dirsep$framed[$i]</A><BR>\n";
    }
    
    print FOUT "<P><HR>\n";
    print FOUT "</BODY></HTML>\n";
}


#################################################################
####           HTML pages with no TITLE tag               #######
#################################################################

#if ($url_doublon == 1) {
#
#for ($nblang=0;$nblang<=$#lang;$nblang++) {
#open(NOTITLE,">$path$lang[$nblang]$dirsep$dirdocument$dirsep$notitle") || di#e "Error, unable to open $path$lang[$nblang]$dirsep$dirdocument$dirsep$notit#le\n";
#&NoTitle(*NOTITLE, eval($Lang{$lang[$nblang]}));
#close (NOTITLE);
#}
#
#}
#
#sub NoTitle {
#	local(*FOUT,*L) = @_;
#	
#print FOUT "<HTML><HEAD>\n";
#print FOUT "<TITLE>$L{'HTML_files'} $L{'without_title'}</TITLE>\n";
#print FOUT "<!-- Page generated by w3perl - cron-url.pl $version - $today $h#ourdate -->\n";
#print FOUT "</HEAD>\n";
#print FOUT "<BODY $backgrd TEXT=\"$custom_text\" LINK=\"$custom_link\" VLINK#=\"$custom_vlink\">\n";
#print FOUT "<H1> $L{'HTML_files'} $L{'without_title'}</H1>\n";
#print FOUT "<P><HR>\n";
#
#for ($i=0;$i<=$#notitle;$i++) {
#print FOUT "<A HREF=\"$linkpathserver$notitle[$i]\" TARGET=\"_top\">$notitle#[$i]</A><BR>\n";
#}
#
#print FOUT "<P><HR>\n";
#print FOUT "</BODY></HTML>\n";
#}
#
#undef @notitle;

#################################################################
####              HTML pages with absolute links          #######
#################################################################

if ($url_absolute_link == 1) {
print STDOUT "Links starting with slash\n";
print "<BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");

for ($nblang=0;$nblang<=$#lang;$nblang++) {

open(FILEABS,">$path$lang[$nblang]$dirsep$dirdocument$dirsep$fileabsolute") || die &error_exit("Error, unable to open $path$lang[$nblang]$dirsep$dirdocument$dirsep$fileabsolute");
&Absolute(*FILEABS, eval($Lang{$lang[$nblang]}));
close (FILEABS);
}

}

sub Absolute {
    local(*FOUT,*L) = @_;
	
    print FOUT "$doctype\n";
    print FOUT "<HTML><HEAD>\n";
    print FOUT "$charset\n";
    print FOUT "<TITLE>$L{'List_of'} $L{'absolute_links'}</TITLE>\n";
    print FOUT "<!-- Page generated by w3perl - cron-url.pl $version - $today $hourdate -->\n";
    print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$helpjs\"></script>\n";
    print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$sorttablejs\"></script>\n";
    print FOUT "<link rel=\"stylesheet\" type=\"text/css\" href=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dircss$dirsepurl$css_w3perl\">\n";
    print FOUT "<link rel=\"stylesheet\" type=\"text/css\" href=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dircss$dirsepurl$css_help\">\n";
    print FOUT "</HEAD>\n";
    print FOUT "<BODY $backgrd TEXT=\"$custom_text\" LINK=\"$custom_link\" VLINK=\"$custom_vlink\">\n";
    print FOUT "<H2> $L{'List_of'} $L{'absolute_links'}</H2>\n";
    print FOUT "<P><HR><P>\n";
    print FOUT "<DIV CLASS=\"item_page\">-&nbsp; $L{'HTML_files'} : </DIV><P>\n";

    $j = 0;
    $absolutebis[0] = $absolute[0];
    print FOUT "<TABLE><TR><TH>$absolutebis[0]</TH></TR>\n";
    for ($k=1;$k<=$ab{$absolutebis[$j]};$k++) {
	print FOUT "<TR>\n";
	print FOUT "<TD CLASS=\"left\">" if (($k/2) == int($k/2));
	print FOUT "<TD CLASS=\"left_alter\">" if (($k/2) != int($k/2));
	print FOUT "$fileabs{$absolutebis[$j],$k}</TD></TR>\n";
    }
    print FOUT "</TABLE><P>\n";

    for ($i=1;$i<=($#absolute);$i++) {
	if ($absolute[$i] ne $absolute[$i-1]) {
	    $absolutebis[$j] = $absolute[$i];
	    print FOUT "<TABLE><TR><TH>$absolutebis[$j]</TH></TR>\n";
	    for ($k=1;$k<=$ab{$absolutebis[$j]};$k++) {
		print FOUT "<TR>\n";
		print FOUT "<TD CLASS=\"left\">" if (($k/2) == int($k/2));
		print FOUT "<TD CLASS=\"left_alter\">" if (($k/2) != int($k/2));
		print FOUT "$fileabs{$absolutebis[$j],$k}</TD></TR>\n";
            }
	    print FOUT "</TABLE><P>\n";
	    $j++;
	}
    }

    print FOUT "<P>\n";
    print FOUT "<DIV CLASS=\"item_page\">-&nbsp; $L{'Images'} : </DIV><P>\n";

    $j = 0;
    $absoluteimabis[0] = $absoluteima[0];
    print FOUT "<TABLE><TR><TH>$absoluteimabis[0]</TH></TR>\n";
    for ($k=1;$k<=$abima{$absoluteimabis[$j]};$k++) {
	print FOUT "<TR>\n";
	print FOUT "<TD CLASS=\"left\">" if (($k/2) == int($k/2));
	print FOUT "<TD CLASS=\"left_alter\">" if (($k/2) != int($k/2));
	print FOUT "$fileimaabs{$absoluteimabis[$j],$k}</TD></TR>\n";
    }
    print FOUT "</TABLE><P>\n";
    
    for ($i=1;$i<=($#absoluteima);$i++) {
	if ($absoluteima[$i] ne $absoluteima[$i-1]) {
	    $absoluteimabis[$j] = $absoluteima[$i];
	    print FOUT "<TABLE><TR><TH>$absoluteimabis[$j]</TH></TR>\n";
	    for ($k=1;$k<=$abima{$absoluteimabis[$j]};$k++) {
		print FOUT "<TR>\n";
		print FOUT "<TD CLASS=\"left\">" if (($k/2) == int($k/2));
		print FOUT "<TD CLASS=\"left_alter\">" if (($k/2) != int($k/2));
		print FOUT "$fileimaabs{$absoluteimabis[$j],$k}</TD></TR>\n";
            }
	    print FOUT "</TABLE><P>\n";
	    $j++;
     }
    }
    
    print FOUT "<P><HR>\n";
    print FOUT "</BODY></HTML>\n";
}

undef @absolute;
undef @absoluteima;


#################################################################
####                     HTML symbolic links              #######
#################################################################

if ($url_symbolic_link == 1) {
    print STDOUT "Symbolic links\n";
    print "<BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");

    for ($nblang=0;$nblang<=$#lang;$nblang++) {
	open(FILESYM,">$path$lang[$nblang]$dirsep$dirdocument$dirsep$filelinksym") || die &error_exit("Error, unable to open $path$lang[$nblang]$dirsep$dirdocument$dirsep$filelinksym");
	&Symbolic(*FILESYM, eval($Lang{$lang[$nblang]}));
	close (FILESYM);
    }
}

sub Symbolic {
    local(*FOUT,*L) = @_;
    local($tmp,$tmp2);

    print FOUT "$doctype\n";
    print FOUT "<HTML><HEAD>\n";
    print FOUT "$charset\n";
    print FOUT "<TITLE>$L{'List_of'} $L{'symbolic_links'}</TITLE>\n";
    print FOUT "<!-- Page generated by w3perl - cron-url.pl $version - $today $hourdate -->\n";
    print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$helpjs\"></script>\n";
    print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$sorttablejs\"></script>\n";
    print FOUT "<link rel=\"stylesheet\" type=\"text/css\" href=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dircss$dirsepurl$css_w3perl\">\n";
    print FOUT "<link rel=\"stylesheet\" type=\"text/css\" href=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dircss$dirsepurl$css_help\">\n";
    print FOUT "</HEAD>\n";
    print FOUT "<BODY $backgrd TEXT=\"$custom_text\" LINK=\"$custom_link\" VLINK=\"$custom_vlink\">\n";
    print FOUT "<H2> $L{'List_of'} $L{'symbolic_links'}</H2>\n";
    print FOUT "<P><HR><P>\n";

    print FOUT "<TABLE CLASS=\"sortable_base\" ID=\"symlink\">\n";
    print FOUT "<TR><TH>$L{'symbolic_links'}</TH><TH>$L{'File'}</TH></TR>\n";
    for ($i=0;$i<=($#linkfile);$i++) {
	$tmp2 = readlink($linkfile[$i]);
	$tmp = $linkfile[$i];
	$tmp =~ s/$pathserver//;
	$tmp2 =~ s/$pathserver//;
	print FOUT "<TR><TD CLASS=\"left\">$tmp</TD>\n<TD CLASS=\"left\">$tmp2</TD></TR>\n";
    }

    print FOUT "</TABLE>\n";
    print FOUT "<P><HR>\n";
    print FOUT "</BODY></HTML>\n";
}


undef @linkfile;

#################################################################
####              HTML pages with bad links               #######
#################################################################

if ($url_bad_link == 1) {

    print "Wrong links stats\n";
    print "<BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");

    for ($nblang=0;$nblang<=$#lang;$nblang++) {
	open(NOFILE,">$path$lang[$nblang]$dirsep$dirdocument$dirsep$nofile") || die &error_exit("Error, unable to open $path$lang[$nblang]$dirsep$dirdocument$dirsep$nofile");
	&MissingFiles(*NOFILE, eval($Lang{$lang[$nblang]}));
	close (NOFILE);
    }
}

sub MissingFiles {
    local(*FOUT,*L) = @_;
	
    print FOUT "$doctype\n";
    print FOUT "<HTML><HEAD>\n";
    print FOUT "$charset\n";
    print FOUT "<TITLE>$L{'List_of'} $L{'bad_links'}</TITLE>\n";
    print FOUT "<!-- Page generated by w3perl - cron-url.pl $version - $today $hourdate -->\n";
    print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$helpjs\"></script>\n";
    print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$sorttablejs\"></script>\n";
    print FOUT "<link rel=\"stylesheet\" type=\"text/css\" href=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dircss$dirsepurl$css_w3perl\">\n";
    print FOUT "<link rel=\"stylesheet\" type=\"text/css\" href=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dircss$dirsepurl$css_help\">\n";
    print FOUT "</HEAD>\n";
    print FOUT "<BODY $backgrd TEXT=\"$custom_text\" LINK=\"$custom_link\" VLINK=\"$custom_vlink\">\n";
    print FOUT "<H2> $L{'List_of'} $L{'bad_links'}</H2>\n";
    print FOUT "<P><HR><P>\n";

    if (scalar(@protected_files) != 0 || scalar(@protected_dir) != 0) {
	print FOUT "<A NAME=\"protected\"></A>\n";
	print FOUT "<DIV CLASS=\"item_page\">-&nbsp; $L{'Protected_files'} : </DIV><P>\n";
    }

    if (scalar(@protected_files) != 0) {
	print FOUT "<TABLE CLASS=\"sortable_base\" ID=\"protected_file\">\n";
	print FOUT "<TR><TH>$L{'File'}</TH></TR>\n";
	foreach $line (@protected_files) {
	    $line =~ s/$pathserver//;
	    print FOUT "<TR><TD CLASS=\"left\">$line</TD></TR>\n";
	}
	print FOUT "</TABLE><P>\n";
    }

    if (scalar(@protected_dir) != 0) {
	print FOUT "<TABLE CLASS=\"sortable_base\" ID=\"protected_dir\">\n";
	print FOUT "<TR><TH>$L{'Directories'}</TH></TR>\n";
	foreach $line (@protected_dir) {
	    $line =~ s/$pathserver//;
	    print FOUT "<TR><TD CLASS=\"left\">$line</TD></TR>\n";
	}
	print FOUT "</TABLE><P>\n";
    }

    print FOUT "<A NAME=\"html\"></A>\n";
    print FOUT "<DIV CLASS=\"item_page\">-&nbsp; $L{'HTML_files'} : </DIV><P>\n";

    $j = 0;
    $nofilebis[0] = $nofile[0];
    $tmp = $nofilebis[0];
    $tmp =~ s/\//_/g;
    print FOUT "<TABLE CLASS=\"sortable_base\" ID=\"html_$tmp\"><TR>";
    print FOUT "<TH>$nofilebis[0]</TH></TR>\n";
    for ($k=1;$k<=$no{$nofilebis[$j]};$k++) {
	print FOUT "<TR><TD CLASS=\"left\">$filemiss{$nofilebis[$j],$k}</TD></TR>\n";
    }
    print FOUT "</TABLE><P>\n";

    for ($i=1;$i<=($#nofile);$i++) {
	if ($nofile[$i] ne $nofile[$i-1]) {
	    $nofilebis[$j] = $nofile[$i];
	    $tmp = $nofilebis[$j];
	    $tmp =~ s/\//_/g;
	    print FOUT "<TABLE CLASS=\"sortable_base\" ID=\"$tmp\"><TR>";
	    print FOUT "<TH>$nofilebis[$j]</TH></TR>\n";
	    for ($k=1;$k<=$no{$nofilebis[$j]};$k++) {
#		print FOUT "<LI>$filemiss{$nofilebis[$j],$k}\n";
		print FOUT "<TR><TD CLASS=\"left\">$filemiss{$nofilebis[$j],$k}</TD></TR>\n";
            }
	    print FOUT "</TABLE><P>\n";
	    $j++;
     }
    }

    print FOUT "<P>\n";
    print FOUT "<A NAME=\"ima\"></A>\n";
    print FOUT "<DIV CLASS=\"item_page\">-&nbsp; $L{'Images'} : </DIV><P>\n";

    $j = 0;
    $noimabis[0] = $noima[0];
    $tmp = $noimabis[0];
    $tmp =~ s/\//_/g;
    print FOUT "<TABLE CLASS=\"sortable_base\" ID=\"ima_$tmp\"><TR>";
    print FOUT "<TH>$noimabis[0]</TH></TR>\n";
    for ($k=1;$k<=$noima{$noimabis[$j]};$k++) {
	print FOUT "<TR><TD CLASS=\"left\">$filemiss{$noimabis[$j],$k}</TD></TR>\n";
    }
    print FOUT "</TABLE><P>\n";

    for ($i=1;$i<=($#noima);$i++) {
	if ($noima[$i] ne $noima[$i-1]) {
	    $noimabis[$j] = $noima[$i];
	    $tmp = $noimabis[$j];
	    $tmp =~ s/\//_/g;
	    print FOUT "<TABLE CLASS=\"sortable_base\" ID=\"$tmp\"><TR>";
	    print FOUT "<TH>$noimabis[$j]</TH></TR>\n";
	    for ($k=1;$k<=$noima{$noimabis[$j]};$k++) {
		print FOUT "<TR><TD CLASS=\"left\">$imamiss{$noimabis[$j],$k}</TD></TR>\n";
            }
	    print FOUT "</TABLE><P>\n";
	    $j++;
	}
    }

    print FOUT "<P>\n";
    print FOUT "<A NAME=\"background\"></A>\n";
    print FOUT "<DIV CLASS=\"item_page\">-&nbsp; $L{'Background'} : </DIV><P>\n";

    $j = 0;
    $nobackbis[0] = $noback[0];
    $tmp = $nobackbis[0];
    $tmp =~ s/\//_/g;
    print FOUT "<TABLE CLASS=\"sortable_base\" ID=\"back_$tmp\"><TR>";
    print FOUT "<TH>$nobackbis[0]</TH></TR>\n";
    for ($k=1;$k<=$back{$nobackbis[$j]};$k++) {
	print FOUT "<TR><TD CLASS=\"left\">$filebackmiss{$nobackbis[$j],$k}</TD></TR>\n";
    }
    print FOUT "</TABLE><P>\n";
    
    for ($i=1;$i<=($#noback);$i++) {
	if ($noback[$i] ne $noback[$i-1]) {
	    $nobackbis[$j] = $noback[$i];
	    $tmp = $nobackbis[$j];
	    $tmp =~ s/\//_/g;
	    print FOUT "<TABLE CLASS=\"sortable_base\" ID=\"$tmp\"><TR>";
	    print FOUT "<TH>$nobackbis[$j]</TH></TR>\n\n";
	    for ($k=1;$k<=$back{$nobackbis[$j]};$k++) {
		print FOUT "<TR><TD CLASS=\"left\">$filebackmiss{$nobackbis[$j],$k}</TD></TR>\n";
            }
	    print FOUT "</TABLE><P>\n";
	    $j++;
	}
    }

    print FOUT "<P>\n";
    print FOUT "<A NAME=\"cgibin\"></A>\n";
    print FOUT "<DIV CLASS=\"item_page\">-&nbsp; $L{'Cgi-bin'} : </DIV><P>\n";

    $j = 0;
    $nocgibinbis[0] = $nocgibin[0];
    $tmp = $nocgibinbis[0];
    $tmp =~ s/\//_/g;
    print FOUT "<TABLE CLASS=\"sortable_base\" ID=\"cgi_$tmp\"><TR>";
    print FOUT "<TH>$nocgibinbis[0]</TH></TR>\n";
    for ($k=1;$k<=$nocgi{$nocgibinbis[$j]};$k++) {
	print FOUT "<TR<TD CLASS=\"left\">$filecgimiss{$nocgibinbis[$j],$k}</TD></TR>\n";
    }
    print FOUT "</TABLE><P>\n";

    for ($i=1;$i<=($#nocgibin);$i++) {
	if ($nocgibin[$i] ne $nocgibin[$i-1]) {
	    $nocgibinbis[$j] = $nocgibin[$i];
	    $tmp = $nocgibinbis[$j];
	    $tmp =~ s/\//_/g;
	    print FOUT "<TABLE CLASS=\"sortable_base\" ID=\"$tmp\"><TR>";
	    print FOUT "<TH>$nocgibinbis[$j]</TH></TR>\n";
	    for ($k=1;$k<=$nocgi{$nocgibinbis[$j]};$k++) {
		print FOUT "<TR><TD CLASS=\"left\">$filecgimiss{$nocgibinbis[$j],$k}</TD</TR>\n";
            }
	    print FOUT "</TABLE><P>\n";
	    $j++;
	}
    }

    print FOUT "<P><HR>\n";
    print FOUT "</BODY></HTML>\n";
}

undef @nofile;
undef @noima;
undef @noback;
undef @nocgibin;

#################################################################
####         HTML pages with the same TITLE tag           #######
#################################################################

if ($url_doublon ==  1) {
    print STDOUT "Pages with the same TITLE tag\n";
    print "<BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");

    @doublon = sort @doublon;

    for ($nblang=0;$nblang<=$#lang;$nblang++) {
	open(DOUBLONS,">$path$lang[$nblang]$dirsep$dirdocument$dirsep$doublons") || die &error_exit("Error, unable to open $path$lang[$nblang]$dirsep$dirdocument$dirsep$doublons");
	&Doublons(*DOUBLONS, eval($Lang{$lang[$nblang]}));
	close (DOUBLONS);
    }
}

undef @notitle;

sub Doublons {
    local(*FOUT,*L) = @_;
	
    print FOUT "$doctype\n";
    print FOUT "<HTML><HEAD>\n";
    print FOUT "$charset\n";
    print FOUT "<TITLE>$L{'HTML_files'} $L{'with_the_same_title'}</TITLE>\n";
    print FOUT "<!-- Page generated by w3perl - cron-url.pl $version - $today $hourdate -->\n";
    print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$helpjs\"></script>\n";
    print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$sorttablejs\"></script>\n";
    print FOUT "<link rel=\"stylesheet\" type=\"text/css\" href=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dircss$dirsepurl$css_w3perl\">\n";
    print FOUT "<link rel=\"stylesheet\" type=\"text/css\" href=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dircss$dirsepurl$css_help\">\n";
    print FOUT "</HEAD>\n";
    print FOUT "<BODY $backgrd TEXT=\"$custom_text\" LINK=\"$custom_link\" VLINK=\"$custom_vlink\">\n";
    
    print FOUT "<H2> $L{'HTML_files'} $L{'without_title'}</H2>\n";
    print FOUT "<P><HR>\n";

    if ($#notitle != -1) {
	print FOUT "<TABLE CLASS=\"sortable_base\" ID=\"no_title\"><TR>\n";
	print FOUT "<TH>$L{'Pages'}</TH>\n</TR>\n";
	for ($i=0;$i<=$#notitle;$i++) {
	    print FOUT "<TR>\n";
	    print FOUT "<TD CLASS=\"left\">";
	    print FOUT "<A HREF=\"$linkpathserver$notitle[$i]\" TARGET=\"_top\">$notitle[$i]</A></TD>\n";
	    print FOUT "</TR>\n";
	}
	print FOUT "</TABLE>\n";
    }

    print FOUT "<P>\n";
    print FOUT "<H2>$L{'HTML_files'} $L{'with_the_same_title'}</H2>\n";
    print FOUT "<P><HR>\n";

    if ($dou{$doublonbis[$j]} != 0) {
	$j = 0;
	$doublonbis[$j] = $doublon[$j];
	print FOUT "<TABLE CLASS=\"sortable_base\" ID=\"same_title\"><TR>\n";
	print FOUT "<TH><I>null string</I></TH>" if ($doublonbis[$j] eq '' && $dou{$doublonbis[$j]} != 0);
	print FOUT "<TH>$doublonbis[$j]</TH>\n" if ($doublonbis[$j] ne '');
	print FOUT "</TR>\n";
	for ($k=1;$k<=$dou{$doublonbis[$j]};$k++) {
	    print FOUT "<TR>\n";
	    print FOUT "<TD CLASS=\"left\">";
	    print FOUT "$filedoublon{$doublonbis[$j],$k}</TD>\n</TR>\n";
	}
	print FOUT "</TABLE><P>\n";
    
	for ($i=1;$i<=($#doublon);$i++) {
	    if ($doublon[$i] ne $doublon[$i-1]) {
		$doublonbis[$j] = $doublon[$i];
		print FOUT "<TABLE CLASS=\"sortable_base\" ID=\"$doublonbis[$j]\"><TR>\n";
		print FOUT "<TH>$doublonbis[$j]</TH></TR>\n";
		for ($k=1;$k<=$dou{$doublonbis[$j]};$k++) {
		    print FOUT "<TR>\n";
		    print FOUT "<TD CLASS=\"left\">";
		    print FOUT "$filedoublon{$doublonbis[$j],$k}\n";
		    print FOUT "</TD></TR>\n";
		}
		print FOUT "</TABLE>\n";
		$j++;
	    }
	}
    }

    print FOUT "</BODY></HTML>";
}

undef @doublon;

# extract ~ for alias path

#$debline = $pathserver;
if ($pathserver =~ m/$tildealias/i) {
    $userid = $linkpathserver;
    $userid =~ s/~//;
    $pathserver =~ s/$userid$tildealias//;
    ($a,$debline) = split($dirsep,$pathserver);
}
#$debline = $debline.$dirsep;

#################################################################
####         write back the file with uniq URL            #######
#################################################################

open (LISTE, "$path$dirdata$dirsep$fileurl");
@lines = <LISTE>;
close LISTE;

@lines = sort @lines;

$tmpa = $linkpathserver;
chop($tmpa);

$pathserver2 =~ s/\\/\//g if ($type_serveur == 1);

open(OUTFILE,">$path$dirdata$dirsep$fileurl");

BOUCLE:
    foreach $line (@lines) {
	$line =~ s/\\/\//g;
	$double = 0;
	($var1,$var2,@end) = split(/\"/,$line);
	chop($var1);
	
	# Acorn
                
	if ($dirsep eq ".") {
		$var1 =~ s/\./$dirsepurl/g;
		$var1 =~ s/(.*)$dirsepurl(.*)$/$1\.$2/;
	}      

#      $var1 =~ s/$userid$tildealias\//$linkpathserver/;
#      $var1 =~ s/$pathserver2//i;

	$done = 0;
	$done = 1 if ($var1 =~ /$tildealias/);

	$var1 =~ s/$pathserver2//i;
	$var1 = $tmpa.$var1 if ($done == 1);

	for ($i=0;$i<=($#doublonbis);$i++) {
	    if ($var2 eq $doublonbis[$i] && $doublonbis[$i] ne '') {
		$double = 1;
		$doubvar2{$var2}++;
		print OUTFILE "$var1 \"$var2 ($doubvar2{$var2})\"@end";
		next BOUCLE;
	    }
	}

	if ($double == 0) {
	    $done = 0;
	    $done = 1 if ($line =~ /$tildealias/);
	    $line =~ s/$pathserver2//i;
	    $line = $tmpa.$line if ($done == 1);

            # Acorn
	    if ($dirsep eq ".") {
		($var1,$var2,@end) = split(/\"/,$line);
		chop($var1);
		$var1 =~ s/\./$dirsepurl/g;
		$var1 =~ s/(.*)$dirsepurl(.*)$/$1\.$2/;
		$line = "$var1 \"$var2\"@end";
	    }      
	    
	    $line = $tripart.$line if ($done == 0);
	    print OUTFILE $line;
	}
    }
close (OUTFILE);

# Reload the file to sort with titlename
open (LISTE, "$path$dirdata$dirsep$fileurl");
@lines = <LISTE>;
close LISTE;

open(OUTFILE,">$path$dirdata$dirsep$fileurl");
foreach $line (@lines) {
    ($var1,$var2) = split(/\"/,$line);
    chop($var1);
    if ($var1 eq $var2) {
	push(@tmpline,$line);
    } else {
	print OUTFILE $line;
    }
}
print OUTFILE "###\n";
foreach $line (@tmpline) {
    print OUTFILE $line;
}
close(OUTFILE);

### current file time in second

($now)= (stat("$path$dirdata$dirsep$fileurl")) [9];

### images and misc files info

#print "TOTO Opening $path$dirtmp$dirsep$vtmp$tmp4\n";

open (LISTE, "$path$dirtmp$dirsep$vtmp$tmp4");
@lines = <LISTE>;
close LISTE;

@lines = sort @lines;

open(OUTFILE,">$path$dirtmp$dirsep$vtmp$tmp4");
BOUCLE:
foreach $line (@lines) {
    $line =~ s/\\/\//g;
      ($var1,$var2) = split(/ /,$line);

$done = 0;
$done = 1 if ($var1 =~ /$tildealias/);
$line =~ s/$pathserver2//i;
$line = $tmpa.$line if ($done == 1);

# Acorn
if ($dirsep eq ".") {
($var1,$var2) = split(/ /,$line);
$var1 =~ s/\./$dirsepurl/g;
$var1 =~ s/(.*)$dirsepurl(.*)$/$1\.$2/ if ($var1 =~ /$searchima/i);
$var1 =~ s/(.*)$dirsepurl(.*)$/$1$dirsepurl$2/ if ($var1 !~ /$searchima/i);
$line = "$var1 $var2";
}      

$line = $tripart.$line if ($done == 0);
print OUTFILE $line;

}
close (OUTFILE);

# A faire : gerer les title avec des champs vide !!!!!!!!!!!

#################################################################
####               scanning the file produced             #######
#################################################################

open(TMP4,"$path$dirtmp$dirsep$vtmp$tmp4") || die &error_exit("Cannot open $path$dirtmp$dirsep$vtmp$tmp4");
while (<TMP4>) {
    ($url,$size) = split;
$posslash = rindex($url,$dirsepurl,length($url));
$racine = substr($url,0,$posslash+1);

$freqracima{$racine}++ if ($url =~ /$searchima/i);
$freqracdiv{$racine}++ if ($url !~ /$searchima/i);

#$freqracglob{$racine}++;
#$freqsizeglob{$racine} += $size;   

$freqrac{$racine}++;
$repertunique++ if ($freqrac{$racine} == 1);
#$repertunique++ if ($freqracima{$racine} == 1);
#$repertunique++ if ($freqracdiv{$racine} == 1);
$freqsizeima{$racine} += $size if ($url =~ /$searchima/i);
$freqsizediv{$racine} += $size if ($url !~ /$searchima/i);
$freqsizeall{$racine} += $size;

   $posslash = rindex($racine,'/',length($racine));
   $racine = substr($racine,0,$posslash+1);
   $racinebis = $racine;

   while ($posslash > 0) {
   $freqracglob{$racinebis}++;
   $freqsizeglob{$racinebis} += $size;
#   $freqracglob{$dirsepurl}++;
#   $freqsizeglob{$dirsepurl} += $size;               
   $posslash--;
   $posslash--;
   $posslash = rindex($racinebis,'/',$posslash);
   $racinebis = substr($racinebis,0,$posslash+1);
   }
}

close(TMP4);
#unlink("$path$dirtmp$dirsep$vtmp$tmp4");

open(LIEN,"$path$dirdata$dirsep$fileurl") || die &error_exit("Cannot open $path$dirdata$dirsep$fileurl");
while (<LIEN>) {

($url,$title,$end) = split(/\"/);
chop ($url);

$urlconv{$url} = $title;

chop($title);
chop($end);

($a,$nblink,$nbima,$size,$mtime,$sizefile) = split(/ /,$end);

#print "$url - $size - $sizefile\n";
#chop($mtime);

# directories stats

$posslash = rindex($url,$dirsepurl,length($url));
$racine = substr($url,0,$posslash+1);

$freqrachtml{$racine}++;
$freqrac{$racine}++;
$repertunique++ if ($freqrac{$racine} == 1);

#$freqracglob{$racine}++;
#$freqsizeglob{$racine} += $size;   
$freqsizehtml{$racine} += $size;
$freqsizeall{$racine} += $size;

#   $posslash = rindex($racine,'/',length($racine));
#   $racine = substr($racine,0,$posslash+1);
   $racinebis = $racine;

   while ($posslash > 0) {
   $freqracglob{$racinebis}++;
   $freqsizeglob{$racinebis} += $size;
#   $freqracglob{$dirsepurl}++;
#   $freqsizeglob{$dirsepurl} += $size;         

   $posslash--;
   $posslash--;
   $posslash = rindex($racinebis,'/',$posslash);
   $racinebis = substr($racinebis,0,$posslash+1);
   }

   
if ($now - $mtime < $timeweek) {
$frequpdate{$racine}++;
}


# tree

if ($url_tree == 1) {
$leveldepth = 0;
$racine = $url;
$posslash = rindex($racine,$dirsepurl,length($racine));

#print STDERR "$racine\n";

while ($posslash > 1) {
$leveldepth = 1;
$racine = substr($racine,0,$posslash+1); # if ($type_serveur != 1);
#$racine = substr($racine,0,$posslash) if ($type_serveur == 1);
$temp2 = $racine;
$temp2 .= $dirsepurl;
$freqracdepth{$temp2}++;

#$a = substr($racine,$posslash);
#print STDERR "$racine - $temp2 - $freqracdepth{$temp2} - $racine - $a - $dirsepurl\n";

if ($freqracdepth{$temp2} == 1 && substr($racine,$posslash) eq $dirsepurl) {

     # compte le nombre de / dans $racine
     $temp = $racine;
     $pos = rindex($temp,$dirsepurl,length($temp));

     $pos2 = rindex($temp,$dirsepurl,length($temp)-2);
     $remind = substr($temp,$pos2,length($temp));

     while ($pos > 1) {

     $temp = substr($temp,0,$pos);
     $pos = rindex($temp,$dirsepurl,length($temp));
     $leveldepth++;
     }

#     $leveldepth /= 2 if ($type_serveur == 1);
    
     $temp .= $dirsepurl;

#     print STDOUT "temp : $temp racine $racine $leveldepth\n";

     $depthocc{$temp,2} = 1;

     if (!($seen{$temp}++)) {
     $depth{$leveldepth}++;
     $depth{2}++ if ($leveldepth != 2);
     $line{$depth{2}} = $temp if ($leveldepth != 2);
     }

#     print STDOUT "$temp  $leveldepth $depth{$leveldepth} $depth{2}\n";
     $depthocc{$temp,$leveldepth}++ unless (($seen{$racine}++) || $leveldepth == 2);
     $line{$depth{$leveldepth}} = $temp if ($leveldepth == 2);
#     $line{$depth{$leveldepth}} = $temp unless ($seen{$temp}++);

     $depthrac{$temp,$depthocc{$temp,$leveldepth},$leveldepth} = $racine;
     $maxdepth = $leveldepth if ($leveldepth > $maxdepth);
     }

$posslash = rindex($racine,$dirsepurl,length($racine));
$posslash--;
}
}

# find recents documents

if ($url !~ /$pathserver$dirsep$packagename$dirsep/o && $url_new_doc == 1) {
    if ($now - $mtime < $timeweek) {
        $secjour = ($now - $mtime)/(60*60*24);
        $intsecjour = int($secjour);
        $nbmodif{$intsecjour}++;
        $modif{$intsecjour,$nbmodif{$intsecjour}} = $url;
    }
$mostlink{$url} = $nblink;
$mostima{$url} = $nbima;
$mostsize{$url} = $sizefile;
}


$ima{$nbima}++;
$link{$nblink}++;

$imamax = $nbima if ($nbima > $imamax);
$yimamax = $ima{$nbima} if ($ima{$nbima} > $yimamax);

$linkmax = $nblink if ($nblink > $linkmax);
$ylinkmax = $link{$nblink} if ($link{$nblink} > $ylinkmax);


$size = int($mostsize{$url}/1024);
$taille{$size}++;

$sizemax = $size if ($size > $sizemax);
$ysizemax = $taille{$size} if ($taille{$size} > $ysizemax);

}
close (LIEN);


####    checking WIDTH, HEIGHT, ALT and HTML weight

#################################################################
####               width, height and alt tag              #######
#################################################################

if ($url_img_tag == 1) {
    print STDOUT "Checking WITH, HEIGHT and ALT tags\n";
print "<BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");

for ($nblang=0;$nblang<=$#lang;$nblang++) {

    open(IMAWIDTH,">$path$lang[$nblang]$dirsep$dirdocument$dirsep$imawidth") || &error_exit("Error, unable to open $path$lang[$nblang]$dirsep$dirdocument$dirsep$imawith");
    &DocImageWidth(*IMAWIDTH, eval($Lang{$lang[$nblang]}));
    close (IMAWIDTH);

    open(IMAALT,">$path$lang[$nblang]$dirsep$dirdocument$dirsep$imaalt") || die &error_exit("Error, unable to open $path$lang[$nblang]$dirsep$dirdocument$dirsep$imaalt");
    &DocImageAlt(*IMAALT, eval($Lang{$lang[$nblang]}));
    close (IMAALT);
}
}

sub DocImageWidth {
    local(*FOUT,*L) = @_;
	
    print FOUT "$doctype\n";
    print FOUT "<HTML><HEAD>\n";
    print FOUT "$charset\n";
    print FOUT "<TITLE>$L{'Stats_about_width'}</TITLE>\n";
    print FOUT "<!-- Page generated by w3perl - cron-url.pl $version - $today $hourdate -->\n";
    print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$helpjs\"></script>\n";
    print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$sorttablejs\"></script>\n";
    print FOUT "<link rel=\"stylesheet\" type=\"text/css\" href=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dircss$dirsepurl$css_w3perl\">\n";
    print FOUT "<link rel=\"stylesheet\" type=\"text/css\" href=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dircss$dirsepurl$css_help\">\n";
    print FOUT "</HEAD>\n";
    print FOUT "<BODY $backgrd TEXT=\"$custom_text\" LINK=\"$custom_link\" VLINK=\"$custom_vlink\">\n";

    print FOUT "<H2>$L{'Stats_about_width'}</H2>\n";

    print FOUT "<P><HR><P>\n";
    print FOUT "<A HREF=\"$nofile#ima\">$L{'Bad_links'}</A> $L{'not_included'}<P>\n";

#    print FOUT "<P><HR ALIGN=CENTER WIDTH=30% SIZE=5><P>\n";

    print FOUT "<DIV CLASS=\"item_page\">-&nbsp;$L{'Pages'} $L{'without'} WIDTH $L{'and'} HEIGHT : </DIV><P>\n";

    print FOUT " - $nowidth $L{'hTML_pages'} $L{'With'} $countwidth $L{'images'} $L{'without'} WIDTH, HEIGHT ($L{'among'} $uniqwidth $L{'different_images'})\n<P>";

    open(TMPWIDTH,"$path$dirtmp$dirsep$vtmp$tmp1") || die &error_exit("Error, unable to open $path$dirtmp$dirsep$vtmp$tmp1");
    while (<TMPWIDTH>) {
	print FOUT;
    }
    close(TMPWIDTH);

    print FOUT "<P><DIV CLASS=\"item_page\">-&nbsp;$L{'Pages'} $L{'With'} $L{'wrong'} WIDTH, HEIGHT</DIV><P>\n";

    print FOUT "<TABLE>\n";
    print FOUT "<TR><TH ROWSPAN=2 COLSPAN=2>$L{'Pages'}</TH>\n";
    print FOUT "<TH COLSPAN=2>&nbsp;$L{'Found_in'} $L{'hTML_pages'}&nbsp;</TH>\n<TH COLSPAN=2>&nbsp;$L{'Correct_size_taken_from_image'}&nbsp;</TH>\n";
    print FOUT "</TR>\n<TR>\n";
    print FOUT "<TH>&nbsp;WIDTH&nbsp;</TH>\n<TH>&nbsp;HEIGHT&nbsp;</TH>\n";
    print FOUT "<TH>&nbsp;WIDTH&nbsp;</TH>\n<TH>&nbsp;HEIGHT&nbsp;</TH>\n";
    print FOUT "</TR>\n";

    $tmp = 0;
    open(TMPWIDTH2,"$path$dirtmp$dirsep$vtmp$tmp2") || die &error_exit("Error, unable to open $path$dirtmp$dirsep$vtmp$tmp2");
    while (<TMPWIDTH2>) {
	($temp1,$url,$linksrc,$x1,$y1,$x,$y) = split(/\t/,$_);
	$tmp++;
	print FOUT "<TR>\n";
	print FOUT "<TD CLASS=\"left\">" if (($tmp/2) == int($tmp/2));
	print FOUT "<TD CLASS=\"left_alter\">" if (($tmp/2) != int($tmp/2));
	print FOUT "<B>$L{'Page'}</B></TD>";
	print FOUT "<TD CLASS=\"left\">" if (($tmp/2) == int($tmp/2));
	print FOUT "<TD CLASS=\"left_alter\">" if (($tmp/2) != int($tmp/2));
	print FOUT "<B>";
	print FOUT "<A HREF=\"$dirsepurl$temp1\">" if (-f "$pathserver$dirsepurl$temp1");
	print FOUT "$dirsepurl$temp1";
	print FOUT "</A>" if (-f "$pathserver$dirsepurl$temp1");
	print FOUT "</B></TD>\n";
	print FOUT "<TD ROWSPAN=3 ALIGN=CENTER>" if (($tmp/2) == int($tmp/2));
	print FOUT "<TD ROWSPAN=3 CLASS=\"alter\">" if (($tmp/2) != int($tmp/2));
	print FOUT "<I>$x1</I></TD>\n";
	print FOUT "<TD ROWSPAN=3 ALIGN=CENTER>" if (($tmp/2) == int($tmp/2));
	print FOUT "<TD ROWSPAN=3 CLASS=\"alter\">" if (($tmp/2) != int($tmp/2));
	print FOUT "<I>$y1</I></TD>\n";
	print FOUT "<TD ROWSPAN=3 ALIGN=CENTER>" if (($tmp/2) == int($tmp/2));
	print FOUT "<TD ROWSPAN=3 CLASS=\"alter\">" if (($tmp/2) != int($tmp/2));
	print FOUT "<B>$x</B></TD>\n";
	print FOUT "<TD ROWSPAN=3 ALIGN=CENTER>" if (($tmp/2) == int($tmp/2));
	print FOUT "<TD ROWSPAN=3 CLASS=\"alter\">" if (($tmp/2) != int($tmp/2));
	print FOUT "<B>$y</B></TD>\n</TR>\n";
	print FOUT "<TR>\n";
	print FOUT "<TD CLASS=\"left\">" if (($tmp/2) == int($tmp/2));
	print FOUT "<TD CLASS=\"left_alter\">" if (($tmp/2) != int($tmp/2));
	print FOUT "$L{'Image'}</TD>\n";
	print FOUT "<TD CLASS=\"left\">" if (($tmp/2) == int($tmp/2));
	print FOUT "<TD CLASS=\"left_alter\">" if (($tmp/2) != int($tmp/2));
	print FOUT "$url</TD>\n</TR>\n";
	print FOUT "<TR>\n";
	print FOUT "<TD CLASS=\"left\">" if (($tmp/2) == int($tmp/2));
	print FOUT "<TD CLASS=\"left_alter\">" if (($tmp/2) != int($tmp/2));
	print FOUT "$L{'Link'}</TD>\n";
	print FOUT "<TD CLASS=\"left\">" if (($tmp/2) == int($tmp/2));
	print FOUT "<TD CLASS=\"left_alter\">" if (($tmp/2) != int($tmp/2));
	print FOUT "$linksrc</TD>\n</TR>\n";
    }
    close(TMPWIDTH2);
    
    print FOUT "</TABLE>\n";
    print FOUT "</BODY></HTML>";

}


sub DocImageAlt {
    local(*FOUT,*L) = @_;
    local($tmp);

    print FOUT "$doctype\n";
    print FOUT "<HTML><HEAD>\n";
    print FOUT "$charset\n";
    print FOUT "<TITLE>$L{'Stats_about_alt'}</TITLE>\n";
    print FOUT "<!-- Page generated by w3perl - cron-url.pl $version - $today $hourdate -->\n";
    print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$helpjs\"></script>\n";
    print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$sorttablejs\"></script>\n";
    print FOUT "<link rel=\"stylesheet\" type=\"text/css\" href=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dircss$dirsepurl$css_w3perl\">\n";
    print FOUT "<link rel=\"stylesheet\" type=\"text/css\" href=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dircss$dirsepurl$css_help\">\n";
    print FOUT "</HEAD>\n";
    print FOUT "<BODY $backgrd TEXT=\"$custom_text\" LINK=\"$custom_link\" VLINK=\"$custom_vlink\">\n";

    print FOUT "<H2>$L{'Stats_about_alt'}</H2>\n";

    print FOUT "<P><HR><P>\n";
    print FOUT "<DIV CLASS=\"item_page\">-&nbsp;$L{'Pages'} $L{'without'} ALT :</B></DIV><P>\n";

#print FOUT "<TABLE BORDER=1>\n";
#    print FOUT "<UL><UL>\n";

    $baktemp1 = '';
    open(TMPWIDTH3,"$path$dirtmp$dirsep$vtmp$tmp3") || die &error_exit("Error, unable to open $path$dirtmp$dirsep$vtmp$tmp3");
    while (<TMPWIDTH3>) {
	($temp1,$linksrc) = split(/\t/,$_);
	print FOUT "</TABLE>\n" if ($temp1 ne $baktemp1 && $baktemp1 ne '');
	$tmp = $temp1;
	$tmp =~ s/$pathserver//;
	print FOUT "<TABLE CLASS=\"sortable_base\" ID=\"$temp1\"><TR><TH>$tmp</TH></TR>\n" if ($temp1 ne $baktemp1);	
#	print FOUT "</UL></I><LI>$temp1\n<I><UL>\n" if ($temp1 ne $baktemp1);
	$baktemp1 = $temp1;
	print FOUT "<TR><TD CLASS=\"left\">$linksrc</TD></TR>\n";
    }
    close(TMPWIDTH3);

    print FOUT "</TABLE>\n";
    print FOUT "</BODY></HTML>";
}

unlink("$path$dirtmp$dirsep$vtmp$tmp1");
unlink("$path$dirtmp$dirsep$vtmp$tmp2");
unlink("$path$dirtmp$dirsep$vtmp$tmp3");

#################################################################
####               scanning holes in tree                 #######
#################################################################

if ($url_tree == 1) {
for ($j=1;$j<=$depth{2};$j++) {
$temp = $line{$j};
#print STDOUT "\nLine : $temp\n";
for ($leveldepth=$maxdepth;$leveldepth>=3;$leveldepth--) {
#      print STDOUT "Niveau : $leveldepth\n";

      for ($m=0;$m<=$depthocc{$temp,$leveldepth};$m++) {
           $racine = $depthrac{$temp,$m,$leveldepth};
           if ($racine ne '') {
#              print STDOUT "$racine ";

             $match = 0;
	     $temp3 = $depthrac{$temp,$l,$leveldepth-1};
	     $temp3 =~ s/\+/\\+/g; # /C++/
	     $tmp3 =~ s/\)/\\)/g;
	     $tmp3 =~ s/\(/\\(/g;
	     $tmp3 =~ s/[\[\]]//g;

             # check si le niveau en dessous existe
             for ($l=0;$l<=$depthocc{$temp,$leveldepth-1};$l++) {
               if ($racine =~ /$temp3/ && $temp3 ne '') {
#               print STDOUT " OK $depthrac{$temp,$l,$leveldepth-1}\n";
               $match = 1;
               last;
               }
             }

             if ($match == 0) {
               $subleveldepth = $leveldepth;
#               print STDOUT " HOLE !!! ";
               # extraction de la sous-chaine et iteration
               $temp2 = $racine;
               chop($temp2);
               $pos = rindex($temp2,$dirsepurl,length($temp2))+1;
               $remind = substr($temp2,0,$pos);

               while ($pos > 1) {
                  $temp2 = substr($temp2,0,$pos);
                  $pos = rindex($temp2,$dirsepurl,length($temp2));
                  }
               $temp2 .= $dirsepurl;

#              while ($subleveldepth == 2) {
               $subleveldepth--;
#               print STDOUT "$remind (leveldepth : $subleveldepth) not found (root is $temp2)\n";

               $depthocc{$temp2,$subleveldepth}++ unless (($seen{$remind}++) || $subleveldepth == 2);
               $depthrac{$temp2,$depthocc{$temp2,$subleveldepth},$subleveldepth} = $remind;
#               $pos = rindex($remind,$dirsepurl,length($remind))+1;
#               $remind = substr($remind,0,$pos);

#              }

               }

           }

      }
}

}


#################################################################
####                 valeur de rowspan                    #######
#################################################################

for ($j=1;$j<=$depth{2};$j++) {
$temp = $line{$j};
#print STDOUT "ligne $temp\n\n";

for ($k=1;$k<=$depthocc{$temp,$maxdepth};$k++) {
$rowspan{$temp,$k,$maxdepth} = 1; # derniere colonne a 1
}

for ($i=$maxdepth+1;$i>=2;$i--) {

        $depthocc{$temp,$i} = 1 if ($depthocc{$temp,$i} eq '');

        $boucle = $depthocc{$temp,$i-1};

        for ($k=1;$k<=$boucle;$k++) {

        $racine = $depthrac{$temp,$k,$i-1};
	$racine =~ s/\+/\\+/g;
	$racine =~ s/[\[\]]//g;

        # valeur de ROWSPAN
        $rowspan{$temp,$k,$i-1} = 0;
        $rowboucle{$temp,$racine,$i-1} = 0;

        if ($racine ne '') {
	    $racine =~ s/\(/\\(/g;
	    $racine =~ s/\)/\\)/g;
        for ($m=0;$m<=$depthocc{$temp,$i};$m++) {
             $rowspan{$temp,$k,$i-1}+=$rowspan{$temp,$m,$i} if ($depthrac{$temp,$m,$i} =~ m/$racine/);
             $rowboucle{$temp,$racine,$i-1}++ if ($depthrac{$temp,$m,$i} =~ m/$racine/);
        }
        }

        $rowspan{$temp,$k,$i-1}++ if ($rowspan{$temp,$k,$i-1} == 0);
#        $rowboucle{$temp,$racine,$i-1}++ if ($rowboucle{$temp,$racine,$i-1} == 0);
#       print STDOUT "$racine $rowspan{$temp,$k,$i-1} $rowboucle{$temp,$racine,$i-1}\n";
       }
}
}

$maxrowspan = 0;
for ($j=1;$j<=$depth{2};$j++) {
$temp = $line{$j};
for ($k=1;$k<=$depthocc{$temp,2};$k++) {
$maxrowspan += $rowspan{$temp,$k,2};
}
}

} # end $url_tree

# images

$moysizeimage = $sizeimage/$nbimage if ($nbimage != 0);
$moysizeimage = $moysizeimage/1024;


#################################################################
###               computing maxima and mean                   ###
#################################################################

if ($countdoc == 0) {
    $msg = "Nothing have been scanned !\n";
    $msg .= "Check \$pathserver in config.pl, it should be your html home directory\n";
    &error_exit($msg,0);
}

print "Sorting data\n";
print "<BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");

# computing mean data

$moyareffloat = $totaref / $countdoc;
$moyaref = int($totaref / $countdoc);

$moyimafloat = $totalima / $countdoc;
$moyima = int($totalima / $countdoc);
$moyima++ if ($moyima == 0);

$moysize = int(($totsize / $countdoc)/1024);

# tri des $topten pages avec le plus de liens

#$bouclelink = $topten unless ($linkmax < $topten);
#$bouclelink = $linkmax unless ($linkmax > ($topten-1));

$bouclelink = $topten;

$occurlink[0] = 0;

foreach $page (keys(%mostlink)) {
if ($mostlink{$page} > $occurlink[0]) {
    $occurlink[0] = $mostlink{$page};
    $bestlink[0] = $page;
}
}

$mostlink{$bestlink[0]} = 0;

for ($i=1;$i < $bouclelink;$i++) {
    $occurlink[$i] = 0;
    foreach $page (keys(%mostlink)) {
        if ($mostlink{$page} > $occurlink[$i]) {
              $occurlink[$i] = $mostlink{$page};
              $bestlink[$i] = $page;
              }
          }
$mostlink{$bestlink[$i]} = 0;
}


# tri des $topten pages avec le plus d'images

#$boucleima = $topten unless ($imamax < $topten);
#$boucleima = $imamax unless ($imamax > ($topten-1));

$boucleima = $topten;

$occurima[0] = 0;

foreach $page (keys(%mostima)) {
if ($mostima{$page} > $occurima[0]) {
    $occurima[0] = $mostima{$page};
    $bestima[0] = $page;
}
}

$mostima{$bestima[0]} = 0;

for ($i=1;$i < $boucleima;$i++) {
    $occurima[$i] = 0;
    foreach $page (keys(%mostima)) {
        if ($mostima{$page} > $occurima[$i]) {
              $occurima[$i] = $mostima{$page};
              $bestima[$i] = $page;
              }
          }
$mostima{$bestima[$i]} = 0;
}


# tri des $topten pages avec les plus lourdes

##### !!!!  sizemax est une taille de fichier....

#$bouclesize = $topten unless ($sizemax < $topten);
#$bouclesize = $sizemax unless ($sizemax > ($topten-1));

$bouclesize = $topten;

$occursize[0] = 0;

foreach $page (keys(%mostsize)) {
if ($mostsize{$page} > $occursize[0]) {
    $occursize[0] = $mostsize{$page};
    $bestsize[0] = $page;
}
}

$mostsize{$bestsize[0]} = 0;

for ($i=1;$i < $bouclesize;$i++) {
    $occursize[$i] = 0;
    foreach $page (keys(%mostsize)) {
        if ($mostsize{$page} > $occursize[$i]) {
              $occursize[$i] = $mostsize{$page};
              $bestsize[$i] = $page;
              }
          }
$mostsize{$bestsize[$i]} = 0;
}

# conversion en Megaoctets

$websize = $totsize + $sizeimage + $divsize;

$divsize /= (1024*1024);
$totsize /= (1024*1024);
$sizeimage /= (1024*1024);
$websize /= (1024*1024);

###############################################################
###         links, images and size graphs                   ###
###############################################################

################ graphs sur les liens #####################

if ($url_link == 1) {

$linkmax = $occurlink[$bouclelink-1] if ($linkmax > (2*$topten));

$it = length($linkmax)-1;
$div = 10**$it;
$factx = ($div*(int($linkmax/$div)+1))/$grad;

$factx = 1 if ($it == 0);

$it = length($ylinkmax)-1;
$div = 10**$it;
$facty = ($div*(int($ylinkmax/$div)+1))/$grad;

open(FLY,">$tmpfly$vtmp");
print FLY "new\n";
print FLY "size $xmax,$ymax\n";
 print FLY "frect 0,0,0,0,200,200,200\n";
 for ($i=0;$i<=$linkmax;$i++) {
 $x1 = $i*$xstep/$factx;
 $x2 = ($i+1)*$xstep/$factx;
 $y2 = $ymax - ($ystep/$facty * $link{$i});
 print FLY "frect $x1,$y2,$x2,$ymax,$red[0],$green[0],$blue[0]\n";
 print FLY "frect $x1,$y2,$x2,$ymax,0,,\n" if ($i == $moyaref);
 print FLY "rect $x1,$y2,$x2,$ymax,0,0,0\n";
 }
print FLY "transparent 200,200,200\n";
close (FLY);

open(FOO,"$FLY -q -i $tmpfly$vtmp -o $lienfile |");
while( <FOO> ) {print;}
close(FOO);
unlink("$tmpfly$vtmp");

### image pour les abscisses

$xlegend = "Number of links";

open(FLY,">$tmpfly$vtmp");
print FLY "new\n";
print FLY "size $xmax,$ydecal\n";
 print FLY "frect 0,0,0,0,200,200,200\n";
 $posx = (($xmax/2)-(length($xlegend)*7/2));
 print FLY "string 0,0,0,$posx,$ydecalm,medium,$xlegend\n";
 for ($i=$xstep;$i<=$xmax;$i+=$xstep) {
 $valstep = $i*$factx/$xstep;
 $posx = $i - length(int($valstep))*5;
 print FLY "line $i,0,$i,5,0,0,0\n";
 print FLY "string 0,0,0,$posx,10,small,$valstep\n";
 }
print FLY "transparent 200,200,200\n";
close (FLY);

open(FOO,"$FLY -q -i $tmpfly$vtmp -o $lienfilex |");
while( <FOO> ) {print;}
close(FOO);
unlink("$tmpfly$vtmp");

### image pour les ordonnees

open(FLY,">$tmpfly$vtmp");
print FLY "new\n";
print FLY "size $xdecal,$ymax\n";
 print FLY "frect 0,0,0,0,200,200,200\n";
 $posy = $ymax - (($ymax/2)-(length("times")/2));
 print FLY "stringup 0,0,0,5,$posy,medium,times\n";
 for ($i=$ystep;$i<=$ymax;$i+=$ystep) {
 $valstep = int(($ymax - $i) * ($facty/$ystep));
 $valstep = int(($ymax - $i) / ($ystep/$facty)) if ($facty < $ystep);
 $pos = ($xdecal - length($valstep)*9);
 $posy = $i-5;
 print FLY "line $xdecalm,$i,$xdecal,$i,0,0,0\n";
 print FLY "string 0,0,0,$pos,$posy,small,$valstep\n";
 }
print FLY "transparent 200,200,200\n";
close (FLY);

open(FOO,"$FLY -q -i $tmpfly$vtmp -o $lienfiley |");
while( <FOO> ) {print;}
close(FOO);
unlink("$tmpfly$vtmp");
}

################## graphs sur les images ################################

if ($url_image == 1) {
$imamax = $occurima[$boucleima-1] if ($imamax > (2*$topten));

$it = length($imamax)-1;
$div = 10**$it;
$factx = ($div*(int($imamax/$div)+1))/$grad;

$factx = 1 if ($it == 0);

$it = length($yimamax)-1;
$div = 10**$it;
$facty = ($div*(int($yimamax/$div)+1))/$grad;

open(FLY,">$tmpfly$vtmp");
print FLY "new\n";
print FLY "size $xmax,$ymax\n";
 print FLY "frect 0,0,0,0,200,200,200\n";
 for ($i=0;$i<$imamax;$i++) {
 $x1 = $i*$xstep/$factx;
 $x2 = ($i+1)*$xstep/$factx;

 $y2 = $ymax - ($ystep/$facty * $ima{$i});
 print FLY "frect $x1,$y2,$x2,$ymax,$red[1],$green[1],$blue[1]\n";
 print FLY "frect $x1,$y2,$x2,$ymax,,,\n" if ($i == $moyima);
 print FLY "rect $x1,$y2,$x2,$ymax,0,0,0\n";
 }
print FLY "transparent 200,200,200\n";
close (FLY);

open(FOO,"$FLY -q -i $tmpfly$vtmp -o $imafile |");
while( <FOO> ) {print;}
close(FOO);
unlink("$tmpfly$vtmp");

### image pour les abscisses

$xlegend = "Number of images";

open(FLY,">$tmpfly$vtmp");
print FLY "new\n";
print FLY "size $xmax,$ydecal\n";
 print FLY "frect 0,0,0,0,200,200,200\n";
 $posx = (($xmax/2)-(length($xlegend)*7/2));
 print FLY "string 0,0,0,$posx,$ydecalm,medium,$xlegend\n";
 for ($i=$xstep;$i<$xmax;$i+=$xstep) {
 $valstep = $i*$factx/$xstep;
 $posx = $i - length(int($valstep))*5;
 print FLY "line $i,0,$i,5,0,0,0\n";
 print FLY "string 0,0,0,$posx,10,small,$valstep\n";
 }
print FLY "transparent 200,200,200\n";
close (FLY);

open(FOO,"$FLY -q -i $tmpfly$vtmp -o $imafilex |");
while( <FOO> ) {print;}
close(FOO);
unlink("$tmpfly$vtmp");

### image pour les ordonnees

open(FLY,">$tmpfly$vtmp");
print FLY "new\n";
print FLY "size $xdecal,$ymax\n";
 print FLY "frect 0,0,0,0,200,200,200\n";
 $posy = $ymax - (($ymax/2)-(length("times")/2));
 print FLY "stringup 0,0,0,5,$posy,medium,times\n";
 for ($i=$ystep;$i<=$ymax;$i+=$ystep) {
 $valstep = int(($ymax - $i) * ($facty/$ystep));
 $valstep = int(($ymax - $i) / ($ystep/$facty)) if ($facty < $ystep);
 $pos = ($xdecal - length($valstep)*9);
 $posy = $i-5;
 print FLY "line $xdecalm,$i,$xdecal,$i,0,0,0\n";
 print FLY "string 0,0,0,$pos,$posy,small,$valstep\n";
 }
print FLY "transparent 200,200,200\n";
close (FLY);

open(FOO,"$FLY -q -i $tmpfly$vtmp -o $imafiley |");
while( <FOO> ) {print;}
close(FOO);
unlink("$tmpfly$vtmp");
}

################ graphs sur les tailles des documents #####################

if ($url_weight == 1) {
$sizemax++; # pour aller jusqu'au Ko suivant
$sizemax = int($occursize[$bouclesize-1]/1024)+1 if ($sizemax > (2*$topten));

$it = length($sizemax)-1;
$div = 10**$it;
$factx = ($div*(int($sizemax/$div)+1))/$grad;

$factx = 1 if ($it == 0);

$it = length($ysizemax)-1;
$div = 10**$it;
$facty = ($div*(int($ysizemax/$div)+1))/$grad;

open(FLY,">$tmpfly$vtmp");
print FLY "new\n";
print FLY "size $xmax,$ymax\n";
 print FLY "frect 0,0,0,0,200,200,200\n";
 for ($i=0;$i<$sizemax;$i++) {
 $x1 = $i*$xstep/$factx;
 $x2 = ($i+1)*$xstep/$factx;

 $y2 = $ymax - ($ystep/$facty * $taille{$i});
 print FLY "frect $x1,$y2,$x2,$ymax,$red[2],$green[2],$blue[2]\n";
 print FLY "frect $x1,$y2,$x2,$ymax,0,0,0\n" if ($i == $moysize);
 print FLY "rect $x1,$y2,$x2,$ymax,0,0,0\n";
 }
print FLY "transparent 200,200,200\n";
close (FLY);

open(FOO,"$FLY -q -i $tmpfly$vtmp -o $sizefilegraph |");
while( <FOO> ) {print;}
close(FOO);
unlink("$tmpfly$vtmp");

### image pour les abscisses

$xlegend = "Size";

open(FLY,">$tmpfly$vtmp");
print FLY "new\n";
print FLY "size $xmax,$ydecal\n";
 print FLY "frect 0,0,0,0,200,200,200\n";
 $posx = (($xmax/2)-(length($xlegend)*7/2));
 print FLY "string 0,0,0,$posx,$ydecalm,medium,$xlegend\n";
 for ($i=$xstep;$i<$xmax;$i+=$xstep) {
 $valstep = $i*$factx/$xstep;
 $posx = $i - length(int($valstep))*5;
 print FLY "line $i,0,$i,5,0,0,0\n";
 print FLY "string 0,0,0,$posx,10,small,$valstep\n";
 }
print FLY "transparent 200,200,200\n";
close (FLY);

open(FOO,"$FLY -q -i $tmpfly$vtmp -o $sizefilegraphx |");
while( <FOO> ) {print;}
close(FOO);
unlink("$tmpfly$vtmp");

### image pour les ordonnees

open(FLY,">$tmpfly$vtmp");
print FLY "new\n";
print FLY "size $xdecal,$ymax\n";
 print FLY "frect 0,0,0,0,200,200,200\n";
 $posy = $ymax - (($ymax/2)-(length("time")/2));
 print FLY "stringup 0,0,0,5,$posy,medium,time\n";
 for ($i=$ystep;$i<=$ymax;$i+=$ystep) {
 $valstep = int(($ymax - $i) / ($facty/$ystep));
 $valstep = int(($ymax - $i) / ($ystep/$facty)) if ($facty < $ystep);
 $pos = ($xdecal - length($valstep)*9);
 $posy = $i-5;
 print FLY "line $xdecalm,$i,$xdecal,$i,0,0,0\n";
 print FLY "string 0,0,0,$pos,$posy,small,$valstep\n";
 }
print FLY "transparent 200,200,200\n";
close (FLY);

open(FOO,"$FLY -q -i $tmpfly$vtmp -o $sizefilegraphy |");
while( <FOO> ) {print;}
close(FOO);
unlink("$tmpfly$vtmp");
}

################ graphs sur les documents recents #####################

if ($url_new_doc == 1) {
for ($i=0;$i<=$modifjour;$i++) {
$max = $nbmodif{$i} if ($nbmodif{$i} > $max);
}

if ($max != 0) {

$it = length($modifjour)-1;
$div = 10**$it;
$factx = ($div*(int($modifjour/$div)+1))/$grad;

$factx = 1 if ($it == 0);

$it = length($max)-1;
$div = 10**$it;
$facty = ($div*(int($max/$div)+1))/$grad;

open(FLY,">$tmpfly$vtmp");
print FLY "new\n";
print FLY "size $xmax,$ymax\n";
 print FLY "frect 0,0,0,0,200,200,200\n";
 for ($i=0;$i<$modifjour;$i++) {
 $x1 = $i*$xstep/$factx;
 $x2 = ($i+1)*$xstep/$factx;

 $y2 = $ymax - ($ystep/$facty * $nbmodif{$i});
 print FLY "frect $x1,$y2,$x2,$ymax,$red[3],$green[3],$blue[3]\n";
 print FLY "rect $x1,$y2,$x2,$ymax,0,0,0\n";
 }
print FLY "transparent 200,200,200\n";
close (FLY);

open(FOO,"$FLY -q -i $tmpfly$vtmp -o $recentfile |");
while( <FOO> ) {print;}
close(FOO);
unlink("$tmpfly$vtmp");

### image pour les abscisses

$xlegend = "$modifjour days (starting $pasttoday)";

open(FLY,">$tmpfly$vtmp");
print FLY "new\n";
print FLY "size $xmax,$ydecal\n";
 print FLY "frect 0,0,0,0,200,200,200\n";
 $posx = (($xmax/2)-(length($xlegend)*7/2));
 print FLY "string 0,0,0,$posx,$ydecalm,medium,$xlegend\n";
 for ($i=$xstep;$i<$xmax;$i+=$xstep) {
 $valstep = $i*$factx/$xstep;
 $posx = $i - length(int($valstep))*5;
 print FLY "line $i,0,$i,5,0,0,0\n";
 print FLY "string 0,0,0,$posx,10,small,$valstep\n";
 }
print FLY "transparent 200,200,200\n";
close (FLY);

open(FOO,"$FLY -q -i $tmpfly$vtmp -o $recentfilex |");
while( <FOO> ) {print;}
close(FOO);
unlink("$tmpfly$vtmp");

### image pour les ordonnees

open(FLY,">$tmpfly$vtmp");
print FLY "new\n";
print FLY "size $xdecal,$ymax\n";
 print FLY "frect 0,0,0,0,200,200,200\n";
 $posy = $ymax - (($ymax/2)-(length("Number of files")));
 print FLY "stringup 0,0,0,5,$posy,medium,Number of files\n";
 for ($i=$ystep;$i<=$ymax;$i+=$ystep) {
 $valstep = int(($ymax - $i) / ($facty/$ystep));
 $valstep = int(($ymax - $i) / ($ystep/$facty)) if ($facty < $ystep);
 $pos = ($xdecal - length($valstep)*9);
 $posy = $i-5;
 print FLY "line $xdecalm,$i,$xdecal,$i,0,0,0\n";
 print FLY "string 0,0,0,$pos,$posy,small,$valstep\n";
 }
print FLY "transparent 200,200,200\n";
close (FLY);

open(FOO,"$FLY -q -i $tmpfly$vtmp -o $recentfiley |");
while( <FOO> ) {print;}
close(FOO);
unlink("$tmpfly$vtmp");
}
}

#########################################################################
####                                                                #####
####              FABRICATION DES PAGES HTML                        #####
####                                                                #####
#########################################################################

print "Generating HTML pages\n";
print "<BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");

&LogoWidth("$logo") if ($logo !~ /^http/);

### page index

for ($nblang=0;$nblang<=$#lang;$nblang++) {
    open(HOME,">$path$lang[$nblang]$dirsep$dirdocument$dirsep$menu") || die &error_exit("Error, unable to open $path$lang[$nblang]$dirsep$dirdocument$dirsep$menu");
&HomeDoc(*HOME, eval($Lang{$lang[$nblang]}));
close (HOME);
}

sub HomeDoc {
    local(*FOUT,*L) = @_;
    
    print FOUT "$doctype\n";
    print FOUT "<HTML><HEAD>\n";
    print FOUT "$charset\n";
    print FOUT "<TITLE>$L{'Stats_about_HTML_files'}</TITLE>\n";
    print FOUT "<!-- Page generated by w3perl - cron-url.pl $version - $today $hourdate -->\n";
    print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$helpjs\"></script>\n";
    print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$sorttablejs\"></script>\n";
    print FOUT "<link rel=\"stylesheet\" type=\"text/css\" href=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dircss$dirsepurl$css_w3perl\">\n";
    print FOUT "<link rel=\"stylesheet\" type=\"text/css\" href=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dircss$dirsepurl$css_help\">\n";
    print FOUT "</HEAD>\n";
    print FOUT "<BODY $backgrd TEXT=\"$custom_text\" LINK=\"$custom_link\" VLINK=\"$custom_vlink\">\n";

    print FOUT "<TABLE BORDER=0 WIDTH=\"100%\">\n";
    print FOUT "<TR>\n";
    print FOUT "<TD ALIGN=LEFT VALIGN=MIDDLE WIDTH=\"20%\">";
#    print FOUT "<IMG WIDTH=\"49\" HEIGHT=\"49\" SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$logo\" ALT=\"Logo\">\n";
    print FOUT "<IMG";
    print FOUT " WIDTH=\"$logo_width\" HEIGHT=\"$logo_height\"" if ($logo !~ /^http/);
    print FOUT " SRC=\"";
    print FOUT "$logo" if ($logo =~ /^http/ || $logo =~ /^\//);
    print FOUT "..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$logo" if ($logo !~ /^\// && $logo !~ /^http/);
    print FOUT "\" ALT=\"Logo\">\n";
    print FOUT "</TD>\n";
    print FOUT "<TD ALIGN=CENTER WIDTH=\"60%\">\n";
    print FOUT "<TABLE BORDER=1 BGCOLOR=\"#000000\">\n<TR>\n<TD BGCOLOR=\"#FFEECC\" ALIGN=CENTER>\n";
    print FOUT "<H1>".uc(&noaccentinhtml($L{'Stats_about_HTML_files'}))." : $today</H1><P>\n";
    print FOUT "</TD>\n</TR>\n</TABLE>\n";
    print FOUT "</TD>\n";
    print FOUT "<TD ALIGN=RIGHT VALIGN=MIDDLE WIDTH=\"20%\">\n";
    print FOUT "</TD>\n";
    print FOUT "</TR>\n";
    print FOUT "</TABLE>\n";

    print FOUT "<P><TABLE WIDTH=\"100%\">\n";
    print FOUT "<TR><TD>\n";

# First cell

    print FOUT "<TABLE>\n";
    print FOUT "<TR>\n<TD CLASS=\"left_alter\">\n";
    print FOUT "$L{'Total_number_of_html_files'}";
    print FOUT "</TD>\n<TD CLASS=\"right_alter\">";
    print FOUT "$countdoc\n";
    print FOUT "</TD></TR>\n<TR><TD CLASS=\"left\">";
    print FOUT "$L{'Total_number_of_images'}";
    print FOUT "</TD>\n<TD CLASS=\"right\">";
    print FOUT "$nbimage\n";
    print FOUT "</TD></TR>\n<TR><TD CLASS=\"left_alter\">";
    print FOUT "$L{'Others'}";
    print FOUT "</TD>\n<TD CLASS=\"right_alter\">";
    print FOUT "$countdiv\n";
    print FOUT "</TD>\n</TR>\n</TABLE>\n";

    print FOUT "</TD>\n<TD VALIGN=TOP>";

    print FOUT "<TABLE>\n";
    print FOUT "<TR>\n<TH COLSPAN=2 CLASS=\"right_alter\">\n";
    print FOUT "$L{'Average'}</TH></TR>\n<TR>\n";
    print FOUT "<TD CLASS=\"left_alter\"><I>$L{'HTML_files'}</I></TD>\n<TD CLASS=\"right_alter\">";
    print FOUT "$moyaref $L{'links'}";
    print FOUT ", $moyima $L{'images'}";
    print FOUT " $L{'and'} $L{'weighting'} $moysize $L{'Data_unit_Kb'}</TD>\n";
    print FOUT "</TR>\n<TR>\n";
    print FOUT "<TD CLASS=\"left\"><I>$L{'Images'}</I> $L{'weighting'}</TD>";
    printf FOUT "<TD CLASS=\"right\">%.1f",$moysizeimage;
    print FOUT " $L{'Data_unit_Kb'}</TD>\n";
    print FOUT "</TR>\n<TR>\n";
    print FOUT "<TD CLASS=\"left_alter\"><I>$L{'HTML_files'}</I> $L{'weighting'}</TD>";
    printf FOUT "<TD CLASS=\"right_alter\">%.1f",($moyimafloat*$moysizeimage+$moysize);
    print FOUT " $L{'Data_unit_Kb'}</TD>";
    print FOUT "</TR>\n<TR>\n";
    print FOUT "<TD CLASS=\"left\"><I>$L{'Downloading_time'}</I> $L{'hTML_pages'}</TD>";
    printf FOUT "<TD CLASS=\"right\">%.f",($moyimafloat*$moysizeimage+$moysize)/$baudrate;
    print FOUT " $L{'seconds'} ($L{'28800_modem'})</TD>\n";
    print FOUT "</TR></TABLE>\n";

    print FOUT "</TD>\n<TD VALIGN=TOP>";

# Third cell
    print FOUT "<TABLE>\n";
    print FOUT "<TR>\n<TD CLASS=\"left_alter\">\n";
    print FOUT "$L{'Web_size'}";
    print FOUT "</TD>\n<TD CLASS=\"right_alter\">";
    printf FOUT "%.2f",$websize;
    print FOUT " $L{'Mb'}";
    print FOUT "</TD>\n</TR>\n<TR>\n<TD CLASS=\"left\">";
    print FOUT "$L{'Images'}";
    print FOUT "</TD>\n<TD CLASS=\"right\">";
    printf FOUT "%.2f",$sizeimage;
    print FOUT " $L{'Mb'}";
    print FOUT "</TD>\n</TR>\n<TR>\n<TD CLASS=\"left_alter\">";
    print FOUT "$L{'HTML_files'}";
    print FOUT "</TD>\n<TD CLASS=\"right_alter\">";
    printf FOUT "%.2f",$totsize;
    print FOUT " $L{'Mb'}";
    print FOUT "</TD>\n</TR>\n<TR>\n<TD CLASS=\"left\">";
    print FOUT "$L{'Others'}";
    print FOUT "</TD>\n<TD CLASS=\"right\">";
    printf FOUT "%.2f",$divsize;
    print FOUT " $L{'Mb'}";
    print FOUT "</TD>\n</TR>\n</TABLE>";
    
    print FOUT "</TD></TR><TR><TD>";
# Second cell
    print FOUT "<TABLE>\n";
    print FOUT "<TR>\n<TD CLASS=\"left_alter\">\n";
    print FOUT "$L{'Total_number_of_directories'}";
    print FOUT "</TD>\n<TD CLASS=\"right_alter\">";
    print FOUT "$nbdir\n";
    print FOUT "</TD>\n</TR>\n<TR>\n<TD CLASS=\"left\">";
    print FOUT "$L{'Total_number_of_links'}";
    print FOUT "</TD>\n<TD CLASS=\"right\">";
    print FOUT "$totaref\n";
    print FOUT "</TD>\n</TR>\n<TR>\n<TD CLASS=\"left_alter\">";
    print FOUT "$L{'Total_number_of_images_in_files'}";
    print FOUT "</TD>\n<TD CLASS=\"right_alter\">";
    print FOUT "$totalima\n";
    print FOUT "</TD>\n</TR>\n</TABLE>\n";

    print FOUT "</TD>\n</TR>\n</TABLE>\n";

    print FOUT "<P><HR><P>\n";
    
    print FOUT "<CENTER>\n";
    print FOUT "<TABLE WIDTH=\"100%\" CELLPADDING=5 CELLSPACING=5 BORDER=0>\n";
    print FOUT "<TR>\n";
    print FOUT "<TD ALIGN=CENTER VALIGN=MIDDLE>\n";

    print FOUT "<TABLE CELLPADDING=5 CELLSPACING=0 BORDER=0>\n";
    print FOUT "<TR>\n";
    print FOUT "<TD ALIGN=CENTER VALIGN=MIDDLE>\n";

### pointeurs sur les liens, images, poids et repertoires

    if ($url_link == 1) {
	print FOUT "<A HREF=\"$doclien\"><IMG WIDTH=\"40\" HEIGHT=\"40\" SRC=\"..$dirsepurl..$dirsepurl$homeicons$dirsepurl$icon_links\" ALT=\"$L{'Links'}\" BORDER=0></A>\n";
	print FOUT "<BR>\n";
	print FOUT "<A HREF=\"$doclien\">$L{'Links'}</A>\n";
	print FOUT "";
    }
    print FOUT "</TD>\n";
    print FOUT "<TD ALIGN=CENTER VALIGN=BOTTOM>\n";
    if ($url_image == 1) {
	print FOUT "<A HREF=\"$docimage\"><IMG WIDTH=\"40\" HEIGHT=\"40\" SRC=\"..$dirsepurl..$dirsepurl$homeicons$dirsepurl$icon_ima\" ALT=\"$L{'Images'}\" BORDER=0></A>\n";
	print FOUT "<BR>\n";
	print FOUT "<A HREF=\"$docimage\">$L{'Images'}</A>\n";
	print FOUT "";
    }
    print FOUT "</TD>\n";
    print FOUT "</TR>\n";
    print FOUT "<TR>\n";
    print FOUT "<TD ALIGN=CENTER VALIGN=BOTTOM>\n";
    if ($url_weight == 1) {
	print FOUT "<A HREF=\"$docsize\"><IMG WIDTH=\"40\" HEIGHT=\"40\" SRC=\"..$dirsepurl..$dirsepurl$homeicons$dirsepurl$icon_weight\" ALT=\"$L{'Weight_of_HTML_files'}\" BORDER=0></A>\n";
	print FOUT "<BR>\n";
	print FOUT "<A HREF=\"$docsize\">$L{'Weight_of_HTML_files'}</A>\n";
	print FOUT "\n";
    }
    print FOUT "</TD>\n";
    print FOUT "<TD ALIGN=CENTER VALIGN=BOTTOM>\n";
    if ($url_directory == 1) {
	print FOUT "<A HREF=\"$docrepert\"><IMG WIDTH=\"40\" HEIGHT=\"40\" SRC=\"..$dirsepurl..$dirsepurl$homeicons$dirsepurl$icon_docrepert\" ALT=\"$L{'Directories'}\" BORDER=0></A>\n";
	print FOUT "<BR>\n";
	print FOUT "<A HREF=\"$docrepert\">$L{'Directories'}</A>\n";
	print FOUT "\n";
    }
    print FOUT "</TD>\n";
    print FOUT "</TR>\n";
    
    print FOUT "</TABLE>\n";

###

    print FOUT "</TD>\n";
    print FOUT "<TD ALIGN=CENTER VALIGN=MIDDLE>\n";
    
### pointeurs sur arborescence + pages nouvelles

    print FOUT "<TABLE BORDER=0 CELLSPACING=0 CELLPADDING=5>\n";
    print FOUT "<TR>\n";
    print FOUT "<TD ALIGN=CENTER VALIGN=BOTTOM>\n";
    if ($url_new_doc == 1) {
	print FOUT "<A HREF=\"$new\"><IMG WIDTH=\"40\" HEIGHT=\"40\" SRC=\"..$dirsepurl..$dirsepurl$homeicons$dirsepurl$icon_new\" ALT=\"$L{'Newest_pages'}\" BORDER=0></A>\n";
	print FOUT "<BR>\n";
	print FOUT "<A HREF=\"$new\">$L{'Newest_pages'}</A>\n";
	print FOUT "\n";
    }
    print FOUT "</TD>\n";
    print FOUT "</TR><TR>\n";
    print FOUT "<TD ALIGN=CENTER VALIGN=BOTTOM>\n";
    if ($url_tree == 1) {
	print FOUT "<A HREF=\"$tree\"><IMG WIDTH=\"40\" HEIGHT=\"40\" SRC=\"..$dirsepurl..$dirsepurl$homeicons$dirsepurl$icon_tree\" ALT=\"$L{'Tree'}\" BORDER=0></A>\n";
	print FOUT "<BR>\n";
	print FOUT "<A HREF=\"$tree\">$L{'Tree'}</A>\n";
	print FOUT "\n";
    }
    print FOUT "</TD>\n";
    print FOUT "</TR>\n";
    print FOUT "</TABLE>\n";
    
    print FOUT "</TD>\n";
    print FOUT "</TR><TR>\n";
    print FOUT "<TD ALIGN=CENTER VALIGN=MIDDLE>\n";

### pointeurs sur liens

    print FOUT "<TABLE BORDER=0 CELLSPACING=0 CELLPADDING=5>\n";
    print FOUT "<TR>\n";
    print FOUT "<TD ALIGN=CENTER VALIGN=BOTTOM>\n";

    if ($url_frame == 1) {
	print FOUT "<A HREF=\"$frame\"><IMG WIDTH=\"40\" HEIGHT=\"40\" SRC=\"..$dirsepurl..$dirsepurl$homeicons$dirsepurl$icon_null\" ALT=\"$L{'Frames'}\" BORDER=0></A>\n" if ($#framed != -1);
	print FOUT "<BR>\n";
	print FOUT "<A HREF=\"$frame\">$L{'Frames'}</A>\n" if ($#framed != -1);
	print FOUT "\n";
    }
    print FOUT "</TD>\n";
    print FOUT "<TD ALIGN=CENTER VALIGN=BOTTOM>\n";
    if ($url_doublon == 1) {
	print FOUT "<A HREF=\"$doublons\"><IMG WIDTH=\"40\" HEIGHT=\"40\" SRC=\"..$dirsepurl..$dirsepurl$homeicons$dirsepurl$icon_verif\" ALT=\"$L{'Same_title'}\" BORDER=0></A>\n";
	print FOUT "<BR>\n";
	print FOUT "<A HREF=\"$doublons\">$L{'Same_title'}</A>\n";
	print FOUT "\n";
    }
    print FOUT "</TD>\n";
    print FOUT "</TR><TR>\n";
    print FOUT "<TD ALIGN=CENTER VALIGN=BOTTOM>\n";
    if ($url_img_tag == 1) {
	print FOUT "<A HREF=\"$imawidth\"><IMG WIDTH=\"40\" HEIGHT=\"40\" SRC=\"..$dirsepurl..$dirsepurl$homeicons$dirsepurl$icon_useless\" ALT=\"WIDTH - HEIGHT\" BORDER=0></A>\n";
	print FOUT "<BR>\n";
	print FOUT "<A HREF=\"$imawidth\">WIDTH,&nbsp;HEIGHT</A>\n";
	print FOUT "\n";
	print FOUT "</TD>\n";
	print FOUT "<TD ALIGN=CENTER VALIGN=BOTTOM>\n";
	print FOUT "<A HREF=\"$imaalt\"><IMG WIDTH=\"40\" HEIGHT=\"40\" SRC=\"..$dirsepurl..$dirsepurl$homeicons$dirsepurl$icon_info2\" ALT=\"ALT\" BORDER=0></A>\n";
	print FOUT "<BR>\n";
	print FOUT "<A HREF=\"$imaalt\">ALT</A>\n";
	print FOUT "\n";
    }
    print FOUT "</TD>\n";
    print FOUT "</TR><TR>\n";
    print FOUT "<TD ALIGN=CENTER VALIGN=BOTTOM>\n";
    if ($url_useless == 1) {
	print FOUT "<A HREF=\"$useless\"><IMG WIDTH=\"40\" HEIGHT=\"40\" SRC=\"..$dirsepurl..$dirsepurl$homeicons$dirsepurl$icon_trash\" ALT=\"$L{'Useless_pages'}\" BORDER=0></A>\n";
	print FOUT "<BR>\n";
	print FOUT "<A HREF=\"$useless\">$L{'Useless_pages'}</A>\n";
	print FOUT "\n";
    }
    print FOUT "</TD>\n";
    print FOUT "<TD ALIGN=CENTER VALIGN=BOTTOM>\n";
    if ($url_cdrom == 1) {
	print FOUT "<A HREF=\"$cdrom\"><IMG WIDTH=\"40\" HEIGHT=\"40\" SRC=\"..$dirsepurl..$dirsepurl$homeicons$dirsepurl$icon_cdrom\" ALT=\"$L{'Index_pages'}\" BORDER=0></A>\n";
	print FOUT "<BR>\n";
	print FOUT "<A HREF=\"$cdrom\">$L{'Index_pages'}</A>\n";
	print FOUT "\n";
    }
    print FOUT "</TD>\n";
    print FOUT "</TR>\n";
    print FOUT "</TABLE>\n";
    
    print FOUT "</TD>\n";
    print FOUT "<TD ALIGN=CENTER VALIGN=MIDDLE>\n";

    print FOUT "<TABLE BORDER=0 CELLSPACING=0 CELLPADDING=5>\n";
    print FOUT "<TR>\n";
    print FOUT "<TD ALIGN=CENTER VALIGN=BOTTOM>\n";
    if ($url_absolute_link == 1) {
	print FOUT "<A HREF=\"$fileabsolute\"><IMG WIDTH=\"40\" HEIGHT=\"40\" SRC=\"..$dirsepurl..$dirsepurl$homeicons$dirsepurl$icon_linkabs\" ALT=\"$L{'Absolute_links'}\" BORDER=0></A>\n" if ($#absolute != 0 || $#absoluteima != 0);
	print FOUT "<BR>\n";
	print FOUT "<A HREF=\"$fileabsolute\">$L{'Absolute_links'}</A>\n" if ($#absolute != 0 || $#absoluteima != 0);
	print FOUT "\n";
    }
    print FOUT "</TD>\n";
    print FOUT "</TR><TR>\n";
    print FOUT "<TD ALIGN=CENTER VALIGN=BOTTOM>\n";
    if ($url_symbolic_link == 1) {
	print FOUT "<A HREF=\"$filelinksym\"><IMG WIDTH=\"40\" HEIGHT=\"40\" SRC=\"..$dirsepurl..$dirsepurl$homeicons$dirsepurl$icon_linksym\" ALT=\"$L{'Symbolic_links'}\" BORDER=0></A>\n" if ($#linkfile != 0);
	print FOUT "<BR>\n";
	print FOUT "<A HREF=\"$filelinksym\">$L{'Symbolic_links'}</A>\n" if ($#linkfile != 0);
	print FOUT "\n";
    }
    print FOUT "</TD>\n";
    print FOUT "</TR><TR>\n";
    print FOUT "<TD ALIGN=CENTER VALIGN=BOTTOM>\n";
    if ($url_bad_link == 1) {
	print FOUT "<A HREF=\"$nofile\"><IMG WIDTH=\"40\" HEIGHT=\"40\" SRC=\"..$dirsepurl..$dirsepurl$homeicons$dirsepurl$icon_linkerr\" ALT=\"$L{'Bad_links'}\" BORDER=0></A>\n";
	print FOUT "<BR>\n";
	print FOUT "<A HREF=\"$nofile\">$L{'Bad_links'}</A>\n";
	print FOUT "\n";
    }
    print FOUT "</TD>\n";
    print FOUT "</TR>\n";
    print FOUT "</TABLE>\n";

    print FOUT "</TD>\n";
    print FOUT "</TR>\n";
    print FOUT "</TABLE>\n";
    print FOUT "</CENTER>\n";

    print FOUT "</BODY></HTML>\n";
}

undef @framed;

###############################################################
###         page sur l'arborescence du serveur              ###
###############################################################

if ($url_tree == 1) {
    print STDOUT "Webserver tree\n";
    print "<BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");

# compute the tree

    open(TMPTREE,">$path$dirtmp$dirsep$vtmp$tmp1") || die &error_exit("Error, unable to open $path$dirtmp$dirsep$vtmp$tmp1");
    &ComputeTree(*TMPTREE,2);
    close(TMPTREE);

# output pages
    
    for ($nblang=0;$nblang<=$#lang;$nblang++) {
	
	open(TREE,">$path$lang[$nblang]$dirsep$dirdocument$dirsep$tree") || die &error_exit("Error, unable to open $path$lang[$nblang]$dirsep$dirdocument$dirsep$tree");
	&Tree(*TREE, eval($Lang{$lang[$nblang]}));
	close (TREE);
    }
}

sub Tree {
    local(*FOUT,*L) = @_;
	
    print FOUT "$doctype\n";
    print FOUT "<HTML><HEAD>\n";
    print FOUT "$charset\n";
    print FOUT "<TITLE>$L{'Server_tree'}</TITLE>\n";
    print FOUT "<!-- Page generated by w3perl - cron-url.pl $version - $today $hourdate -->\n";
    print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$helpjs\"></script>\n";
    print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$sorttablejs\"></script>\n";
    print FOUT "<link rel=\"stylesheet\" type=\"text/css\" href=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dircss$dirsepurl$css_w3perl\">\n";
    print FOUT "<link rel=\"stylesheet\" type=\"text/css\" href=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dircss$dirsepurl$css_help\">\n";
    print FOUT "</HEAD>\n";
    print FOUT "<BODY $backgrd TEXT=\"$custom_text\" LINK=\"$custom_link\" VLINK=\"$custom_vlink\">\n";

    print FOUT "<H2>$L{'Server_tree'}</H2>\n";

    print FOUT "<P><HR>\n";
    print FOUT "<CENTER><B>$today</B></CENTER>\n";
    print FOUT "<HR><P>\n";
    print FOUT "<A HREF=\"$new\">$L{'Newest_pages'}</A> $L{'day'} $L{'by'} $L{'day'}<P>\n";

    print FOUT "<I>$L{'Legend_in_bracket'} :</I><BR>\n\n";
    print FOUT "$L{'Number_of_HTML_files'} $L{'in_whole_directory'}<BR>\n";
    print FOUT "$L{'Number_of_HTML_files'} $L{'in_this_directory'}<BR>\n";
    print FOUT "$L{'Newest_pages'} $L{'in_this_directory'} ($L{'less_than'} $modifjour $L{'days'})\n";
    print FOUT "<P>\n";

    print FOUT "<TABLE BORDER=0><TR>\n";

    for ($i=0;$i<$maxdepth;$i++) {
	print FOUT "<TH ALIGN=CENTER>$L{'Level'} $i</TH>\n";
    }
    print FOUT "</TR>\n";

# display the tree

    open(TMPTREE,"$path$dirtmp$dirsep$vtmp$tmp1") || die &error_exit("Error, unable to open $path$dirtmp$dirsep$vtmp$tmp1");
    while (<TMPTREE>) {
	print FOUT;
    }
    close(TMPTREE);

    print FOUT "</TABLE>\n";
    print FOUT "</BODY></HTML>\n";
}

###

unlink("$path$dirtmp$dirsep$vtmp$tmp1");

###############################################################
###             page sur les repertoires                   ####
###############################################################

if ($url_directory == 1) {
    print STDOUT "Directories\n";
    print "<BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");
    
    $freqsizeglob{$tri} = $websize*1024*1024;
    $freqracglob{$tri} = $countdoc+$nbimage+$countdiv;
    
    for ($nblang=0;$nblang<=$#lang;$nblang++) {

	open(REPERT,">$path$lang[$nblang]$dirsep$dirdocument$dirsep$docrepert") || die &error_exit("Error, unable to open $path$lang[$nblang]$dirsep$dirdocument$dirsep$docrepert");
	&DocRepert(*REPERT, eval($Lang{$lang[$nblang]}));
	close (REPERT);
    }
}

sub DocRepert {
    local(*FOUT,*L) = @_;
	
    print FOUT "$doctype\n";
    print FOUT "<HTML><HEAD>\n";
    print FOUT "$charset\n";
    print FOUT "<TITLE>$L{'Stats'} $L{'about'} $repertunique $L{'directories'}</TITLE>\n";
    print FOUT "<!-- Page generated by w3perl - cron-url.pl $version - $today $hourdate -->\n";
    print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$helpjs\"></script>\n";
    print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$sorttablejs\"></script>\n";
    print FOUT "<link rel=\"stylesheet\" type=\"text/css\" href=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dircss$dirsepurl$css_w3perl\">\n";
    print FOUT "<link rel=\"stylesheet\" type=\"text/css\" href=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dircss$dirsepurl$css_help\">\n";
    print FOUT "</HEAD>\n";
    print FOUT "<BODY $backgrd TEXT=\"$custom_text\" LINK=\"$custom_link\" VLINK=\"$custom_vlink\">\n";

    print FOUT "<H2>$L{'Stats'} $L{'about'} $repertunique $L{'directories'}</H2>\n";

    print FOUT "<P><HR><P>\n";


    print FOUT "<TABLE CLASS=\"sortable_base\" ID=\"docrepert\"><TR>\n";
    print FOUT "<TH>&nbsp;</TH>\n";
    print FOUT "<TH>&nbsp;</TH>\n";
    print FOUT "<TH COLSPAN=4>$L{'Tree'}</TH>\n";
    print FOUT "<TH COLSPAN=4>$L{'Total'}</TH>\n";
    print FOUT "<TH COLSPAN=2>$L{'HTML_files'}</TH>\n";
    print FOUT "<TH COLSPAN=2>$L{'Images'}</TH>\n";
    print FOUT "<TH COLSPAN=2>$L{'Misc'}</TH>\n";
    print FOUT "</TR><TR>\n";

    print FOUT "<TH>$L{'Directories'}</TH>\n";
    print FOUT "<TH>$L{'Level'}</TH>\n";

    print FOUT "<TH>$L{'Number'}</TH>\n";
    print FOUT "<TH>%</TH>\n";
    print FOUT "<TH>$L{'Kb'}</TH>\n";
    print FOUT "<TH>%</TH>\n";

    print FOUT "<TH>$L{'Number'}</TH>\n";
    print FOUT "<TH>%</TH>\n";
    print FOUT "<TH>$L{'Kb'}</TH>\n";
    print FOUT "<TH>%</TH>\n";

    print FOUT "<TH>$L{'Number'}</TH>\n";
    print FOUT "<TH>$L{'Kb'}</TH>\n";

    print FOUT "<TH>$L{'Number'}</TH>\n";
    print FOUT "<TH>$L{'Kb'}</TH>\n";

    print FOUT "<TH>$L{'Number'}</TH>\n";
    print FOUT "<TH>$L{'Kb'}</TH>\n";

    print FOUT "</TR>\n";

    foreach $racine (sort keys(%freqrac)) {

	$tmp = 0;
	$pos = length($racine);
	while (($pos = rindex($racine,$dirsepurl,$pos)) >= 0) {
	    $tmp++;
	    $pos--;
	}
	
	$tmp -= $tmpdirsep;

	print FOUT "<TR>\n<TD ";
	print FOUT "CLASS=\"left\"" if ($tmp > 2);
	print FOUT "CLASS=\"head_left\"" if ($tmp < 3);
	print FOUT "><I><A HREF=\"$racine\">$racine</A></I>";
	print FOUT "</TD>\n";

	print FOUT "<TD ";
	print FOUT "CLASS=\"right\"" if ($tmp > 2);
	print FOUT "CLASS=\"head_right\"" if ($tmp < 3);
	print FOUT ">$tmp</TD>\n";

	$p1 = 100*$freqsizeglob{$racine}/($websize*1024*1024);
	$p2 = 100*$freqracglob{$racine}/($countdoc+$nbimage+$countdiv);

	print FOUT "<TD ";
	print FOUT "CLASS=\"right\"" if ($tmp > 2);
	print FOUT "CLASS=\"head_right_dir_req\"" if ($tmp < 3);
	print FOUT ">$freqracglob{$racine}";
	print FOUT "</TD><TD ";
	print FOUT "CLASS=\"right\"" if ($tmp > 2);
	print FOUT "CLASS=\"head_right_dir_req\"" if ($tmp < 3);
	printf FOUT ">%.1f",$p2;
	print FOUT "</TD><TD ";
	print FOUT "CLASS=\"right\"" if ($tmp > 2);
	print FOUT "CLASS=\"head_right_dir_req\"" if ($tmp < 3);
	printf FOUT ">%.1f",($freqsizeglob{$racine}/1024);
	print FOUT "</TD><TD ";
	print FOUT "CLASS=\"right\"" if ($tmp > 2);
	print FOUT "CLASS=\"head_right_dir_req\"" if ($tmp < 3);
	printf FOUT ">%.1f",$p1;
	print FOUT "</TD>\n";

	$p1 = 100*$freqsizeall{$racine}/($websize*1024*1024);
	$p2 = 100*$freqrac{$racine}/($countdoc+$nbimage+$countdiv);

	print FOUT "<TD ";
	print FOUT "CLASS=\"right\"" if ($tmp > 2);
	print FOUT "CLASS=\"head_right_dir_access\"" if ($tmp < 3);
	print FOUT ">$freqrac{$racine}";
	print FOUT "</TD><TD ";
	print FOUT "CLASS=\"right\"" if ($tmp > 2);
	print FOUT "CLASS=\"head_right_dir_access\"" if ($tmp < 3);
	printf FOUT ">%.1f",$p2;
	print FOUT "</TD><TD ";
	print FOUT "CLASS=\"right\"" if ($tmp > 2);
	print FOUT "CLASS=\"head_right_dir_access\"" if ($tmp < 3);
	printf FOUT ">%.1f",($freqsizeall{$racine}/1024);
	print FOUT "</TD><TD ";
	print FOUT "CLASS=\"right\"" if ($tmp > 2);
	print FOUT "CLASS=\"head_right_dir_access\"" if ($tmp < 3);
	printf FOUT ">%.1f",$p1;
	print FOUT "</TD>\n";
	
	$freqsizetml{$racine} = 0 if ($freqsizetml{$racine} eq '');
	$freqrachtml{$racine} = 0 if ($freqrachtml{$racine} eq '');

	print FOUT "<TD ";
	print FOUT "CLASS=\"right\"" if ($tmp > 2);
	print FOUT "CLASS=\"head_right_dir_traffic\"" if ($tmp < 3);
	print FOUT ">$freqrachtml{$racine}";
	print FOUT "</TD>";
	print FOUT "<TD ";
	print FOUT "CLASS=\"right\"" if ($tmp > 2);
	print FOUT "CLASS=\"head_right_dir_traffic\"" if ($tmp < 3);
	printf FOUT ">%.1f",($freqsizehtml{$racine}/1024);
	print FOUT "</TD>\n";
	
	$freqsizeima{$racine} = 0 if ($freqsizeima{$racine} eq '');
	$freqracima{$racine} = 0 if ($freqracima{$racine} eq '');
	
	print FOUT "<TD ";
	print FOUT "CLASS=\"right\"" if ($tmp > 2);
	print FOUT "CLASS=\"head_right_dir_ima\"" if ($tmp < 3);
	print FOUT ">$freqracima{$racine}";
	print FOUT "</TD>";
	print FOUT "<TD ";
	print FOUT "CLASS=\"right\"" if ($tmp > 2);
	print FOUT "CLASS=\"head_right_dir_ima\"" if ($tmp < 3);
	printf FOUT ">%.1f",($freqsizeima{$racine}/1024);
	print FOUT "</TD>\n";
	
	$freqsizediv{$racine} = 0 if ($freqsizediv{$racine} eq '');
	$freqracdiv{$racine} = 0 if ($freqracdiv{$racine} eq '');
	
	print FOUT "<TD ";
	print FOUT "CLASS=\"right\"" if ($tmp > 2);
	print FOUT "CLASS=\"head_right_dir_misc\"" if ($tmp < 3);
	print FOUT ">$freqracdiv{$racine}";
	print FOUT "</TD>";
	print FOUT "<TD ";
	print FOUT "CLASS=\"right\"" if ($tmp > 2);
	print FOUT "CLASS=\"head_right_dir_misc\"" if ($tmp < 3);
	printf FOUT ">%.1f",($freqsizediv{$racine}/1024);
	print FOUT "</TD></TR>\n";

    }

    print FOUT "</TABLE>\n";
    print FOUT "</BODY></HTML>\n";
}


###############################################################
###        page sur le poids des pages HTML                ###
###############################################################

if ($url_weight == 1) {
    print STDOUT "HTML pages weight\n";
    print "<BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");

    for ($nblang=0;$nblang<=$#lang;$nblang++) {
	open(SIZE,">$path$lang[$nblang]$dirsep$dirdocument$dirsep$docsize") || die &error_exit("Error, unable to open $path$lang[$nblang]$dirsep$dirdocument$dirsep$docsize");
	&DocSize(*SIZE, eval($Lang{$lang[$nblang]}));
	close (SIZE);
    }
}

sub DocSize {
    local(*FOUT,*L) = @_;
	
    print FOUT "$doctype\n";
    print FOUT "<HTML><HEAD>\n";
    print FOUT "$charset\n";
    print FOUT "<TITLE>$L{'Stats_about_HTML_files_weight'}</TITLE>\n";
    print FOUT "<!-- Page generated by w3perl - cron-url.pl $version - $today $hourdate -->\n";
    print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$helpjs\"></script>\n";
    print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$sorttablejs\"></script>\n";
    print FOUT "<link rel=\"stylesheet\" type=\"text/css\" href=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dircss$dirsepurl$css_w3perl\">\n";
    print FOUT "<link rel=\"stylesheet\" type=\"text/css\" href=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dircss$dirsepurl$css_help\">\n";
    print FOUT "</HEAD>\n";
    print FOUT "<BODY $backgrd TEXT=\"$custom_text\" LINK=\"$custom_link\" VLINK=\"$custom_vlink\">\n";

    print FOUT "<H2>$L{'Stats_about_HTML_files_weight'}</H2>\n";

    print FOUT "<P>\n";
#print FOUT "<I>$L{'Only_HTML_files_itself'}</I>\n";
#print FOUT "<P><HR><P>\n";

    print FOUT "<CENTER><TABLE BORDER=0 cellpadding=0 CELLSPACING=0>\n";
    print FOUT "<TR>\n";
    print FOUT "<TD><IMG WIDTH=$xdecal HEIGHT=$ymax SRC=\"$linksizefilegraphy\" ALT=\"y\"></TD>\n";
    print FOUT "<TD><IMG WIDTH=$xmax HEIGHT=$ymax SRC=\"$linksizefilegraph\" ALT=\"graph\"></TD>\n";
    print FOUT "</TR><TR><TD></TD>\n";
    print FOUT "<TD><IMG WIDTH=$xmax HEIGHT=$ydecal SRC=\"$linksizefilegraphx\" ALT=\"x\"></TD>\n";
    print FOUT "</TR>\n";
    print FOUT "</TABLE></CENTER>\n";
    print FOUT "<CENTER><B>$L{'Weight_HTML_files_histogram'}</B><BR>";
    print FOUT "<I>($L{'The_Top'} $topten $L{'most_weighty_pages'} $L{'not_included'})</I><BR>\n" if ($sizemax > (2*$topten));
    print FOUT "<I>$L{'Average_is_black'}</I>\n";
    print FOUT "</CENTER><P>\n";
    print FOUT "<DIV CLASS=\"item_page\">-&nbsp;<I>$L{'The_Top'} $topten $L{'most_weighty_pages'}</I></DIV><P>\n";
    print FOUT "<TABLE CLASS=\"sortable_base\" ID=\"docsize\">\n";
    print FOUT "<TR><TH>$L{'Pages'}</TH><TH>$L{'Weight_of_HTML_files'}</TH></TR>\n";
    for ($i=0;$i < $bouclesize;$i++) {
	$tmp = int($occursize[$i]/1024*10)/10;
	print FOUT "<TR><TD CLASS=\"left\"><A HREF=\"$bestsize[$i]\" TARGET=\"_top\" TITLE=\"$bestsize[$i]\">$urlconv{$bestsize[$i]}</A></TD>\n<TD CLASS=\"right\">$tmp $L{'Kb'}</TD></TR>\n" if ($occursize[$i] != 0);
    }
    print FOUT "</TABLE>\n";
    print FOUT "\n<BR>";
    print FOUT "</BODY></HTML>\n";
}


###############################################################
###               page sur les liens                        ###
###############################################################

if ($url_link == 1) {
    print STDOUT "Links\n";
    print "<BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");

    for ($nblang=0;$nblang<=$#lang;$nblang++) {
	open(LIEN,">$path$lang[$nblang]$dirsep$dirdocument$dirsep$doclien") || die &error_exit("Error, unable to open $path$lang[$nblang]$dirsep$dirdocument$dirsep$doclien");
	&DocLien(*LIEN, eval($Lang{$lang[$nblang]}));
	close (LIEN);
    }
}

sub DocLien {
    local(*FOUT,*L) = @_;
	
    print FOUT "$doctype\n";
    print FOUT "<HTML><HEAD>\n";
    print FOUT "$charset\n";
    print FOUT "<TITLE>$L{'Stats_about_internal_links'}</TITLE>\n";
    print FOUT "<!-- Page generated by w3perl - cron-url.pl $version - $today $hourdate -->\n";
    print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$helpjs\"></script>\n";
    print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$sorttablejs\"></script>\n";
    print FOUT "<link rel=\"stylesheet\" type=\"text/css\" href=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dircss$dirsepurl$css_w3perl\">\n";
    print FOUT "<link rel=\"stylesheet\" type=\"text/css\" href=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dircss$dirsepurl$css_help\">\n";
    print FOUT "</HEAD>\n";
    print FOUT "<BODY $backgrd TEXT=\"$custom_text\" LINK=\"$custom_link\" VLINK=\"$custom_vlink\">\n";

    print FOUT "<H2>$L{'Stats_about_internal_links'}</H2>\n";

    print FOUT "<P>\n";

    print FOUT "<CENTER><TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0>\n";
    print FOUT "<TR>\n";
    print FOUT "<TD><IMG WIDTH=$xdecal HEIGHT=$ymax SRC=\"$linklienfiley\" ALT=\"y\"></TD>\n";
    print FOUT "<TD><IMG WIDTH=$xmax HEIGHT=$ymax SRC=\"$linklienfile\" ALT=\"graph\"></TD>\n";
    print FOUT "</TR><TR><TD></TD>\n";
    print FOUT "<TD><IMG WIDTH=$xmax HEIGHT=$ydecal SRC=\"$linklienfilex\" ALT=\"x\"></TD>\n";
    print FOUT "</TR>\n";
    print FOUT "</TABLE></CENTER>\n";
    print FOUT "<CENTER><B>$L{'Links_histogram'}</B><BR>";
    print FOUT "<I>($L{'The_Top'} $topten $L{'most_linky_pages'} $L{'not_included'})</I><BR>\n" if ($linkmax > (2*$topten));
    print FOUT "<I>$L{'Average_is_black'}</I>\n";
    
    print FOUT "</CENTER><P><DIV CLASS=\"item_page\">-&nbsp;<I>$L{'The_Top'} $topten $L{'most_linky_pages'}</I></DIV><P>\n";
    print FOUT "<TABLE CLASS=\"sortable_base\" ID=\"doclien\">\n";
    print FOUT "<TR><TH>$L{'Pages'}</TH><TH>$L{'Links'}</TH></TR>\n";
    for ($i=0;$i < $bouclelink;$i++) {
	if ($occurlink[$i] != 0) {
	    print FOUT "<TR>\n";
	    print FOUT "<TD CLASS=\"left\"><A HREF=\"$bestlink[$i]\" TARGET=\"_top\" TITLE=\"$bestlink[$i]\">$urlconv{$bestlink[$i]}</A></TD>\n";
	    print FOUT "<TD CLASS=\"right\">$occurlink[$i]</TD></TR>\n";
	}
    }
    print FOUT "</TABLE>\n";
    print FOUT "</BODY></HTML>";
}

###############################################################
###            page sur les images                          ###
###############################################################

if ($url_image == 1) {
    print STDOUT "Images\n";
    print "<BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");
    
    for ($nblang=0;$nblang<=$#lang;$nblang++) {
	open(IMA,">$path$lang[$nblang]$dirsep$dirdocument$dirsep$docimage") || die &error_exit("Error, unable to open $path$lang[$nblang]$dirsep$dirdocument$dirsep$docimage");
	&DocImage(*IMA, eval($Lang{$lang[$nblang]}));
	close (IMA);
    }
}

sub DocImage {
    local(*FOUT,*L) = @_;
	
    print FOUT "$doctype\n";
    print FOUT "<HTML><HEAD>\n";
    print FOUT "$charset\n";
    print FOUT "<TITLE>$L{'Stats_about_images'}</TITLE>\n";
    print FOUT "<!-- Page generated by w3perl - cron-url.pl $version - $today $hourdate -->\n";
    print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$helpjs\"></script>\n";
    print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$sorttablejs\"></script>\n";
    print FOUT "<link rel=\"stylesheet\" type=\"text/css\" href=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dircss$dirsepurl$css_w3perl\">\n";
    print FOUT "<link rel=\"stylesheet\" type=\"text/css\" href=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dircss$dirsepurl$css_help\">\n";
    print FOUT "</HEAD>\n";
    print FOUT "<BODY $backgrd TEXT=\"$custom_text\" LINK=\"$custom_link\" VLINK=\"$custom_vlink\">\n";

    print FOUT "<H2>$L{'Stats_about_images'}</H2>\n";

    print FOUT "<P>\n";

    print FOUT "<CENTER>\n";
    print FOUT "<TABLE BORDER=0 CELLPADDING=4>\n";
    print FOUT "<TR><TD ALIGN=CENTER>\n";

    print FOUT "<TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0>\n";
    print FOUT "<TR>\n";
    print FOUT "<TD><IMG WIDTH=$xdecal HEIGHT=$ymax SRC=\"$linkimafiley\" ALT=\"y\"></TD>\n";
    print FOUT "<TD><IMG WIDTH=$xmax HEIGHT=$ymax SRC=\"$linkimafile\" ALT=\"graph\"></TD>\n";
    print FOUT "</TR><TR><TD></TD>\n";
    print FOUT "<TD><IMG WIDTH=$xmax HEIGHT=$ydecal SRC=\"$linkimafilex\" ALT=\"x\"></TD>\n";
    print FOUT "</TR>\n";
    print FOUT "</TABLE>\n";

    print FOUT "<B>$L{'Images_histogram'}</B><BR>";
    print FOUT "<I>($L{'The_Top'} $topten $L{'most_graphic_pages'} $L{'not_included'})</I><BR>\n" if ($imamax > (2*$topten));
    print FOUT "<I>$L{'Average_is_black'}</I>\n";

#    print FOUT "</CENTER>\n";
    print FOUT "<P>\n";

    print FOUT "</TD><TD ALIGN=CENTER>\n";

    if ($nbimage != 0) {
    print FOUT "<TABLE CLASS=\"sortable_base\" ID=\"docimagetype\">\n";
    print FOUT "<TR><TH>$L{'File'}</TH><TH>$L{'Occurence'}</TH><TH>$L{'Percentage'}</TH></TR>\n";
    if ($gif != 0) {
	print FOUT "<TR>\n";
	$tmp = int($gif*100/$nbimage);
	print FOUT "<TD CLASS=\"left\">GIF</TD><TD CLASS=\"right\">$gif</TD><TD CLASS=\"left\">";
	print FOUT "<img width=$tmp height=$square src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\">&nbsp;" if ($tmp != 0);
	print FOUT "$tmp&nbsp;%</TD>\n";
	print FOUT "</TR>\n";
    }
    if ($jpg != 0) {
	$tmp = int($jpg*100/$nbimage);
	print FOUT "<TR>\n";
	print FOUT "<TD CLASS=\"left\">JPG</TD><TD CLASS=\"right\">$jpg</TD><TD CLASS=\"left\">\n";
	print FOUT "<img width=$tmp height=$square src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\">&nbsp;" if ($tmp != 0);
	print FOUT "$tmp&nbsp;%</TD>\n";
	print FOUT "</TR>\n";
    }
    if ($png != 0) {
	$tmp = int($png*100/$nbimage);
	print FOUT "<TR>\n";
	print FOUT "<TD CLASS=\"left\">PNG</TD><TD CLASS=\"right\">$png</TD><TD CLASS=\"left\">";
	print FOUT "<img width=$tmp height=$square src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\">&nbsp;" if ($tmp != 0);
	print FOUT "$tmp&nbsp;%</TD>\n";
	print FOUT "</TR>\n";
    }
    if ($tif != 0) {
	$tmp = int($tif*100/$nbimage);
	print FOUT "<TR>\n";
	print FOUT "<TD CLASS=\"left\">TIFF</TD><TD CLASS=\"right\">$tif</TD><TD CLASS=\"left\">";
	print FOUT "<img width=$tmp height=$square src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\">&nbsp;" if ($tmp != 0);
	print FOUT "$tmp&nbsp;%</TD>\n";
	print FOUT "</TR>\n";
    }
    if ($pnm != 0) {
	$tmp = int($pnm*100/$nbimage);
	print FOUT "<TR>\n";
	print FOUT "<TD CLASS=\"left\">PNM</TD><TD CLASS=\"right\">$pnm</TD><TD CLASS=\"left\">";
	print FOUT "<img width=$tmp height=$square src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\">&nbsp;" if ($tmp != 0);
	print FOUT "$tmp&nbsp;%</TD>\n";
	print FOUT "</TR>\n";
    }
    if ($xbm != 0) {
	$tmp = int($xbm*100/$nbimage);
	print FOUT "<TR>\n";
	print FOUT "<TD CLASS=\"left\">XBM</TD><TD CLASS=\"right\">$xbm</TD><TD CLASS=\"left\">\n";
	print FOUT "<img width=$tmp height=$square src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\">&nbsp;" if ($tmp != 0);
	print FOUT "$tmp&nbsp;%</TD>\n";
	print FOUT "</TR>\n";
    }
    print FOUT "</TABLE>\n";
}
    print FOUT "</TD></TR></TABLE>\n";

    print FOUT "</CENTER>\n";

    print FOUT "<P><DIV CLASS=\"item_page\">-&nbsp;<I>$L{'The_Top'} $topten $L{'most_graphic_pages'}</I></DIV><P>\n";

    print FOUT "<TABLE CLASS=\"sortable_base\" ID=\"docimage\">\n";
    print FOUT "<TR><TH>$L{'Pages'}</TH><TH>$L{'Images'}</TH></TR>\n";
    for ($i=0;$i < $boucleima;$i++) {
	print FOUT "<TR><TD CLASS=\"left\"><A HREF=\"$bestima[$i]\" TARGET=\"_top\" TITLE=\"$bestima[$i]\">$urlconv{$bestima[$i]}</A></TD><TD CLASS=\"right\">$occurima[$i]</TD></TR>\n" if ($occurima[$i] != 0);
    }
    print FOUT "</TABLE>\n";
    
    print FOUT "</BODY></HTML>";
}

###############################################################
###            pages les plus recentes                      ###
###############################################################

if ($url_new_doc == 1) {
    print "Newest HTML pages\n";
    print "<BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");

    for ($nblang=0;$nblang<=$#lang;$nblang++) {

	open(NEW,">$path$lang[$nblang]$dirsep$dirdocument$dirsep$new") || die &error_exit("Error, unable to open $path$lang[$nblang]$dirsep$dirdocument$dirsep$new");
	&DocNew(*NEW, eval($Lang{$lang[$nblang]}));
	close (NEW);
    }
}

sub DocNew {
    local(*FOUT,*L) = @_;
	
    print FOUT "$doctype\n";
    print FOUT "<HTML><HEAD>\n";
    print FOUT "$charset\n";
    print FOUT "<TITLE>$L{'Newest_pages'}</TITLE>\n";
    print FOUT "<!-- Page generated by w3perl - cron-url.pl $version - $today $hourdate -->\n";
    print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$helpjs\"></script>\n";
    print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$sorttablejs\"></script>\n";
    print FOUT "<link rel=\"stylesheet\" type=\"text/css\" href=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dircss$dirsepurl$css_w3perl\">\n";
    print FOUT "<link rel=\"stylesheet\" type=\"text/css\" href=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dircss$dirsepurl$css_help\">\n";
    print FOUT "</HEAD>\n";
    print FOUT "<BODY $backgrd TEXT=\"$custom_text\" LINK=\"$custom_link\" VLINK=\"$custom_vlink\">\n";

    print FOUT "<H2> $L{'Newest_pages'} $L{'since'} $modifjour $L{'days'}</H2>\n";
    print FOUT "<P><HR>\n";
    print FOUT "<CENTER><B>$today</B></CENTER>\n";
    print FOUT "<HR><P>\n";

    if ($max != 0) {
	print FOUT "<CENTER><TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0>\n";
	print FOUT "<TR>\n";
	print FOUT "<TD><IMG WIDTH=$xdecal HEIGHT=$ymax SRC=\"$linkrecentfiley\" ALT=\"y\"></TD>\n";
	print FOUT "<TD><IMG WIDTH=$xmax HEIGHT=$ymax SRC=\"$linkrecentfile\" ALT=\"graph\"></TD>\n";
	print FOUT "</TR><TR><TD></TD>\n";
	print FOUT "<TD><IMG WIDTH=$xmax HEIGHT=$ydecal SRC=\"$linkrecentfilex\" ALT=\"x\"></TD>\n";
	print FOUT "</TR>\n";
	print FOUT "</TABLE></CENTER>\n";
	print FOUT "<CENTER><B>$L{'Newest_pages_histogram'}</B></CENTER><P>\n";
	
	print FOUT "<P><HR><P>\n";
	print FOUT "<BLOCKQUOTE>\n";

	for ($j=0;$j<=$modifjour;$j++) {
	    $plusi = $j+1;
	    
	    $bouclemodif = $nbmodif{$j} if ($nbmodif{$j} < $topten);
	    $bouclemodif = $topten if ($nbmodif{$j} > $topten);
	    
	    if ($bouclemodif ne '') {
		print FOUT "<UL><LI><B>$bouclemodif $L{'hTML_pages'} $L{'modified_less_than'} $plusi $L{'days'} : </B><UL><BR>\n";
		for ($i=1;$i<=$bouclemodif;$i++) {
		    print FOUT "<LI><A HREF=\"$modif{$j,$i}\" TARGET=\"_top\" TITLE=\"$modif{$j,$i}\">$urlconv{$modif{$j,$i}}</A><BR>\n";
		}
		print FOUT "</UL></UL><P>\n";
	    }
	}
	print FOUT "</BLOCKQUOTE>\n";	
	print FOUT "<P><HR><P>\n";
	print FOUT "<I>$L{'Only_first'} $topten $L{'hTML_pages'} $L{'are_printed'}</I>\n" if ($bouclemodif == $topten);
	print FOUT "<P><HR><P>\n" if ($bouclemodif == $topten);
	
    } else {
	print FOUT "<CENTER><P><BR><B>$L{'No_modification'} $L{'since'} $modifjour $L{'days'} !</CENTER></b>\n";
    }
    
    print FOUT "</BODY></HTML>";
}

###############################################################
###                  compatibilite cdrom                    ###
###############################################################

if ($url_cdrom == 1) {
    print STDOUT "Website enable to be put on a CDROM ?\n";
    print "<BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");

    for ($nblang=0;$nblang<=$#lang;$nblang++) {
	
	open(CDROM,">$path$lang[$nblang]$dirsep$dirdocument$dirsep$cdrom") || die &error_exit("Error, unable to open $path$lang[$nblang]$dirsep$dirdocument$dirsep$cdrom");
	&Cdrom(*CDROM, eval($Lang{$lang[$nblang]}));
	close (CDROM);
    }
}

sub Cdrom {
    local(*FOUT,*L) = @_;

    print FOUT "$doctype\n";
    print FOUT "<HTML><HEAD>\n";
    print FOUT "$charset\n";
    print FOUT "<TITLE>$L{'Index_pages'}</TITLE>\n";
    print FOUT "<!-- Page generated by w3perl - cron-url.pl $version - $today $hourdate -->\n";
    print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$helpjs\"></script>\n";
    print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$sorttablejs\"></script>\n";
    print FOUT "<link rel=\"stylesheet\" type=\"text/css\" href=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dircss$dirsepurl$css_w3perl\">\n";
    print FOUT "<link rel=\"stylesheet\" type=\"text/css\" href=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dircss$dirsepurl$css_help\">\n";
    print FOUT "</HEAD>\n";
    print FOUT "<BODY $backgrd TEXT=\"$custom_text\" LINK=\"$custom_link\" VLINK=\"$custom_vlink\">\n";

    print FOUT "<H2> $L{'Index_pages'}</H2>\n";
    print FOUT "<P><HR><P>\n";

    print FOUT "$L{'You_should_add'} $defaulthomepage $L{'files_stored_locally_CD-ROM'}\n";
    print FOUT "<P>\n";

#for ($j=0;$j<=$#cdrom;$j++) {
#print FOUT "$cdrom[$j]<BR>\n";
#}
    
    $j = 0;
    $cdrombis[0] = $cdrom[0];
    print FOUT "<TABLE CLASS=\"sortable_base\" ID=\"cdrom\"><TR>";

    print FOUT "<TH CLASS=\"left\">$cdrombis[0]</TH>\n<TR><TD CLASS=\"left\"<I>\n";
    for ($k=1;$k<=$noindex{$cdrombis[$j]};$k++) {
	$filecdrom{$cdrombis[$j],$k} =~ s/$defaulthomepage//;
	print FOUT "$filecdrom{$cdrombis[$j],$k}\n";
    }
    print FOUT "</I></TD></TR>\n";

    for ($i=1;$i<=($#cdrom);$i++) {
	if ($cdrom[$i] ne $cdrom[$i-1]) {
	    $cdrombis[$j] = $cdrom[$i];
	    print FOUT "<TH CLASS=\"left\">$cdrombis[$j]</TH>\n<TR><TD CLASS=\"left\"><I>\n";
#	    print FOUT "<B>$cdrombis[$j]</B>\n<br><UL><I>\n";
	    for ($k=1;$k<=$noindex{$cdrombis[$j]};$k++) {
		$filecdrom{$cdrombis[$j],$k} =~ s/$defaulthomepage//;
		print FOUT "$filecdrom{$cdrombis[$j],$k}<BR>\n";
            }
	    print FOUT "</I></TD></TR>\n";
	    $j++;
	}
    }

    print FOUT "</TABLE><P>\n";	
    print FOUT "</BODY></HTML>";
}

undef @cdrom;

###############################################################
###                  pages inutiles                         ###
###############################################################

if ($url_useless == 1) {
    print STDOUT "Useless HTML pages (beta)\n";
    print "<BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");

#for ($i=0;$i<=$#imafind;$i++) {
#print "$i - $imafind[$i]\n";
#}

#print "---------------------\n";

#for ($i=0;$i<=$#imause;$i++) {
#print "$i - $imause[$i]\n";
#}

    grep($temp{$_}++,@imause);
    @imafind = grep(!$temp{$_},@imafind);

#print "@imafind\n";

    grep($temp{$_}++,@pageuse);
    @pagefind = grep(!$temp{$_},@pagefind);

    for ($nblang=0;$nblang<=$#lang;$nblang++) {
	open(USELESS,">$path$lang[$nblang]$dirsep$dirdocument$dirsep$useless") || die &error_exit("Error, unable to open $path$lang[$nblang]$dirsep$dirdocument$dirsep$useless");
	&DocUseless(*USELESS, eval($Lang{$lang[$nblang]}));
	close (USELESS);
    }
}

sub DocUseless {
    local(*FOUT,*L) = @_;

    print FOUT "$doctype\n";
    print FOUT "<HTML><HEAD>\n";
    print FOUT "$charset\n";
    print FOUT "<TITLE>$L{'Useless_pages'}</TITLE>\n";
    print FOUT "<!-- Page generated by w3perl - cron-url.pl $version - $today $hourdate -->\n";
    print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$helpjs\"></script>\n";
    print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$sorttablejs\"></script>\n";
    print FOUT "<link rel=\"stylesheet\" type=\"text/css\" href=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dircss$dirsepurl$css_w3perl\">\n";
    print FOUT "<link rel=\"stylesheet\" type=\"text/css\" href=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dircss$dirsepurl$css_help\">\n";
    print FOUT "</HEAD>\n";
    print FOUT "<BODY $backgrd TEXT=\"$custom_text\" LINK=\"$custom_link\" VLINK=\"$custom_vlink\">\n";

    print FOUT "<H2> $L{'Useless_pages'}</H2>\n";
#    print FOUT "<P><HR>\n";
#    print FOUT "<CENTER><B>$today</B></CENTER>\n";
    print FOUT "<HR><P>\n";

    print FOUT "<DIV CLASS=\"item_page\">-&nbsp; $L{'HTML_files'}</DIV><P>\n";

    print FOUT "$#pagefind $L{'pages_found_on_server'}<BR>\n";
    print FOUT "$#pageuse $L{'different_references_found'}<BR>\n";

    print FOUT "<P>\n";
    print FOUT "<TABLE CLASS=\"sortable_base\" ID=\"useless_page\"><TR>";
    print FOUT "<TH>$L{'Pages_never_used'} ($L{'no_reference_found'})</TH></TR>";

    for ($j=0;$j<=$#pagefind;$j++) {
#	$pagefind[$j] =~ s/$pathserver$dirsep// if ($type_serveur == 0);
#	$pagefind[$j] =~ s/$pathserver$dirsep$dirsep// if ($type_serveur == 1);
	$pagefind[$j] =~ s/$pathserver2//;
	print FOUT "<TR><TD CLASS=\"left\">$pagefind[$j]</TD></TR>\n";
    }

    print FOUT "</TABLE><P>\n";

    print FOUT "<DIV CLASS=\"item_page\">-&nbsp; $L{'Images'}</DIV><P>\n";

    print FOUT "$#imafind $L{'images_found_on_server'}<BR>\n";
    print FOUT "$#imause $L{'different_references_found'} <BR>\n";
    
    print FOUT "<P>\n";
    print FOUT "<TABLE CLASS=\"sortable_base\" ID=\"useless_image\"><TR>";
    print FOUT "<TH>$L{'Images_never_used'} ($L{'no_reference_found'})</TH></TR>";

    for ($j=0;$j<=$#imafind;$j++) {
#	$imafind[$j] =~ s/$pathserver$dirsep// if ($type_serveur == 0);
#	$imafind[$j] =~ s/$pathserver$dirsep$dirsep// if ($type_serveur == 1);	
	$imafind[$j] =~ s/$pathserver2//;
	print FOUT "<TR><TD CLASS=\"left\">$imafind[$j]</TD></TR>\n";
    }
	
    print FOUT "</TABLE><P>\n";
    print FOUT "</BODY></HTML>";
}

&update_homepage;

$datesyst = &ctime(time);
($dayletter,$month,$day,$hourdate,$a,$year) = split(/[ \t\n\[]+/,$datesyst);
($hour,$minute,$second) = split(/:/,$hourdate);

# calculer le temps mis pour le calcul
$endrun = "$hour:$minute:$second";

($hour,$min,$sec) = &timetaken($startrun,$endrun);

$endtime = time();
#printf STDOUT "Computing took %d CPU secondes\n",$endtime - $starttime;
#print "<BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");
print "Computing took";
print " $hour h" if ($hour > 0);
print " $min min $sec sec\n\n";
print "<P>" if ($ENV{'REQUEST_METHOD'} eq "GET");

&admin_goback if ($ENV{'REQUEST_METHOD'} eq "GET" && $opt_y eq '');

$today =~ s/ /\//g;

open(FILE,">>$history");
printf FILE "cron-url\t%s\t%s\t%s\t%d:%d:%d\n",$today,$startrun,$endrun,$hour,$min,$sec;
close(FILE);

#################################################################
####         subroutine for scanning each HTML page       #######
#################################################################

sub dodir {
    local($dir,$nlink,$symlinkdir) = @_;
    local($dev,$ino,$mode,$subcount);

    ($dev,$ino,$mode,$nlink) = stat('.') unless $nlink;

    return if (!(opendir(SOURCEDIR,$dir)));
    opendir(SOURCEDIR,$dir) || die &error_exit("Couldn't open directory $dir !!");
    local(@filenames) = readdir(SOURCEDIR);
    closedir(SOURCEDIR);

    @filenames = sort @filenames;
#    for (@filenames) {
#	print "$_ - $nlink\n";
#    }

    if ($nlink == 2 && $dirsep eq '/') {
#    if (($nlink == 0 && $dirsep eq '.') || ($nlink == 2 && $dirsep eq '/')) {    
#    if ($nlink == 2) {    
        for (@filenames) {
           next if $_ eq '.';
           next if $_ eq '..';
	   next if ($_ =~ /^#/);
	   next if ($_ =~ /^_/ && $type_serveur == 1);

	   $tmp = $_;
	   $tmp =~ s/\./\// if ($dirsep eq '.'); # acorn
#           $name = "$dir$dirsep$_";
		    $name = "$dir$dirsep$tmp";	   


		    if ($tmp eq $readme && -f $name) {
			open(README,"$name");
			$line = (<README>);
			close(README);
			print "Bypassing $dir$dirsepurl\n";
			print "<BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");
			$reject_dir = $dir if ($line =~ /^w3perl/i);
		    }

		    next if ($name =~ /$reject_dir/ && $reject_dir ne '');

           push(@linkfile,$name) if (-l $name);
#           next if (-l $name);
           next if ($name =~ /$excluderepert/i  && $excluderepert ne '');
           next if ($name =~ /^$path/);

	   $filepicwidth = 0;

           $nbdir++ unless $seen{$dir}++;
	   $fl = 0;
#           ($size)= (stat("$name")) [7];
		    $size = -s $name;
		    if ($size < 0) {
			$msg = "Problem with logfile size\n";
			$msg .= "You should upgrade to the latest Perl version to be able to handle file larger than 2 Gb\n";
			$msg .= "or split your logfile under the 2 Gb limit\n";
			&error_exit($msg);
		    }

#           if (m/$searchima/i && ($name !~ /^$path/)) {
           if (m/$searchima/i) {
               $nbimage++;
               $sizeimage += $size;
               push(@imafind,$name) unless $seen{$name}++;
      	       print TMP4 "$name $size\n";               
               $fl = 1;
               }

           if (m/$search/i) {
               $fl = 1;
               ($size,$mtime)= (stat("$_")) [7,9];
	       if ($size < 0) {
		   $msg = "Problem with logfile size\n";
		   $msg .= "You should upgrade to the latest Perl version to be able to handle file larger than 2 Gb\n";
		   $msg .= "or split your logfile under the 2 Gb limit\n";
		   &error_exit($msg);
	       }
               $nblink = 0;
               $nbima = 0;
	       $sizefile = 0;
               $countdoc++;
#               if ($name !~ /^$path/) {
		   push(@pagefind,$name) unless $seen{$name}++;
#		}
	
	       $slash_name = 0;
	       $pos = rindex($name,$dirsep);
	       while ($pos != -1) {
		   $slash_name++;
		   $pos = rindex($name,$dirsep,$pos-1);
	       }

	       if ($slash_name == $slash_pathserver) {
		   $pos = rindex($name,$dirsep);
		   $tmp = substr($name,0,$pos+1); 
		   if (!($seen_scan{$tmp}++)) {
		       print "Scanning $tmp\n"; 
		       print "<BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");
		   }
	       }

		print "\nLoading $name\n" if ($debug == 1);
		$data = '';
	       	$nameshort = $name;
	       	$nameshort =~ s/$pathserver$dirsep//;
#	       	$nameshort =~ s/$pathserver$dirsep// if ($type_serveur == 0);
#	       	$nameshort =~ s/$pathserver$dirsep$dirsep// if ($type_serveur == 1);
#		$nameshort =~ s/$pathserver2//;

		if (!(-r $name)) {
                print "Can't open file $name\n";
	    } else {			 
		open(FILE,$name);
		while (<FILE>) {
		    $refcom = 0;
		    $line = $_;

		    while ($line =~ m/<!--(.*)-->/) {
			$out = 0;
			$refcom = 1;
#			$line =~ s/<!--$1-->//;
			$line =~ s/<!--//;
			$line =~ s/-->//;
			$data .= $line if ($line !~ /=\".*$1.*\"/);
			$data .= $_ if ($line =~ /=\".*$1.*\"/);
		    }

		    if ($line =~ m/<!--/ && $refcom == 0) {
			$out = 1;
			$data .= $`;
		    }
		
		    if ($line =~ m/-->/ && $refcom == 0) {
			$out = 0;
			$data .= $';
			next;
		    }

		    next if ($out == 1);		
		
		    $data .= " " if ((!(/<.+"(.)+".+>/)) && ($1 eq ''));
		    $data .= $_ if ($refcom == 0);
		    $data .= $line if ($refcom == 1);
		}
		close (FILE);
	    }
		$data =~ s/\s*\^M\s*/ /g;
		$data =~ s/\n//g;
		$data =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
	       $data = &accent2html($data);

               ##### TITLE #####

		if ($data =~ m/<TITLE>([&;~:' \(\),"&@*#0-9a-z_\!\?\-\/\s.]+)<\/TITLE>/i) {
                $tmp = $1;

#		print OUTFILE "$name \"$tmp\" " if ($tmp ne '');
#		print OUTFILE "$name \"$dirsep$nameshort\" " if ($tmp eq '');

                $tmp =~ s/"/'/g;
		print "1 - Title $tmp pour $nameshort ....\n" if ($debug == 1);

		push(@doublon,$1) if ($seen{$1}++);
		$dou{$1}++;
		$filedoublon{$1,$dou{$1}} = $nameshort;

		print OUTFILE "$name \"$tmp" if ($tmp ne '');
		print OUTFILE "$name \"$dirsep$nameshort" if ($tmp eq '');
		print OUTFILE " (symlink)" if ($name =~ /$symlinkdir/);
		print OUTFILE "\" ";

		} else {
	               print OUTFILE "$name \"$dirsep$nameshort\" ";
		       push(@notitle,$nameshort) if ($name ne "$dirdocument$notitle");
		       }		

	       print OUTFILE "$nblink $nbima $size $mtime $sizefile\n" if ($name =~ /$pathserver$dirsep$packagename$dirsep/o);

	       # inutile de checker le logiciel de stats !

	       if ($name !~ /$pathserver$dirsep$packagename$dirsep/o) {
	        
               ##### BACKGROUND #####

		if ($data =~ m/<BODY.*BACKGROUND="([&;~#: 0-9a-z_\-\/.]*)".*>/i && $data !~ /<!--/) {
		print "1 - Background : $1 ($nameshort)\n" if ($debug == 1);

		&background($1,$name);
		$sizefile += $sizebkg;
		}
		
               ##### FORM ACTION #####

	        while ($data =~ m/<FORM([",a-z=\s\d]+)ACTION="([;~#&:*0-9a-z_\?\-\/.]+)"(["a-z=\s\d]*)>/i && $data !~ /<!--/) {

		   	print "1 - Form action : $1 ($nameshort)\n" if ($debug == 1);
			$temp3 = $2;
                       if (index($2,'/') == 0) {
                            $temp1 = $2;
			    if ($temp1 =~ /cgi-bin/i) {
				$temp2 = $temp1;
				$temp2 =~ s/\/cgi-bin\//$cgipath/;
				$temp2 =~ s/\?.*//;				
                                if (!(-e $temp2)) {
				   push(@nocgibin,$nameshort);
				   $nocgi{$nameshort}++;
				   $filecgimiss{$nameshort,$nocgi{$nameshort}} = $temp2;
#				   next;
			         }
			     }
			 }
			$temp3 =~ s/\?/\\?/g;
			$temp3 =~ s/\*/\\*/g;			
	 		$data =~ s/"$temp3"//i;			 
		   }

               ##### LINKS #####

		while (($data =~ /<[A|AREA]([",a-z=\s\d]+)HREF="([&;~: &*#0-9a-z_\?\-\/.]+)"([\(\)!';",_a-z=\s\d]*)>/i || $data =~ /<FRAME(["a-z=\s\d]+)SRC="([&;~#: 0-9a-z_\-\/.]+)"([\[\]#"a-z=\s\d]*)>/i) && $data !~ /<!--/) {
		print "1 - Liens : $2 ($nameshort)\n" if ($debug == 1);

		$uu = $2;					
		$delstring = $&;
		$delstring =~ s/\?/\\?/g;
                $delstring =~ s/\*/\\*/g;                	
                $delstring =~ s/\(/\\(/g;
                $delstring =~ s/\)/\\)/g;

		&html($uu,$name);
#		$data =~ s/$&//i;
		$data =~ s/$delstring//i;
		}	

               ##### FRAMES #####

		if ($data =~ /<FRAMESET/i) {
        	      push(@framed,$nameshort);
		  print FILEFRAME "$nameshort\n";
		}

               ##### IMAGES #####

		while ($data =~ /<IMG([#"a-z=\s\d]+)SRC="([\<\>\!&;~ :0-9a-z_\-\/.]+)"([\!\?\[\-\]#"a-z=_\s\d]*)>/i && $data !~ /<!--/) {
#				       if (!($seen_ima{"$2 $nameshort"}++)) {
	   	print "1 - Img src : $2 ($nameshort) $nbima\n" if ($debug == 1);

#		$uu = $2;
#                $delstring = $&;
                $nbima++;
#     if (!($seen{$temp}++)) {

		$searchwidth = $1.$3;	
	 	$filepicwidth = &ima($2,$searchima,$name); # if ($uu !~ /<!-/ && $uu !~ /-->/);
		$sizefile += $sizeima;
#		$data =~ s/$delstring//i;
#	    }
		$data =~ s/<IMG$1SRC="$2"([\!\?\[\-\]#"a-z=_\s\d]*)>//i;
		}		   	

        print OUTFILE "$nblink $nbima $size $mtime $sizefile\n";

	# fin de la boucle sur $packagename
	}

	print TMPWIDTH "</TABLE></TD></TR></TABLE><P>\n" if ($filepicwidth != 0);

        $totaref += $nblink;
        $totalima += $nbima;
        $totsize += $size;

	# fin de la boucle sur /$search/
	}

	if ($fl == 0 && (-f $name)) {
		$divsize += $size;
		$countdiv++;
		print TMP4 "$name $size\n";	
	   }
	       
		   	
	}
    }
    else {

       $subcount = $nlink-2 if ($dirsep eq "/");
        for (@filenames) {
           next if $_ eq '.';
           next if $_ eq '..';
	   next if ($_ =~ /^#/);           
	   next if ($_ =~ /^_/ && $type_serveur == 1);           
	   $tmp = $_;
	   $tmp =~ s/\./\// if ($dirsep eq '.'); # acorn
#           $name = "$dir$dirsep$_";
           $name = "$dir$dirsep$tmp";	   

		    if ($tmp eq $readme && -f $name) {
			open(README,"$name");
			$line = (<README>);
			close(README);
			print "Bypassing $dir$dirsepurl\n";
			print "<BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");
			$reject_dir = $dir if ($line =~ /^w3perl/i);
		    }

		    next if ($name =~ /$reject_dir/ && $reject_dir ne '');

           push(@linkfile,$name) if (-l $name);
#           next if (-l $name);
           next if ($name =~ /$excluderepert/i  && $excluderepert ne '');
           next if ($name =~ /^$path/);

	   $filepicwidth = 0;

           $nbdir++ unless $seen{$dir}++;
#           ($size)= (stat("$name")) [7];
		    $size = -s $name;
		    if ($size < 0) {
			$msg = "Problem with logfile size\n";
			$msg .= "You should upgrade to the latest Perl version to be able to handle file larger than 2 Gb\n";
			$msg .= "or split your logfile under the 2 Gb limit\n";
			&error_exit($msg);
		    }

           $fl = 0;
           
#           if (m/$searchima/i && ($name !~ /^$path/)) {
           if (m/$searchima/i) {
#           ($size)= (stat("$_")) [7];
           $sizeimage += $size;
           $nbimage++;
           push(@imafind,$name) unless $seen{$name}++;
      	   print TMP4 "$name $size\n";
           $fl = 1;
           }

           if (m/$search/i) {
           ($size,$mtime)= (stat("$_")) [7,9];
	   if ($size < 0) {
	       $msg = "Problem with logfile size\n";
	       $msg .= "You should upgrade to the latest Perl version to be able to handle file larger than 2 Gb\n";
	       $msg .= "or split your logfile under the 2 Gb limit\n";
	       &error_exit($msg);
	   }
               $fl = 1;
               $nblink = 0;
               $nbima = 0;
	       $sizefile = 0;
               $countdoc++;
#               if ($name !~ /^$path/) {
		   push(@pagefind,$name) unless $seen{$name}++;
#		}
		
	       $nameshort = $name;
	       $nameshort =~ s/$pathserver$dirsep//;
#	       $nameshort =~ s/$pathserver$dirsep// if ($type_serveur == 0);
#	       $nameshort =~ s/$pathserver$dirsep$dirsep// if ($type_serveur == 1);	       
#		$nameshort =~ s/$pathserver2//;

	       $slash_name = 0;
	       $pos = rindex($name,$dirsep);
	       while ($pos != -1) {
		   $slash_name++;
		   $pos = rindex($name,$dirsep,$pos-1);
	       }

	       if ($slash_name == $slash_pathserver) {
		   $pos = rindex($name,$dirsep);
		   $tmp = substr($name,0,$pos+1); 
		   if (!($seen_scan{$tmp}++)) {
		       print "Scanning $tmp\n"; 
		       print "<BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");
		   }
	       }


		$data = '';
		print "\n2 - Loading $name\n" if ($debug == 1);
		if (!(-r $name)) {
                print "Can't open file $name\n";
	    } else {
		open(FILE,$name);
		while (<FILE>) {
		    $refcom = 0;
		    $line = $_;

		    while ($line =~ m/<!--(.*)-->/) {
			$out = 0;
			$refcom = 1;
#			print "$1 - $&\n";
#			$line =~ s/<!--$1-->//;
			$line =~ s/<!--//;
			$line =~ s/-->//;
			$data .= $line if ($line !~ /=\".*$1.*\"/);
			$data .= $_ if ($line =~ /=\".*$1.*\"/);
		    }

		    if ($line =~ m/<!--/ && $refcom == 0) {
			$out = 1;
			$data .= $`;
		    }
		
		    if ($line =~ m/-->/ && $refcom == 0) {
			$out = 0;
			$data .= $';
			next;
		    }

		    next if ($out == 1);		
		
		    $data .= " " if ((!(/<.+"(.)+".+>/)) && ($1 eq ''));
		    $data .= $_ if ($refcom == 0);
		    $data .= $line if ($refcom == 1);
		}
		close (FILE);
	    }
		$data =~ s/\s*\^M\s*/ /g;		
		$data =~ s/\n//g;
		$data =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
	       $data = &accent2html($data);
		
                ##### TITLE #####

		if ($data =~ m/<TITLE>([&;~:' \(\),"&@*#0-9a-z_\!\?\-\/\s.]+)<\/TITLE>/i) {

                $tmp = $1;
                $tmp =~ s/"/'/g;
		print "2 - Title $tmp pour $nameshort ....\n" if ($debug == 1);

		push(@doublon,$1) if ($seen{$1}++);
		$dou{$1}++;                                      # utile ?
		$filedoublon{$1,$dou{$1}} = $nameshort;          # utile ? pas de test ?

		print OUTFILE "$name \"$tmp" if ($tmp ne '');
		print OUTFILE "$name \"$dirsep$nameshort" if ($tmp eq '');
		print OUTFILE " (symlink)" if ($name =~ /$symlinkdir/);
		print OUTFILE "\" ";

		} else {
	              print OUTFILE "$name \"$dirsep$nameshort\" ";
        	      push(@notitle,$nameshort) if ($name ne "$dirdocument$notitle");
        	      }

       	       print OUTFILE "$nblink $nbima $size $mtime $sizefile\n" if ($name =~ /$pathserver$dirsep$packagename$dirsep/o);

	       # inutile de checker le logiciel de stats !
	       if ($name !~ /$pathserver$dirsep$packagename$dirsep/o) {

               ##### BACKGROUND #####

		if ($data =~ m/<BODY.*BACKGROUND="([&;~#: 0-9a-z_\-\/.]*)".*>/i && $data !~ /<!--/) {
		print "2 - Background : $1 ($nameshort)\n" if ($debug == 1);

		&background($1,$name);
		$sizefile += $sizebkg;
		}
		
               ##### FORM ACTION #####

	        while ($data =~ m/<FORM([",a-z=\s\d]+)ACTION="([;~#&:*0-9a-z_\?\-\/.]+)"(["a-z=\s\d]*)>/i && $data !~ /<!--/) {
			
		   	print "2 - Form action : $1 - $2  ($nameshort)\n" if ($debug == 1);			 

		   	$temp3 = $2;

                       if (index($2,'/') == 0) {
                            $temp1 = $2;
			    if ($temp1 =~ /cgi-bin/i) {
				$temp2 = $temp1;
				$temp2 =~ s/\/cgi-bin\//$cgipath/;
				$temp2 =~ s/\?.*//;
                                if (!(-e $temp2)) {
				   push(@nocgibin,$nameshort);
				   $nocgi{$nameshort}++;
				   $filecgimiss{$nameshort,$nocgi{$nameshort}} = $temp2;
#				   next;
			         }
			     }
			 }
			$temp3 =~ s/\?/\\?/g;
			$temp3 =~ s/\*/\\*/g;			
	 		$data =~ s/"$temp3"//i;
		   }

               ##### LINKS #####

		while (($data =~ /<[A|AREA]([",a-z=\s\d]+)HREF="([&;~: &*#0-9a-z_\?\-\/\<\>\!.]+)"([\(\)!';",_a-z=\s\d]*)>/i || $data =~ /<FRAME(["a-z=\s\d]+)SRC="([&;~#: 0-9a-z_\-\/.]+)"([\[\]#"a-z=\s\d]*)>/i) && $data !~ /<!--/) {

		print "2 - Liens : $2 ($nameshort)\n" if ($debug == 1);
		$uu = $2;
                $delstring = $&;
                $delstring =~ s/\?/\\?/g;
                $delstring =~ s/\*/\\*/g;
                $delstring =~ s/\(/\\(/g;
                $delstring =~ s/\)/\\)/g;

		&html($uu,$name);
#		$data =~ s/<[A|AREA]$1HREF="$2"$3>//i;
		$data =~ s/$delstring//i;
		}	

               ##### FRAMES #####

		if ($data =~ /<FRAMESET/i) {
        	      push(@framed,$nameshort);
		      print FILEFRAME "$nameshort\n";
		}
				
               ##### IMAGES #####

		while ($data =~ /<IMG([#"a-z=\s\d]+)SRC="([&;~: 0-9a-z_\-\/\>\<\!.]+)"([\!\?\[\-\]#"a-z=_\s\d]*)>/i && $data !~ /<!--/) {
		      print "2 - Img src : $2 $& ($nameshort)\n" if ($debug == 1);

#		$uu = $2;
#                $delstring = $&;
		      $nbima++;
		      $searchwidth = $1.$3;
		      $filepicwidth = &ima($2,$searchima,$name); # if ($uu !~ /<!-/ && $uu !~ /-->/);
#		$data =~ s/$delstring//i;
		      $data =~ s/<IMG$1SRC="$2"([\!\?\[\-\]#"a-z=_\s\d]*)>//i;
                      $sizefile += $sizeima;		
		 }

	print OUTFILE "$nblink $nbima $size $mtime $sizefile\n";

	# fin de la boucle sur $packagename
	}		

	print TMPWIDTH "</TABLE></TD></TR></TABLE><P>\n" if ($filepicwidth != 0);

        $totaref += $nblink;
        $totalima += $nbima;
        $totsize += $size;


	# fin de la boucle sur /$search/
	}

	if ($fl == 0 && (-f $name)) {
		$divsize += $size;
		$countdiv++;
		print TMP4 "$name $size\n";
	              }
		   	
        next if (($subcount == 0) && ($dirsep eq "/"));

	# Allow to follow symbolic link

          ($dev,$ino,$mode,$nlink) = lstat($_); # if ($dirsep eq '/');
				      
#				      next if ($mode == );
#	   next if ((!(-d $_)) && (!(-l $_)));

	   next if (!(-d $_));
#	   next if (-l $_); # symlink can go outside web area

	   next if (-l $_);				      
#	   if (-l $_) {
#	       next if (readlink($_) =~ /^\// && readlink($_) !~ /^$pathserver/);
#	       next if (readlink($_) =~ /^\.\./);
#	   }
#	   next if (-l $_ && readlink("$dir$dirsep$_") !~ /^$pathserver/); # symlink can go outside web area
				      
           if (!(-r $_) || !(-x $_)) {
	       push(@protected_dir,"$dir$dirsep$_"); # unless $seen_dir{$_}++;
	       next;
	   }

	   $symlinkdir = $name if (-l $_);

	   chdir $_ || die &error_exit("CC - Can't cd to $name");
           &dodir($name,$nlink,$symlinkdir);

           chdir '..';
           --$subcount;

#          if ($chok == 1) {
#	      &dodir($name,$nlink,$symlinkdir);
#	      chdir '..';
#	      --$subcount;
#	  } else {
#	      print "CC - Can't cd to $name\n";
#	  }

}
}
}

#################################################################
####         subroutine to check BACKGROUND link            #####
#################################################################

sub background {
    local($background_file,$name) = @_;
	
    # lien relatif sans remontee de repertoire

    $linkfile = $background_file;
    $pospoint = rindex($name,$dirsep,length($name));
    $name2 = substr($name,0,$pospoint+1);
                            
    if (index($background_file,'.') != 0) {
	$temp1 = $name2.$background_file;
	
	# lien absolu

	if (index($background_file,'/') == 0) {
	    $temp1 = $pathserver.$background_file;
	    $temp1 =~ s/~(\w+)\///;
	}
    }

    # lien relatif commencant par un ..

    if (index($background_file,'.') == 0) {
	$temp1 = $background_file;
	while ($temp1 =~ m/^\.\.\//) {
	    $pospoint = rindex($name2,$dirsep,length($name2)-2);
	    $name2 = substr($name2,0,$pospoint+1);
	    $temp1 =~ s/\.\.\///;
	}
	$temp1 = $name2.$temp1;
    }

    $sizebkg = -s $temp1;
    if ($sizebkg < 0) {
	$msg = "Problem with logfile size\n";
	$msg .= "You should upgrade to the latest Perl version to be able to handle file larger than 2 Gb\n";
	$msg .= "or split your logfile under the 2 Gb limit\n";
	&error_exit($msg);
    }

    if ($dirsep eq ".") {
	$temp1 =~ s/$dirsepurl/\./g ;
	if ($temp1 !~ /$dirsepurl$/) { # && $temp1 =~ /$searchima/) {
	    $temp1 =~ s/(.*)\.(.*)$/$1$dirsepurl$2/;
	}
    }
    
    # NT
    
    $temp1 =~ s/$dirsepurl/\\/g if ($type_serveur == 1);
    $temp1 =~ s/#.*//;

    if (-e $temp1 && !(-r $temp1)) {
	push(@protected_files,$temp1) unless $seen_protected{$temp1}++;
	print "Can't read $temp1 : seems to be a protected file\n" if ($debug == 1);
    }
		     	                            
    if (!(-e $temp1)) {
        $done = ($temp1 =~ s/$pathserver2//);
	$temp1 = "Security restriction for '$linkfile' - outside root server !" if ($done eq '');
        push(@noback,$nameshort);
        $back{$nameshort}++;
        $filebackmiss{$nameshort,$back{$nameshort}} = $temp1;
    }

    push(@imause,$temp1);
                       
}
             
#################################################################
####      subroutine to check FRAME and HREF links          #####
#################################################################

sub html {
	local($linkfile,$name) = @_;

        $nblink++;
        $absolute = 0;

	$linkfile =~ s/\?.*//;
	return if ($linkfile =~ /^\#.*/);	
	return if ($linkfile =~ /^mailto:/);

	### lien interne au serveur web
							
        if ($linkfile !~ /:\/\//i) {

               $pospoint = rindex($name,$dirsep,length($name));
               $name2 = substr($name,0,$pospoint+1);

               if (index($linkfile,'.') != 0) {
                        $temp1 = $name2.$linkfile;
                        $temp1 .= $defaulthomepage if (substr($temp1,length($temp1)-1) eq "/");

			### lien absolu

                        if (index($linkfile,'/') == 0) {
                               $temp1 = $linkfile;
			       $absolute = 1;

			       ##### BEGIN - CGI-BIN #####

			       if ($temp1 =~ /cgi-bin/i) {
			           $absolute = 0;			       
				   $temp2 = $temp1;
				   $temp2 =~ s/\/cgi-bin\//$cgipath/;
				   
                                   if (!(-e $temp2)) {
				        push(@nocgibin,$nameshort);
				        $nocgi{$nameshort}++;
				        $filecgimiss{$nameshort,$nocgi{$nameshort}} = $temp2;
#					$delstring = "$tmp2$linkfile"
#				        $data =~ s/$tmp2$linkfile"//i;
#				        next;
			           }
			       }

			       ##### END - CGI-BIN #####

                               $temp1 =~ s/~(\w+)\///;
                               $temp1 = $pathserver.$temp1;
			  }
               }

	       # lien relatif
			
               if (index($linkfile,'.') == 0) {
                       $temp1 = $linkfile;
                       $temp1 .= $defaulthomepage if (substr($temp1,length($temp1)-1) eq "/");

                        while ($temp1 =~ m/^\.\.\//) {
                             $pospoint = rindex($name2,$dirsep,length($name2)-2);
                             $name2 = substr($name2,0,$pospoint+1);
                             $temp1 =~ s/\.\.\///;
                        }
                        $temp1 = $name2.$temp1;
                }

		$temp2 = $temp1;
                $temp2 =~ s/#.*//;

#		print "$temp2\n";

		# NT

		$temp1 =~ s/$dirsepurl/\\/g if ($type_serveur == 1);
		$temp2 = $temp1 if ($type_serveur == 1);
				
                # Acorn
                
		if ($dirsep eq ".") {
		$temp1 =~ s/$dirsepurl/\./g ;
			if ($temp1 !~ /$dirsepurl$/ && $temp1 =~ /$search/) {
			$temp1 =~ s/(.*)\.(.*)$/$1$dirsepurl$2/;
			}
		$temp2 = $temp1;
		}
		                
		# detection des liens sans $defaulthomepage pour les cdrom (ou local web)
	       $temp2 =~ s/#.*//;
			
		if (substr($linkfile,length($linkfile)-1) eq "/" && (-e $temp2)) {
		  $done = ($temp1 =~ s/$pathserver2//);
		  $temp1 = "Security restriction for '$linkfile' - outside root server !" if ($done eq '');
			push(@cdrom,$nameshort);
                        $noindex{$nameshort}++;
                        $filecdrom{$nameshort,$noindex{$nameshort}} = $temp1;
                }


                if ((!(-e $temp2)) && ($linkfile !~ /cgi-bin/i) && ($nameshort !~ /\/$packagename\/$dirdocs/o)) {
#			  $temp1 =~ s/$pathserver2// if ($type_serveur == 0);
#			  $temp1 =~ s/$pathserver2$dirsep$dirsep// if ($type_serveur == 1);			  
			  $done = ($temp1 =~ s/$pathserver2//);
			  $temp1 = "Security restriction for '$linkfile' - outside root server !" if ($done eq '');
                           push(@nofile,$nameshort);
                           $no{$nameshort}++;
                           $filemiss{$nameshort,$no{$nameshort}} = $temp1;
                           
			   if ($absolute == 1) {
			       push(@absolute,$nameshort);
                               $ab{$nameshort}++;
                               $fileabs{$nameshort,$ab{$nameshort}} = $temp1;
			       $absolute = 0;
                            }
                            
                 } else {
			if ($linkfile =~ m/$searchima$/i) {
			        push(@imause,$temp1) unless $seen{$temp1}++;
		        } else {
#			     push(@pageuse,$temp2) unless ((($temp1 =~ /#.*/) && ($name eq $temp2)) || $seen{$temp2}++);
                             push(@pageuse,$temp2) unless (($temp1 =~ /#.*/) && ($name eq $temp2));
			}
		}
     }

#return($delstring);

        if ($linkfile =~ m#^http:\/\/([\w-\.]+):?(\d*)($|/(.*))#i) {
        	if ($1 =~ /$localserver$tripart/i) {
#        		$temp1 = $1;
#                        $temp1 =~ s/$localserver$tripart//;
#                        $temp1 = $pathserver.$temp1;
			push(@absolute,$nameshort);
                        $ab{$nameshort}++;
                        $fileabs{$nameshort,$ab{$nameshort}} = $linkfile;
                        print "$linkfile\n" if ($debug == 1);
                        
        	}

		if ($opt_a == 1) {
        		$port = $2;
			$link = $3;
			$link = "/" if ($path eq "");
			$port = 80 if ($port eq "");

            	        next if (defined($HTTPStatusList{$linkfile}));
			$rcode = &check_external_link($1,$port,$link);
	    	        $HTTP_Fail_html{$linkfile} = $rcode if (defined($FailStatusMsgs{$rcode}));
	     	        print "$linkfile ($name) : $FailStatusMsgs{$rcode}\n" if (defined($FailStatusMsgs{$rcode}));	        
	     	        $HTTPStatusList{$linkfile} = $rcode;
        	}
        	
        }
        
#        if ($linkfile =~ m#^http:\/\/([\w-\.]+):?(\d*)($|/(.*))#i && $opt_a == 1) {
#        	$port = $2;
#		$link = $3;
#		$link = "/" if ($path eq "");
#		$port = 80 if ($port eq "");
#
#                next if (defined($HTTPStatusList{$linkfile}));
#		$rcode = &check_external_link($1,$port,$link);
#	        $HTTP_Fail_html{$linkfile} = $rcode if (defined($FailStatusMsgs{$rcode}));
#	        print "$linkfile ($name) : $FailStatusMsgs{$rcode}\n" if (defined($FailStatusMsgs{$rcode}));	        
#	        $HTTPStatusList{$linkfile} = $rcode;
#        }

}


#################################################################
####         subroutine to check external links             #####
#################################################################

# code by Darryl Burgdorf <burgdorf@awsd.com> from his webtester.pl script
# http://awsd.com/scripts/

sub check_external_link {
    local($host,$port,$path) = @_;
    local($name,$aliases,$proto,$type,$len,$protocol,$status);
    local($thisaddr,$thataddr,$this,$that,$response);
    
    $SOCK_STREAM = 1;	
    ($name,$aliases,$proto) = getprotobyname('tcp');
    ($name,$aliases,$port) = getservbyname($port,'tcp') unless $port =~ /^\d+$/;
    ($name,$aliases,$type,$len,$thisaddr) = gethostbyname($hostname);
    if (!(($name,$aliases,$type,$len,$thataddr) = gethostbyname($host))) {
	return -1;
    }
    $this = pack($sockaddr, $AF_INET, 0, $thisaddr);
    $that = pack($sockaddr, $AF_INET, $port, $thataddr);
    if (!(socket(S, $AF_INET, $SOCK_STREAM, $proto))) {
	$SOCK_STREAM = 2;
	if (!(socket(S, $AF_INET, $SOCK_STREAM, $proto))) { return -2; }
    }
    if (!(bind(S, $this))) {
	return -3;
    }
    if (!(connect(S,$that))) {
	return -4;
    }
    select(S); $| = 1; select(STDOUT);
    print S "HEAD $path HTTP/1.0\n\n";
    $response = <S>;
    ($protocol, $status) = split(/ /, $response);
    close(S);
    return $status;	
}

#################################################################
####         subroutine to check IMG tag                    #####
#################################################################

sub ima {
    local($linkfile,$searchima,$name) = @_;
    local($temp1);

    print "$linkfile $name\n" if ($debug == 2);

#    if ($linkfile !~ /:\/\//i) {
	
#	if ($linkfile !~ /\\_/ && $type_serveur != 1) {
	if ($linkfile !~ /\\_/) {

	    $pospoint = rindex($name,$dirsep,length($name));
	    $name2 = substr($name,0,$pospoint+1);
	    
	    if (index($linkfile,'.') != 0) {
		$temp1 = $name2.$linkfile;
		
		if (index($linkfile,'/') == 0) {
		    $temp1 = $linkfile;
		    $temp1 =~ s/~(\w+)\///;
		    $temp1 = $pathserver.$temp1;
		}
	    }

	    if (index($linkfile,'.') == 0) {
		$temp1 = $linkfile;
		while ($temp1 =~ m/^\.\.\//) {
		    $pospoint = rindex($name2,$dirsep,length($name2)-2);
		    $name2 = substr($name2,0,$pospoint+1);
		    $temp1 =~ s/\.\.\///;
		}
		$temp1 = $name2.$temp1;
	    }

	    # Acorn

	    if ($dirsep eq ".") {
		$temp1 =~ s/$dirsepurl/\./g ;
		if ($temp1 !~ /$dirsepurl$/) { # && $temp1 =~ /$searchima/) {
		    $temp1 =~ s/(.*)\.(.*)$/$1$dirsepurl$2/;
		}
	    }


	    # NT

	    $temp1 =~ s/$dirsepurl/\\/g if ($type_serveur == 1);
	    $temp1 =~ s/#.*//;

#		$temp1 =~ s/$dirsepurl/\./g if ($dirsep eq ".");
#		if ($dirsep eq "." && $temp1 !~ /$dirsepurl$/) {
#		$temp1 =~ s/(.*)\.(.*)$/$1$dirsepurl$2/;
#		}

#		print "ZOZO $temp1\n";

	    if ((!(-e $temp1)) && ($nameshort !~ /\/$packagename\/$dirdocs/o)) {
#			      $temp1 =~ s/$pathserver$dirsep// if ($type_serveur == 0);
#			      $temp1 =~ s/$pathserver$dirsep$dirsep// if ($type_serveur == 1);			      
		$done = ($temp1 =~ s/$pathserver2//);
		$temp1 = "Security restriction for '$linkfile' - outside root server !" if ($done eq '');
		push(@noima,$nameshort);
		$noima{$nameshort}++;
		$imamiss{$nameshort,$noima{$nameshort}} = $temp1;

		if (index($linkfile,'/') == 0) {
		    push(@absoluteima,$nameshort);
		    $abima{$nameshort}++;
		    $fileimaabs{$nameshort,$abima{$nameshort}} = $temp1;
		}
		
	    }

	    if (-f $temp1 && !(-r $temp1)) {
		push(@protected_files,$temp1) unless $seen_protected{$temp1}++;
		print "Can't read $temp1 : seems to be a protected file\n" if ($debug == 1);
	    }

	    if (-f $temp1 && -r $temp1) {

		$sizeima = -s $temp1;
		if ($sizeima < 0) {
		    $msg = "Problem with logfile size\n";
		    $msg .= "You should upgrade to the latest Perl version to be able to handle file larger than 2 Gb\n";
		    $msg .= "or split your logfile under the 2 Gb limit\n";
		    &error_exit($msg);
		}

		if (($searchwidth =~ /WIDTH/i) || ($searchwidth =~ /HEIGHT/i)) {
		    $x1 = '-';
		    $y1 = '-';
		    $x1 = $1 if ($searchwidth =~ /WIDTH=["]?(\d+)["]?/i);
		    $y1 = $1 if ($searchwidth =~ /HEIGHT=["]?(\d+)["]?/i);
		    ($x,$y) = &imaxy($temp1);
		    $urltmp = $name;
		    $urltmp =~ s/$pathserver$dirsep// if ($type_serveur == 0);
		    $urltmp =~ s/$pathserver$dirsep$dirsep// if ($type_serveur == 1);	    
		    $temptmp = $temp1;
		    $temptmp =~ s/$pathserver$dirsep// if ($type_serveur == 0);
		    $temptmp =~ s/$pathserver$dirsep$dirsep// if ($type_serveur == 1);	    
		    print TMPWIDTH2 "$urltmp\t$temptmp\t$linkfile\t$x1\t$y1\t$x\t$y\n" if ($x1 != $x || $y1 != $y);
		}

		if (($searchwidth !~ /WIDTH/i) || ($searchwidth !~ /HEIGHT/i)) {
		    $countwidth++;	
		    if (!($seen{"$name $linkfile"}++)) {
			if ($filepicwidth == 0) {
			    $filepicwidth = 1;
			    $nowidth++;
			    $urltmp = $name;
			    $urltmp =~ s/$pathserver$dirsep// if ($type_serveur == 0);
			    $urltmp =~ s/$pathserver$dirsep$dirsep// if ($type_serveur == 1);		  
			    print TMPWIDTH "<TABLE><TR><TH COLSPAN=4>$urltmp</TH></TR>\n";
#      	          print TMPWIDTH "$urltmp\n";
			    print TMPWIDTH "<TR><TD>\n";
			    print TMPWIDTH "<TABLE CLASS=\"sortable_base\" ID=\"$urltmp\"><TR><TH>Image</TH><TH>Link</TH><TH>WIDTH</TH><TH>HEIGHT</TH></TR>\n";
			}
			($x,$y) = &imaxy($temp1);
			$temptmp = $temp1;
			$temptmp =~ s/$pathserver$dirsep// if ($type_serveur == 0);
			$temptmp =~ s/$pathserver$dirsep$dirsep// if ($type_serveur == 1);	       
			print TMPWIDTH "<TR>\n";
			print TMPWIDTH "<TD CLASS=\"left\">" if (($nowidth/2) == int($nowidth/2));
			print TMPWIDTH "<TD CLASS=\"left_alter\">" if (($nowidth/2) != int($nowidth/2));
			print TMPWIDTH "$temptmp</TD>\n";
			print TMPWIDTH "<TD CLASS=\"left\">" if (($nowidth/2) == int($nowidth/2));
			print TMPWIDTH "<TD CLASS=\"left_alter\">" if (($nowidth/2) != int($nowidth/2));
			print TMPWIDTH "$linkfile</TD>\n";
			print TMPWIDTH "<TD CLASS=\"right\">" if (($nowidth/2) == int($nowidth/2));
			print TMPWIDTH "<TD CLASS=\"right_alter\">" if (($nowidth/2) != int($nowidth/2));
			print TMPWIDTH "$x</TD>\n";
			print TMPWIDTH "<TD CLASS=\"right\">" if (($nowidth/2) == int($nowidth/2));
			print TMPWIDTH "<TD CLASS=\"right_alter\">" if (($nowidth/2) != int($nowidth/2));
			print TMPWIDTH "$y</TD></TR>\n";
			$uniqwidth++;
		    }
		}

		print TMPWIDTH3 "$name\t$linkfile\n" if (($searchwith !~ /ALT/i) && (!($seen{"$name $temp1 $linkfile"}++)));

		push(@imause,$temp1);

		if ($linkfile =~ m#^http:\/\/([\w-\.]+):?(\d*)($|/(.*))#i) {
		    if ($1 =~ /$localserver$tripart/i) {
			push(@absoluteima,$nameshort);
			$abima{$nameshort}++;
			$fileimaabs{$nameshort,$abima{$nameshort}} = $linkfile;        	
			print "$linkfile\n" if ($debug == 1);
		    }

		    if ($opt_a == 1) {
			$port = $2;
			$link = $3;
			$link = "/" if ($path eq "");
			$port = 80 if ($port eq "");
			
			next if (defined($HTTPStatusList{$linkfile}));
			$rcode = &check_external_link($1,$port,$link);
			$HTTP_Fail_html{$linkfile} = $rcode if (defined($FailStatusMsgs{$rcode}));
			print "$linkfile ($name) : $FailStatusMsgs{$rcode}\n" if (defined($FailStatusMsgs{$rcode}));	        
			$HTTPStatusList{$linkfile} = $rcode;
		    }
		}

	    }

#     ($size)+= (stat("$temp1")) [7];

#     $mostsize{$nameshort} += $size;
#		print STDERR "$temp1 $nameshort $size\n";
	}
#    }
         
    return ($filepicwidth);
}

#################################################################
####     subroutine to find width and height for IMG tag    #####
#################################################################

sub read_string {
    local($str) = '';
    local($buf);
    local($*) = 1;
    do {
        if ($_[0] =~ s/^\s*(\S+)(\s+)/$2/) {
            $str = $1;
            if (substr($str,0,1) eq '#') {
                $str = '';
                $_[0] =~ s/^[^\n\r]*//;
                until ($_[0]) {
                    read(IN, $_[0], 256);
                    $_[0] =~ s/^[^\n\r]*//;
                }
            }
        } else {
            read(IN, $buf, 256);
            $_[0] .= $buf;
        }
    } until ($str);
    $str;
}

