#!/usr/bin/perl
# <plaintext>  just in case you look at this via a browser

#########################################################################
####                                                                #####
####                     W3PERL LIBRAIRY                            #####
####                                                                #####
####                                                                #####
####    domisse@w3perl.com                   version 18/09/2007     #####
####                                                                #####
#########################################################################

$car = substr($pathserver,1,1);
$nt = 1 if ($car eq ':');

unless (defined $perlpath) {
    open(ME,$0) || die "Can't open $0\n";
    $perlpath = <ME>;
    chop($perlpath);
    close(ME);
    $perlpath =~ s/\#\!//;
}

### Check Geographic IP mapping modules

&check_module("Geo::IPfree","Can't resolve IP address","Get country code from IP") if ($geoip_free == 1);
&check_module("Geo::IP","Can't resolve IP address","Get country code from IP") if ($netgeo == 1);
&check_module("MIME::Lite","Can't send email","Email report") if ($enable_email == 1);
&check_module("DBI","Can't connect to a database","Database connector") if ($spip == 1);

#use ExtUtils::Installed;
#my $instmod = ExtUtils::Installed->new();
#foreach my $module ($instmod->modules()) {
#my $version = $instmod->version($module) || "???";
#       print "$module -- $version\n";
#}


### Check mail modules

# If all modules installed, default would be the last one
#@mail_module = ("Mail::Sendmail","MIME::Lite");
#@mail_module = ("MIME::Lite");

#if ($enable_email == 1) {
#    $perl_mail_module = &check_mail_module(@mail_module);
#    &check_module($perl_mail_module,"Can't send email report");
#    if ($perl_mail_module eq '') {
#	&error_exit("No perl module found to send mail");
#    }
#}

#sub check_mail_module {
#    local(@list_module) = @_;
#    local($i,$found_mail_module,$mail_module);

#    $found_mail_module = 0;
#    $mail_module = '';
#    for ($i=0;$i<=$#list_module;$i++) {
#	$commit = system("$perlpath -e 'use $list_module[$i]'\n");
#	if ($commit == 0) {
#	    $found_mail_module = 1;
#	    $mail_module = $list_module[$i];
#	}
#    }
#    return $mail_module;
#}


sub check_module {
    local($module,$msg,$fonction) = @_;

    eval("use $module");
    if ($@) {
	$msg = "\n$module module missing : $msg !\n\n";
	$msg .= "1) If you want to install the $module module : \n";
	if ($nt == 1) {
	    $msg .= " Go to your Perl installation path (usually C:\Perl) and type :\n";
	    $msg .= "'ppm'\n";
	    $msg .= "At the prompt 'PPM>' type :\n";
	    $msg .= "'install $module'\n\n"; 
	}
	if ($nt == 0) {
	    $msg .= " Use CPAN to download the required modules, type :\n";
	    $msg .= "'perl -MCPAN -e shell'\n";
	    $msg .= "At the prompt 'cpan>' type :\n";
	    $msg .= "'install $module'\n\n";
	}
	if ($spip == 1) {
	    $msg .= "Then the module according to your database\n";
	    $msg .= "'install DBD-mysql'\n"; 
	    $msg .= "(for mysql database)\n";
	}
	$msg .= "2) or you can choose to disable '$fonction' in your configuration file\n";
	&error_exit($msg);
    } else {
#	require $module;
	if ($enable_email == 1) {
#	    if ($perl_mail_module eq "MIME::Lite") {
	    require MIME::Lite;
#	    }
	}
	if ($netgeo == 1) {
	    require Geo::IP;
	}
	if ($geoip_free == 1) {
	    require Geo::IPfree;
	}
    }
}

1;
