#!/usr/bin/perl
# <plaintext>  just in case you look at this via a browser

#########################################################################
####                                                                #####
####                    HOURLY STATS                                #####
####                                                                #####
####                                                                #####
####    domisse@w3perl.com                   version 19/11/2007     #####
####                                                                #####
#########################################################################

$version = "3.01";
$verdate = "19/11/07";

# CSS open div hosts/accees/traffic

$tleclim = 30; # 30 minutes ########## A METTRE DANS LE FICHIER DE CONFIG

$dirjs = "js";
$dircss = "css";

$sorttablejs = "sorttable.js";
$calendarjs = "basiccalendar.js";
$helpjs = "help.js";

$css_w3perl = "w3perl.css";
$css_help = "help.css";
$css_calendar = "calendar.css";

$toggle_on = "chkCheckAll.gif";
$toggle_off = "chkUnCheckAll.gif";

############ script a lancer a XX heures 01 minutes ##########

$debug = 0;
$crypt = 0;
if ($crypt == 1) {
    $localdomaine = crypt($localdomaine,"aa");
    $localdomainename = crypt($localdomainename,"aa");
}

## valeur a modifier avec fixperlpath.pl

require "/home/web/cgi-bin/w3perl/libw3perl.pl";

#print "Hourly stats : $version\n" if ($ENV{'REQUEST_METHOD'} ne "GET");
print "Hourly stats : $version\n" if ($opt_n eq '');
print "<P>" if ($opt_n eq '' && $ENV{'REQUEST_METHOD'} eq "GET");

# Retrieve external log
&retrieve_external_logfile($fileroot,$remote_host_log) if ($retrieve_external_log == 1 && $opt_w eq '');

$starttime = time();
$file_now = "now".$htmlext;

$filter_min = 60;  # Filtre sur la duree (min)
$refresh_sec = 60; # Temps de rafraichissement de la page web
$bin_sec = 60;     # Pas d'integration pour le graphe (en seconde)
$homeicons2 = "homepage";
$filezip = '';
$scriptname = "cron-hour".$plext;

#################################################################
###            parsing the command line option                ###
#################################################################

if ($opt_h == 1) {
      print STDOUT "Usage : \n";
      print STDOUT "        -a               : cumulated stats over full logfile\n";
      print STDOUT "        -b               : hourly stats over full logfile\n";
      print STDOUT "        -c <file>        : load configuration file\n";
      print STDOUT "        -d <sec>         : integration intervalle (real stats)\n";
      print STDOUT "        -i <file>        : input logfile\n";
      print STDOUT "        -o <file>        : output filename\n";
      print STDOUT "        -l <";
      for ($i=0;$i<$#lang;$i++) {
      print STDOUT "$lang[$i],";
      } 
      print STDOUT "$lang[$#lang]";
      print STDOUT ">       : language output (comma split)\n";
      print STDOUT "        -j <dd/Mmm/yyyy> : stats on dd/Mmm/yyyy\n";
      print STDOUT "        -p <level>       : precision level\n";
      print STDOUT "        -q <minutes>     : graph time length (real stats)\n";
      print STDOUT "        -n               : compute real time stats\n";
      print STDOUT "        -r <tri>         : scanning this matching string only\n";
      print STDOUT "        -s <seuilsite>   : display host with more than requests\n";
      print STDOUT "        -t <toplist>     : display only toplist files\n";
      print STDOUT "        -x               : show default value for flag options\n";
      print STDOUT "        -v               : version\n";
      print STDOUT "\n";
      exit;
}

if ($opt_v == 1) {
      print STDOUT "$scriptname version $version $verdate\n";
      exit;
}

if ($opt_x == 1) {
      print STDOUT "Default : \n";
      print STDOUT "          -a               : ";
      &id($opt_a);
      print STDOUT "          -b               : ";
      &id($opt_b);
      print STDOUT "          -c               : $configfile\n";
      print STDOUT "          -d <minutes>     : $bin_sec (real stats)\n";
      print STDOUT "          -i <file>        : $file\n";
      print STDOUT "          -o <file>        : \n";
      for ($nblang=0;$nblang<=$#lang;$nblang++) {
      $filehour = $path.$lang[$nblang].$dirsep.$dirdate.$dirsep.$filenamehour;
      print STDOUT "                      ($lang[$nblang]) : $filehour \n";
      }
      print STDOUT "          -j <dd/Mmm/yyyy> : <none>\n";
      print STDOUT "          -l <language>    : ";
      for ($i=0;$i<$#lang;$i++) {
      print STDOUT "$lang[$i],";
      }
      print STDOUT "$lang[$#lang]\n";
      print STDOUT "          -n               : ";
      &id($opt_n);
      print STDOUT "          -p <level>       : $precision\n";
      print STDOUT "          -q <minutes>     : $filter_min (real stats)\n";
      print STDOUT "          -r <tri>         : $tri\n";
      print STDOUT "          -s <seuilsite>   : $seuilsite\n";
      print STDOUT "          -t <toplist>     : $topten\n";
      print STDOUT "          -v               : $version\n";
      exit;
}

# argument cmds line

if ($opt_l ne '') {
  @lang = split(/, /,$opt_l);
  for ($i=0;$i<=$#lang;$i++) {
      $tmp = $dirress.$dirsep."lang".$dirsep.$lang[$i].$plext;
      $tmp = $pathinit.$tmp;
      require "$tmp";
  }

#  undef @newlang;
  if ($lang[0] eq '') {
      &error_exit("None of your language choices have been yet translated !",1);
  }
}

if ($opt_q ne '') {
    $filter_min = $opt_q;
}


if ($opt_d ne '') {
    $bin_sec = $opt_d;
}

if ($opt_p ne '') {
    $precision = $opt_p;
}

if ($opt_r ne '') {
    $tri = $opt_r;
}

if ($opt_t ne '') {
    $topten = $opt_t;
}

if ($opt_s ne '') {
    $seuilsite = $opt_s;
}

if ($opt_o ne '') {
    $filenamehour = $opt_o;
}

if ($opt_j ne '')
{
    if ($opt_j =~  /(\d\d)\/([JFMASOND][aepuco][nbrylgptvc])\/(\d\d\d\d)/) {
	$day = $1;

	$month = $month_equiv{$2};	
	$month .= "0".$month if (length($month) == 1 && $struct_compressed_logfile !~ /\%smallmonth/);
	$year = $3;
	$lettermonth = $2;
	$dirresume = "$year-$lettermonth-$day";
	if ($zipcut != 0) {
	    if ($2 ne $month || $zipcut == 2) {
#		$file = $fileroot;
		$smallyear = $year - int($year/100)*100;
		$smallyear = "0".$smallyear if (length($smallyear) == 1);
		$date_filename = $day.$dirsepurl.$lettermonth.$dirsepurl.$year; # Format XX/Mmm/YYYY
		$file = &Get_LogfileName($fileroot);
#		for ($i=1;$i<=$#compressed_logfile_fields;$i++) {
#		    $compressed_logfile_fields[$i] =~ s/\%/\$/;
#		    $file .= eval($compressed_logfile_fields[$i]).$compressed_sep_fields[$i];
#	        }    
		$filezip = $file.$zipext;
	    }
	}

	$startday = $opt_j;

	if ($zipcut == 3) {
	    $file = &find_index_log($fileroot,$prefixlog,$startday);
	    $filezip = $file.$zipext if ($zip == 1);
	    if ($file eq "$fileroot$prefixlog") {
		$zip = 0;
		$filezip = '';
	    }
	}

	$day = $1 ;
	$month = $2 ;
	$year = $3 ;
	$today = "$1"."/"."$2"."/"."$3";
	
	$hour = 24;
    } else {
	$msg = "Error : date should be in dd/Mmm/yyyy format\n";
	$msg .= "        dd is the day number\n";
	$msg .= "        Mmm is the abbreviated month name with first letter upper\n";
	$msg .= "        yyyy is the year number\n\n";
	&error_exit($msg,1);
    }
}

if ($opt_i ne '') {
    $file = $opt_i;
}

if ($opt_n ne '') {

    # To allow faster speed, disable dns,robot and refererspam detection
    $reverse_dns = 0;
    $exclude_robot = 0;
    $exclude_refererspam = 0;

    $lockfile = $path.$dirtmp.$dirsep."lock-hour";
    # test if lockfile there and old
    if (-f $lockfile) {
	$lockfile_date = -M $lockfile;
	if (($lockfile_date*24) > (5/(24*60))) {
#	    print "Suppose to be an old lockfile (older than 5 minutes)\n";
	    $now = time;
	    utime($now,$now,$lockfile);
	} else {
	    &error_exit("Sorry, script already running",0);
	}
    } else {
#	print "Writing $lockfile\n";
	open(LOCKFILE,">$lockfile");
	close(LOCKFILE);
    }

    $filter_sec = $filter_min*60;

    $current_time = time;
    $tmp = $today.":".$hourdate;
    $sec_deb = &nb_sec_deb($tmp);
    $decal_sec = $sec_deb - $current_time;

    $tmp1 = $sec_deb-$filter_sec;
#    &get_time($tmp1);
    ($date,$datehour,$datemisc) = &get_time($tmp1);
    ($hourfilter,$minutefilter) = split(/:/,$datehour);
    $minutefilter = 0 if ($hourfilter > $hour);
    $hourfilter = 0 if ($hourfilter > $hour);

    $hour = "0".$hour if (length($hour) == 1);
    $minutefilter = "0".$minutefilter if (length($minutefilter) == 1);

    if ($hour != $hourfilter) {
	$filter_previous = $today.":".$hourfilter;
    }

    $filtertoday = $today.":(";
    for ($i=$hourfilter;$i<=$hour;$i++) {
	$i = "0".$i if (length($i) == 1);
	$filtertoday .= $i."|";
    }
    chop($filtertoday);
    $filtertoday .= ")";

}

#################################################################
####                   initialisation                     #######
#################################################################

$link_use = "..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl";
$link_use = "..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl" if ($opt_j ne '' || $opt_b ne '');
$linkcsv_use = "..$dirsepurl..$dirsepurl$linkpathinit$dircsv$dirsepurl";
$linkcsv_use = "..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dircsv$dirsepurl" if ($opt_j ne '' || $opt_b ne '');

$stop = 0;
$linelog = 0;
$offset = 0;
$nbdays = 0;
$oldheure = 0;
$domreq = 0;
$reqtot = 0;
$serverunique = 0;
$extreq = 0;
$RequeteHtml = 0;
$RequeteGif = 0;
$max_server = 0;

$trafic = 0;
$hits = 0;
$access = 0;
$host = 0;

# globale
$VolumeTotal = 0;
$VolumeTotalExt = 0;
$VolumeTotalInt = 0;
$VolumeHtml = 0;
$VolumeGif = 0;

# interne
$RequeteGifInt = 0;
$RequeteHtmlInt = 0;
$VolumeHtmlInt = 0;
$VolumeGifInt = 0;

# externe
$RequeteGifExt = 0;
$RequeteHtmlExt = 0;
$VolumeHtmlExt = 0;
$VolumeGifExt = 0;

$scriptunique = 0;
$add_fields_logfile = 0;

$day_end = $today if ($zipcut == 1);
$dos_format = 0;


if ($struct_compressed_logfile !~ /\%hour/ && $struct_compressed_logfile !~ /\%min/ && $struct_compressed_logfile !~ /\%sec/) {
$daytmp = $day;
if ($zipcut == 2 || $zipcut == 3) {
$monthtmp = $month;
#$filetmpzip = $fileroot;
$month = $month_equiv{$month};
#$month = "0".$month if (length($month) == 1);
$month = "0".$month if (length($month) == 1 && $struct_compressed_logfile !~ /\%smallmonth/);
   $lettermonth = $month_nb[$month-1];
$smallyear = $year - int($year/100)*100;
$smallyear = "0".$smallyear if (length($smallyear) == 1);
$smallday = $day;
$smallday = substr($smallday,1,2) if ($smallday < 10);
$smallmonth = $month;
$datetmpzip = $year.$month.$day;
$date_filename = $day.$dirsepurl.$lettermonth.$dirsepurl.$year; # Format XX/Mmm/YYYY
$filetmpzip = &Get_LogfileName($fileroot);
#for ($i=1;$i<=$#compressed_logfile_fields;$i++) {
#$compressed_logfile_fields[$i] =~ s/\%/\$/;
#$filetmpzip .= eval($compressed_logfile_fields[$i]).$compressed_sep_fields[$i];
#}
#print "$date_filename\n";
    $filetmpzip_day .= &nbday($date_filename);
$filetmpzip = $filetmpzip.$zipext if ($zip == 1);
$month = $monthtmp;
}
}

#############################################################################

&load_reverse_dns if ($reverse_dns == 1); # chargement de la table de DNS
print "<BR>" if ($opt_n eq '' && $ENV{'REQUEST_METHOD'} eq "GET" && $reverse_dns == 1);

if ($exclude_robot == 1) {
    &LoadRobot(0);
}

if ($exclude_refererspam == 1) {
    if ($opt_w == 1) {
	&LoadReferSpamList;
    } else {
#	&LoadReferSpamByIP;
	&LoadReferSpamByDomain;
    }
}

#################################################################
####               directories building                   #######
#################################################################

&MakeDirectories;

#################################################################
####               URL to title conversion                #######
#################################################################

chop($pathserver);

if (!(-e "$path$dirdata$dirsep$fileurl")) {
    $titlename = 0;
}

&load_url_map if ($titlename == 1);

&load_fileext if ($precision > 2);

#################################################################
###                   jour precedent                          ###
#################################################################

if ($precision > 2) {

$dernier_month = $month;
$hier = $day - 1;

#$hier = "0".$hier if (length($hier) == 1);
$hier = "0".$hier if (length($hier) == 1 && $struct_compressed_logfile !~ /\%smallday/);

if ($hier < 1) {
    $countmonth--;
    if ($countmonth < 1) {
       $year--;
        $countmonth = 12;
    }
    $dernier_month = $month_nb[$countmonth-1];

    $hier = $month_of_year{$dernier_month};
    }

#$precedent = "$hier/$dernier_month/$year";

$filejour = $hier."-".$dernier_month.$htmlext;

if ($hour == 0 && $opt_n eq '') {
           $hour = 24;
           $today = $hier."/".$dernier_month."/".$year;
           $dirresume = $year."-".$dernier_month."-".$hier;
           }
}

if ($opt_j ne '') {

         print "Output files are : ";
	 print "<BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");
#         for ($nblang=0;$nblang<=$#lang;$nblang++) {
#             $filejourarc = $path.$lang[$nblang].$dirsep.$dirdate.$dirsep.$dirresume.$dirsep.$filenamehour;
             $filejourarc = $path."[lang]".$dirsep.$dirdate.$dirsep.$dirresume.$dirsep.$filenamehour;
             print "\n$filejourarc";
	 print "<BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");
#         }
	 print "\n";
}

if ($opt_a == 1) {

    print "The file will be save in : \n";
	 print "<BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");
        $filenamehour = "all".$htmlext;
#         for ($nblang=0;$nblang<=$#lang;$nblang++) {
             $filejourarc = $path."[lang]".$dirsep.$dirdate.$dirsep.$filenamehour;
             print "\n$filejourarc";
	 print "<BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");
#         }
    print "\n";
    $hour = 24;
}

$filenamehourcsv = $filenamehour;
$filenamehourcsv =~ s/$htmlext/$csvext/;

#################################################################
###       seek to the right place to scan the log file        ###
#################################################################

if ($zipcut == 1 && $zip == 1) {
    if (!(-f $file) && !(-f $filezip)) {
#	$file = $fileroot;
	$month = $month_equiv{$month};
	$month = "0".$month if (length($month) == 1 && $struct_compressed_logfile !~ /\%smallmonth/);
	$lettermonth = $month_nb[$month-1];
	$smallyear = $year - int($year/100)*100;
	$smallyear = "0".$smallyear if (length($smallyear) == 1);
	$file = &Get_LogfileName($fileroot);
#	for ($i=1;$i<=$#compressed_logfile_fields;$i++) {
#	    $compressed_logfile_fields[$i] =~ s/\%/\$/;
#	    $file .= eval($compressed_logfile_fields[$i]).$compressed_sep_fields[$i];
#	} 

	$filezip = $file.$zipext if (!(-f $file));
	if (!(-f $file) && !(-f $filezip)) {
	    unlink($lockfile) if ($opt_n ne '');
	    &error_exit("Unable to find any logfile : $prefixlog, $prefixlog$zipext, $file or $file$zipext\n",1);
	}
	
    }
}

$filezip = $file.$zipext if ($zip == 1 && $zipcut == 0); # NEW zip=1 zipcut=0

print "A1 - $file - $filezip\n" if ($debug == 1);

#if ($zipcut != 2 && (!(-f $file))) {
if ($zipcut != 2 && $zipcut != 3) {
    if ($opt_a eq '' || $opt_b == 1) {
#    if ($filezip eq '' && $zipcut == 0) {
#    if ($zipcut == 0) {
	if ($zipcut != 2) {
	    if ($filezip eq '' || (!(-f $filezip))) {
		if (!(-r $file)) {
		    unlink($lockfile) if ($opt_n ne '');
		    &error_open($file);
		} 
		open(INFILE, $file) || &error_exit("Error, unable to open $file",1);
	    } else {
		if (!(-r $filezip)) {
		    unlink($lockfile) if ($opt_n ne '');
		    &error_open($filezip);
		}
		open(INFILE, "$GZIP $filezip |") || &error_exit("Error, unable to open $filezip",1);
	    }

        ### taille du fichier de log

	    $size = -s $file;
	    if ($size == 0 && -f $file) {
		unlink($lockfile) if ($opt_n ne '');
		&error_exit("Your logfile is empty !\n",1);
	    }
	    if ($size < 0) {
		unlink($lockfile) if ($opt_n ne '');
		$msg = "Problem with logfile size\n";
		$msg .= "You should upgrade to the latest Perl version to be able to handle file larger than 2 Gb\n";
		$msg .= "or split your logfile under the 2 Gb limit\n\n";
		&error_exit($msg,1);
	    }
	    
        ### date selectionnee

	    $yday = &nbday($today);
#	    $yday = &nbdayan($opt_j) if ($opt_j ne '');
	    
	    print "Search date : $today is day number $yday\n" if ($debug == 1);

        ### date de depart
	    
	    $scalar = (<INFILE>);
	    $scalar = (<INFILE>) if ($scalar =~ /\"format\=/i); # Fasttrack server bug
	    while ($scalar =~ /^\#/) {
		$struct_logfile = &detect_w3c_logformat($scalar) if ($scalar =~ /^\#Fields:/);
		$scalar = (<INFILE>);
	    }
	    
	    if ($scalar =~ /\r\n$/) {
		$dos_format = 1;
		print "*** Warning *** Dos file found\n" if ($debug == 1);
	    }

	    if ($mail_format == 1) {
		@line_log = split(/\s+/,$scalar);
		if ($line_log[0] =~ /(\d\d\d\d)-(\d\d)-(\d\d)/) {
		    $date = $3.$dirsep.$month_nb[$2-1].$dirsep.$1.":".$line_log[$fields_logfile{'%time'}];
		} else {
		    $year-- if ($month_equiv{$line_log[0]} > $monthindex);
		    $year-- if ($month_equiv{$line_log[0]} == $monthindex && $line_log[1] > $day);

		    $date = "$line_log[1]";
		    $date = "0".$date if (length($line_log[1]) == 1);
		    $date .= "/$line_log[0]/$year:$line_log[2]";
		}
	    } elsif ($ftp_format == 1) {
		@line_log = split(/\s+/,$scalar);
		chomp($line_log[$#line_log]);
		$line_log[2] = "0".$line_log[2] if ($line_log[2] < 10);
		$date = "$line_log[2]/$line_log[1]/$line_log[4]:$line_log[3]";
		$direction = $line_log[$fields_logfile{'%direction'}];
	    } else {
		@line_log = split(/$logfile_sep/,$scalar);
		$add_fields_logfile = &LoginWithSpace(@line_log) if ($line_log[$fields_logfile{'%login'}] =~ /^\"/);
		$date = $line_log[$fields_logfile{'%date'}+$add_fields_logfile];
		$date =~ s/\[//;
		$date = &date_squid($date) if ($date =~ /\d{9}\.\d{3}/);
		$date = &date_common($line_log[$fields_logfile{'%date'}+$add_fields_logfile],$line_log[$fields_logfile{'%hour'}+$add_fields_logfile]) if ($iis_format == 1 && $fields_logfile{'%date'} ne '');
		$date = $date_filename.":".$line_log[$fields_logfile{'%hour'}+$add_fields_logfile] if ($fields_logfile{'%date'} eq '');
	    }

	    ($firstjour) = split(/:/,$date);
	    ($jourstart,$monthstart,$yearstart) = split(/\//,$firstjour);
	    
	    $ydaystart = &nbday($firstjour);

	    print "debut du logfile : $firstjour est le $ydaystart jour de l'annee\n" if ($debug == 1);
	    
	    ### Prendre la derniere date du fichier de log
	    
	    if ($filezip eq '') {
		$offset = int($size - 1024);
		seek(INFILE,$offset,0);
		$scalar = (<INFILE>);
		$scalar = (<INFILE>) if ($offset > 0);
	    } else {
		while ($scalar2 = <INFILE>) {
		    $scalar = $scalar2;
		}
	    }

	    if ($mail_format == 1) {
		@line_log = split(/\s+/,$scalar);
		if ($line_log[0] =~ /(\d\d\d\d)-(\d\d)-(\d\d)/) {
		    $date = $3.$dirsep.$month_nb[$2-1].$dirsep.$1.":".$line_log[$fields_logfile{'%time'}];
		} else {
		    $year-- if ($month_equiv{$line_log[0]} > $monthindex);
		    $year-- if ($month_equiv{$line_log[0]} == $monthindex && $line_log[1] > $day);

		    $date = "$line_log[1]";
		    $date = "0".$date if (length($line_log[1]) == 1);
		    $date .= "/$line_log[0]/$year:$line_log[2]";
		}
	    } elsif ($ftp_format == 1) {
		@line_log = split(/\s+/,$scalar);
		chomp($line_log[$#line_log]);
		$line_log[2] = "0".$line_log[2] if ($line_log[2] < 10);
		$date = "$line_log[2]/$line_log[1]/$line_log[4]:$line_log[3]";
		$direction = $line_log[$fields_logfile{'%direction'}];
	    } else {
		@line_log = split(/$logfile_sep/,$scalar);
	    	$add_fields_logfile = &LoginWithSpace(@line_log) if ($line_log[$fields_logfile{'%login'}] =~ /^\"/);
		$date = $line_log[$fields_logfile{'%date'}+$add_fields_logfile];
		$date =~ s/\[//;
		$date = &date_squid($date) if ($date =~ /\d{9}\.\d{3}/);
		$date = &date_common($line_log[$fields_logfile{'%date'}+$add_fields_logfile],$line_log[$fields_logfile{'%hour'}+$add_fields_logfile]) if ($iis_format == 1 && $fields_logfile{'%date'} ne '');
		$date = $date_filename.":".$line_log[$fields_logfile{'%hour'}+$add_fields_logfile] if ($fields_logfile{'%date'} eq '');
	    }

	    if ($fields_logfile{'%date'} eq '') {
		# date de ce jour
		$timesec = time;
#		&get_time($timesec);
		($date,$datehour,$datemisc) = &get_time($timesec);
	    }
	
	    ($dayfinale) = split(/:/,$date);

	    $ydayfinale = &nbday($dayfinale);
	    
	    print "fin du logfile : $dayfinale  est le $ydayfinale jour de l'annee\n" if ($debug == 1);
	    
	    close (INFILE);

	    # nbre de jours total
	    # Ne marche que pour des diff d'un an au plus !!!
	    $intervalle = $ydayfinale - $ydaystart;
#	$intervalle = $ydayfinale - $ydaystart if ($ydayfinale > $ydaystart);
#	$intervalle = $ydayfinale + (366-$ydaystart) if ($ydayfinale < $ydaystart);
	    $intervalle++;

	    # taille moyenne d'une journee

	    $sizejour = $size/$intervalle if ($intervalle != 0);
	    $sizejour = $size if ($intervalle == 0);
	    
	    print "SIZE : $size $sizejour $intervalle\n" if ($debug == 1);
	}

    # trouver la date de depart pour $zip = 1, $zipcut = 1 et 2;

#    if (($zip == 1 || $zipcut != 0) && $opt_i eq '') {
#    if ($zipcut != 0 && $opt_i eq '') {
	if (!(-f $file)) {
	if (($zip == 1 || $zip == 0) && $zipcut != 0 && $opt_i eq '') {

#	$day = $daytmp;
	    $month = $monthindex;
	    $monthprev = $month-1;
	    $yyear = $year;
	    $year = $fyear;
	    $oldhour = $hour;
	    $hour = '';

	# detection du premier mois de log zipe

	    while ($out == 0) {
		$tmp++;
		if ($zipcut == 2) {
		    $day++;
		    $day = "0".$day if (length($day) == 1 && $struct_compressed_logfile !~ /\%smallday/);
		    if ($day > $month_of_year{$month_nb[$monthprev]}) {
			$month++;
			$monthprev++;
			$day = "1" if ($struct_compressed_logfile =~ /\%smallday/);
			$day = "01" if ($struct_compressed_logfile !~ /\%smallday/);
		    }
		}
		$month++ if ($zipcut == 1);
		$monthprev++ if ($zipcut == 1);       
		$year++ if ($month == 13);
		$month = "1" if ($month == 13);
		$month = "0".$month if (length($month) == 1 && $struct_compressed_logfile !~ /\%smallmonth/);

		$monthprev = 0 if ($month == 1);       
		$lettermonth =  $month_nb[$monthprev];
		if ($year ==  $fullyear && $month > $monthindex && $zipcut != 0) {
		    $msg = "No gziped files found !\n" if ($zip == 1);
		    $msg = "No log files found !\n" if ($zip == 0);
		    $msg .= "\n";
		    &error_exit("$msg",1);
		}
		$smallyear = $year - int($year/100)*100;
		$smallyear = "0".$smallyear if (length($smallyear) == 1);
		$smallday = $day;
		$smallmonth = $month;
#		$file = $fileroot;
		$file = &Get_LogfileName($fileroot);		
#		for ($i=1;$i<=$#compressed_logfile_fields;$i++) {
#		    $compressed_logfile_fields[$i] =~ s/\%/\$/;
#		    $file .= eval($compressed_logfile_fields[$i]).$compressed_sep_fields[$i];
#		}
		$out = 1 if (-e $file && $zip == 0);
		$filezip = $file.$zipext if ($zip == 1);
		$out = 1 if (-e $filezip && $zip == 1);
		if ($zipcut == 3 && $filetmpzip eq $file) {
		    $out = 1;
		    $zip = 0;
		    $filezip = $file;
		}
		# if larger then (today-1996)*366 for daily logfiles
		if ($tmp > 5000) {
		    $msg = "No logfile found\n";
		    $msg .= "Are you sure you are using compressed logfile ?\n" if ($zip == 1);
		    &error_exit($msg,1);
		}
	    }
	    
	    if ($zipcut == 1) {
		$day = "01" if ($struct_compressed_logfile !~ /\%smallday/);
		$day = "1" if ($struct_compressed_logfile =~ /\%smallday/);
	    }
	    $firstjour = "$day/$lettermonth/$year" if ($zipcut != 0);
	    $stop = 0;
	    $fyear = $year;
	    $year = $yyear;
	    print "$file - $firstjour\n" if ($debug == 1);
	    $hour = $oldhour;
	}
    }
    }
    
}

# zipcut set to 2;

if ($zipcut == 2 && $opt_b ne '') {
	    $month = $monthindex;
	    $monthprev = $month-1;
	    $yyear = $year;
	    $year = $fyear;
	    $oldhour = $hour;
	    $hour = '';

	# detection du premier mois de log zipe

	    while ($out == 0) {
		$tmp++;
		if ($zipcut == 2) {
		    $day++;
		    $day = "0".$day if (length($day) == 1 && $struct_compressed_logfile !~ /\%smallday/);
		    if ($day > $month_of_year{$month_nb[$monthprev]}) {
			$month++;
			$monthprev++;
			$day = "1" if ($struct_compressed_logfile =~ /\%smallday/);
			$day = "01" if ($struct_compressed_logfile !~ /\%smallday/);
		    }
		}
		$month++ if ($zipcut == 1);
		$monthprev++ if ($zipcut == 1);       
		$year++ if ($month == 13);
		$month = "1" if ($month == 13);
		$month = "0".$month if (length($month) == 1 && $struct_compressed_logfile !~ /\%smallmonth/);

		$monthprev = 0 if ($month == 1);       
		$lettermonth =  $month_nb[$monthprev];
		if ($year ==  $fullyear && $month > $monthindex && $zipcut != 0) {
		    $msg = "No gziped files found !\n" if ($zip == 1);
		    $msg = "No log files found !\n" if ($zip == 0);
		    $msg .= "\n";
		    &error_exit("$msg",1);
		}
		$smallyear = $year - int($year/100)*100;
		$smallyear = "0".$smallyear if (length($smallyear) == 1);
		$smallday = $day;
		$smallmonth = $month;
#		$file = $fileroot;
		$file = &Get_LogfileName($fileroot);
#		for ($i=1;$i<=$#compressed_logfile_fields;$i++) {
#		    $compressed_logfile_fields[$i] =~ s/\%/\$/;
#		    $file .= eval($compressed_logfile_fields[$i]).$compressed_sep_fields[$i];
#		}
		$out = 1 if (-e $file && $zip == 0);
		$filezip = $file.$zipext if ($zip == 1);
		$out = 1 if (-e $filezip && $zip == 1);
		if ($zipcut == 3 && $filetmpzip eq $file) {
		    $out = 1;
		    $zip = 0;
		    $filezip = $file;
		}
		# if larger then (today-1996)*366 for daily logfiles
		if ($tmp > 5000) {
		    $msg = "No logfile found\n";
		    $msg .= "Are you sure you are using compressed logfile ?\n" if ($zip == 1);
		    &error_exit($msg,1);
		}
	    }
	    
	    if ($zipcut == 1) {
		$day = "01" if ($struct_compressed_logfile !~ /\%smallday/);
		$day = "1" if ($struct_compressed_logfile =~ /\%smallday/);
	    }
	    $firstjour = "$day/$lettermonth/$year" if ($zipcut != 0);
	    $stop = 0;
	    $fyear = $year;
	    $year = $yyear;
	    print "File : $file - $firstjour\n" if ($debug == 1);
	    $hour = $oldhour;

	}

if ($zipcut == 3 && $opt_b ne '') {

    $filetmpzip = &find_last_log($fileroot,$prefixlog);
    $filetmpzip = "$fileroot$prefixlog" if ($filetmpzip == -1);
    
    open(INFILE, "$fileroot$prefixlog");
    
    $size = -s "$fileroot$prefixlog";
    $offset = int($size - 1024);
    seek(INFILE,$offset,0);
    $scalar = (<INFILE>);
    $scalar = (<INFILE>) if ($offset > 0);

    if ($mail_format == 1) {
	@line_log = split(/\s+/,$scalar);
	if ($line_log[0] =~ /(\d\d\d\d)-(\d\d)-(\d\d)/) {
	    $date = $3.$dirsep.$month_nb[$2-1].$dirsep.$1.":".$line_log[$fields_logfile{'%time'}];
	} else {
	    $year-- if ($month_equiv{$line_log[0]} > $monthindex);
	    $year-- if ($month_equiv{$line_log[0]} == $monthindex && $line_log[1] > $day);
	    
	    $date = "$line_log[1]";
	    $date = "0".$date if (length($line_log[1]) == 1);
	    $date .= "/$line_log[0]/$year:$line_log[2]";
	}
    } elsif ($ftp_format == 1) {
	@line_log = split(/\s+/,$scalar);
	chomp($line_log[$#line_log]);
	$line_log[2] = "0".$line_log[2] if ($line_log[2] < 10);
	$date = "$line_log[2]/$line_log[1]/$line_log[4]:$line_log[3]";
	$direction = $line_log[$fields_logfile{'%direction'}];
    } else {
	@line_log = split(/$logfile_sep/,$scalar);
	$add_fields_logfile = &LoginWithSpace(@line_log) if ($line_log[$fields_logfile{'%login'}] =~ /^\"/);
	$date = $line_log[$fields_logfile{'%date'}+$add_fields_logfile];
	$date =~ s/\[//;
	$date = &date_squid($date) if ($date =~ /\d{9}\.\d{3}/);
	$date = &date_common($line_log[$fields_logfile{'%date'}+$add_fields_logfile],$line_log[$fields_logfile{'%hour'}+$add_fields_logfile]) if ($iis_format == 1 && $fields_logfile{'%date'} ne '');
	$date = $date_filename.":".$line_log[$fields_logfile{'%hour'}+$add_fields_logfile] if ($fields_logfile{'%date'} eq '');
    }

    
    close(INFILE);

    ($tmp) = split(/:/,$date);
    ($tmp1,$tmp2,$tmp3) = split(/\//,$tmp);    
    $datetmpzip = $tmp3.$month_equiv{$tmp2}.$tmp1;

    $first_logfile = &find_first_log($fileroot,$prefixlog);
    $first_logfile = "$fileroot$prefixlog" if ($first_logfile == -1);

    if ($filetmpzip == -1 || $first_logfile == -1) {
	if (!(-f "$fileroot$prefixlog")) {
	    $msg = "No file found in $fileroot\n";
	    &error_exit($msg);
	} else {
	    $zip = 0;
	    $zipcut = 0;
	    }
	}
    if ($zipcut == 3) {
	$tmp = $filetmpzip;
	$filetmpzip =  $first_logfile;
	$first_logfile = $tmp;
    }
    $rotate_index = $max_rotate_index;
    if ($rotate_index !~ /^\d+$/) {
	$msg = "Found a logfile I don't understand : $prefixlog$rotate_index.\nIndex should be a number (found the string '$rotate_index').\n";
	&error_exit($msg);
    }
    if (-f $first_logfile) {
	$file = $first_logfile;
	$zip = 0;
	open(INFILE, $first_logfile) || &error_exit("Error, unable to open $first_logfile",1);
    } else {
	$file = $first_logfile;
	$filezip = $first_logfile.$zipext;
	$zip = 1;
	open(INFILE, "$GZIP $first_logfile$zipext |") || &error_exit("Error, unable to open $first_logfile$zipext",1);
    }
    $scalar = (<INFILE>);
    
    if ($mail_format == 1) {
	@line_log = split(/\s+/,$scalar);
		    if ($line_log[0] =~ /(\d\d\d\d)-(\d\d)-(\d\d)/) {
			$date = $3.$dirsep.$month_nb[$2-1].$dirsep.$1.":".$line_log[$fields_logfile{'%time'}];
		    } else {
			$year-- if ($month_equiv{$line_log[0]} > $monthindex);
			$year-- if ($month_equiv{$line_log[0]} == $monthindex && $line_log[1] > $day);

			$date = "$line_log[1]";
			$date = "0".$date if (length($line_log[1]) == 1);
			$date .= "/$line_log[0]/$year:$line_log[2]";
		    }
		} elsif ($ftp_format == 1) {
		    @line_log = split(/\s+/,$scalar);
		    chomp($line_log[$#line_log]);
		    $line_log[2] = "0".$line_log[2] if ($line_log[2] < 10);
		    $date = "$line_log[2]/$line_log[1]/$line_log[4]:$line_log[3]";
		    $direction = $line_log[$fields_logfile{'%direction'}];
		} else {
		    @line_log = split(/$logfile_sep/,$scalar);
		    $add_fields_logfile = &LoginWithSpace(@line_log) if ($line_log[$fields_logfile{'%login'}] =~ /^\"/);
		    $date = $line_log[$fields_logfile{'%date'}+$add_fields_logfile];
		    $date =~ s/\[//;
		    $date = &date_squid($date) if ($date =~ /\d{9}\.\d{3}/);
		    $date = &date_common($line_log[$fields_logfile{'%date'}+$add_fields_logfile],$line_log[$fields_logfile{'%hour'}+$add_fields_logfile]) if ($iis_format == 1 && $fields_logfile{'%date'} ne '');
		    $date = $day.$dirsepurl.$lettermonth.$dirsepurl.$year.":".$line_log[$fields_logfile{'%hour'}+$add_fields_logfile] if ($fields_logfile{'%date'} eq '');
		}

    ($firstjour) = split(/:/,$date);    
    close(FILE);

}

# Faire une boucle de $firstday a $dayfinale

if ($opt_b ne '') {
    $hour = 24;
    $nb_full = 0 if ($zipcut == 2);
    $nb_full = $intervalle if ($zipcut != 2);
    $nb_id = 0;
    $today = $firstjour;
    $yday = &nbday($today);
    ($day,$month,$year) = split(/\//,$today);
    print "OPT_D : $intervalle - $nb_id - $nb_full - $stop\n" if ($debug == 1);

    if (($year%4 == 0 && $year%100 != 0) || $year%400 == 0) {
	$month_of_year{'Feb'} = "29";
    } else {
	$month_of_year{'Feb'} = "28";
    }

} else {
    $nb_id = $nb_full = 1;
}

print "A - $filezip - $file - $today\n" if ($debug == 1);

#################################################################
###                   Main loop over days                     ###
#################################################################

while ($nb_id <= $nb_full && $stop == 0) {

    print "TODAY $today - $filezip $stop - $nb_id - $nb_full - $rotate_index\n" if ($debug == 1);

#if ($zipcut != 0 && $file ne "$fileroot$prefixlog" && $opt_i eq '') {
if ($zipcut != 0 && (!(-f "$fileroot$prefixlog")) && $opt_i eq '') {
    ($day,$month2,$year) = split('/',$today);
    $month = $month_equiv{$month2};
    $month = "0".$month if (length($month) == 1 && $struct_compressed_logfile !~ /\%smallmonth/);
    $lettermonth = $month2;
#    $file = $fileroot;
#    print "$day - $month - $lettermonth - $year\n";
    $smallyear = $year - int($year/100)*100;	
    $smallyear = "0".$smallyear if (length($smallyear) == 1);

    $smallday = $day;
    $smallday = substr($smallday,1,2) if ($smallday < 10);
    $smallmonth = $month;

    $date_filename = $day.$dirsepurl.$lettermonth.$dirsepurl.$year; # Format XX/Mmm/YYYY
    $file = &Get_LogfileName($fileroot);

#    for ($i=1;$i<=$#compressed_logfile_fields;$i++) {

#	$compressed_logfile_fields[$i] =~ s/\%/\$/;
#	$file .= eval($compressed_logfile_fields[$i]).$compressed_sep_fields[$i];
#    }

    if ($zipcut == 2) {
	$filezip = $file.$zipext if (!(-f $file));
	$filezip = "" if (-f $file);
    }
    print "B $filezip - $file\n" if ($debug == 1);
    if ($zipcut == 1) {
	if (!(-f $file)) {
	    $filezip = $file.$zipext;
		if (!(-f $filezip)) {
		    $filezip = "";
		    $file = $fileroot.$prefixlog;
		    $stop = 1;
		}
	}
    }
#    if ($zipcut == 1 && !(-f $filezip)) {
#	$filezip = "";
#	$file = $fileroot.$prefixlog;
#	$stop = 1;
#    }
}        

    ($day,$month2,$year) = split(/\//,$today);
    $dirresume = $year."-".$month2."-".$day;
    $dir = $path.$lang[$nblang].$dirsep.$dirdate.$dirsep.$dirresume;
    mkdir ($dir,0775) unless -d $dir;

    if ($opt_b == 1) {
	$nbdays = 0;
#	if (($zip == 1 || $zip == 0) && $zipcut == 0) {
#	if ($linelog != 0) {
	    $starttime2 = time();
	    print "$today : ";
#	}
#	}
    }

##################

if ($opt_a eq '' || $opt_b == 1) {
#    if ($filezip eq '' && $zipcut != 2 && ($file ne "$fileroot$prefixlog" || $opt_b == 0)) {
    if ($filezip eq '' && $zipcut != 2 && $zipcut != 3) {
#    if ($filezip eq '' && $zipcut == 0) {
#    if ($zipcut != 2) {

        # intervalle entre dernier jour et date choisie

	$nb = $ydayfinale - $yday;

#	$nb = $ydayfinale - $yday if ($ydayfinale > $yday);
#	$nb = $ydayfinale + (366-$yday) if ($ydayfinale < $yday);
	
	$nb++; 

        print "NB : $nb $ydayfinale - $yday - $sizejour\n" if ($debug == 1);

        # comparer $yday ($today) et $ydayfinale ($dayfinale)
        # si > pble ! le fichier ne contient pas $today !

	$sizejour = 512 if ($sizejour < 512);
	$sizejour = 512 if ($nb == 0);
	$intervalle2 = $ydayfinale - $yday+1;

	if ($firstjour ne $today) {
	    if (!(-r $file)) {
		unlink($lockfile) if ($opt_n ne '');
		&error_open($file);
	    }
	    open(INFILE, $file) || &error_exit("Error, unable to open $file",1);
	    $verifjour = $today;
	    
	    $intervalle = $nb;

#	    while ($verifjour eq $today || $intervalle > $intervalle2) {
	    while ($intervalle2 > 0) {
		$offset = int($size - ($nb*$sizejour));
		$offset = 0 if ($firstjour eq $dayfinale);
		if ($offset < 0) {
		    $msg = "Problem : Your logfile does not contains any data about $today !\n";
		    $msg .= "Today is $today, last logfile entry is $dayfinale\n\n";
		    &error_exit($msg,0);
		}

		# verif de la date
		seek(INFILE,$offset,0);
	
		$scalar = (<INFILE>);
		$scalar = (<INFILE>) if ($offset > 0);

		if ($mail_format == 1) {
		    @line_log = split(/\s+/,$scalar);
		    if ($line_log[0] =~ /(\d\d\d\d)-(\d\d)-(\d\d)/) {
			$date = $3.$dirsep.$month_nb[$2-1].$dirsep.$1.":".$line_log[$fields_logfile{'%time'}];
		    } else {
			$year-- if ($month_equiv{$line_log[0]} > $monthindex);
			$year-- if ($month_equiv{$line_log[0]} == $monthindex && $line_log[1] > $day);

			$date = "$line_log[1]";
			$date = "0".$date if (length($line_log[1]) == 1);
			$date .= "/$line_log[0]/$year:$line_log[2]";
		    }
		} elsif ($ftp_format == 1) {
		    @line_log = split(/\s+/,$scalar);
		    chomp($line_log[$#line_log]);
		    $line_log[2] = "0".$line_log[2] if ($line_log[2] < 10);
		    $date = "$line_log[2]/$line_log[1]/$line_log[4]:$line_log[3]";
		    $direction = $line_log[$fields_logfile{'%direction'}];
		} else {
		    @line_log = split(/$logfile_sep/,$scalar);
		    $add_fields_logfile = &LoginWithSpace(@line_log) if ($line_log[$fields_logfile{'%login'}] =~ /^\"/);
		    $date = $line_log[$fields_logfile{'%date'}+$add_fields_logfile];
		    $date =~ s/\[//;
		    $date = &date_squid($date) if ($date =~ /\d{9}\.\d{3}/);
		    $date = &date_common($line_log[$fields_logfile{'%date'}+$add_fields_logfile],$line_log[$fields_logfile{'%hour'}+$add_fields_logfile]) if ($iis_format == 1 && $fields_logfile{'%date'} ne '');
#		    $date = $date_filename.":".$line_log[$fields_logfile{'%hour'}] if ($fields_logfile{'%date'} eq '');
		    $date = $day.$dirsepurl.$lettermonth.$dirsepurl.$year.":".$line_log[$fields_logfile{'%hour'}+$add_fields_logfile] if ($fields_logfile{'%date'} eq '');
		}

		($verifjour) = split(/:/,$date);
		$nb++;

		# calcul le nombre de jour

		$ydayverif = &nbday($verifjour);		
		$intervalle2 = $ydayverif - $yday +1;
		$intervalle2 = 0 if ($firstjour eq $dayfinale);
                print "UU $offset - $date - $verifjour - $intervalle2 - $ydayverif - $yday\n" if ($debug == 1);

	    }

	    close (INFILE);
#	    $nb++;
	    $offset = int($size - ($nb*$sizejour));
	}
	print "verif : $nb $verifjour $ydayverif $precedent\n" if ($debug == 1);
    }
}

$offset = 0 if (($firstjour eq $today) || ($opt_a == 1));

#print "$offset\n";

($date) = split(/ /,$date);

#################################################################
###       scanning the log file matching for today            ###
#################################################################

#if ($zipcut != 0 && $opt_i eq '') {

($day,$month2,$year) = split('/',$today);
$month = $month_equiv{$month2};
$month = "0".$month if (length($month) == 1 && $struct_compressed_logfile !~ /\%smallmonth/);

$lettermonth = $month2;
#    $file = $fileroot;
#    $smallyear = $year - int($year/100)*100;	
 #   $smallyear = "0".$smallyear if (length($smallyear) == 1);
#    for ($i=1;$i<=$#compressed_logfile_fields;$i++) {
#	$date_filename = $day.$dirsepurl.$lettermonth.$dirsepurl.$year; # Format XX/Mmm/YYYY
#	$compressed_logfile_fields[$i] =~ s/\%/\$/;
#	$file .= eval($compressed_logfile_fields[$i]).$compressed_sep_fields[$i];
#    }
#    $filezip = $file.$zipext if (!(-f $file));

if ($zip != 0 && !(-f $filezip) && !(-f $file) && $opt_i eq '') {
    $filezip = "";
    $file = $fileroot.$prefixlog;
    $stop = 1;
}

$offset = 0 if ($filezip ne '');

print "R - $file - $filezip\n" if ($debug == 1);

if ($filezip eq '' || (!(-f $filezip))) {

#    &retrieve_external_logfile($fileroot,$remote_host_log,$file) if ($retrieve_external_log == 1);
    if (!(-r $file)) {
	unlink($lockfile) if ($opt_n ne '');
	&error_open($file,0);
    }
    open(INFILE, $file) || &error_exit("Error, unable to open $file",1);
    if ($opt_b eq '') {
    print "Logfile $file\n" if ($ENV{'REQUEST_METHOD'} ne "GET");
    print "\n" if ($ENV{'REQUEST_METHOD'} ne "GET" && $opt_n);
    print "<BR>" if ((!($opt_n)) && $ENV{'REQUEST_METHOD'} eq "GET");
}
} else {
    if ($zip != 0) {
#	&retrieve_external_logfile($fileroot,$remote_host_log,$filezip) if ($retrieve_external_log == 1);
	if (!(-r $filezip)) {
	    unlink($lockfile) if ($opt_n ne '');
	    &error_open($filezip,0);
	}
	open(INFILE, "$GZIP $filezip |") || &error_exit("Error, unable to open $filezip",1);
#    if (($zip == 1 || $zip == 0) && $zipcut == 1) {
	if ($opt_b eq '') {
	    print "File $filezip\n" if ($ENV{'REQUEST_METHOD'} ne "GET");
	    print "<BR>" if ($opt_n eq '' && $ENV{'REQUEST_METHOD'} eq "GET");
	}
    }
}

$offset = 0 if ($offset < 0);
seek(INFILE,$offset,0);
$starttime2 = time();

BOUCLE:
while (<INFILE>) {

if ($mail_format == 1) {
    @line_log = split(/\s+/);
    if ($line_log[0] =~ /(\d\d\d\d)-(\d\d)-(\d\d)/) {
	$date = $3.$dirsep.$month_nb[$2-1].$dirsep.$1.":".$line_log[$fields_logfile{'%time'}];
	$module = "exim";
	$mod = $line_log[$fields_logfile{'%module'}];
    } else {
	$year++ if ($month_equiv{$line_log[0]} < $monthold);
	$monthold = $month_equiv{$line_log[0]};
	$date = "$line_log[1]";
	$date = "0".$date if (length($line_log[1]) == 1);
	$date .= "/$line_log[0]/$year";
	($day,$lettermonth,$year) = split(/\//,$date);
	$date .= ":$line_log[2]";
	$module = $line_log[$fields_logfile{'%module'}];
	$module =~ s/\[\d+\]://;
	($mail_server_type,$mod) = split(/\//,$module);
	$mod = $mail_server_type if ($mod eq '');
    }

    $status = 0;
    $tmp = '';

    $message = $line_log[$fields_logfile{'%message'}];

    for ($i=$fields_logfile{'%message'}+1;$i<=$#line_log;$i++) {
	$message .= " ".$line_log[$i];
    }
    next if ($message eq "removed");

    $id = $line_log[$fields_logfile{'%id'}];

    # EXIM
    if ($module eq "exim") {

	($tmp1,@tmp) = split(/\s/,$message);

	if ($mod eq "<=") {
	    $from = $tmp1;
	    ($login,$adresse) = split(/\@/,$from);
	    if ($crypt == 1) {
		$from2 = $from;
		$tmp5 = substr($from2,rindex($from2,'.')+1,length($from2));
		$from2 =~ s/$tmp5\.//;
		$from2 = crypt($from2,"aa");
		$from = $from2.".".$tmp5;

		$login = crypt($login,"aa");

		$adresse2 = $adresse;
		$tmp5 = substr($adresse2,rindex($adresse2,'.')+1,length($adresse2));
		$adresse2 =~ s/$tmp5\.//;
		$adresse2 = crypt($adresse2,"aa");
		$adresse = $adresse2.".".$tmp5;
	    }
	    $adresse = $localdomaine if ($adresse eq '' || $adresse !~ /\./);
	    ($tmp,$requetesize) = split(/\sS=/,$message);
	    $requetesize =~ s/\s.*//;
	    $id_mail{$id} = "$from\t$login\t$adresse\t$requetesize";
	    next BOUCLE;
	}

	if ($mod eq "=>" || $mod eq "->") {
	    $to = $tmp1;
	    $to .= "@".$localdomaine if ($to !~ /\@/);
	    if ($crypt == 1) {
		$adresse2 = $to;
		($tmp6,$tmp7) = split(/\@/,$to);
		$tmp5 = substr($tmp7,rindex($tmp7,'.')+1,length($tmp7));
		$tmp7 =~ s/$tmp5\.//;
		$tmp7 = crypt($tmp7,"aa");
		$to = crypt($tmp6,"aa")."@".$tmp7.".".$tmp5;
	    }
	    $status = 200;
	    ($tmp,$relay) = split(/=/,$tmp[2]);
	    ($from,$login,$adresse,$requetesize) = split(/\t/,$id_mail{$id});

	    $page = $to."&nbsp;&lt;-&nbsp;".$from if ($from !~ /$localdomaine$/);
	    $page = $from."&nbsp;-&gt;&nbsp;".$to if ($from =~ /$localdomaine$/);
#	    undef($id_mail{$id});
	}
    }

    # SENDMAIL

    if ($mod eq "sendmail") {
	($tmp1,$size,@tmp) = split(/,\s/,$message);
	
	if ($tmp1 =~ /^from/) {
	    ($tmp,$from) = split(/=/,$tmp1);
	    $from =~ s/^\<(.*)\>$/$1/;
	    ($login,$adresse) = split(/\@/,$from);
	    $adresse = $localdomaine if ($adresse eq '' || $adresse !~ /\./);
	    ($tmp,$requetesize) = split(/=/,$size);
	    $id_mail{$id} = "$from\t$login\t$adresse\t$requetesize";
	    next BOUCLE;
	}
	if ($tmp1 =~ /^to/) {
	    ($tmp,$to) = split(/=/,$tmp1);
	    $to =~ s/^\<(.*)\>$/$1/;
	    $to .= "@".$localdomaine if ($to !~ /\@/);
	    $delay = $tmp[0];
	    $status = $tmp[6];
	    $relay = $tmp[4];
	    ($tmp,$status) = split(/=/,$status);
	    ($status) = split(/\s+/,$status);
	    $status = 200 if ($status =~ /^sent/i);
	    $status = 404 if ($status =~ /^deferred/i);
	    $status = 401 if ($status =~ /^bounced/i);
	    ($from,$login,$adresse,$requetesize) = split(/\t/,$id_mail{$id});
	    $page = $to."&nbsp;&lt;-&nbsp;".$from if ($from !~ /$localdomaine$/);
	    $page = $from."&nbsp;-&gt;&nbsp;".$to if ($from =~ /$localdomaine$/);
#	    undef($id_mail{$id});
	}
	next BOUCLE if ($to eq '');
    }

    # POSTFIX
    if ($mod eq "qmgr") {
	($from,$size) = split(/,\s/,$message);
	next BOUCLE if ($size eq '');
	($tmp,$from) = split(/=/,$from);
	$from =~ s/^\<(.*)\>$/$1/;
	($tmp,$requetesize) = split(/=/,$size);
	($login,$adresse) = split(/\@/,$from);
	$adresse = $localdomaine if ($adresse eq '' || $adresse !~ /\./);
	$id_mail{$id} = "$from\t$login\t$adresse\t$requetesize";
	next BOUCLE;
    }

    if (($mod eq "lmtp" || $mod eq "smtp") && $id_old == $id) {
	($to,$relay,$delay,$status) = split(/,\s/,$message);
	($tmp,$to) = split(/=/,$to);
	$to =~ s/^\<(.*)\>$/$1/;
	$to .= "@".$localdomaine if ($to !~ /\@/);
	next BOUCLE if ($to eq '');
	($tmp,$status) = split(/=/,$status);
	($status) = split(/\s+/,$status);
	$status = 200 if ($status =~ /^sent/i);
	$status = 404 if ($status =~ /^deferred/i);
	$status = 401 if ($status =~ /^bounced/i);
	($from,$login,$adresse,$requetesize) = split(/\t/,$id_mail{$id});
	$page = $to."&nbsp;&lt;-&nbsp;".$from if ($from !~ /$localdomaine$/);
	$page = $from."&nbsp;-&gt;&nbsp;".$to if ($from =~ /$localdomaine$/);
#	undef($id_mail{$id});
    }

    next BOUCLE if ($tmp eq '');

} elsif ($ftp_format == 1) {

#    if ($ftp_format == 1) {
	@line_log = split(/\s+/);
	chomp($line_log[$#line_log]);
	chop($line_log[$#line_log]) if ($dos_format == 1);
	$line_log[2] = "0".$line_log[2] if ($line_log[2] < 10);
	$date = "$line_log[2]/$line_log[1]/$line_log[4]:$line_log[3]";
	$direction = $line_log[$fields_logfile{'%direction'}];
    } else {
	@line_log = split(/$logfile_sep/);
	chomp($line_log[$#line_log]);
	chop($line_log[$#line_log]) if ($dos_format == 1);
	$struct_logfile = &detect_w3c_logformat($_) if ($line_log[0] =~ /^\#Fields:/);
	next if ($line_log[0] =~ /^\#/);
	$add_fields_logfile = 0;
	$add_fields_logfile = &LoginWithSpace(@line_log) if ($line_log[$fields_logfile{'%login'}] =~ /^\"/);
	$date = $line_log[$fields_logfile{'%date'}+$add_fields_logfile];
	$date =~ s/\[//;
	$date = &date_squid($date) if ($date =~ /\d{9}\.\d{3}/);
	$date = &date_common($line_log[$fields_logfile{'%date'}+$add_fields_logfile],$line_log[$fields_logfile{'%hour'}+$add_fields_logfile]) if ($iis_format == 1 && $fields_logfile{'%date'} ne '');
	$date = $date_filename.":".$line_log[$fields_logfile{'%hour'}+$add_fields_logfile] if ($fields_logfile{'%date'} eq '');
    }
    next if ($date !~ m/^((\d+)\/(\w+)\/(\d\d\d\d):)(.*)/);

    ($jour,$heure,$minute,$seconde) = split(/:/,$date);

    $out = 0;
    $out = 2 if (($date !~ $today) && ($opt_a != 1) && ($opt_n eq ''));
    if ($opt_n ne '') {
#	$out = 1 if ($date !~ /$opt_j/);
	$out = 1 if ($date !~ $filtertoday);
	$out = 1 if ($date =~ $filter_previous && $filter_previous ne '' && $minute < $minutefilter);
	$out = 1 if ($filter_previous eq '' && $minute < $minutefilter);
    }

    last BOUCLE if (($nbdays != 0) && ($out == 2));
    next BOUCLE if (($nbdays == 0) && ($out == 2));
    next if ($date !~ /$opt_j/ && $opt_j ne '');
    next if ($out == 1); # stats sur la journee courante
    next if (/\"format\=/i); # Fasttrack server bug
    $previousjour = $jour;

    $nbdays++ if ($jour ne $previousjour);

    $adresse = $line_log[$fields_logfile{'%host'}] if ($fields_logfile{'%host'} ne '');
    $adresse =~ s/::ffff://; # Ipv6
    $page = $line_log[$fields_logfile{'%page'}+$add_fields_logfile] if ($fields_logfile{'%page'} ne '');
    $page =~ s/$ftpserver// if ($ftp_format == 1);
    $page =~ s/\%3C.*\%3E//g;
    $page =~ s/\&?PHPSESSID=(.*)//i if ($spip == 1);
    $page =~ s/\/\//\// if ($page !~ /^http:\/\//);

    if ($page =~ /\/\.\.\//) {
	while ($page =~ /\/\.\.\//) {
	    $page =~ s/\.\.\///;
	    $pos = index($page,$dirsepurl,1);
	    $page = substr($page,$pos,length($page));
	}
    }

    $d = $line_log[$fields_logfile{'%method'}+$add_fields_logfile];
    $query = $line_log[$fields_logfile{'%query'}+$add_fields_logfile] if ($fields_logfile{'%query'} ne ''); 
    $status = $line_log[$fields_logfile{'%status'}+$add_fields_logfile] if ($fields_logfile{'%status'} ne '');

    if ($notrafic == 0) {
	$requetesize = $line_log[$fields_logfile{'%requetesize'}+$add_fields_logfile] if ($mail_format == 0);
	next if ($requetesize !~ /^\d+/ && $requetesize ne "-" && $ftp_format == 0);
    }

    next if ($direction ne $ftp_direction && $ftp_format == 1);

    if ($struct_logfile =~ /\%refer/) {
	$fullsite = $line_log[$fields_logfile{'%referer'}+$add_fields_logfile];
	$fullsite =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
	$fullsite =~ s/\"//g;
    }

    $vserver = $line_log[$fields_logfile{'%virtualhost'}+$add_fields_logfile] if ($fields_logfile{'%virtualhost'} ne '');
    $vserver = $1 if ($page =~ /^\/\/([-.0-9a-z]+)\//i && $virtualCLF != 0);
    $vserver = $line_log[$#line_log] if ($#logfile_fields == $fields_logfile{'%virtualhost'});
    $page =~ s/\/\/$virtualfilter// if (($virtualCLF != 0 && $virtualfilter ne '') || ($d =~ /$localserver/));

    $elapsed = $line_log[$fields_logfile{'%elapsed'}] if ($fields_logfile{'%elapsed'} ne ''); 
#
    $page =~ s/^http:\/// if ($squid_format == 1);

    $status = $1 if ($query =~ /(\d\d\d);http:\/\// && $type_serveur == 1);
#
    if ($squid_format == 1) {
	$codestatus = $line_log[$fields_logfile{'%codestatus'}];
	($code_squid,$status) = split(/\//,$codestatus);
	$elapsed[$heure] += $elapsed;
	$elapsed_nb[$heure]++;
	$hit_proxy[$heure]++ if ($code_squid =~ /HIT/i);
	$miss_proxy[$heure]++ if ($code_squid =~ /MISS/i);
	$trafic_hit_proxy[$heure] += $requetesize if ($code_squid =~ /HIT/i);
	$trafic_miss_proxy[$heure] += $requetesize if ($code_squid =~ /MISS/i);
	next if ($code_squid =~ /UDP_/);
    }


    if ($ftp_format == 1) {
	$status = 200 if ($status eq 'c');
	$status = 206 if ($status eq 'i');
    }

    next if ($status !~ /^(\d+)$/);
    next if (($status > 399) && ($status < 599));

    next if ($adresse eq '');

    $page =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;

    $page =~ tr/[A-Z]/[a-z]/ if ($type_serveur == 1);
#    next if ($page !~ /^\//); ### REALSERVER
    next if (($page =~ /^http:\/\//i || $page eq '') && $mail_format == 0); # (proxy)
    $page = $dirsep.$page if ($page !~ /^\// && $mail_format == 0);

    next if ($page =~ /$excluderepert/i && $excluderepert ne '');

    next if ($page !~ m#$tri#i && $tri ne '/'); # stats sur une partie du serveur
    next if ($page =~ /$dirsepurl[_]/ && $type_serveur == 1 && $mail_format == 0);

    next if ($d =~ /$localserver/ && $vserver ne '');

    next if ($vserver =~ /$excludevirtual/i && $excludevirtual ne '');
    next if ($vserver !~ /$virtualfilter/i && $virtualfilter ne '' && $vserver ne '');
    next if ($requetesize == 0 && $notrafic == 0) ; #ote les pages ne contenant rien

#
    if ($squid_format != 1) {
	next if ($page =~ /\"$/ && $iis_format != 1); # all format should be %page %protocol
	next if ($d !~ /^\"/ && $iis_format != 1 && $ftp_format != 1); # all format should be %page %protocol
    }

#    $reverse_dns = 0 if ($reverse_dns == 1 && $adresse !~ /[0-9]+$/);

#    $adresse = $nis{$adresse} if ($nis{$adresse} ne '');
    $adresse = &reversedns($adresse) if ($reverse_dns == 1 && $adresse =~ /[0-9]+$/);
    $adresse = $adresse.".".$localdomainename if (split(/[.]/,$adresse) == 1);
    $adresse =~ tr/[A-Z]/[a-z]/;
    next if (($adresse =~ /$localdomaine$/o) && ($locallog == 0));
    next if (($adresse =~ /$nolog/i) && ($nolog ne ''));

    $page .= $defaulthomepage if (substr($page,length($page)-1) eq "/" && $page !~ /\?/);
    $page = $page."?".$query if ($query ne '' && $query !~ /^-,*/);
    
    ($daytoday,$monthtoday,$yeartoday) = split(/\//,$jour);
    next if ($month_equiv{$monthtoday} !~ /(\d+)/);
    next if (length($yeartoday) != 4);

    $domadresse = substr($adresse,(rindex(substr($adresse,0,rindex($adresse,'.')),'.')+1),length($adresse));

    if ($exclude_robot == 1) {
	$foundrobot = 0;
	if ($struct_logfile =~ "%agent") {
	    $i = $fields_logfile{'%agent'};
	    $f = $line_log[$i+$add_fields_logfile];
	    next if ($f =~ /^\d+/);

	    $f = &GetAgentString($f,$i);
	    $foundrobot = &ExcludeRobot($f);
	    if ($foundrobot == 1) { 
		next BOUCLE;
	    }
	}
    }

    if ($exclude_refererspam == 1) {
	$foundreferspam = 0;
	if ($opt_w eq '') {
	    if ($fullsite ne "-" && $fullsite !~ /$localdomainename$/) {
		$site = $fullsite;
		$site =~ s/http:\/\///i;
		$site = substr($site,0,index($site,'/'));
		$sitesh = substr($site,(rindex(substr($site,0,rindex($site,'.')),'.')+1),length($site));
		$foundreferspam = &ExcludeRefererSpamByDomain($sitesh);
	    }
	}
	if ($opt_w ne '') {
	    if ($robot_list ne '') {
		$foundreferspam = 0;
		$foundreferspam = 1 if ($adresse =~ /$spam_list/);
	    }
	}
	if ($foundreferspam == 1) { next BOUCLE }
    }

# maximum : 9 champs dans une adresse !

    next if (split(/[.]/,$adresse) > 9);
    next if (split(/[.]/,$adresse) == 0);

    $last_date = $date;

    if ($firstday eq '') {
	($firstday) = $date; # =~ m/^((\d+)\/(\w+)\/(\d+))(.*)/;
	$ydayfirst = &nbday($firstday);
	$sec_deb = &nb_sec_deb($date);
	$sec_deb -= $decal_sec;
	$sec_old = $sec_deb;
	($tmp,$hour_begin,$min_begin) = split(/:/,$date);
	$min_begin = "0".$min_begin if (length($min_begin) == 1);
	$hour_begin = "0".$hour_begin if (length($hour_begin) == 1);
    }

    if ($opt_n ne '') {

	$sec1 = &nb_sec_deb($date);
	$sec1 -= $decal_sec;
	$sec_ecoule = $sec1-$sec_old;
	$totsec_ecoule += $sec_ecoule;

#	$last_date = $date;
	last if ($current_time < $sec1); ## ICI ONLY

	if ($totsec_ecoule >= $bin_sec) {

	    $sec2 = $sec_old-$sec_deb;
	    $real_hit{$sec2} = $hits;
	    $real_access{$sec2} = $access;
	    $real_trafic{$sec2} = $trafic;
	    $real_host{$sec2} = $host;
	    $hits = 0;
	    $access = 0;
	    $trafic = 0;
	    $host = 0;
	    $totsec_ecoule = 0;
	    undef %server_now;
	}
    }

    $sec_old = $sec1;

    $linelog++;
#    print "$date - $today - $out - $linelog\n";

#($machine,$extra)=split(/[.]/,$adresse);
#next if ($extra eq "" && $locallog == 0);

    if ($oldheure == $heure) {
	$servheure{$adresse}++;
	$hitheure[$heure]++;
	$size[$heure] += $requetesize;
	if ($servheure{$adresse} == 1) {
	    $user[$heure]++;
	}
    } else {
	$oldheure = $heure;
	foreach $adr (keys(%servheure)) {
	    $servheure{$adr} = 0;
	}
	$hitheure[$heure]++;
	$servheure{$adresse}++;
	$size[$heure] += $requetesize;
	if ($servheure{$adresse} == 1) {
	    $user[$heure]++;
	}
    }


### liste des cgi de ce jour
    if ($precision > 2) {
	$d =~ s/\"//g;
	$d =~ tr/[a-z]/[A-Z]/;
	if ($d eq "POST") {
	    $script{$page}++;
	    $scriptunique++ if ($script{$page} == 1);
	}
	if ($d eq "GET" && $page =~ /[^\/]\?/) {
	    ($namescript,$argscript) = split(/\?/,$page);
	    $page = $namescript if ($spip == 0); # to count cgi with html
	    $script{$namescript}++;
	    $scriptunique++ if ($script{$namescript} == 1);
	}
    }

### liste des serveurs de ce jour
    $server{$adresse}++;
    $server_now{$adresse}++ if ($opt_n ne '');
#$max_server = $server{$adresse} if ($server{$adresse} > $max_server);
    $last_host{$adresse} = "$heure$minute";
    $first_host{$adresse} = "$heure$minute" if ($server{$adresse} == 1);
    $serverunique++ if ($server{$adresse} == 1);
    $host++ if ($server_now{$adresse} == 1 && $opt_n ne '');
#    if (substr($page,rindex($page,$carext)) =~ /$extension/i || ($page =~ /\?/ && $spip == 1)) {
	if (($nohtmlext == 1 && $page !~ /[$carext]/) || ($extension ne '' && $page =~ /$extension/i) || ($page =~ /\?/ && $spip == 1) || $mail_format == 1) {

# Problem : session detection
#	    $date = $server_real_date{$adresse,$j};
#	    $tmp1 = ($date- (int($date/100)*100))*100/60 +(int($date/100)*100);
#	    if ($tmp1-$tmp > ($tleclim*100/60) && $tmp != 0) {
#		$tmp2 .= "<HR>";
#		$usersession++;
#	    }

	$server_html{$adresse}++;
	if ($opt_n ne '' || $precision > 3) {
	    $server_real_html_nb{$adresse,$page}++;
	    if ($server_real_html_nb{$adresse,$page} == 1) {
		$server_real_html{$adresse,$server_html{$adresse}} = $page;
	    }
	    $server_real_date{$adresse,$server_html{$adresse}} = "$heure$minute";
	}

    }

#   $serverunique++;
#   if ($precision > 2) {
#       $listadresse[$serverunique] = $adresse;
#       $locserver++ unless ($adresse !~ m/$localdomaine/);
#       }
#}

### Classement par type de fichiers
	     
    $sizepage{$page} += $requetesize; ### NEW
#	     print "$page - $sizepage{$page} - $filetype{$page}\n";

    if ($precision > 2 && $page =~ /\./) {

	if ($page =~ /\?/) {
	    $tmp1 = substr($page,0,rindex($page,'?'));
	    $tmp1 = substr($tmp1,rindex($tmp1,$carext));
	} else {
	    $tmp1 = substr($page,rindex($page,$carext));
	}
	$tmp1 =~ tr/[A-Z]/[a-z]/;
	$tmp1 =~ s/\#.*$//;
	$tmp1 =~ s/\/.*$//;
	if ($notrafic == 0) {
	    $tmp = length($requetesize);
#	    $maxdownloadlength = $tmp if ($tmp > $maxdownloadlength);
#	$download{$tmp1,$tmp}++;
#	$downloadsize{$tmp1,$tmp} += $requetesize;
	    $downloadsize{$tmp1} += $requetesize;
#	push(@listext,$tmp1) if ($downloadsizeext{$tmp1} eq '');
	    $downloadsizeext{$tmp1} += $requetesize;
	}
	$filetype{$page}++; # if ($tmp1 !~ /$extension/);
	$download{$tmp1}++;
	push(@listext,$tmp1) if ($download{$tmp1} == 1);
    }

### liste des pages lues de ce jour
#for ($i=0;$i<=($#extension);$i++) {
#    if (substr($page,rindex($page,'.')+1) =~ /^$extension[$i]$/i) {
#    if (substr($page,rindex($page,$carext)) =~ /$extension/i || ($page =~ /\?/ && $spip == 1)) {

if (($nohtmlext == 1 && $page !~ /[$carext]/) || ($extension ne '' && $page =~ /$extension/i) || ($page =~ /\?/ && $spip == 1) || $mail_format == 1) {

	if ($precision > 2) {
	    $VolumeHtml += $requetesize;
	    $RequeteHtml++;
	    $access++;
	    $accesstot[$heure]++;
	    if ($adresse !~ /$localdomaine$/) {
		$VolumeHtmlExt += $requetesize;
		$RequeteHtmlExt++;
	    } else {
		$VolumeHtmlInt += $requetesize;
		$RequeteHtmlInt++;
	    }
        }
        $pageslues{$page}++;
        $pageunique++ unless ($pageslues{$page} != 1) ;
    }
#  }


    if ($precision > 2) {
	for ($i=0;$i<=($#extensionimage);$i++) {
	    if (substr($page,rindex($page,$carext)+1) =~ /^$extensionimage[$i]$/i) {
		$VolumeGif += $requetesize;
		$RequeteGif++;
		if ($adresse !~ /$localdomaine$/) {
		    $VolumeGifExt += $requetesize;
		    $RequeteGifExt++;
		} else {
		    $VolumeGifInt += $requetesize;
		    $RequeteGifInt++;
		}
	    }
	}
	$VolumeTotal += $requetesize;
	$trafic += $requetesize;

	if ($adresse !~ /$localdomaine$/) {
	    $VolumeTotalExt+=$requetesize ;
	    $extreq++;
	} else {
	    $VolumeTotalInt+=$requetesize ;
	}
    }
    
    $reqtot++;
    $hits++;
    $domreq++ unless ($adresse !~ /$localdomaine$/);

}

close(INFILE);

if ($reqtot == 0 && $opt_b eq '') {
    if ($opt_n eq '') {
	$msg ="Problem :\n";
	$msg .= "          - No current logfile found or\n";
	$msg .= "          - Your logfile does not contains any data";
	($jour,$heure,$minute,$seconde) = split(/:/,$date);
	$today =~ s/\// /g;
	$jour =~ s/\// /g;
	if ($date ne '' && $today ne $jour) {
	    $msg .= " about $today !\n";
	    $msg .= "Today is $today, last logfile entry is $jour";
	}
	$msg .= "\n";
	&error_exit($msg,0);
    }
    else {

	&error_exit("Nothing to scan during the last $filter_min minutes",0) if ($opt_w ne '');
#	&error_exit("Nothing to scan during the last $filter_min minutes",0) if ($ENV{'REQUEST_METHOD'} ne "GET");
	print "Nothing to scan during the last $filter_min minutes\n" if ($opt_w eq '' && $ENV{'REQUEST_METHOD'} ne "GET");
    }
#    exit;
}

#################################################################
###                    computing maxima                       ###
#################################################################

# nbre max de users , d'access html et sur la taille

if ($linelog != 0) {

    $max = 0;
    $maxhit = 0;
    $maxsize = 0;
    $maxhtml = 0;
    $maxelapsed = 0;
    $maxhitproxy = 0;
    $maxmissproxy = 0;
    $maxtraficmissproxy = 0;
    $maxtrafichitproxy = 0;

    for ($i=0;$i<=$hour;$i++) {
	if ($hitheure[$i] > $maxhit) {
	    $maxhit = $hitheure[$i];
	}
	if ($user[$i] > $max) {
	    $max = $user[$i];
	}
	if ($size[$i] > $maxsize) {
	    $maxsize = $size[$i];
	}
	if ($accesstot[$i] > $maxhtml) {
	    $maxhtml = $accesstot[$i];
	}
	if ($squid_format == 1) {
	    if ($trafic_hit_proxy[$i] > $maxtrafichitproxy) {
		$maxtrafichitproxy = $trafic_hit_proxy[$i];
	    }
	    if ($trafic_miss_proxy[$i] > $maxtraficmissproxy) {
		$maxtraficmissproxy = $trafic_miss_proxy[$i];
	    }
	    if ($hit_proxy[$i] > $maxhitproxy) {
		$maxhitproxy = $hit_proxy[$i];
	    }
	    if ($miss_proxy[$i] > $maxmissproxy) {
		$maxmissproxy = $miss_proxy[$i];
	    }
	    if ($elapsed_nb[$i] != 0) {
		if (($elapsed[$i]/$elapsed_nb[$i]) > $maxelapsed) {
		    $maxelapsed = $elapsed[$i]/$elapsed_nb[$i];
		}
	    }
	}
    }

# Tri des zones de filetype

for ($k=0;$k<=$#listext;$k++) {

#    next if ($listext[$k] =~ /$extension/);
    $listextbis[$k] = $listext[$k];
    
#    $tmp2 = 0;
#    $tmp3 = 0;
#    for ($j=1;$j<=$maxdownloadlength;$j++) {
#	$tmp2 += $download{$listext[$k],$j};
#	$tmp3 += $downloadsize{$listext[$k],$j};
#    }
    $tmp2 = $download{$listext[$k]};
    $tmp3 = $downloadsize{$listext[$k]};
    $zoneext[$extfilenb{$listext[$k]}] += $tmp2;
    $downloadext[$extfilenb{$listext[$k]}] += $tmp3;
}

##

for ($k=0;$k<=$nbzonefile;$k++) {
    $zoneextbis[$k] = $zoneext[$k];
}

for ($j=0;$j<=$nbzonefile;$j++) {
    $maxi = $zoneextbis[$j];
    $filetypemax[$j] = 0;
    for ($k=0;$k<=$nbzonefile;$k++) {
	if ($zoneextbis[$k] > $maxi) {
	    $maxi = $zoneextbis[$k];
	    $filetypemax[$j] = $k;
	}
    }
    $zoneextbis[$filetypemax[$j]] = 0;      
}


# tri des $topten meilleurs script
$bouclescript = $topten unless ($scriptunique < $topten);
$bouclescript = $scriptunique unless ($scriptunique > ($topten-1));

#for ($i=0;$i < $bouclescript;$i++) {
#$maxi = 0;
#foreach $page (keys(%script)) {
#    if ($script{$page} > $maxi) {
#         $maxi = $script{$page};
#         $bestscript[$i] = $page;
#         $occurscript[$i] = $script{$page};
#         }
#    }
#$script{$bestscript[$i]} = 0;
#}

# tri des $topten sites par date

if ($opt_a eq '') {
    for ($i=0;$i < $serverunique;$i++) {
	$maxi = 0;
	foreach $page (sort (keys(%last_host))) {
	    if ($last_host{$page} > $maxi) {
		$maxi = $last_host{$page};
		$bestserverdate[$i] = $page;
#		$bestserverdatenb{$page,$i}++;
#		print "OTTO $page - $last_host{$page} - $i - $bestserverdatenb{$page,$i}\n";
		$occurserverdate[$i] = $last_host{$page};
		$t_time2 = int($last_host{$page}/100)*60 + ($last_host{$page} - (int($last_host{$page}/100)*100));
		$t_time1 = int($first_host{$page}/100)*60 + ($first_host{$page} - (int($first_host{$page}/100)*100));
		$t_time = $t_time2 - $t_time1;
		$occurserverdate_time[$i] = $t_time;
	    }
	}
	$last_host{$bestserverdate[$i]} = 0;
    }
}

# tri des $topten meilleures pages lues

$boucle = $topten unless ($pageunique < $topten);
$boucle = $pageunique unless ($pageunique > ($topten-1));

#for ($i=0;$i < $boucle;$i++) {
#    $maxi = 0;
#    foreach $page (keys(%pageslues)) {
#	if ($pageslues{$page} > $maxi) {
#	    $maxi = $pageslues{$page};
#	    $bestpage[$i] = $page;
#	    $occur[$i] = $pageslues{$page};
#	}
#    }
#    $pageslues{$bestpage[$i]} = 0;
#}


# unite pour l'affichage a l'ecran
$unite = ($max*$square)/100 unless ($max == 0);
$unite = 1 unless ($max != 0);

$unitehit = ($maxhit*$square)/100 unless ($maxhit == 0);
$unitehit = 1 unless ($maxhit != 0);

$unitehtml = ($maxhtml*$square)/100 unless ($maxhtml == 0);
$unitehtml = 1 unless ($maxhtml != 0);

$unitesize = $maxsize/10 unless ($maxsize == 0);
$unitesize = 1 unless ($maxsize != 0);

if ($squid_format == 1) {
$uniteelapsed = $maxelapsed/10 unless ($maxelapsed == 0);
$uniteelapsed = 1 unless ($maxelapsed != 0);

$unitehitproxy = $maxhitproxy/10 unless ($maxhitproxy == 0);
$unitehitproxy = 1 unless ($maxhitproxy != 0);

$unitemissproxy = $maxmissproxy/10 unless ($maxmissproxy == 0);
$unitemissproxy = 1 unless ($maxmissproxy != 0);

$unitetrafichitproxy = $maxtrafichitproxy/10 unless ($maxtrafichitproxy == 0);
$unitetrafichitproxy = 1 unless ($maxtrafichitproxy != 0);

$unitetraficmissproxy = $maxtraficmissproxy/10 unless ($maxtraficmissproxy == 0);
$unitetraficmissproxy = 1 unless ($maxtraficmissproxy != 0);
}

# conversion en Mo

$VolumeTotal /= (1024*1024);
$VolumeTotalExt /= (1024*1024);
$VolumeTotalInt /= (1024*1024);
$VolumeHtml /= (1024*1024);
$VolumeHtmlExt /= (1024*1024);
$VolumeHtmlInt /= (1024*1024);
$VolumeGif /= (1024*1024);
$VolumeGifExt /= (1024*1024);
$VolumeGifInt /= (1024*1024);

#############################################################################

&save_reverse_dns if ($reverse_dns == 1); # sauvegarde de la table de DNS
}

if ($opt_n ne '') {

    $sec_deb = $current_time-$filter_sec;

    for ($i=0;$i<=$filter_sec;$i++) {
	$real_hit{$i} = 0 if ($real_hit{$i} eq '');
	$real_access{$i} = 0 if ($real_access{$i} eq '');
	$real_trafic{$i} = 0 if ($real_trafic{$i} eq '');
	$real_host{$i} = 0 if ($real_host{$i} eq '');

	if ($real_hit{$i} != 0) {
	    $real_hit_max = $real_hit{$i} if ($real_hit{$i} > $real_hit_max);

	    for ($k=0;$k<$bin_sec;$k++) {
		$tmp = $i-$k;
		$real_hit{$tmp} = $real_hit{$i};
	    }
	}
	if ($real_access{$i} != 0) {
	    $real_access_max = $real_access{$i} if ($real_access{$i} > $real_access_max);
	    for ($k=0;$k<$bin_sec;$k++) {
		$tmp = $i-$k;
		$real_access{$tmp} = $real_access{$i};
	    }
	}
	if ($real_trafic{$i} != 0) {
	    $real_trafic_max = $real_trafic{$i} if ($real_trafic{$i} > $real_trafic_max);
	    for ($k=0;$k<$bin_sec;$k++) {
		$tmp = $i-$k;
		$real_trafic{$tmp} = $real_trafic{$i};
	    }
	}
	if ($real_host{$i} != 0) {
	    $real_host_max = $real_host{$i} if ($real_host{$i} > $real_host_max);
	    for ($k=0;$k<$bin_sec;$k++) {
		$tmp = $i-$k;
		$real_host{$tmp} = $real_host{$i};
	    }
	}

    }

    $realhit = $path.$dirtmp.$dirsep."realhit".$gifext;
    $realhitx = $path.$dirtmp.$dirsep."realhitx".$gifext;
    $realhity = $path.$dirtmp.$dirsep."realhity".$gifext;
    $linkrealhit = "..".$dirsepurl."..".$dirsepurl.$dirtmp.$dirsepurl."realhit".$gifext;
    $linkrealhitx =  "..".$dirsepurl."..".$dirsepurl.$dirtmp.$dirsepurl."realhitx".$gifext;
    $linkrealhity =  "..".$dirsepurl."..".$dirsepurl.$dirtmp.$dirsepurl."realhity".$gifext;

    $realaccess = $path.$dirtmp.$dirsep."realaccess".$gifext;
    $realaccessx = $path.$dirtmp.$dirsep."realaccessx".$gifext;
    $realaccessy = $path.$dirtmp.$dirsep."realaccessy".$gifext;
    $linkrealaccess = "..".$dirsepurl."..".$dirsepurl.$dirtmp.$dirsepurl."realaccess".$gifext;
    $linkrealaccessx =  "..".$dirsepurl."..".$dirsepurl.$dirtmp.$dirsepurl."realaccessx".$gifext;
    $linkrealaccessy =  "..".$dirsepurl."..".$dirsepurl.$dirtmp.$dirsepurl."realaccessy".$gifext;

    $realtrafic = $path.$dirtmp.$dirsep."realtrafic".$gifext;
    $realtraficx = $path.$dirtmp.$dirsep."realtraficx".$gifext;
    $realtraficy = $path.$dirtmp.$dirsep."realtraficy".$gifext;
    $linkrealtrafic = "..".$dirsepurl."..".$dirsepurl.$dirtmp.$dirsepurl."realtrafic".$gifext;
    $linkrealtraficx =  "..".$dirsepurl."..".$dirsepurl.$dirtmp.$dirsepurl."realtraficx".$gifext;
    $linkrealtraficy =  "..".$dirsepurl."..".$dirsepurl.$dirtmp.$dirsepurl."realtraficy".$gifext;

    $realhost = $path.$dirtmp.$dirsep."realhost".$gifext;
    $realhostx = $path.$dirtmp.$dirsep."realhostx".$gifext;
    $realhosty = $path.$dirtmp.$dirsep."realhosty".$gifext;
    $linkrealhost = "..".$dirsepurl."..".$dirsepurl.$dirtmp.$dirsepurl."realhost".$gifext;
    $linkrealhostx =  "..".$dirsepurl."..".$dirsepurl.$dirtmp.$dirsepurl."realhostx".$gifext;
    $linkrealhosty =  "..".$dirsepurl."..".$dirsepurl.$dirtmp.$dirsepurl."realhosty".$gifext;

    unlink($realhit);
    unlink($realhitx);
    unlink($realhity);
    unlink($realaccess);
    unlink($realaccessx);
    unlink($realaccessy);
    unlink($realtrafic);
    unlink($realtraficx);
    unlink($realtraficy);
    unlink($realhost);
    unlink($realhostx);
    unlink($realhosty);

    ###
    ### Generation des graphs
    ###

    $xmax = 300;
    $ymax = 100;
    $grad = 5;

#    $xmax = 450;               # x graph size
#    $ymax = 250;               # y graph size
#    $grad = 10;                # number of graduation
    $xstep = int($xmax/$grad); # x step for graph
    $ystep = int($ymax/$grad); # y step for graph
    $xdecal = 50;              # x scale width
    $xdecalm = $xdecal - 5;    # length of x scale
    $ydecal = 40;              # y scale width
    $ydecalm = $ydecal - 15;   # length of y scale

    $pos = rindex($conf_file,$dirsep);
    $vtmp = substr($conf_file,$pos+1,length($conf_file));
    $pos = rindex($0,"-");
    $vtmp .= substr($0,$pos+1,length($0));
    $vtmp =~ s/$plext//g;

    unlink("$tmpfly$vtmp");

    #
    ### Graphs sur les hits
    #

    $it = length($filter_sec)-1;
    $div = 10**$it;
    $factx = ($div*(int($filter_sec/$div)+1))/$grad;
    
    $factx = 1 if ($it == 0);
    
    $it = length($real_hit_max)-1;
    $div = 10**$it;
    $facty = ($div*(int($real_hit_max/$div)+1))/$grad;

    open(FLY,">$tmpfly$vtmp");
    print FLY "new\n";
    print FLY "size $xmax,$ymax\n";
    print FLY "frect 0,0,0,0,200,200,200\n";
    for ($i=0;$i<=$filter_sec;$i++) {
	$x1 = $i*$xstep/$factx;
	$x2 = ($i+1)*$xstep/$factx;
	
	$y2 = $ymax - ($ystep/$facty * $real_hit{$i});
	print FLY "line $x1,$y2,$x1,$ymax,$red[0],$green[0],$blue[0]\n";
    }

    for ($i=$ystep;$i<=$ymax;$i+=$ystep) {
	print FLY "line $0,$i,$xmax,$i,150,150,150\n";
    }
    $tmp = $ymax-1;
    print FLY "line $0,$tmp,$xmax,$tmp,150,150,150\n";

    print FLY "transparent 200,200,200\n";
    close (FLY);
    
    open(FOO,"$FLY -q -i $tmpfly$vtmp -o $realhit |");
    while( <FOO> ) {print;}
    close(FOO);

    chmod 0666, $realhit;

    # image pour les abscisses

    $xlegend = "Requests";
    
    open(FLY,">$tmpfly$vtmp");
    print FLY "new\n";
    print FLY "size $xmax,$ydecal\n";
    print FLY "frect 0,0,0,0,200,200,200\n";
    $posx = (($xmax/2)-(length($xlegend)*7/2));
    print FLY "string 0,0,0,$posx,$ydecalm,medium,$xlegend\n";
    for ($i=$xstep;$i<=$xmax;$i+=$xstep) {
	$valstep = $i*$factx/$xstep;
	$valstep = int($valstep/60);
	$valstep += $min_begin;
	$valstep2 = $hour_begin;
	if ($valstep > 59) {
	    $valstep2 += int($valstep/60);
#	    $valstep2 = 0 if ($valstep2 > 24);
	    $valstep = $valstep-(int($valstep/60)*60);
	    $valstep2 = "0".$valstep2 if (length($valstep2) == 1);
	}
	$valstep = "0".$valstep if (length($valstep) == 1);
	$valstep = $valstep2.":".$valstep;
	$posx = $i - length(int($valstep))*5;
	print FLY "line $i,0,$i,5,0,0,0\n";
	print FLY "string 0,0,0,$posx,10,small,$valstep\n";
    }
    print FLY "transparent 200,200,200\n";
    close (FLY);

    open(FOO,"$FLY -q -i $tmpfly$vtmp -o $realhitx |");
    while( <FOO> ) {print;}
    close(FOO);

    chmod 0666, $realhitx;
    
    # image pour les ordonnees
 
    open(FLY,">$tmpfly$vtmp");
    print FLY "new\n";
    print FLY "size $xdecal,$ymax\n";
    print FLY "frect 0,0,0,0,200,200,200\n";
    for ($i=$ystep;$i<=$ymax;$i+=$ystep) {
	$valstep = int(($ymax - $i) * ($facty/$ystep));
	$valstep = int(($ymax - $i) / ($ystep/$facty)) if ($facty < $ystep);
	$pos = ($xdecal - length($valstep)*9);
	$posy = $i-5;
	print FLY "line $xdecalm,$i,$xdecal,$i,0,0,0\n";
	print FLY "string 0,0,0,$pos,$posy,small,$valstep\n";
    }
    print FLY "transparent 200,200,200\n";
    close (FLY);
    
    open(FOO,"$FLY -q -i $tmpfly$vtmp -o $realhity |");
    while( <FOO> ) {print;}
    close(FOO);

    chmod 0666, $realhity;

    #
    ### graphe sur les access
    #

    $it = length($real_access_max)-1;
    $div = 10**$it;
    $facty = ($div*(int($real_access_max/$div)+1))/$grad;

    open(FLY,">$tmpfly$vtmp");
    print FLY "new\n";
    print FLY "size $xmax,$ymax\n";
    print FLY "frect 0,0,0,0,200,200,200\n";
    for ($i=0;$i<=$filter_sec;$i++) {
	$x1 = $i*$xstep/$factx;
	$x2 = ($i+1)*$xstep/$factx;
       	$y2 = $ymax - ($ystep/$facty * $real_access{$i});
	print FLY "line $x1,$y2,$x1,$ymax,$red[1],$green[1],$blue[1]\n";
    }

    for ($i=$ystep;$i<=$ymax;$i+=$ystep) {
	print FLY "line $0,$i,$xmax,$i,150,150,150\n";
    }
    $tmp = $ymax-1;
    print FLY "line $0,$tmp,$xmax,$tmp,150,150,150\n";

    print FLY "transparent 200,200,200\n";
    close (FLY);
    
    open(FOO,"$FLY -q -i $tmpfly$vtmp -o $realaccess |");
    while( <FOO> ) {print;}
    close(FOO);

    chmod 0666, $realaccess;

    # image pour les abscisses

    $xlegend = "Accesses";
    
    open(FLY,">$tmpfly$vtmp");
    print FLY "new\n";
    print FLY "size $xmax,$ydecal\n";
    print FLY "frect 0,0,0,0,200,200,200\n";
    $posx = (($xmax/2)-(length($xlegend)*7/2));
    print FLY "string 0,0,0,$posx,$ydecalm,medium,$xlegend\n";
    for ($i=$xstep;$i<=$xmax;$i+=$xstep) {
	$valstep = $i*$factx/$xstep;
	$valstep = int($valstep/60);
	$valstep += $min_begin;
	$valstep2 = $hour_begin;
	if ($valstep > 59) {
	    $valstep2 += int($valstep/60);
	    $valstep = $valstep-(int($valstep/60)*60);
	    $valstep2 = "0".$valstep2 if (length($valstep2) == 1);
	}
	$valstep = "0".$valstep if (length($valstep) == 1);
	$valstep = $valstep2.":".$valstep;
	$posx = $i - length(int($valstep))*5;
	print FLY "line $i,0,$i,5,0,0,0\n";
	print FLY "string 0,0,0,$posx,10,small,$valstep\n";
    }
    print FLY "transparent 200,200,200\n";
    close (FLY);

    open(FOO,"$FLY -q -i $tmpfly$vtmp -o $realaccessx |");
    while( <FOO> ) {print;}
    close(FOO);

    chmod 0666, $realaccessx;

    # image pour les ordonnees
 
    open(FLY,">$tmpfly$vtmp");
    print FLY "new\n";
    print FLY "size $xdecal,$ymax\n";
    print FLY "frect 0,0,0,0,200,200,200\n";
    for ($i=$ystep;$i<=$ymax;$i+=$ystep) {
	$valstep = int(($ymax - $i) * ($facty/$ystep));
	$valstep = int(($ymax - $i) / ($ystep/$facty)) if ($facty < $ystep);
	$pos = ($xdecal - length($valstep)*9);
	$posy = $i-5;
	print FLY "line $xdecalm,$i,$xdecal,$i,0,0,0\n";
	print FLY "string 0,0,0,$pos,$posy,small,$valstep\n";
    }
    print FLY "transparent 200,200,200\n";
    close (FLY);
    
    open(FOO,"$FLY -q -i $tmpfly$vtmp -o $realaccessy |");
    while( <FOO> ) {print;}
    close(FOO);

    chmod 0666, $realaccessy;

    #
    ### graphe sur le trafic
    #

    $it = length($real_trafic_max)-1;
    $div = 10**$it;
    $facty = ($div*(int($real_trafic_max/$div)+1))/$grad;

    open(FLY,">$tmpfly$vtmp");
    print FLY "new\n";
    print FLY "size $xmax,$ymax\n";
    print FLY "frect 0,0,0,0,200,200,200\n";
    for ($i=0;$i<=$filter_sec;$i++) {
	$x1 = $i*$xstep/$factx;
	$x2 = ($i+1)*$xstep/$factx;
	
	$y2 = $ymax - ($ystep/$facty * $real_trafic{$i});
	print FLY "line $x1,$y2,$x1,$ymax,$red[2],$green[2],$blue[2]\n";
    }

    for ($i=$ystep;$i<=$ymax;$i+=$ystep) {
	print FLY "line $0,$i,$xmax,$i,150,150,150\n";
    }
    $tmp = $ymax-1;
    print FLY "line $0,$tmp,$xmax,$tmp,150,150,150\n";

    print FLY "transparent 200,200,200\n";
    close (FLY);
    
    open(FOO,"$FLY -q -i $tmpfly$vtmp -o $realtrafic |");
    while( <FOO> ) {print;}
    close(FOO);

    chmod 0666, $realtrafic;

    # image pour les abscisses

    $xlegend = "Traffic (Kb)";
    
    open(FLY,">$tmpfly$vtmp");
    print FLY "new\n";
    print FLY "size $xmax,$ydecal\n";
    print FLY "frect 0,0,0,0,200,200,200\n";
    $posx = (($xmax/2)-(length($xlegend)*7/2));
    print FLY "string 0,0,0,$posx,$ydecalm,medium,$xlegend\n";
    for ($i=$xstep;$i<=$xmax;$i+=$xstep) {
	$valstep = $i*$factx/$xstep;
	$valstep = int($valstep/60);
	$valstep += $min_begin;
	$valstep2 = $hour_begin;
	if ($valstep > 59) {
	    $valstep2 += int($valstep/60);
	    $valstep = $valstep-(int($valstep/60)*60);
	    $valstep2 = "0".$valstep2 if (length($valstep2) == 1);
	}
	$valstep = "0".$valstep if (length($valstep) == 1);
	$valstep = $valstep2.":".$valstep;
	$posx = $i - length(int($valstep))*5;
	print FLY "line $i,0,$i,5,0,0,0\n";
	print FLY "string 0,0,0,$posx,10,small,$valstep\n";
    }
    print FLY "transparent 200,200,200\n";
    close (FLY);

    open(FOO,"$FLY -q -i $tmpfly$vtmp -o $realtraficx |");
    while( <FOO> ) {print;}
    close(FOO);

   chmod 0666, $realtraficx;

    # image pour les ordonnees
 
    open(FLY,">$tmpfly$vtmp");
    print FLY "new\n";
    print FLY "size $xdecal,$ymax\n";
    print FLY "frect 0,0,0,0,200,200,200\n";
    for ($i=$ystep;$i<=$ymax;$i+=$ystep) {
	$valstep = int(($ymax - $i) * ($facty/$ystep));
	$valstep = int(($ymax - $i) / ($ystep/$facty)) if ($facty < $ystep);
	$valstep = int($valstep/1024);
	$pos = ($xdecal - length($valstep)*9);
	$posy = $i-5;
	print FLY "line $xdecalm,$i,$xdecal,$i,0,0,0\n";
	print FLY "string 0,0,0,$pos,$posy,small,$valstep\n";
    }
    print FLY "transparent 200,200,200\n";
    close (FLY);
    
    open(FOO,"$FLY -q -i $tmpfly$vtmp -o $realtraficy |");
    while( <FOO> ) {print;}
    close(FOO);

    chmod 0666, $realtraficy;

    #
    ### graphe sur les hosts
    #

    $it = length($real_host_max)-1;
    $div = 10**$it;
    $facty = ($div*(int($real_host_max/$div)+1))/$grad;

    open(FLY,">$tmpfly$vtmp");
    print FLY "new\n";
    print FLY "size $xmax,$ymax\n";
    print FLY "frect 0,0,0,0,200,200,200\n";
    for ($i=0;$i<=$filter_sec;$i++) {
	$x1 = $i*$xstep/$factx;
	$x2 = ($i+1)*$xstep/$factx;
	
	$y2 = $ymax - ($ystep/$facty * $real_host{$i});
	print FLY "line $x1,$y2,$x1,$ymax,$red[4],$green[4],$blue[4]\n";
    }

    for ($i=$ystep;$i<=$ymax;$i+=$ystep) {
	print FLY "line $0,$i,$xmax,$i,150,150,150\n";
    }
    $tmp = $ymax-1;
    print FLY "line $0,$tmp,$xmax,$tmp,150,150,150\n";

    print FLY "transparent 200,200,200\n";
    close (FLY);
    
    open(FOO,"$FLY -q -i $tmpfly$vtmp -o $realhost |");
    while( <FOO> ) {print;}
    close(FOO);

    chmod 0666, $realhost;

    # image pour les abscisses

    $xlegend = "Hosts";
    
    open(FLY,">$tmpfly$vtmp");
    print FLY "new\n";
    print FLY "size $xmax,$ydecal\n";
    print FLY "frect 0,0,0,0,200,200,200\n";
    $posx = (($xmax/2)-(length($xlegend)*7/2));
    print FLY "string 0,0,0,$posx,$ydecalm,medium,$xlegend\n";
    for ($i=$xstep;$i<=$xmax;$i+=$xstep) {
	$valstep = $i*$factx/$xstep;
	$valstep = int($valstep/60);
	$valstep += $min_begin;
	$valstep2 = $hour_begin;
	if ($valstep > 59) {
	    $valstep2 += int($valstep/60);
	    $valstep = $valstep-(int($valstep/60)*60);
	    $valstep2 = "0".$valstep2 if (length($valstep2) == 1);
	}
	$valstep = "0".$valstep if (length($valstep) == 1);
	$valstep = $valstep2.":".$valstep;
	$posx = $i - length(int($valstep))*5;
	print FLY "line $i,0,$i,5,0,0,0\n";
	print FLY "string 0,0,0,$posx,10,small,$valstep\n";
    }
    print FLY "transparent 200,200,200\n";
    close (FLY);

    open(FOO,"$FLY -q -i $tmpfly$vtmp -o $realhostx |");
    while( <FOO> ) {print;}
    close(FOO);

    chmod 0666, $realhostx;

    # image pour les ordonnees
 
    open(FLY,">$tmpfly$vtmp");
    print FLY "new\n";
    print FLY "size $xdecal,$ymax\n";
    print FLY "frect 0,0,0,0,200,200,200\n";
    for ($i=$ystep;$i<=$ymax;$i+=$ystep) {
	$valstep = int(($ymax - $i) * ($facty/$ystep));
	$valstep = int(($ymax - $i) / ($ystep/$facty)) if ($facty < $ystep);
	$pos = ($xdecal - length($valstep)*9);
	$posy = $i-5;
	print FLY "line $xdecalm,$i,$xdecal,$i,0,0,0\n";
	print FLY "string 0,0,0,$pos,$posy,small,$valstep\n";
    }
    print FLY "transparent 200,200,200\n";
    close (FLY);
    
    open(FOO,"$FLY -q -i $tmpfly$vtmp -o $realhosty |");
    while( <FOO> ) {print;}
    close(FOO);

    chmod 0666, $realhosty;
}

###############################################################
### creation du fichier contenant les stats pour les heures ###
###############################################################

$conv = 1;
$convunit = "Data_unit_octet";

if ($maxsize > 1024) {
    $conv = 1024;
    $convunit = "Kb";
}

if ($maxsize > (1024*1024)) {
    $conv = 1024*1024;
    $convunit = "Mb";
}

if ($maxsize > (1024*1024*1024)) {
    $conv = 1024*1024*1024;
    $convunit = "Gb";
}

#$VolumeTotal /= 1024 if ($convunit eq "Gb");

# pour CGI

if ($type_serveur != 1) {

    $pos = rindex($path,$pathserver);
    if ($pos != -1) {
	$tmp = length($pathserver);
	$link = substr($path,$tmp,length($path));
    } else {
# try to guess from /htdocs/, /html/, /www/
	$tmp = "/htdocs/";
	$link = substr($path,index($path,$tmp)+length($tmp)-1,length($path)) if (index($path,$tmp) != -1);
	$tmp = "/html/";
	$link = substr($path,index($path,$tmp)+length($tmp)-1,length($path)) if (index($path,$tmp) != -1);
	$tmp = "/www/";
	$link = substr($path,index($path,$tmp)+length($tmp)-1,length($path)) if (index($path,$tmp) != -1);
    }
    print "Unable to compute the right path from $path - contact me please\n" if ($link eq '');

    $link2 = $link;

    if ($backgrd =~ /background/i && $ENV{'REQUEST_METHOD'} eq "GET") {
	$backgrd =~ s/BACKGROUND="(.*)\/(.*)"/BACKGROUND="$link2$dirress$dirsep$2"/i if ($background !~ /^\// && $background !~ /^http/);
    }

    if ($ENV{'REQUEST_METHOD'} eq "GET") {

	$linkrealhit =~ s/(.*)\/(.*)/$link2$dirtmp$dirsep$2/i;
	$linkrealhitx =~ s/(.*)\/(.*)/$link2$dirtmp$dirsep$2/i;
	$linkrealhity =~ s/(.*)\/(.*)/$link2$dirtmp$dirsep$2/i;
	$linkrealaccess =~ s/(.*)\/(.*)/$link2$dirtmp$dirsep$2/i;
	$linkrealaccessx =~ s/(.*)\/(.*)/$link2$dirtmp$dirsep$2/i;
	$linkrealaccessy =~ s/(.*)\/(.*)/$link2$dirtmp$dirsep$2/i;
	$linkrealtrafic =~ s/(.*)\/(.*)/$link2$dirtmp$dirsep$2/i;
	$linkrealtraficx =~ s/(.*)\/(.*)/$link2$dirtmp$dirsep$2/i;
	$linkrealtraficy =~ s/(.*)\/(.*)/$link2$dirtmp$dirsep$2/i;
	$linkrealhost =~ s/(.*)\/(.*)/$link2$dirtmp$dirsep$2/i;
	$linkrealhostx =~ s/(.*)\/(.*)/$link2$dirtmp$dirsep$2/i;
	$linkrealhosty =~ s/(.*)\/(.*)/$link2$dirtmp$dirsep$2/i;

	$link_use =~ s/(.*)\/(.*)/$link2$dirress$dirsep$2/i;
    }
}


# Save in csv format

if ($maxhit != 0) {
if ($opt_n eq '') {
    $filehour = $path.$dircsv.$dirsep.$dirresume.$csvext;
    open(FILEHOUR,">$filehour") || &error_exit("Error, unable to open $filehour",1);
    &HourCSV(*FILEHOUR);
    close(FILEHOUR);
}

    for ($nblang=0;$nblang<=$#lang;$nblang++) {

	mkdir("$path$lang[$nblang]$dirsep$dirdate$dirsep$dirresume") if (!(-d "$path$lang[$nblang]$dirsep$dirdate$dirsep$dirresume"));

	$filehour = $path.$lang[$nblang].$dirsep.$dirdate.$dirsep.$dirresume.$dirsep.$filenamehour if ($opt_j ne '' || $opt_b ne '');
#	$filehour = $path.$lang[$nblang].$dirsep.$dirdate.$dirsep.$filenamehour if ($opt_n eq '');
	$filehour = $path.$lang[$nblang].$dirsep.$dirdate.$dirsep.$filenamehour if ($opt_j eq '' && $opt_b eq '');
	$filehour = $path.$lang[$nblang].$dirsep.$dirdate.$dirsep.$file_now if ($opt_n ne '');
	
	open(FILEHOUR,">$filehour") || &error_exit("Error, unable to open $filehour",1);
	
	&HourHeader(*FILEHOUR, eval($Lang{$lang[$nblang]}),$lang[$nblang]);
	&GraphHour(*FILEHOUR, eval($Lang{$lang[$nblang]}),$lang[$nblang]) if ($opt_n ne '');
	if ($opt_n eq '') {

	    $string = "\n<TABLE BORDER=0 WIDTH=\"100%\">\n<TR>\n<TD VALIGN=TOP>\n";
	    &TableMasterDisplay(*FILEHOUR, eval($Lang{$lang[$nblang]}),$string);
	    &HourHits(*FILEHOUR, eval($Lang{$lang[$nblang]}));

	    if ($mail_format == 0 && $ftp_format == 0) {
		$string = "\n</TD>\n<TD VALIGN=TOP>\n";
		&TableMasterDisplay(*FILEHOUR, eval($Lang{$lang[$nblang]}),$string);
		&HourPages(*FILEHOUR, eval($Lang{$lang[$nblang]}));
	    }

	    $string = "\n</TD>\n<TD VALIGN=TOP>\n";
	    &TableMasterDisplay(*FILEHOUR, eval($Lang{$lang[$nblang]}),$string);
	    &HourHosts(*FILEHOUR, eval($Lang{$lang[$nblang]}));

	    if ($precision > 2 && $notrafic == 0) {
		$string = "\n</TD>\n<TD VALIGN=TOP>\n";
		&TableMasterDisplay(*FILEHOUR, eval($Lang{$lang[$nblang]}),$string);
		&HourTraffic(*FILEHOUR, eval($Lang{$lang[$nblang]}));
	    }

	    $string = "</TD>\n</TR>\n</TABLE>\n";
	    &TableMasterDisplay(*FILEHOUR, eval($Lang{$lang[$nblang]}),$string);

#	    &HourElapsed(*FILEHOUR, eval($Lang{$lang[$nblang]})) if ($precision > 2 && $squid_format == 1);
#	    &HourHitProxy(*FILEHOUR, eval($Lang{$lang[$nblang]})) if ($precision > 2 && $squid_format == 1);
#	    &HourMissProxy(*FILEHOUR, eval($Lang{$lang[$nblang]})) if ($precision > 2 && $squid_format == 1);
	    &HourProxy(*FILEHOUR, eval($Lang{$lang[$nblang]})) if ($precision > 2 && $squid_format == 1);
	}
	&HourFoot1(*FILEHOUR, eval($Lang{$lang[$nblang]}));
	&HourSites(*FILEHOUR, eval($Lang{$lang[$nblang]})) if ($precision > 2);
	&HourTopTen(*FILEHOUR, eval($Lang{$lang[$nblang]}));
	&HourScript(*FILEHOUR, eval($Lang{$lang[$nblang]})) if ($precision > 2 && $scriptunique != 0);
#      &HourTotal(*FILEHOUR, eval($Lang{$lang[$nblang]})) if ($precision > 2);
	&HourTopTenTraffic(*FILEHOUR, eval($Lang{$lang[$nblang]})) if ($notrafic == 0);
	&HourDownload(*FILEHOUR, eval($Lang{$lang[$nblang]})) if ($precision > 2 && $mail_format == 0);
	&HourFoot2(*FILEHOUR, eval($Lang{$lang[$nblang]}));

	close(FILEHOUR);
	chmod 0666, $filehour if ($opt_n ne '');
    }

    if ($opt_w eq '' && $opt_n ne '' && $ENV{'REQUEST_METHOD'} eq "GET") {
	*FILEHOUR = *STDOUT;

	&HourHeader(*FILEHOUR, eval($Lang{$opt_l}),$opt_l);
	&GraphHour(*FILEHOUR, eval($Lang{$opt_l}),$opt_l);
	&HourFoot1(*FILEHOUR, eval($Lang{$opt_l}));
	&HourSites(*FILEHOUR, eval($Lang{$opt_l})) if ($precision > 2);
#	&HourElapsed(*FILEHOUR, eval($Lang{$opt_l})) if ($precision > 2 && $squid_format == 1);
	&HourTopTen(*FILEHOUR, eval($Lang{$opt_l}));
	&HourScript(*FILEHOUR, eval($Lang{$opt_l})) if ($precision > 2 && $scriptunique != 0);
	&HourTopTenTraffic(*FILEHOUR, eval($Lang{$opt_l})) if ($notrafic == 0);
	&HourDownload(*FILEHOUR, eval($Lang{$opt_l})) if ($precision > 2 && $mail_format == 0);
	&HourFoot2(*FILEHOUR, eval($Lang{$opt_l}));
    }
}
#}

# sauvegarde des fichiers de la journee


if ($linelog != 0 && $opt_n eq '') {
#if (($precision > 2) && ($hour == 24) && ($opt_a != 1)) {
if (($precision > 2) && ($opt_a eq '') && ($opt_j eq '') && ($opt_b eq '')) {

    for ($nblang=0;$nblang<=$#lang;$nblang++) {

	$tmp = $path.$lang[$nblang].$dirsep.$dirdate.$dirsep.$dirresume;
	mkdir ($tmp,0775) unless -d $tmp;

	$filejourarc = $path.$lang[$nblang].$dirsep.$dirdate.$dirsep.$dirresume.$dirsep.$filenamehour;
	$filehour = $path.$lang[$nblang].$dirsep.$dirdate.$dirsep.$filenamehour;

	open(DEST,">$filejourarc") || &error_exit("Cannot open $filejourarc : $!",1);
	open(LECT,$filehour) || &error_exit("Cannot read $filehour : $!",1);
	while (<LECT>) {
#         s/$dirress/\.\.$dirsepurl$dirress/i if (/IMG/);
	    s/\"\.\./\"\.\.$dirsepurl\.\./gi if (/IMG/);
	    s/\"\.\./\"\.\.$dirsepurl\.\./gi if (/background=/i);
	    s/\"\.\./\"\.\.$dirsepurl\.\./gi if (/text\/javascript/i);
	    s/\"\.\./\"\.\.$dirsepurl\.\./gi if (/text\/css/i);
	    print DEST;
	}
	close (LECT);
	close (DEST);
    }
}
}

# jour suivant

#    print "RR $stop - $nb_id - $nb_full\n";


$nb_id++ if ($zipcut == 0);
$stop = 1 if ($opt_b eq '');
$stop = 1 if ($nb_id == $nb_full && $zipcut != 2 && $zipcut != 3);

if ($opt_b == 1) {

    if (($zip == 0 || $zip == 1) && $zipcut == 0) {

	$day++;
	$day = "0".$day if (length($day) == 1 && $struct_compressed_logfile !~ /\%smallday/);
	if ($day > $month_of_year{$month_nb[$month-1]}) {
	    $month++;
	    $day = "1" if ($struct_compressed_logfile =~ /\%smallday/);
	    $day = "01" if ($struct_compressed_logfile !~ /\%smallday/);
	    if ($month == 13) {
		$month = 1; 
		$year++;
	    }
	    if (($year%4 == 0 && $year%100 != 0) || $year%400 == 0) {
		$month_of_year{'Feb'} = "29";
	    } else {
		$month_of_year{'Feb'} = "28";
	    }
	}
	$lettermonth = $month_nb[$month-1];
	$today = "$day/$lettermonth/$year";
	$yday = &nbday($today);
    }


    if (($zip == 1 || $zip == 0) && $zipcut != 0) {
#    print "PP1 - $filezip -  $datezip lt $datetmpzip - $stop\n";
	&nextlog;
#    print "PP - $filezip -  $datezip lt $datetmpzip - $stop\n";
	    $stop = 1 if ($datezip gt $datetmpzip);
	if (-e $filezip) {
#	    $stop = 1 if ($datezip gt $datetmpzip);
	    if ($zipcut == 3) {

	    }
	}
	if (!(-e $filezip)) {
	    if ($zipcut == 2 && $stop == 0) {
		$stop = 1 if ($filezip eq $filetmpzip);
#		print "$filezip -  $datezip lt $datetmpzip\n";
		&nextlog while (!(-f $filezip) && $datezip lt $datetmpzip);
	    }
	    if ($zipcut == 3) {

	    }
	    if (!(-f $file)) {
		$filezip = "";
		$file = $fileroot.$prefixlog;
	    }
	    $stop = 1 if ($today eq $day_end);
	}
    }

    $today = "$day/$lettermonth/$year";
    print "EE $today - $file - $filezip\n" if ($debug == 1);

    if ($zipcut == 3) {
	$file = &find_index_log($fileroot,$prefixlog,$today);
	$filezip = $file.$zipext if ($zip == 1);
	if ($rotate_index == 0) {
	    $file = $fileroot.$prefixlog;
#	    $filezip = $file.$zipext;
	    $filezip = "";
	    $zip = 0;
	}
    }

# Remise a zero des stats

    if ($linelog != 0) {
    foreach $adresse (keys(%servheure)) {
	$servheure{$adresse} = 0;
	$server{$adresse} = 0;
	$last_host{$adresse} = '';
	$first_host{$adresse} = '';
	$server_html{$adresse} = 0;
    }

    $scriptunique = 0;
    $VolumeHtml = 0;
    $RequeteHtml = 0;
    $pageunique = 0;
    $VolumeHtmlExt = 0;
    $RequeteHtmlExt = 0;
    $VolumeHtmlInt = 0;
    $RequeteHtmlInt = 0;
    $VolumeGif = 0;
    $RequeteGif = 0;
    $VolumeGifExt = 0;
    $RequeteGifExt = 0;
    $VolumeGifInt = 0;
    $RequeteGifInt = 0;
    $VolumeTotal = 0;
    $VolumeTotalExt = 0;
    $extreq = 0;
    $VolumeTotalInt = 0;
    $reqtot = 0;
    $domreq = 0;
    $serverunique = 0;
    undef $firstday;

    $max = 0;
    $maxhit = 0;
    $maxsize = 0;
    $maxhtml = 0;
    $maxelapsed = 0;
    $maxhitproxy = 0;
    $maxmissproxy = 0;
    $maxtraficmissproxy = 0;
    $maxtrafichitproxy = 0;

    for ($i=0;$i<=$hour;$i++) {
	$size[$i] = 0;
	$user[$i] = 0;
	$hitheure[$i] = 0;
	$accesstot[$i] = 0;
    }

    foreach $page (keys(%pageslues)) {
	$filetype{$page} = 0;
    }
    
    undef %last_host;
    undef %pageslues;
    undef %sizepage;
    undef %script;
    
    for ($k=0;$k<=$#listext;$k++) {
	$download{$listext[$k]} = 0;
	$downloadsize{$listext[$k]} = 0;
	$zoneext[$extfilenb{$listext[$k]}]  = 0;
	$downloadext[$extfilenb{$listext[$k]}] = 0;
	$downloadsizeext{$listext[$k]} = '';
    }
    
    for ($j=0;$j<=$nbzonefile;$j++) {
	$zoneextbis[$j] = 0;
	$filetypemax[$j] = 0;
    }
    
    undef @listext;
}

    $endtime2 = time();
    if ($linelog != 0) { 
	$tmp = $endtime2 - $starttime2;
	print " $tmp second";
	print "s" if ($tmp > 1);
	print " ($linelog lines)\n";
    } else {
	print " No data found\n";
    }
    print "<BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");
    $linelog = 0;
}
}

unlink($lockfile) if ($opt_n ne '');

$endtime = time();
if ($opt_n eq '') {
    printf "Computing took %d CPU second",$endtime - $starttime;
    print "s" if ($endtime-$starttime > 1);
    print "\n\n";
    print "<P>" if ($ENV{'REQUEST_METHOD'} eq "GET");

    &admin_goback if ($ENV{'REQUEST_METHOD'} eq "GET" && $opt_y eq '');
}

#


#################################################################
sub HourHeader {
 local(*FOUT,*L,$I) = @_;

 $dirw3perl = "w3perl"; # repertoire des scripts CGI de w3perl

 print FOUT "$doctype\n";
 print FOUT "<HTML><HEAD>\n";
 print FOUT "$charset\n";
 print FOUT "<META HTTP-EQUIV=\"Pragma\" CONTENT=\"no-cache\">";
 $url_refresh_http = "http://$localserver";
 $url_refresh = $url_refresh_http."$w3perlcgiurl$dirsep$scriptname?";
 $url_refresh = $url_refresh."c=\'$cgipath$dirw3perl$dirsep$opt_c\'&amp;" if ($opt_c ne '' && $opt_c !~ $cgipath);
 $url_refresh = $url_refresh."c=\'$opt_c\'&amp;" if ($opt_c ne '' && $opt_c =~ $cgipath);
 $url_refresh = $url_refresh."i=\'$opt_i\'&amp;" if ($opt_i ne '');
 $url_refresh = $url_refresh."q=$opt_q&amp;" if ($opt_q ne '');
 $url_refresh = $url_refresh."d=$opt_d&amp;" if ($opt_d ne '');
 $url_refresh = $url_refresh."n=1&amp;l=$I";
 print FOUT "<META HTTP-EQUIV=Refresh CONTENT=\"$refresh_sec;URL=$url_refresh\">" if ($opt_n ne '');
 print FOUT "<TITLE>$L{'Stats'} $L{'about'} $L{'hours'} - $today</TITLE>\n";
 print FOUT "<!-- Page generated by w3perl - $scriptname $version - $today $hourdate -->\n";
 print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\">\n";
 print FOUT "function PopIt(ref,x,y) {\n";
 print FOUT "var xwin;\n";
 print FOUT "var ywin;\n";
 print FOUT "xwin = x+100;\n";
 print FOUT "ywin = y*2;\n";
 print FOUT "popup = window.open(\"\"+ref,\"popDialog\",\"height=\"+ywin+\",width=\"+xwin+\",scrollbars=yes,resizable=yes\")\n";
 print FOUT "popup.focus()\n";
# print FOUT "popup.document.close()\n";
 print FOUT "}\n";

 print FOUT "function ToggleMenuAll(obj) {\n";
 print FOUT " var elementsDIV = document.getElementsByTagName('div');\n";
 print FOUT "	for (var i = 0; i < elementsDIV.length; i++) {\n";
 print FOUT "     var el = elementsDIV[i].id;\n";
 print FOUT "     if (el.indexOf(\"TOGGLE_\") != -1) {\n";
 print FOUT "     elementsDIV[i].style.display  = (elementsDIV[i].style.display != 'none' ? 'none' : 'inline');\n";
 print FOUT "     }\n";
 print FOUT "	}\n";
 print FOUT "}\n";
 print FOUT "function ToggleMenu(obj) {\n";
 print FOUT "target = document.getElementById(obj);\n";
 print FOUT "if (target.style.display == \"none\"){\n";
 print FOUT "target.style.display = \"inline\";\n";
 print FOUT "} else {\n";
 print FOUT "target.style.display = \"none\";\n";
 print FOUT "}\n";
 print FOUT "}\n";
 print FOUT "</SCRIPT>\n";
 print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"$link_use$dirjs$dirsepurl$sorttablejs\"></script>\n";
 print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"$link_use$dirjs$dirsepurl$helpjs\"></script>\n";
 print FOUT "<link rel=\"stylesheet\" type=\"text/css\" href=\"$link_use$dircss$dirsepurl$css_w3perl\">\n";
 print FOUT "</HEAD>\n";

# print FOUT "<BODY $backgrd TEXT=\"$custom_text\" LINK=\"$custom_link\" VLINK=\"$custom_vlink\">\n" if ($opt_j eq '');
# print FOUT "<BODY $backgrd2 TEXT=\"$custom_text\" LINK=\"$custom_link\" VLINK=\"$custom_vlink\">\n" if ($opt_j ne '');

 print FOUT "<BODY $backgrd TEXT=\"$custom_text\" LINK=\"$custom_link\" VLINK=\"$custom_vlink\">\n";

# print FOUT "<BODY $backgrd2 TEXT=\"$custom_text\" LINK=\"$custom_link\" VLINK=\"$custom_vlink\">\n" if ($opt_j ne '');

 print FOUT "<!-- Email_report_exclude_begin -->\n";

 &help_div(*FOUT);

# print FOUT "<div id=\"object1\" style=\"text-decoration:none; position:absolute; visibility:visible; left:0px; top:-120px; z-index:+1\" onmouseover=\"overdiv=1;\"  onmouseout=\"overdiv=0; setTimeout('hideLayer()',500)\"></div>\n";


# print FOUT "<table><tr><td>";
# print FOUT "<a href=\"#\" onMouseOver=\"popLayer('$L{'Title_hour'}','$L{'Line_hour'}','$L{'Desc_hour'}','$L{'Link_hour'}','$help_width')\">test</A>\n";
# print FOUT "</td></tr></table>\n";


 print FOUT "<CENTER>\n";
 print FOUT "<TABLE BORDER=0 WIDTH=\"100%\">\n";
 print FOUT "<TR>\n";
 print FOUT "<TD ALIGN=LEFT VALIGN=MIDDLE WIDTH=\"20%\">";

 print FOUT "<A HREF=\"..$dirsepurl$dirsession$dirsepurl$filemoyenne#moyheure\"><IMG SRC=\"$link_use$homeicons2$dirsepurl$icon_moyenne\" WIDTH=\"40\" HEIGHT=\"40\" BORDER=0 ALT=\"average\" onMouseOver=\"popLayer('$L{'Title_average_hour'}','$L{'Line_average_hour'}','$L{'Desc_average_hour'}','$L{'Link_average_hour'}',0,'display','$help_width')\"></A>\n" if (-f "$path$I$dirsep$dirsession$dirsep$filemoyenne" && $opt_b eq '' && $opt_j eq '' && $opt_n eq '');

 print FOUT "</TD>\n";
 print FOUT "<TD ALIGN=CENTER WIDTH=\"60%\">\n";

 print FOUT "<TABLE BORDER=1 BGCOLOR=\"#000000\">\n<TR>\n<TD BGCOLOR=\"#FFEECC\" ALIGN=CENTER>\n";
# print FOUT "<div class=\"titre_section\">\n";
 print FOUT "<H1>".uc(&noaccentinhtml($L{'Stats'}))." ".uc(&noaccentinhtml($L{'about'}))." ".uc(&noaccentinhtml($L{'the'}))." ".uc(&noaccentinhtml($L{'hours'}))."\n" if ($opt_n eq '');
 print FOUT "<H1>".uc(&noaccentinhtml($L{'Real_time'}))."\n" if ($opt_n ne '');
 print FOUT "<BR>($L{'total_for'} $nbdays $L{'days'})\n" if ($opt_a == 1 && $nbdays != 0);
 print FOUT "</H1>";
# print FOUT "</DIV>\n";
 print FOUT "</TD>\n</TR>\n</TABLE>\n";

 print FOUT "</TD>\n";
 print FOUT "<TD ALIGN=RIGHT VALIGN=MIDDLE WIDTH=\"20%\">\n";

 $link_use2 = "..$dirsepurl..$dirsepurl$homeicons$dirsepurl" if ($link_use eq '');
 $link_use2 = "$link_use$homeicons2$dirsepurl" if ($link_use ne '');

 print FOUT "<A HREF=\"..$dirsepurl..$dirsepurl$dircsv$dirsepurl$dirresume$csvext\" TITLE=\"Export in CSV\"><IMG WIDTH=\"40\" HEIGHT=\"40\" SRC=\"$link_use2$icon_csv\" BORDER=0 ALT=\"CSV\"></A>" if (-f "$path$dircsv$dirsep$dirresume$csvext" && $opt_n eq '');

 $title = $L{'Hours'} if ($opt_n eq '');
 $title = $L{'Real_time'} if ($opt_n ne '');

 $tmp3 = $last_date;
 $tmp3 =~ s/[\/:]//g;
 $tmp3 =~ s/(\d\d\d\d)/$1\-/;
 $title = $title."-".$tmp3;

 $tmp4 = $filehour;
 $tmp4 =~ s/$path//;

 if ($w3perlcgiurl ne '' && $enable_pdf == 1) {
     &PagesExportPDF(*FOUT,$tmp4,$title,2,0);
 }

# if ($w3perlcgiurl ne '' && $enable_email == 1) {
#     &PagesExportPDF(*FOUT,$tmp4,$title,1,1);
# }

 print FOUT "</TD>\n";
 print FOUT "</TR>\n";
 print FOUT "</TABLE>\n";
 print FOUT "</CENTER>\n";
 print FOUT "<!-- Email_report_exclude_end -->\n";
 
 print FOUT "<HR SIZE=5>\n";
 print FOUT "<CENTER><B>";
# print FOUT "$firstday - " if ($opt_n ne '');
 print FOUT "$firstday - ";
 print FOUT "$last_date";
 print FOUT "</B></CENTER>\n";
 print FOUT "<HR SIZE=5><P>\n";
 
}

#################################################################
sub GraphHour {
 local(*FOUT,*L,$I) = @_;
 
# print FOUT "<A NAME=\"utilisateur\">\n";
# print FOUT "<A NAME=\"traffic\">\n";
# print FOUT "<A NAME=\"access\">\n";
# print FOUT "<A NAME=\"hosts\">\n";
 print FOUT "<CENTER><TABLE BORDER=0><TR><TD ALIGN=LEFT>\n";
 print FOUT "<TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0>\n";
 print FOUT "<TR>\n";
 print FOUT "<TD><IMG WIDTH=$xdecal HEIGHT=$ymax SRC=\"$linkrealhity?$current_time\" ALT=\"y\"></TD>\n";
 print FOUT "<TD><IMG WIDTH=$xmax HEIGHT=$ymax SRC=\"$linkrealhit?$current_time\" ALT=\"graph\"></TD>\n";
 print FOUT "</TR><TR><TD></TD>\n";
 print FOUT "<TD><IMG WIDTH=$xmax HEIGHT=$ydecal SRC=\"$linkrealhitx?$current_time\" ALT=\"x\"></TD>\n";
 print FOUT "</TR>\n";
 print FOUT "</TABLE>\n";

 print FOUT "</TD><TD ALIGN=RIGHT>\n";

 print FOUT "<TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0>\n";
 print FOUT "<TR>\n";
 print FOUT "<TD><IMG WIDTH=$xdecal HEIGHT=$ymax SRC=\"$linkrealhosty?$current_time\" ALT=\"y\"></TD>\n";
 print FOUT "<TD><IMG WIDTH=$xmax HEIGHT=$ymax SRC=\"$linkrealhost?$current_time\" ALT=\"graph\"></TD>\n";
 print FOUT "</TR><TR><TD></TD>\n";
 print FOUT "<TD><IMG WIDTH=$xmax HEIGHT=$ydecal SRC=\"$linkrealhostx?$current_time\" ALT=\"x\"></TD>\n";
 print FOUT "</TR>\n";
 print FOUT "</TABLE>\n";

 print FOUT "</TD></TR>";
 print FOUT "<TR><TD ALIGN=LEFT>\n";

 if ($mail_format == 0 && $ftp_format == 0) {

     print FOUT "<TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0>\n";
     print FOUT "<TR>\n";
     print FOUT "<TD><IMG WIDTH=$xdecal HEIGHT=$ymax SRC=\"$linkrealaccessy?$current_time\" ALT=\"y\"></TD>\n";
     print FOUT "<TD><IMG WIDTH=$xmax HEIGHT=$ymax SRC=\"$linkrealaccess?$current_time\" ALT=\"graph\"></TD>\n";
     print FOUT "</TR><TR><TD></TD>\n";
     print FOUT "<TD><IMG WIDTH=$xmax HEIGHT=$ydecal SRC=\"$linkrealaccessx?$current_time\" ALT=\"x\"></TD>\n";
     print FOUT "</TR>\n";
     print FOUT "</TABLE>\n";
 }

 print FOUT "</TD><TD ALIGN=RIGHT>\n";

 print FOUT "<TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0>\n";
 print FOUT "<TR>\n";
 print FOUT "<TD><IMG WIDTH=$xdecal HEIGHT=$ymax SRC=\"$linkrealtraficy?$current_time\" ALT=\"y\"></TD>\n";
 print FOUT "<TD><IMG WIDTH=$xmax HEIGHT=$ymax SRC=\"$linkrealtrafic?$current_time\" ALT=\"graph\"></TD>\n";
 print FOUT "</TR><TR><TD></TD>\n";
 print FOUT "<TD><IMG WIDTH=$xmax HEIGHT=$ydecal SRC=\"$linkrealtraficx?$current_time\" ALT=\"x\"></TD>\n";
 print FOUT "</TR>\n";
 print FOUT "</TABLE>\n";

 print FOUT "</TD></TR></TABLE>\n";

 print FOUT "<P>";
 print FOUT "$L{'Stats_over'}\n";
 print FOUT "<FORM METHOD=\"GET\" ACTION=\"$url_refresh\">\n";

 print FOUT "<INPUT TYPE=hidden NAME=\"c\" VALUE=\"\'$cgipath$dirw3perl$dirsep$opt_c\'\">\n" if ($opt_c ne '' && $opt_c !~ $cgipath);
 print FOUT "<INPUT TYPE=hidden NAME=\"c\" VALUE=\"\'$opt_c\'\">\n" if ($opt_c ne '' && $opt_c =~ $cgipath);
 print FOUT "<INPUT TYPE=hidden NAME=\"i\" VALUE=\"'$opt_i'\">\n" if ($opt_i ne '');
 print FOUT "<INPUT TYPE=hidden NAME=\"l\" VALUE=\"$I\">\n";
 print FOUT "<INPUT TYPE=hidden NAME=\"n\" VALUE=\"1\">\n";

 print FOUT "<INPUT TYPE=text NAME=\"q\" VALUE=\"$filter_min\" MAXLENGTH=\"3\" SIZE=\"3\"> $L{'minutes'} $L{'updated_every'} \n";
 print FOUT "$refresh_sec $L{'seconds'} ($L{'with_an_integration_time_of'} \n";
 print FOUT "<INPUT TYPE=text NAME=\"d\" VALUE=\"$bin_sec\" MAXLENGTH=\"3\" SIZE=\"3\"> $L{'seconds'})&nbsp;\n";
# print FOUT "<INPUT TYPE=\"image\" WIDTH=\"16\" HEIGHT=\"16\" SRC=\"$link_use$icon_go\" ALT=\"Go\">\n";
 print FOUT "<INPUT TYPE=\"image\" SRC=\"$link_use$icon_go\" ALT=\"Go\">\n";
 print FOUT "</FORM>\n";
 print FOUT "<P>";
 print FOUT "</CENTER>\n";
}

sub TableMasterDisplay {
 local(*FOUT,*L,$string) = @_;

 print FOUT $string;
}


#################################################################
sub HourHits {
 local(*FOUT,*L) = @_;

 print FOUT "<TABLE CLASS=\"sortable_base\" ID=\"GraphHits\">\n<TR>\n";
 print FOUT "<TH CLASS=\"left\">&nbsp;$L{'Hour'}&nbsp;</TH>\n";
 print FOUT "<TH CLASS=\"left\">&nbsp;$L{'Requests'}&nbsp;</TH>\n";
 print FOUT "</TR>\n";

 for ($heure=0;$heure < $hour;$heure++) {
     $nbre = 2*$hitheure[$heure];           # $square est la largeur du bloc image
     $nbre *= 2 if ($max > 100);
     $nbre = int($nbre/$unitehit) if ($maxhit > 100);
     $heuresuivante = $heure + 1;
     $heure = "0".$heure unless (length($heure) != 1);
     $heuresuivante = "0".$heuresuivante unless (length($heuresuivante) != 1);
     print FOUT "<TR>\n";
     print FOUT "<TD CLASS=\"left\">$heure&nbsp;-&nbsp;$heuresuivante&nbsp;$L{'hour'}</TD>";
     print FOUT "<TD CLASS=\"left\">";
     print FOUT "<IMG WIDTH=$nbre HEIGHT=$square SRC=\"$link_use$gcolor[0]\" ALT=\"$gcolor[0]\">&nbsp;<B>$hitheure[$heure]</B>" if ($hitheure[$heure]);
     print FOUT "<B>0</B>" if (!($hitheure[$heure]));
     print FOUT "</TD>\n";
     print FOUT "</TR>\n";
 }
     print FOUT "</TABLE>\n";
}

#################################################################
sub HourHosts {
 local(*FOUT,*L) = @_;

 print FOUT "<TABLE CLASS=\"sortable_base\" ID=\"GraphHosts\">\n<TR>\n";
 print FOUT "<TH CLASS=\"left\">&nbsp;$L{'Hour'}&nbsp;</TH>\n";
 print FOUT "<TH CLASS=\"left\">&nbsp;$L{'Hosts'}&nbsp;</TH>\n";
 print FOUT "</TR>\n";

 for ($heure=0;$heure < $hour;$heure++) {
     $nbre = 2*$user[$heure];           # $square est la largeur du bloc image
     $nbre *= 2 if ($max > 100);
     $nbre = int($nbre/$unite) if ($max > 100);
     $heuresuivante = $heure + 1;
     $heure = "0".$heure unless (length($heure) != 1);
     $heuresuivante = "0".$heuresuivante unless (length($heuresuivante) != 1);
     print FOUT "<TR>\n";
     print FOUT "<TD CLASS=\"left\">$heure&nbsp;-&nbsp;$heuresuivante&nbsp;$L{'hour'}</TD>";
     print FOUT "<TD CLASS=\"left\">";
     print FOUT "<IMG WIDTH=$nbre HEIGHT=$square SRC=\"$link_use$gcolor[4]\" ALT=\"$gcolor[4]\">&nbsp;<B>$user[$heure]</B>" if ($user[$heure]);
     print FOUT "<B>0</B>" if (!($user[$heure]));
     print FOUT "</TD>\n";
     print FOUT "</TR>\n";
 }
     print FOUT "</TABLE>\n";
}

#################################################################
sub HourPages {
 local(*FOUT,*L) = @_;

 print FOUT "<TABLE CLASS=\"sortable_base\" ID=\"GraphPages\">\n<TR>\n";
 print FOUT "<TH CLASS=\"left\">&nbsp;$L{'Hour'}&nbsp;</TH>\n";
 print FOUT "<TH CLASS=\"left\">&nbsp;$L{'Accesses'}&nbsp;</TH>\n";
 print FOUT "</TR>\n";

 for ($heure=0;$heure < $hour;$heure++) {
     $nbre = 2*$accesstot[$heure];           # $square est la largeur du bloc image
     $nbre *= 2 if ($maxhtml > 100);
     $nbre = int($nbre/$unitehtml) if ($maxhtml > 100);
     $heuresuivante = $heure + 1;
     $heure = "0".$heure unless (length($heure) != 1);
     $heuresuivante = "0".$heuresuivante unless (length($heuresuivante) != 1);
     print FOUT "<TR>\n";
     print FOUT "<TD CLASS=\"left\">$heure&nbsp;-&nbsp;$heuresuivante&nbsp;$L{'hour'}</TD>";
     print FOUT "<TD CLASS=\"left\">";
     print FOUT "<IMG WIDTH=$nbre HEIGHT=$square SRC=\"$link_use$gcolor[1]\" ALT=\"$gcolor[1]\">&nbsp;<B>$accesstot[$heure]</B>" if ($accesstot[$heure]);
     print FOUT "<B>0</B>" if (!($accesstot[$heure]));
     print FOUT "</TD>\n";
     print FOUT "</TR>\n";
 }
     print FOUT "</TABLE>\n";
}

#################################################################
sub HourTraffic {
 local(*FOUT,*L) = @_;
# local($conv);

 print FOUT "<TABLE CLASS=\"sortable_base\" ID=\"GraphTraffic\">\n<TR>\n";
 print FOUT "<TH CLASS=\"left\">&nbsp;$L{'Hour'}&nbsp;</TH>\n";
 print FOUT "<TH CLASS=\"left\">&nbsp;$L{'Traffic'} ($L{$convunit})&nbsp;</TH>\n";
 print FOUT "</TR>\n";

 for ($heure=0;$heure < $hour;$heure++) {
     $nbre = int(2*$size[$heure]*$square/$unitesize) if ($unitesize != 0);       # $square est la largeur du bloc image
     $nbre = 0 if ($unitesize == 0);
     $heuresuivante = $heure + 1;
     $heure = "0".$heure unless (length($heure) != 1);
     $heuresuivante = "0".$heuresuivante unless (length($heuresuivante) != 1);
     print FOUT "<TR>\n";
     print FOUT "<TD CLASS=\"left\">$heure&nbsp;-&nbsp;$heuresuivante&nbsp;$L{'hour'}</TD>";
     print FOUT "<TD CLASS=\"left\">";
     print FOUT "<IMG WIDTH=$nbre HEIGHT=$square SRC=\"$link_use$gcolor[2]\" ALT=\"$gcolor[2]\">&nbsp;" if ($nbre != 0);
     $affsize = $size[$heure]/$conv;
     printf FOUT "<B>%.2f</B>",$affsize if ($size[$heure]);
     print FOUT "<B>0</B>" if (!($size[$heure]));
     print FOUT "</TD>\n";
     print FOUT "</TR>\n";
 }
     print FOUT "</TABLE>\n";
}

#################################################################
sub HourFoot1 {
 local(*FOUT,*L) = @_;

 print FOUT "<A NAME=\"requete\"></A>\n";
 print FOUT "<P><HR>\n";
 if ($opt_a == 1 && $opt_n eq '') {
     print FOUT "$L{'At'} $hour $L{'hours'},";
     print FOUT "$L{'on'} $nbdays $L{'days'},";
 }
 print FOUT " $L{'there_are'} $reqtot $L{'requests'} ";
 print FOUT "($RequeteHtml $L{'accesses'}) " if ($mail_format == 0 && $ftp_format == 0);
 print FOUT "$L{'coming_from'} $serverunique $L{'sites'}\n";
 if ($notrafic == 0) {
     $tmp = $VolumeTotal;
     $tmp /= 1024 if ($convunit eq "Gb");
     printf FOUT "($L{'Total_traffic'} : %.1f $L{$convunit})\n",$tmp;
 }
 if ($locallog != 0) {
     print FOUT "($L{'among'} $domreq ";
     print FOUT "$L{'request'}" if ($domreq == 0 || $domreq == 1);
     print FOUT "$L{'requests'}" unless ($domreq == 0 || $domreq == 1);
     print FOUT " $L{'from domain'} $localdomainename)\n";
 }
 print FOUT "<HR><P>";

}

#################################################################
sub HourSites {
 local(*FOUT,*L) = @_;
 local($toggle_string,$toggle_arg);

 print FOUT "<A NAME=\"site\"></A>\n";
# print FOUT "<HR><P>\n";

 print FOUT "<DIV CLASS=\"item_page\">-&nbsp;<I>$L{'ListOfSites'} ";
 print FOUT "$L{'on'} $nbdays $L{'days'} " if ($opt_a == 1 && $opt_n eq '');
 print FOUT "$L{'for_today'}" if ($opt_a != 1 && $opt_n eq '');
 print FOUT " </I>($L{'more_than'} $seuilsite $L{'requests'}) :</DIV><P>\n";

 if ($precision > 3) {
     print FOUT "<TABLE CLASS=\"sortable_base\" ID=\"NO_hour-topsite\">\n";
 } else {
     print FOUT "<TABLE CLASS=\"sortable_base\" ID=\"hour-topsite\">\n";
 }
 print FOUT "<TR>";
# print FOUT "<TH>&nbsp;<A HREF=\"javascript:ToggleMenuAll('Toggle_all');\">ToggleAll</A>&nbsp;</TH>\n"; 
 print FOUT "<TH><A HREF=\"javascript:ToggleMenuAll('Toggle_all');\"><IMG SRC=\"$link_use$toggle_on\" NAME=\"ima_toggle\" BORDER=0 WIDTH=\"12\" HEIGHT=\"21\" ALT=\"toggle\"></A></TH>\n" if ($precision > 3);
 print FOUT "<TH>&nbsp;$L{'Hosts'}&nbsp;</TH>\n";
 print FOUT "<TH>&nbsp;$L{'Requests'}&nbsp;</TH>\n";
 print FOUT "<TH>&nbsp;$L{'Percentage'}&nbsp;</TH>\n" if ($opt_a eq '');

 if ($mail_format == 0 && $ftp_format == 0) {
     print FOUT "<TH>&nbsp;$L{'Accesses'}&nbsp;</TH>\n";
     print FOUT "<TH>&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
 }

 if ($opt_a eq '') {
     print FOUT "<TH>&nbsp;$L{'Last_occurence'}&nbsp;</TH>\n";
     print FOUT "<TH>&nbsp;$L{'Time'}&nbsp;</TH>\n";
     print FOUT "<TH>&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
 }
 print FOUT "</TR>\n";

 if ($opt_a ne '') {
     foreach $adresse (sort (keys(%server))) {
	 if ($server{$adresse} > $seuilsite) {

	     print FOUT "<TR>\n";
	     print FOUT "<TD CLASS=\"left\">";
	     print FOUT "$adresse" unless ($adresse =~ /$localdomaine$/);
	     print FOUT "<I>$adresse</I>" unless ($adresse !~ /$localdomaine$/);
	     print FOUT "</TD>\n";
	     print FOUT "<TD CLASS=\"right\"><B>$server{$adresse}</B></TD>";
	     print FOUT "<TD CLASS=\"right\"><B>$server_html{$adresse}</B></TD>";
	     print FOUT "</TR>\n";
	 }
     }
 }

 if ($opt_a eq '') {
     for ($i=0;$i < $serverunique;$i++) {
	 $adresse = $bestserverdate[$i];
	 if ($server{$adresse} > $seuilsite && $server_html{$adresse} > $seuilpage) {
#$server_html{$adresse}
	     print FOUT "<TR>\n";
#	     print FOUT "<TD CLASS=\"left\">";
#	     print FOUT "<TABLE CELLPADDING=0 CELLSPACING=0 BORDER=1 WIDTH=\"100%\">\n<TR>\n";
	     if ($precision > 3) {
		 print FOUT "<TD VALIGN=TOP ALIGN=LEFT WIDTH=\"10\" ";
		 print FOUT "OnClick=\"javascript:ToggleMenu('";
		 print FOUT "TOGGLE_$adresse";
		 print FOUT "')\"";
		 print FOUT " TITLE=\"$L{'Click_here'}\">";
		 print FOUT "&gt;</TD>\n";
	     }
#	     print FOUT "<TD VALIGN=TOP ALIGN=LEFT OnClick=\"javascript:ToggleMenu('";
#	     print FOUT "TOGGLE_$adresse";
#	     print FOUT "')\">";
	     print FOUT "<TD VALIGN=TOP ALIGN=LEFT";
	     print FOUT " TITLE=\"$L{'Click_here'}\"" if ($precision > 3);
	     print FOUT ">";
	     print FOUT "<I>" if ($adresse =~ /$localdomaine$/);
	     print FOUT "<A HREF=\"javascript:ToggleMenu('TOGGLE_$adresse')\" STYLE=\"display:inline\">" if ($precision > 3);
	     print FOUT "$adresse";
	     print FOUT "</A>" if ($precision > 3);
	     print FOUT "</I>" if ($adresse =~ /$localdomaine$/);
#	     print FOUT "</TD>\n<TD>\n";
#	     $tmp3 = "</TD>\n</TR>\n";
#	     $tmp3 .= "</TD><TD></TD><TD>\n";
#	     print FOUT "</TD>\n</TR>\n";
#	     print FOUT "<TR>\n<TD COLSPAN=2>\n";
	     if ($opt_n ne '' || $precision > 3) {
#		 $tmp2 = "<P>\n";
#		 $tmp2 .= "<TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0><TR>";
		 $usersession = 1;
#		 $tmp2 .= "<DIV ID=\"$adresse\" STYLE=\"display:none\">\n";
		 $tmp2 = "<TABLE CLASS=\"sortable_base\" ID=\"hour-topsite-$adresse-$usersession\">\n<TR>\n";
#		 $tmp2 = "<TABLE>\n<TR>\n";
		 $tmp2 .= "<TH>&nbsp;$L{'Email'}&nbsp;</TH>\n" if ($mail_format == 1);
		 $tmp2 .= "<TH>&nbsp;$L{'File'}&nbsp;</TH>\n" if ($mail_format == 0);
		 $tmp2 .= "<TH>&nbsp;$L{'Occurence'}&nbsp;</TH></TR>\n";
		 $tmp = 0;
		 for ($j=1;$j<=$server_html{$adresse};$j++) {
		     $page = $server_real_html{$adresse,$j};
		     next if (!($page));
		     $date = $server_real_date{$adresse,$j};
		     $nb = $server_real_html_nb{$adresse,$page};
		     $tmp1 = ($date- (int($date/100)*100))*100/60 +(int($date/100)*100);
		     if ($tmp1-$tmp > ($tleclim*100/60) && $tmp != 0) {
#			 $tmp2 .= "<HR>";
			 $usersession++;
		     }
		     $tmp2 .= "<TR>\n";
		     $tmp2 .= "<TD CLASS=\"left\">";
		     if ($mail_format == 0) {
			 $tmp2 .= "<A HREF=\"$page\"";
			 $tmp2 .= " TITLE=\"$page\"" if ($titlename == 1 && $urlconv{$page});
			 $tmp2 .= ">";
		     }
		     $tmp2 .= "$page" if ($titlename == 0);
		     $tmp2 .= "$urlconv{$page}" if ($titlename == 1 && $urlconv{$page});
		     $tmp2 .= "$page" if ($titlename == 1 && !($urlconv{$page}));
		     $tmp2 .= "</A>" if ($mail_format == 0);
		     $tmp2 .= "</TD>\n<TD CLASS=\"right\">";
		     $tmp2 .= "&nbsp;$nb\n";
		     $tmp2 .= "</TD></TR>\n";
		     $tmp = $tmp1;
		 }
		 $tmp2 .= "</TABLE>\n";
#		 $tmp2 .= "<P>\n";
#		 print FOUT " : $usersession $L{'session'}\n" if ($usersession == 1);
#		 $tmp2 .= " : <I>$usersession $L{'sessions'}</I>\n" if ($usersession > 1);
		 print FOUT " : <I>$usersession $L{'sessions'}</I>\n" if ($usersession > 1);
#		 print FOUT $tmp3;
		 print FOUT "\n<DIV ID=\"TOGGLE_$adresse\" STYLE=\"display:none\">\n";
		 print FOUT $tmp2;
		 print FOUT "</DIV>\n";
#		 print FOUT "</TD></TR></TABLE>\n";
	     }
	     print FOUT "</TD>\n<TD CLASS=\"right\"><B>$server{$adresse}</B></TD>\n";

	     print FOUT "<TD CLASS=\"left\">";
	     $percentage = ($server{$adresse}*100)/$reqtot;
	     $tmp2 = int($percentage);
	     print FOUT "<IMG WIDTH=$tmp2 HEIGHT=$square SRC=\"$link_use$gcolor[0]\" ALT=\"$gcolor[0]\">&nbsp;$tmp2%" if ($tmp2 != 0);
	     print FOUT "</TD>\n";

	     if ($mail_format == 0 && $ftp_format == 0) {
		 print FOUT "<TD CLASS=\"right\"><B>$server_html{$adresse}</B></TD>\n";

		 print FOUT "<TD CLASS=\"left\">";
		 $percentage = ($server_html{$adresse}*100)/$RequeteHtml if ($RequeteHtml != 0);
		 $tmp2 = int($percentage);
		 print FOUT "<IMG WIDTH=$tmp2 HEIGHT=$square SRC=\"$link_use$gcolor[1]\" ALT=\"$gcolor[1]\">&nbsp;$tmp2%" if ($tmp2 != 0);
		 print FOUT "</TD>\n";
	     }
	     
	     $tmp = $occurserverdate[$i];
	     $tmp =~ s/(\d\d)(\d\d)/$1:$2/;
	     print FOUT "<TD CLASS=\"right\">$tmp</TD>\n";
	     
	     print FOUT "<TD CLASS=\"right\">";
	     $tmp = int($occurserverdate_time[$i]/60);
	     printf FOUT "%d h ",$tmp if ($tmp != 0);
	     $tmp2 = $occurserverdate_time[$i]-($tmp*60);
	     $tmp2 = "0".$tmp2 if (length($tmp2) == 1 && $tmp != 0);
	     printf FOUT "%s'",$tmp2;
	     print FOUT "</TD>\n";
	    
	     print FOUT "<TD CLASS=\"left\">";
	     $percentage = ($occurserverdate_time[$i]*100)/(60*24);
	     $tmp2 = int($percentage);
	     print FOUT "<IMG WIDTH=$tmp2 HEIGHT=$square SRC=\"$link_use$gcolor[3]\" ALT=\"$gcolor[3]\">&nbsp;$tmp2%" if ($tmp2 != 0);
	     print FOUT "</TD>\n";
	     print FOUT "</TR>\n";

	 }
     }
 }
 
 print FOUT "</TABLE>\n";
# print FOUT "</DIV>\n";
 print FOUT "<P>\n";
}

#################################################################
sub HourTopTen {
 local(*FOUT,*L) = @_;
 local($i,$page);

 print FOUT "<A NAME=\"page\"></A>\n";
# print FOUT "<HR><P>\n";

 print FOUT "<DIV CLASS=\"item_page\">-&nbsp;<I>$L{'ListOf'} $boucle $L{'pages'} ($L{'among'} $pageunique) $L{'with_most_accesses'} ";
 print FOUT "sur $nbdays $L{'days'}" if ($opt_a == 1);
 print FOUT "</I> :</DIV><P>\n";
 
 print FOUT "<TABLE CLASS=\"sortable_base\" ID=\"hour-topten\">\n";
 print FOUT "<TR>\n";
 print FOUT "<TH>&nbsp;$L{'Pages'}&nbsp;</TH>\n";
 print FOUT "<TH>&nbsp;$L{'Occurence'}&nbsp;</TH>\n";
 print FOUT "<TH>&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
 print FOUT "</TR>\n";
 
 $i = 0;
 foreach $page (&reverse_sort_by_value(*pageslues)) {

     print FOUT "<TR>\n";
     print FOUT "<TD CLASS=\"left\">";
     if (-f "$pathserver$page" || $spip == 1) {
	 print FOUT "<A HREF=\"$page\"";
	 print FOUT " TITLE=\"$page\"" if ($titlename == 1 && $urlconv{$page});
	 print FOUT ">"
	 }
     print FOUT "$page" if ($titlename == 0);
     print FOUT "<B>$urlconv{$page}</B>" if ($titlename == 1 && $urlconv{$page});
     print FOUT "$page" if ($titlename == 1 && !($urlconv{$page}));
     print FOUT "</A>" if (-f "$pathserver$page" || $spip == 1);
     print FOUT "</TD>\n<TD CLASS=\"right\"><B>$pageslues{$page}</B> $L{'times'}</TD>\n<TD CLASS=\"left\">\n";
     $percentage = ($pageslues{$page}*100)/$RequeteHtml;
     $tmp2 = int($percentage);
     print FOUT "<IMG WIDTH=$tmp2 HEIGHT=$square SRC=\"$link_use$gcolor[1]\" ALT=\"$gcolor[1]\">&nbsp;" if ($tmp2 != 0);
     printf FOUT "%.1f ",$pourcentage;
     print FOUT " %</TD>\n";
     print FOUT "</TR>\n";
     $i++;
     last if ($i == $boucle);
 }

 print FOUT "</TABLE>\n";
 print FOUT "<P>\n";
}


#################################################################
sub HourScript {
 local(*FOUT,*L) = @_;
 local($i,$page,$tmp3);

 print FOUT "<A NAME=\"script\"></A>\n";
# print FOUT "<HR><P>\n";

 print FOUT "<DIV CLASS=\"item_page\">-&nbsp;<I>$L{'ListOf'} $bouclescript $L{'scripts'} ($L{'among'} $scriptunique) $L{'with_most_accesses'} ";
 print FOUT "sur $nbdays $L{'days'}" if ($opt_a == 1);
 print FOUT "</I> :</DIV><P>\n";

 print FOUT "<TABLE CLASS=\"sortable_base\" ID=\"hour-topscript\">\n";
 print FOUT "<TR>\n<TH>&nbsp;$L{'Scripts'}&nbsp;</TH>\n";
 print FOUT "<TH>&nbsp;$L{'Occurence'}&nbsp;</TH></TR>\n";

 $i = 0;
 foreach $page (&reverse_sort_by_value(*script)) {
     print FOUT "<TR>\n";
     print FOUT "<TD CLASS=\"left\">";
     print FOUT "$page";
     print FOUT "</TD>\n<TD CLASS=\"right\"><B>$script{$page}</B> $L{'times'}</TD>\n";
     print FOUT "</TR>\n";
     $i++;
     last if ($i == $bouclescript);
 }

# for ($i=0;$i < $bouclescript;$i++) {
#     print FOUT "$bestscript[$i]";
#     print FOUT " : <B>$occurscript[$i]</B> $L{'times'}<BR>\n";
# }
 print FOUT "</TABLE>\n";
 print FOUT "<P>\n";
}

#################################################################
sub HourTotal {
 local(*FOUT,*L) = @_;

print FOUT "<A NAME=\"total\"></A>\n";
#print FOUT "<HR><P>\n";

 print FOUT "<DIV CLASS=\"item_page\">-&nbsp;<I>$L{'Filetype'} ";
 print FOUT "sur $nbdays $L{'days'}" if ($opt_a == 1);
 print FOUT "</I> :</DIV><P>\n";

print FOUT "<TABLE CLASS=\"sortable_base\" ID=\"total\">\n";
print FOUT "<TR>\n";
print FOUT "<TD COLSPAN=2 ALIGN=LEFT>\n" if ($locallog == 0);
print FOUT "<TD COLSPAN=4 ALIGN=LEFT>\n" if ($locallog != 0);
print FOUT "$L{'Traffic_statistics'} ";
print FOUT "$L{'on'} $nbdays $L{'days'} " if ($opt_a == 1);
print FOUT ":</TD>\n";
print FOUT "</TR>\n";
print FOUT "<TR>\n";
print FOUT "<TD></TD>\n";
print FOUT "<TD ALIGN=MIDDLE>$L{'All_sites'}</TD>\n" if ($locallog != 0);
print FOUT "<TD ALIGN=MIDDLE>$L{'Outside'}</TD>\n";
print FOUT "<TD ALIGN=MIDDLE>$L{'Inside'}</TD>\n" if ($locallog != 0);
print FOUT "</TR>\n";
print FOUT "<TR>\n";
print FOUT "<TD>$L{'All_requests'}</TD>\n";

if ($locallog != 0) {
    print FOUT "<TD ALIGN=MIDDLE>";
    printf FOUT "%.2f",$VolumeTotal;
    print FOUT " $L{'Mb'} <BR><I> $reqtot $L{'requests'}</I></TD>\n";
}

print FOUT "<TD ALIGN=MIDDLE>";
printf FOUT "%.2f",$VolumeTotalExt;
print FOUT " $L{'Mb'} <BR><I> $extreq $L{'requests'}</I></TD>\n";

if ($locallog != 0) {
    print FOUT "<TD ALIGN=MIDDLE>";
    printf FOUT "%.2f",$VolumeTotalInt;
    print FOUT " $L{'Mb'} <BR><I> $domreq $L{'requests'}</I></TD>\n";
}

print FOUT "</TR>\n";
print FOUT "<TR>\n";
print FOUT "<TD>$L{'All_html_pages_requests'}</TD>\n";

if ($locallog != 0) {
    print FOUT "<TD ALIGN=MIDDLE>";
    printf FOUT "%.2f",$VolumeHtml;
    print FOUT " $L{'Mb'} <BR><I> $RequeteHtml $L{'requests'}</I></TD>\n";
}

print FOUT "<TD ALIGN=MIDDLE>";
printf FOUT "%.2f",$VolumeHtmlExt;
print FOUT " $L{'Mb'} <BR><I> $RequeteHtmlExt $L{'requests'}</I></TD>\n";

if ($locallog != 0) {
    print FOUT "<TD ALIGN=MIDDLE>";
    printf FOUT "%.2f",$VolumeHtmlInt;
    print FOUT " $L{'Mb'} <BR><I> $RequeteHtmlInt $L{'requests'}</I></TD>\n";
}

print FOUT "</TR>\n";
print FOUT "<TR>\n";
print FOUT "<TD>$L{'All_images_requests'}</TD>\n";

if ($locallog != 0) {
    print FOUT "<TD ALIGN=MIDDLE>";
    printf FOUT "%.2f",$VolumeGif;
    print FOUT " $L{'Mb'} <BR><I> $RequeteGif $L{'requests'}</I></TD>\n";
}

print FOUT "<TD ALIGN=MIDDLE>";
printf FOUT "%.2f",$VolumeGifExt;
print FOUT " $L{'Mb'} <BR><I> $RequeteGifExt $L{'requests'}</I></TD>\n";

if ($locallog != 0) {
    print FOUT "<TD ALIGN=MIDDLE>";
    printf FOUT "%.2f",$VolumeGifInt;
    print FOUT " $L{'Mb'} <BR><I> $RequeteGifInt $L{'requests'}</I></TD>\n";
}

print FOUT "</TR>\n";
print FOUT "</TABLE>\n";

}

#################################################################
sub HourElapsed {
 local(*FOUT,*L) = @_;
 local($tmp);

# print FOUT "<P><HR SIZE=5><P>\n";
 print FOUT "<A NAME=\"elapsed\"></A>\n";
# print FOUT "  $L{'Hour'} \t - \t $L{'Average_elapsed_time'} ($L{'milliseconds'}) ";
# print FOUT "<P>\n";

 print FOUT "<TABLE CLASS=\"sortable_base\" ID=\"GraphProxyElapsed\">\n<TR>\n";
 print FOUT "<TH CLASS=\"left\">&nbsp;$L{'Hour'}&nbsp;</TH>\n";
 print FOUT "<TH CLASS=\"left\">&nbsp;$L{'Average_elapsed_time'} ($L{'milliseconds'})&nbsp;</TH>\n";
 print FOUT "</TR>\n";

 for ($heure=0;$heure < $hour;$heure++) {
     $tmp = 0;
     $tmp = int($elapsed[$heure]/$elapsed_nb[$heure]) if ($elapsed_nb[$heure] != 0);
     $nbre = 2*($tmp);     # $square est la largeur du bloc image
     $nbre *= 2 if ($maxelapsed > 100);
     $nbre = int($nbre/$uniteelapsed) if ($maxelapsed > 100);
     $heuresuivante = $heure + 1;
     $heure = "0".$heure unless (length($heure) != 1);
     $heuresuivante = "0".$heuresuivante unless (length($heuresuivante) != 1);
     print FOUT "<TR>\n";
     print FOUT "<TD CLASS=\"left\">$heure&nbsp;-&nbsp;$heuresuivante&nbsp;$L{'hour'}</TD>";
     print FOUT "<TD CLASS=\"left\">";
     print FOUT "<IMG WIDTH=$nbre HEIGHT=$square SRC=\"$link_use$gcolor[5]\" ALT=\"$gcolor[5]\">&nbsp;<B>$tmp</B>" if ($tmp ne '');
     print FOUT "<B>0</B>" if ($tmp eq '');
     print FOUT "</TD>\n";
     print FOUT "</TR>\n";
 }
     print FOUT "</TABLE>\n";
}

#################################################################
sub HourProxy {
 local(*FOUT,*L) = @_;

 print FOUT "<P><HR SIZE=5><P>\n";
 print FOUT "<A NAME=\"proxy\"></A>\n";
 print FOUT "<TABLE><TR><TD VALIGN=TOP>";
 &HourElapsed(*FILEHOUR, eval($Lang{$lang[$nblang]}));
 print FOUT "</TD><TD VALIGN=TOP>";
 &HourMissProxy(*FILEHOUR, eval($Lang{$lang[$nblang]}));
 print FOUT "</TD><TD VALIGN=TOP>";
 &HourTraficMissProxy(*FILEHOUR, eval($Lang{$lang[$nblang]}));
 print FOUT "</TD><TD VALIGN=TOP>";
 &HourHitProxy(*FILEHOUR, eval($Lang{$lang[$nblang]}));
 print FOUT "</TD><TD VALIGN=TOP>";
 &HourTraficHitProxy(*FILEHOUR, eval($Lang{$lang[$nblang]}));
 print FOUT "</TD></TR></TABLE>";

}

#################################################################
sub HourTraficHitProxy {
 local(*FOUT,*L) = @_;
 local($tmp,$conv,$affsize);

 $conv = 1;
 $convunit = $L{'octet'};

 if ($maxtrafichitproxy > 1024) {
     $conv = 1024;
     $convunit = $L{'Kb'};
 }

 if ($maxtrafichitproxy > (1024*1024)) {
     $conv = 1024*1024;
     $convunit = $L{'Mb'};
 }

 if ($maxtrafichitproxy > (1024*1024*1024)) {
     $conv = 1024*1024*1024;
     $convunit = $L{'Gb'};
 }

 print FOUT "<TABLE CLASS=\"sortable_base\" ID=\"GraphProxyTraffic\">\n<TR>\n";
 print FOUT "<TH CLASS=\"left\">&nbsp;$L{'Hour'}&nbsp;</TH>\n";
 print FOUT "<TH CLASS=\"left\">&nbsp;$L{'Cached_trafic'} ($L{$convunit})&nbsp;</TH>\n";
 print FOUT "</TR>\n";

# print FOUT "<A NAME=\"trafichitproxy\"></A>\n";
# print FOUT "  $L{'Hour'} \t - \t $L{'Cached_trafic'} ($convunit)";
# print FOUT "<P>\n";

 for ($heure=0;$heure < $hour;$heure++) {
     $tmp = 0;
     $tmp = $trafic_hit_proxy[$heure];
     $nbre = 2*($tmp);     # $square est la largeur du bloc image
     $nbre *= 2 if ($maxtrafichitproxy > 100);
     $nbre = int($nbre/$unitetrafichitproxy) if ($maxtrafichitproxy > 100);
     $heuresuivante = $heure + 1;
     $heure = "0".$heure unless (length($heure) != 1);
     $heuresuivante = "0".$heuresuivante unless (length($heuresuivante) != 1);
     print FOUT "<TR>\n";
     print FOUT "<TD CLASS=\"left\">$heure&nbsp;-&nbsp;$heuresuivante&nbsp;$L{'hour'}</TD>";
     print FOUT "<TD CLASS=\"left\">";
     print FOUT "<IMG WIDTH=$nbre HEIGHT=$square SRC=\"$link_use$gcolor[7]\" ALT=\"$gcolor[7]\">&nbsp;" if ($nbre != 0);
     $affsize = $trafic_hit_proxy[$heure]/$conv;
     printf FOUT "<B>%.2f</B>",$affsize if ($tmp ne '');
     print FOUT "<B>0</B>",$affsize if ($tmp eq '');
     print FOUT "</TD>\n";
     print FOUT "</TR>\n";
 }
     print FOUT "</TABLE>\n";
}

#################################################################
sub HourTraficMissProxy {
 local(*FOUT,*L) = @_;
 local($tmp,$conv,$affsize);

 $conv = 1;
 $convunit = $L{'octet'};

 if ($maxtraficmissproxy > 1024) {
     $conv = 1024;
     $convunit = $L{'Kb'};
 }

 if ($maxtraficmissproxy > (1024*1024)) {
     $conv = 1024*1024;
     $convunit = $L{'Mb'};
 }

 if ($maxtraficmissproxy > (1024*1024*1024)) {
     $conv = 1024*1024*1024;
     $convunit = $L{'Gb'};
 }

 print FOUT "<TABLE CLASS=\"sortable_base\" ID=\"GraphProxyMissTraffic\">\n<TR>\n";
 print FOUT "<TH CLASS=\"left\">&nbsp;$L{'Hour'}&nbsp;</TH>\n";
 print FOUT "<TH CLASS=\"left\">&nbsp;$L{'Downloaded_trafic'} ($L{$convunit})&nbsp;</TH>\n";
 print FOUT "</TR>\n";

 for ($heure=0;$heure < $hour;$heure++) {
     $tmp = 0;
     $tmp = $trafic_miss_proxy[$heure];
     $nbre = 2*$tmp;     # $square est la largeur du bloc image
     $nbre *= 2 if ($maxtraficmissproxy > 100);
     $nbre = int($nbre/$unitetraficmissproxy) if ($maxtraficmissproxy > 100);
     $heuresuivante = $heure + 1;
     $heure = "0".$heure unless (length($heure) != 1);
     $heuresuivante = "0".$heuresuivante unless (length($heuresuivante) != 1);
     print FOUT "<TR>\n";
     print FOUT "<TD CLASS=\"left\">$heure&nbsp;-&nbsp;$heuresuivante&nbsp;$L{'hour'}</TD>";
     print FOUT "<TD CLASS=\"left\">";
     print FOUT "<IMG WIDTH=$nbre HEIGHT=$square SRC=\"$link_use$gcolor[7]\" ALT=\"$gcolor[7]\">&nbsp;" if ($nbre != 0);
     $affsize = $trafic_miss_proxy[$heure]/$conv;
     printf FOUT "<B>%.2f</B>",$affsize if ($tmp ne '');
     print FOUT "<B>0</B>",$affsize if ($tmp eq '');
     print FOUT "</TD>\n";
     print FOUT "</TR>\n";
 }
 print FOUT "</TABLE>\n";
}

#################################################################
sub HourHitProxy {
 local(*FOUT,*L) = @_;
 local($tmp);

 print FOUT "<A NAME=\"hitproxy\"></A>\n";
# print FOUT "  $L{'Hour'} \t - \t $L{'Cached_files'} ";
# print FOUT "<P>\n";

 print FOUT "<TABLE CLASS=\"sortable_base\" ID=\"GraphProxyHourHitTraffic\">\n<TR>\n";
 print FOUT "<TH CLASS=\"left\">&nbsp;$L{'Hour'}&nbsp;</TH>\n";
 print FOUT "<TH CLASS=\"left\">&nbsp;$L{'Cached_files'}&nbsp;</TH>\n";
 print FOUT "</TR>\n";

 for ($heure=0;$heure < $hour;$heure++) {
     $tmp = 0;
     $tmp = $hit_proxy[$heure];
     $nbre = 2*($tmp);     # $square est la largeur du bloc image
     $nbre *= 2 if ($maxhitproxy > 100);
     $nbre = int($nbre/$unitehitproxy) if ($maxhitproxy > 100);
     $heuresuivante = $heure + 1;
     $heure = "0".$heure unless (length($heure) != 1);
     $heuresuivante = "0".$heuresuivante unless (length($heuresuivante) != 1);
     print FOUT "<TR>\n";
     print FOUT "<TD CLASS=\"left\">$heure&nbsp;-&nbsp; $heuresuivante&nbsp;$L{'hour'}</TD>";
     print FOUT "<TD CLASS=\"left\">";
     print FOUT "<IMG WIDTH=$nbre HEIGHT=$square SRC=\"$link_use$gcolor[6]\" ALT=\"$gcolor[6]\">&nbsp;<B>$tmp</B>" if ($tmp ne '');
     print FOUT "<B>0</B>" if ($tmp eq '');
     print FOUT "</TD>\n";
     print FOUT "</TR>\n";
 }
     print FOUT "</TABLE>\n";

}

#################################################################
sub HourMissProxy {
 local(*FOUT,*L) = @_;
 local($tmp);

 print FOUT "<A NAME=\"missproxy\"></A>\n";
# print FOUT "  $L{'Hour'} \t - \t $L{'Downloaded_files'} ";
# print FOUT "<P>\n";

 print FOUT "<TABLE CLASS=\"sortable_base\" ID=\"GraphProxyHourMissTraffic\">\n<TR>\n";
 print FOUT "<TH CLASS=\"left\">&nbsp;$L{'Hour'}&nbsp;</TH>\n";
 print FOUT "<TH CLASS=\"left\">&nbsp;$L{'File'}&nbsp;</TH>\n";
 print FOUT "</TR>\n";

 for ($heure=0;$heure < $hour;$heure++) {
     $tmp = 0;
     $tmp = $miss_proxy[$heure];
     $nbre = 2*($tmp);     # $square est la largeur du bloc image
     $nbre *= 2 if ($maxmissproxy > 100);
     $nbre = int($nbre/$unitemissproxy) if ($maxmissproxy > 100);
     $heuresuivante = $heure + 1;
     $heure = "0".$heure unless (length($heure) != 1);
     $heuresuivante = "0".$heuresuivante unless (length($heuresuivante) != 1);
     print FOUT "<TR>\n";
     print FOUT "<TD CLASS=\"left\">$heure&nbsp;-&nbsp;$heuresuivante&nbsp;$L{'hour'}</TD>";
     print FOUT "<TD CLASS=\"left\">";
     print FOUT "<IMG WIDTH=$nbre HEIGHT=$square SRC=\"$link_use$gcolor[6]\" ALT=\"$gcolor[6]\">&nbsp;<B>$tmp</B>" if ($nbre ne '');
     print FOUT "<B>0</B>" if ($nbre eq '');
     print FOUT "</TD>\n";
     print FOUT "</TR>\n";
 }
     print FOUT "</TABLE>\n";
}

#################################################################
sub HourTopTenTraffic {
 local(*FOUT,*L) = @_;
 local($count,$unit,$tmp,$tmp2);

 $count = 0;

 print FOUT "<A NAME=\"download_topten\"></A>\n";
# print FOUT "<HR><P>\n";

# print FOUT "<TABLE>\n";
# print FOUT "<TR>\n<TH COLSPAN=";
# print FOUT "5" if ($notrafic == 0);
# print FOUT "3" if ($notrafic != 0);
# print FOUT ">$L{'Traffic_statistics'}</TH>\n</TR>\n";

  $tmp2 = keys(%sizepage);
 
 if ($tmp2 ne '') {
  print FOUT "<DIV CLASS=\"item_page\">-&nbsp;<I>$L{'The_Top'} $topten ";
  print FOUT "$L{'files'}" if ($mail_format == 0);
  print FOUT "$L{'email'}" if ($mail_format == 1);
  print FOUT "</I> ($L{'among'} $tmp2) :</DIV><P>\n";

  $tmp = $sizepage{(&reverse_sort_by_value(*sizepage))[0]};
  $unit = "$L{'bytes'}";
  $unit = "$L{'Kb'}" if ($tmp > 1024);		    
  $unit = "$L{'Mb'}" if ($tmp > (1024*1024));
  $unit = "$L{'Gb'}" if ($tmp > (1024*1024*1024));

  print FOUT "<TABLE CLASS=\"sortable_base\" ID=\"trafic_file_all\">\n";
  print FOUT "<TR>\n<TH>&nbsp;";
  print FOUT "$L{'File'}" if ($mail_format == 0);
  print FOUT "$L{'Email'}" if ($mail_format == 1);
  print FOUT "&nbsp;</TH>\n<TH>&nbsp;$L{'Traffic'}&nbsp;(";
  $unit = "$L{'Mb'}";
  $unit = "$L{'Gb'}" if (($sizepage{$page}/(1024*1024)) > 1024);
  print FOUT "$unit";
  print FOUT ")&nbsp;</TH>\n<TH>&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
  print FOUT "<TH>&nbsp;$L{'Occurence'}&nbsp;</TH>\n<TH>&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
  print FOUT "</TR>\n";

  foreach $page (&reverse_sort_by_value(*sizepage)) {

      if ($count < $topten) {
	  $count++;
	  print FOUT "<TR>\n<TD CLASS=\"left\">";
	  print FOUT "$page";
	  print FOUT "</TD>\n<TD CLASS=\"right\">&nbsp;<B>";
	  printf FOUT "%.1f",($sizepage{$page}/(1024*1024)) if ($unit eq "$L{'Mb'}");
	  printf FOUT "%.1f",($sizepage{$page}/(1024*1024*1024)) if ($unit eq "$L{'Gb'}");
	  print FOUT "</B>&nbsp;</TD>\n<TD CLASS=\"left\">&nbsp;\n";
	  $pourcentage = 100*$sizepage{$page}/($VolumeTotal*1024*1024) if ($VolumeTotal != 0);
	  $pourcentageint = int($pourcentage);
	  print FOUT "<IMG WIDTH=$pourcentageint HEIGHT=$square SRC=\"$link_use$gcolor[1]\" ALT=\"$gcolor[1]\">&nbsp;" if ($pourcentageint != 0);
	  printf FOUT "%.1f ",$pourcentage;
	  print FOUT " %</TD>\n";

	  print FOUT "<TD CLASS=\"right\">&nbsp;<B>";
#	  print FOUT "$pageslues{$page}</B>&nbsp;</TD>\n<TD CLASS=\"left\">&nbsp;\n";
	  print FOUT "$filetype{$page}</B>&nbsp;</TD>\n<TD CLASS=\"left\">&nbsp;\n";
#	  $pourcentage = 100*$pageslues{$page}/$RequeteHtml;
#	  $pourcentage = 100*$filetype{$page}/$RequeteHtml;
#	  $pourcentage = 100*$filetype{$page}/$tmp2;
	  $pourcentage = 100*$filetype{$page}/$reqtot;
	  $pourcentageint = int($pourcentage);
	  print FOUT "<IMG WIDTH=$pourcentageint HEIGHT=$square SRC=\"$link_use$gcolor[1]\" ALT=\"$gcolor[1]\">&nbsp;" if ($pourcentageint != 0);
	  printf FOUT "%.1f ",$pourcentage;
	  print FOUT " %</TD>\n";
	  print FOUT "</TR>\n";
      }
  }

  print FOUT "</TABLE>\n";
  print FOUT "<P>\n";
}

}

#################################################################
sub HourDownload {
 local(*FOUT,*L) = @_;

 print FOUT "<A NAME=\"download\"></A>\n";
#print FOUT "<HR><P>\n";

 print FOUT "<DIV CLASS=\"item_page\">-&nbsp;<I>$L{'Traffic_statistics'} ";
 print FOUT "$L{'on'} $nbdays $L{'days'}" if ($opt_a == 1);
 print FOUT "</I> :</DIV><P>\n";

 print FOUT "<TABLE>\n";
# print FOUT "<TR>\n";
# print FOUT "<TH ALIGN=CENTER COLSPAN=";
# print FOUT "5" if ($notrafic == 0);
# print FOUT "3" if ($notrafic != 0);
#print FOUT ">$L{'Traffic_statistics'}</TH>\n</TR>\n";
#print FOUT "<TR>\n<TH>$L{'File'}</TH>\n<TH>$L{'Occurence'}</TH>\n<TH>$L{'Percentage'}</TH>\n<TH>$L{'Traffic'}</TH>\n<TH>$L{'Percentage'}</TH>\n</TR>\n";
# $percentage = 100;
# $percentageint = int($percentage);
# print FOUT "<TR>\n<TH CLASS=\"left\">$L{'All_requests'}</TH>\n<TH CLASS=\"right\">$reqtot $L{'times'}</TH>\n<TH CLASS=\"left\">";
# print FOUT "<IMG WIDTH=$percentageint HEIGHT=$square SRC=\"$link_use$gcolor[2]\" ALT=\"$gcolor[2]\"> " if ($percentageint != 0);
# printf FOUT "%.1f %</TH>\n",$percentage;

# $percentage = 100;
# $percentageint = int($percentage);
# print FOUT "<TH CLASS=\"right\">";
# printf FOUT "%.1f $L{'Mb'}",$VolumeTotal;
# print FOUT "</TH>\n<TH CLASS=\"left\">";
# print FOUT "<IMG WIDTH=$percentageint HEIGHT=$square SRC=\"$link_use$gcolor[2]\" ALT=\"$gcolor[2]\"> " if ($percentageint != 0);
# printf FOUT "%.1f %</TH>\n</TR>\n",$percentage;

for ($l=0;$l<$nbzonefile;$l++) {

    $k = $filetypemax[$l];
    next if ($zoneext[$k] == 0 || $k == 0);

    print FOUT "<TR><TD>\n";
    print FOUT "<TABLE CLASS=\"sortable_download\" ID=\"$zonefile[$k]\">\n";

#    $percentage = $zoneext[$k]*100/($reqtot-$access) if ($reqtot != $access);
    $percentage = $zoneext[$k]*100/$reqtot;
    $percentageint = int($percentage);
    print FOUT "<TR>\n<TH CLASS=\"left\">$zonefile[$k]</TH>\n<TH CLASS=\"right\">$zoneext[$k] $L{'times'}</TH>\n<TH CLASS=\"left\">";
    print FOUT "<IMG WIDTH=\"$percentageint\" HEIGHT=\"$square\" SRC=\"$link_use$gcolor[2]\" ALT=\"$gcolor[2]\"> " if ($percentageint != 0);
    printf FOUT "%.1f",$percentage;
    print FOUT "&nbsp;%</TH>\n";

    if ($notrafic == 0) {
	print FOUT "<TH CLASS=\"right\">";
	printf FOUT "%.1f",$downloadext[$k]/(1024*1024);
	print FOUT "&nbsp;$L{'Mb'}";
	print FOUT "</TH>\n";
	print FOUT "<TH CLASS=\"left\">";
	$percentage = $downloadext[$k]*100/($VolumeTotal*1024*1024);
	$percentageint = int($percentage);
	print FOUT "<IMG WIDTH=\"$percentageint\" HEIGHT=\"$square\" SRC=\"$link_use$gcolor[2]\" ALT=\"$gcolor[2]\"> " if ($percentageint != 0);
	printf FOUT "%.1f",$percentage;
	print FOUT "&nbsp;%</TH>\n";
    }
    print FOUT "</TR>\n";


    for ($i=0;$i<=$#listext;$i++) {
#	next if ($listext[$k] =~ /$extension/);
	if ($k == $extfilenb{$listext[$i]}) {
#	    $tmp2 = 0;
#	    for ($j=1;$j<=$maxdownloadlength;$j++) {
#		$tmp2 += $download{$listext[$i],$j};
#	    }
	    $tmp2 = $download{$listext[$i]};
	    if ($tmp2 != 0) {
	    $percentage = $tmp2*100/$zoneext[$k];
	    $percentageint = int($percentage);

	    print FOUT "<TR>\n<TD CLASS=\"left\">$extfile{$listext[$i]} ($listext[$i])</TD>\n<TD CLASS=\"right\">$tmp2 $L{'times'}</TD>\n<TD CLASS=\"left\">\n";
	    print FOUT "<IMG WIDTH=\"$percentageint\" HEIGHT=\"$square\" SRC=\"$link_use$gcolor[1]\" ALT=\"$gcolor[1]\"> " if ($percentageint != 0);
	    printf FOUT "%.1f",$percentage;
	    print FOUT "&nbsp;%</TD>\n";

	    if ($notrafic == 0) {
		$percentage = $downloadsizeext{$listext[$i]}*100/$downloadext[$k];
		$percentageint = int($percentage);
		print FOUT "<TD CLASS=\"right\">";
		printf FOUT "%.1f",$downloadsizeext{$listext[$i]}/(1024*1024);
		print FOUT "&nbsp;$L{'Mb'}";
		print FOUT "</TD>\n<TD CLASS=\"left\">";
		print FOUT "<IMG WIDTH=\"$percentageint\" HEIGHT=\"$square\" SRC=\"$link_use$gcolor[1]\" ALT=\"$gcolor[1]\"> " if ($percentageint != 0);
		printf FOUT "%.1f",$percentage;
		print FOUT "&nbsp;%</TD>\n";
	    }
	    print FOUT "</TR>\n";
	}
	}
    }
    print FOUT "</TABLE>\n";
    print FOUT "</TD></TR>\n";
}
print FOUT "</TABLE>\n";
}

#################################################################
sub HourFoot2 {
 local(*FOUT,*L) = @_;

print FOUT "<P><HR><P>\n";
print FOUT "</BODY></HTML>\n";
}

sub HourCSV {
 local(*FOUT) = @_;
 local($tmp);

 $tmp = 0;
 print FOUT "#\"Hour\";\"Hit\";\"Access\";\"Host\";\"Traffic\"\n";
 for ($heure=0;$heure < $hour;$heure++) {
     $heure = "0".$heure unless (length($heure) != 1);
     $tmp = 1 if ($hitheure[$heure] ne '');
     print FOUT "\"$heure\";\"$hitheure[$heure]\";\"$accesstot[$heure]\";\"$user[$heure]\";\"$size[$heure]\"\n" if ($hitheure[$heure] ne '');
     print FOUT "\"$heure\";\"0\";\"0\";\"0\";\"0\"\n" if ($hitheure[$heure] eq '' && $tmp == 0);
 }
}

sub nextlog {

    $day++; # if ($zipcut == 2);
    $day = "0".$day if (length($day) == 1 && $struct_compressed_logfile !~ /\%smallday/);
    
    $monthprev = $month-1; # if ($zipcut == 1);

    if ($day > $month_of_year{$month_nb[$monthprev]}) {
	$month++;
	$monthprev++;
	$day = "1" if ($struct_compressed_logfile =~ /\%smallday/);
	$day = "01" if ($struct_compressed_logfile !~ /\%smallday/);
    }
    

    if ($month == 2) {
	if (($year%4 == 0 && $year%100 != 0) || $year%400 == 0) {
	    $month_of_year{'Feb'} = "29";
	    $bisextil = 1;
	} else {
	    $month_of_year{'Feb'} = "28";
	    $bisextil = 0;
	}
    }

    $year++ if ($month == 13);
    $month = "1" if ($month == 13);
    $month = "0".$month if (length($month) == 1 && $struct_compressed_logfile !~ /\%smallmonth/);
    $monthprev = 0 if ($month == 1);
    $lettermonth =  $month_nb[$monthprev];
#    $file = $fileroot;
    $smallyear = $year - int($year/100)*100;
    $smallyear = "0".$smallyear if (length($smallyear) == 1);

    $file = &Get_LogfileName($fileroot);
#    for ($i=1;$i<=$#compressed_logfile_fields;$i++) {
#	$compressed_logfile_fields[$i] =~ s/\%/\$/;
#	$file .= eval($compressed_logfile_fields[$i]).$compressed_sep_fields[$i];
#    }
    
    $filezip = $file.$zipext if ($zip == 1);
    $datezip = $year.$month.$day;

}


__END__
