#!/usr/bin/perl
# <plaintext>  just in case you look at this via a browser

#########################################################################
####                                                                #####
####                     MONTHLY STATS                              #####
####                                                                #####
####                                                                #####
####    domisse@w3perl.com                   version 21/11/2007     #####
####                                                                #####
#########################################################################

# Skipout if day is unsorted
# filtrage sur pays a ajouter

$version = "3.01";
$verdate = "21/11/07";

$shift_factor = 0.3;

#$dirjs = "js";
#$dircss = "css";

#$sorttablejs = "sorttable.js";
#$helpjs = "help.js";
$calendarmonthjs = "monthcalendar.js";

#$css_w3perl = "w3perl.css";
#$css_help = "help.css";
$css_calendar = "calendar.css";

$scriptname = "cron-month.pl";

$listdailysites = "liste_daily_sites";
$listdailypages = "liste_daily_pages";
$listdailyscripts = "liste_daily_scripts";
$listdailytrafic = "liste_daily_trafic";
$listdailydir = "liste_daily_dir";
$listdailycountries = "liste_daily_country";
$listdailyfiletype = "liste_daily_filetype";
$listdailyrefer = "liste_daily_refer";
$listdailykeyword = "liste_daily_keyword";
$listdailyagent = "liste_daily_agent";

####### script a lancer a 00 heures 01 minutes tous les 1er du mois #####
require "flush.pl";
require "/var/www/cgi-bin/w3perl/libw3perl.pl";

$pos = rindex($conf_file,$dirsep);
$vtmp = substr($conf_file,$pos+1,length($conf_file));
$pos = rindex($0,"-");
$vtmp .= substr($0,$pos+1,length($0));
$vtmp =~ s/$plext//g;
$rss_month = int($nb_rss_item/30)+1;

&MakeDirectories;

$starttime = time();
print "Monthly stats : $version\n";
print "<P>" if ($ENV{'REQUEST_METHOD'} eq "GET");

# Retrieve external log
&retrieve_external_logfile($fileroot,$remote_host_log) if ($retrieve_external_log == 1 && $opt_w eq '');

# calculer le temps mis pour le calcul
$startrun = "$hour:$minute:$second";

# variable liee au serveur

#if ($zipcut == 3 || ($struct_compressed_logfile =~ /\%hour/ && $struct_compressed_logfile =~ /\%min/ && $struct_compressed_logfile =~ /\%sec/)) {
#    $filetmpzip = &find_last_log($fileroot,$prefixlog);
#    $first_logfile = &find_first_log($fileroot,$prefixlog);
#   if ($filetmpzip == -1 || $first_logfile == -1) {
#       if (!(-f "$fileroot$prefixlog")) {
#	   &error_exit("No file found in $fileroot",1);
#       } else {
#	   $zip = 0;
#	   $zipcut = 0;
#       }
#    }
#    if ($zipcut == 3) {
#	$tmp = $filetmpzip;
#	$filetmpzip =  $first_logfile;
#	$first_logfile = $tmp;
#    }
#    $rotate_index = $max_rotate_index;
#   if ($rotate_index !~ /^\d+$/) {
#	&error_exit("Found a logfile I don't understand $prefixlog$rotate_index. Index should be a number.",1);
#    }
#}

#$reverse_geo = 0 if ($reverse_geo eq '');
$domreq = 0;
$reqtot = 0;
$totsize = 0;
$accesslues = 0;
$testday = 1; ### CHANGES
$testday = 0 if ($zipcut == 2);
$timesec = time;
$tabnamecsv = $tabnamemonth;
$tabnamecsv =~ s/$htmlext//;

#&get_time($timesec);
($date,$datehour,$datemisc) = &get_time($timesec);

#if ($struct_compressed_logfile !~ /\%hour/ && $struct_compressed_logfile !~ /\%min/ && $struct_compressed_logfile !~ /\%sec/) {
#    if ($zipcut == 2) {
#	$monthtmp = $month;
#	$month = $month_equiv{$month};
#	$month = "0".$month if (length($month) == 1 && $struct_compressed_logfile !~ /\%smallmonth/);
#	$lettermonth = $month_nb[$month-1];
#	$smallyear = $year - int($year/100)*100;
#	$smallyear = "0".$smallyear if (length($smallyear) == 1);
#	$smallday = $day;
#	$smallday = substr($smallday,1,2) if ($smallday < 10);
#	$smallmonth = $month;
#	$date_filename = $day.$dirsepurl.$lettermonth.$dirsepurl.$year; # Format XX/Mmm/YYYY
#	$datetmpzip = $year.$month.$day;
#	$filetmpzip = &Get_LogfileName($fileroot);
#	$filetmpzip_day = &nbday($date_filename);

#	$filetmpzip = $filetmpzip.$zipext if ($zip == 1);
#	$month = $monthtmp;
#    }
#}


#################################################################
###            parsing the command line option                ###
#################################################################

if ($opt_h == 1) {
      print "Usage : \n";
      print "        -c <file>             : load configuration file\n";
      print "        -d <nbdays>           : scan only nbdays previous day\n";
      print "        -g <";
      for ($i=0;$i<$#graphic;$i++) {
      print "$graphic[$i] ";
      } 
      print "$graphic[$#graphic]";
      print "> : graphic output (choose one)\n";
      print "        -l <";
      for ($i=0;$i<$#lang;$i++) {
      print "$lang[$i],";
      } 
      print "$lang[$#lang]";
      print ">            : language output (comma split)\n";          
      print "        -p <level>            : precision level (from 1 to 4)\n";
      print "        -x                    : show default value for flag options\n";
      print "        -v                    : version\n";
      print "        -z           : zip logfiles\n";      
      print "\n";
      exit;
}

if ($opt_v == 1) {
      print "$scriptname version $version $verdate\n";
      exit;
}

if ($opt_x == 1) {
      print "Default : \n";
      print "          -d            : $nbdays\n";
      print "          -c            : $configfile\n";
      print "          -g <graphic>  : $graphic[0]\n";
      print "          -l <language> : ";
      for ($i=0;$i<$#lang;$i++) {
      print "$lang[$i],";
      }
      print "$lang[$#lang]\n";      
      print "          -p <level>    : $precision\n";
      print "          -v            : $version\n";
      print "          -z            : ";
      &id($opt_z);         
      exit;
}

if ($opt_z ne '') {
$zip = $opt_z;
}

if ($opt_d ne '') {
$nbdays = $opt_d; 
}

if ($opt_l ne '') {
  @lang = split(/, /,$opt_l);
  for ($i=0;$i<=$#lang;$i++) {
      $tmp = $dirress.$dirsep."lang".$dirsep.$lang[$i].$plext;
      $tmp = $pathinit.$tmp;
      require "$tmp";
  }
  if ($lang[0] eq '') {
      &error_exit("\nNone of your language choices have been yet translated !",1);
      }
}


if ($opt_g ne '') {
  if ($opt_g eq "3d")  {
      $bargraph = 1;
      $linegraph = 0;
      $tridim = 1;
  }
  if ($opt_g eq "fill") {
      $bargraph = 0;
      $linegraph = 1;
      $fillgraph = 1;
  }
  if ($opt_g eq "line") {
      $bargraph = 0;
      $linegraph = 1;
  }
  if ($opt_g eq "bar") {
      $bargraph = 1;
      $linegraph = 0;
      $tridim = 0;
  }
}


# argument cmds line

if ($opt_p ne '') {
  $precision = $opt_p;
}

#################################################################
####          debut de l'initialisation                   #######
#################################################################

$outfile1 = $path.$dirgraph.$dirsep."month_mac".$gifext;
$outfile1x = $path.$dirgraph.$dirsep."month_macx".$gifext;
$outfile1y = $path.$dirgraph.$dirsep."month_macy".$gifext;

$linkoutfile1 = "..".$dirsepurl."..".$dirsepurl.$dirgraph.$dirsepurl."month_mac".$gifext;
$linkoutfile1x = "..".$dirsepurl."..".$dirsepurl.$dirgraph.$dirsepurl."month_macx".$gifext;
$linkoutfile1y = "..".$dirsepurl."..".$dirsepurl.$dirgraph.$dirsepurl."month_macy".$gifext;

$outfile2 = $path.$dirgraph.$dirsep."month_req".$gifext;
$outfile2x = $path.$dirgraph.$dirsep."month_reqx".$gifext;
$outfile2y = $path.$dirgraph.$dirsep."month_reqy".$gifext;

$linkoutfile2 = "..".$dirsepurl."..".$dirsepurl.$dirgraph.$dirsepurl."month_req".$gifext;
$linkoutfile2x = "..".$dirsepurl."..".$dirsepurl.$dirgraph.$dirsepurl."month_reqx".$gifext;
$linkoutfile2y = "..".$dirsepurl."..".$dirsepurl.$dirgraph.$dirsepurl."month_reqy".$gifext;

### URL to title conversion

#if (!(-e "$path$dirdata$dirsep$fileurl")) {
#  $titlename = 0;
#}

&load_fileext;

&load_countries_map;

&load_url_map if ($titlename == 1);


# Find last month

$line = 0;
open(INFILE, "$path$dirdata$dirsep$datafile") || &error_exit("Error, unable to open $path$dirdata$dirsep$datafile",1);
while (<INFILE>) {
    $line++;
    next if ($line <= 3);

    ($jour,$lastmonth,$lastyear) = split('\s+');
 }
close(INFILE);

if ($jour eq '') {
    &error_exit("Not enough data to compute monthly stats.\n File $path$dirdata$dirsep$datafile is empty\n",0);
}

if ($jour ne $month_of_year{$lastmonth}) {
    $lastmonth = $month_nb[$month_equiv{$lastmonth}-2];
}

#################################################################
#####              computing monthly stats                 ######
#################################################################

open(OUT, ">$path$dircsv$dirsep$tabnamecsv$csvext");
print OUT "#\"Date\";\"Hosts\";\"New_Hosts\";\"Domain_Hosts\"";
print OUT ";\'Requests\"" if ($mail_format == 0 && $ftp_format == 0);
print OUT ";\"File\"" if ($ftp_format == 1);
print OUT ";\"Email\"" if ($mail_format == 1);
print OUT ";\"Accesses\"" if ($mail_format == 0 && $ftp_format == 0);
print OUT ";\"DomReq\"\n";
close(OUT);

for ($nblang=0;$nblang<=$#lang;$nblang++) {

    $tabmonth = $path.$lang[$nblang].$dirsep.$dirdate.$dirsep.$tabnamemonth;

    open(TABMONTH,">$tabmonth") || &error_exit("Error, unable to open $tabmonth",1);
    &MonthHeader(*TABMONTH, eval($Lang{$lang[$nblang]}));
    close(TABMONTH);
}

open(OUT, ">>$path$dircsv$dirsep$tabnamecsv$csvext");
open(INFILE, "$path$dirdata$dirsep$datafile") || &error_exit("Error, unable to open $path$dirdata$dirsep$datafile",1);

$line = 0;
$count_month = 1;
$lastmonth_found = 0;

while (<INFILE>) {
     $line++;
     next if ($line <= 3);

     $count++;
     ($jour,$month,$year,$m_tot,$m_new,$m_dom,$req_tot,$req_dom,$access,$totsize,$tothtmlsize,$domsize,$script,$pays) = split('\s+');

     if ($line == 4) {
       $start_date = $month." ".$year;
       $oldmonth = $month;
       $oldyear = $year;
     }

     $dirresume = $year."-".$month."-".$jour;
     $dirresumefull = $year."-".$month;

     $oldmonth = $month;
     $oldyear = $year;
#     print "$jour/$month/$year :  $month_of_year{$oldmonth} - $oldmonth - $jour\n";

     if ($month_of_year{$month} != $jour) {
#     if ($month eq $oldmonth) {
	 &LoadDailyData;
	 $machine_tot = $machine_tot + $m_tot;
	 $machine_dom = $machine_dom + $m_dom;
	 $machine_new = $machine_new + $m_new;
	 $requete_tot = $requete_tot + $req_tot;
	 $access_tot = $access_tot + $access;
	 $requete_dom = $requete_dom + $req_dom;
	 $size_tot = $size_tot + $totsize;

	 push(@req_value,$req_tot);
	 push(@acc_value,$access);
	 push(@host_value,$m_tot);
	 push(@date_value,$dirresume);
	 push(@traffic_value,$totsize);
	 $month_current++;
     }
     else {

	 
	 $lastmonth_found = 1 if ($month eq $lastmonth && $year == $lastyear);
	 $month_over = 1 if ($lastmonth_found == 1 && $jour == $month_of_year{$month});

#	 print "OVER : $month_over / LAST : $lastmonth_found ($month/$lastmonth/$year/$lastyear)\n";

	 &LoadDailyData;

	 $machine_tot = $machine_tot + $m_tot;
	 $machine_dom = $machine_dom + $m_dom;
	 $machine_new = $machine_new + $m_new;
	 $requete_tot = $requete_tot + $req_tot;
	 $access_tot = $access_tot + $access;
	 $requete_dom = $requete_dom + $req_dom;
	 $size_tot = $size_tot + $totsize;

	 $month_current++;
	 push(@req_value,$req_tot);
	 push(@acc_value,$access);
	 push(@host_value,$m_tot);
	 push(@date_value,$dirresume);
	 push(@traffic_value,$totsize);

	 $dirresumefull = "$path$lang[0]$dirsep$dirdate$dirsep$dirresumefull";
	 
	 $dirresume_old = $dirresume;
	 $tmpdate = "$oldyear $oldmonth";
	 ($val1,$val2) = split(/\s+/,$tmpdate);
	 $dirresume = $val1."-".$val2;
	 print "Month : $tmpdate\n";
	 print "<BR>" if ($ENV{'REQUEST_METHOD'} eq "GET"); 

#	 $month_nb1 = $month_equiv{$oldmonth};
#	 $month_nb2 = $month_equiv{$month};

	$reqtotjour = $requete_tot;
	$accessjour = $access_tot;
	$totsizejour = $size_tot;
	$domreq = $requete_dom;
	$serveruniquejour = $machine_tot;
	$locserverjour = $machine_dom;
#	$scriptuniquejour = $script_day;
	$newhost = $machine_new;

	if ($mail_format == 0) {

#	for ($k=0;$k<=$#listext;$k++) {
#	    next if ($listext[$k] =~ /$extension/ && $ftp_format == 0);
#	    $tmp2 = $downloadjour{$listext[$k]};
##	    $tmp = $extfilenb{$listext[$k]};
##	    $tmp = 0 if ($extfilenb{$listext[$k]} eq '');
##	    $zoneextjour[$tmp] += $tmp2;
#	    $zoneextjour[$extfilenb{$listext[$k]}] += $tmp2;
#	}

	for ($k=0;$k<=$nbzonefile;$k++) {
	    $zoneextbis[$k] = $zoneextjour[$k];
	}

	for ($j=0;$j<=$nbzonefile;$j++) {
	    $max = 0;
	    $filetypejourmax[$j] = 0;
	    for ($k=0;$k<=$nbzonefile;$k++) {
		if ($zoneextbis[$k] > $max) {
		    $max = $zoneextbis[$k];
		    $filetypejourmax[$j] = $k;
		}
	    }
	    $zoneextbis[$filetypejourmax[$j]] = 0;      
	}

    }

	if ($ftp_format == 0 && $mail_format == 0) {

	# OS

	$unique_new_osday = $uniqueosday;
	foreach $osday (keys(%nbreosday)) {
	    $ok = 0;
	    for ($j=0;$j<=$#os;$j++) {
		if ($osday eq $os[$j]) {
		    $tmp = $os[$j];
		    $tmp1 = $translate_os{$tmp};
		    $new_osday{$tmp1} += $nbreosday{$tmp} if ($ok == 0);
		    $ok = 1;
		    $unique_new_osday-- if ($seen_serveur{"$tmp1 $oldjour"}++);
		}
	    }
	    $new_osday{$osday} = $nbreosday{$osday} if ($ok != 1);
	}


       # Browser

	$unique_new_browserday = 0;

	for ($l=1;$l<=$uniqueday;$l++) {	       
	    for ($j=0;$j<=$#agent;$j++) {
		if ($browserday[$l] =~ /$agent[$j]/) {
		    $tmp = $agent[$j];
		    $tmp1 = $translate_agent{$tmp};
		    $bro_ver = $browserday[$l];
		    $bro_ver =~ /(\d)+/;
		    $bro_ver = int($1);
		    $new_browserday{$tmp1} += $nbreday{$browserday[$l]};
		    $browser_versionday{$tmp1,$bro_ver} += $nbreday{$browserday[$l]};
		    $browser_version_nbday{$tmp1} = $bro_ver if ($bro_ver > $browser_version_nbday{$tmp1});
		    $browserday[$l] = '';
		    $unique_new_browserday++ if (!($seen_serveur{"$tmp1 $oldjour"}++));
		}
	    }
	    $new_browserday{$browserday[$l]} += $nbreday{$browserday[$l]} if ($browserday[$l] ne '');
	    $unique_new_browserday++ if ($browserday[$l] ne '');
	}
	
	for ($i=0;$i<$unique_new_browserday;$i++) {
	    $maxi = 0;
	    foreach $browser (keys(%new_browserday)) {
		if ($new_browserday{$browser} > $maxi) {
		    $maxi = $new_browserday{$browser};
		    $bestbrowserday[$i] = $browser;
		    $occurbrowserday[$i] = $new_browserday{$browser};                 
		}
	    }
	    $new_browserday{$bestbrowserday[$i]} = 0;
	}

	for ($i=0;$i<$unique_new_browser;$i++) {
	    for ($j=0;$j<=$#agent;$j++) {
		if ($bestbrowserday[$i] =~ /$agent[$j]/) {
		    $tmp = $agent[$j];
		    $tmp1 = $translate_agent{$tmp};
		}
	    }
	    $bestbrowserday[$i] =~ s/$tmp/$tmp1/ if ($tmp1 ne '');
	}
    }
	 

	 ($tmp1,$tmp2) = split(/ /,$tmpdate);
	 $tmp = $month_of_year{$oldmonth}-$month_current+1;
	 $first_date = $tmp." ".$tmp2." ".$tmp1;

#	 &BuildRequestsGraph($tmpdate,$month_of_year{$oldmonth},\@date_value,\@req_value,\@acc_value,\@host_value,\@traffic_value);
	 &BuildRequestsGraph($tmpdate,$month_current,$first_date,\@date_value,\@req_value,\@acc_value,\@host_value,\@traffic_value);
	 &BuildDailyResume($scriptname,$lastmonth_found);
	 if ($ftp_format == 0 && $mail_format == 0) {
	     &BuildDailyReferResume($scriptname) if (keys(%nbredayref) != 0);
	     &BuildDailyAgentResume($scriptname) if ($uniqueosday != 0);
	 }
	 &UpdatePageResumeMenu($scriptname,$lastmonth_found);

	 undef @req_value;
	 undef @acc_value;
	 undef @host_value;
	 undef @date_value;
	 undef @traffic_value;
	 $month_current = 0;

	 if ($mail_format == 0) {
	    undef @zoneextjour;
	    undef @filetypejourmax;
	    undef @listext;
	    undef %downloadjour;
	    undef %filetypejour;
	}

	 if ($ftp_format == 0 && $mail_format == 0) {

	    for ($i=0;$i<=$unique_new_browserday;$i++) {
		for ($l=$browser_version_nbday{$bestbrowserday[$i]};$l>0;$l--) {
		    $browser_versionday{$bestbrowserday[$i],$l} = '';
		}
	    }

	    undef %browser_versionday;
	    undef %browser_version_nbday;
	    undef %new_browserday;
	    undef %nbrebrowserday;
	    undef %nbreosday;
	    undef @browserday;
	    undef %new_osday;
	    undef @bestbrowserday;
	    undef @occurbrowserday;
	    undef %nbreday;
	    undef %idx_browser;

	    $unique_new_browserday = 0;
	    $nbagent = 0;

	    undef %nbredayref;
	    undef %nbrefullday;
	    undef %occurday;
	    undef %wday;
	    undef %keyshday;
	    undef @wordsday;

	}

	$uniquenbrefullday = 0;
	$uniqueurlday = 0;

	$countday = 0;
	$uniqueday = 0;


	undef %seen_server;
	undef %freqjourrac;
	undef %freqjourrachtml;
	undef %sizejourrachtml;
	undef %dailysizepage;
	undef %serverjour;
	undef %hostluesday;
	undef %serversizejour;
	undef %pagesluesday;
	undef %paysjour;
	undef %payshtmljour;
	undef %paysjourlist;
	undef %scriptday;
	undef %client_day_error;
	undef %client_day_refer;
	undef %downloadjour;
	undef %filetypejour;

	$domsizejour = 0;
	$script_day = 0;
	$scriptuniquejour = 0;
	$pageuniquejour = 0;
	$paysuniquejour = 0;
	$tothtmlsizejour = 0;

	 push(@listhost,$machine_tot);
	 push(@listreq,$requete_tot);
	 push(@listacc,$access_tot);
	 push(@listsize,$size_tot);
	 push(@listdate,$tmpdate);

#	 $tmp_intervalle = $month_nb2-$month_nb1;
#	 $sw_oldyear = 0;
#	 if ($tmp < 0) {
#	     $tmp += 12;
#	     $sw_oldyear = 1;
#	 }

#	 for ($j=0;$j<$tmp_intervalle;$j++) {

#	     $indice = $j+$month_nb1-1;
#	     if ($indice > 11) {
#		 if ($sw_oldyear == 1) {
#		     $oldyear++;
#		     $sw_oldyear = 0;
#		 }
#		 $indice = $indice-12;
#	     }

#	     $oldmonth = $month_nb[$indice];

	     $machmaxtot{$count_month} = $machine_tot;
	     $newmaxtot{$count_month} = $machine_new;
	     $dommaxtot{$count_month} = $machine_dom;
	     
	     $machmax = $machine_tot if ($machine_tot > $machmax);
       	     $maxtot = $size_tot if ($size_tot > $maxtot);

	     $reqmaxtot{$count_month} = $requete_tot;
	     $accessmaxtot{$count_month} = $access_tot;
	     $reqdommaxtot{$count_month} = $requete_dom;
	     $sizemaxtot{$count_month} = $size_tot;

	     $reqmax = $requete_tot if ($requete_tot > $reqmax);

	     ($val1,$val2) = split(/\s+/,$tmpdate);
	     $tmp = $val1."-".$val2;
	     $linkjour = "..".$dirsepurl.$dirdate.$dirsepurl.$tmp.$dirsepurl.$menu;
	     $fulljour = $path.$lang[0].$dirsep.$dirdate.$dirsep.$tmp.$dirsep.$menu;

	     for ($nblang=0;$nblang<=$#lang;$nblang++) {
		 $tabmonth = $path.$lang[$nblang].$dirsep.$dirdate.$dirsep.$tabnamemonth;
		 $taboldmonth = $oldyear."-".$oldmonth;

#		 print "$taboldmonth - $count_month\n";

		 $graphline[$count_month] = $taboldmonth if ($nblang == 0);

		 open(TABMONTH,">>$tabmonth") || &error_exit("Error, unable to open $tabmonth",1);
		 print TABMONTH "<TR><TD CLASS=\"left\">";
		 print TABMONTH "<A HREF=\"$linkjour\">";
#		 print TABMONTH "<A HREF=\"$taboldmonth$htmlext\">" if (-f "$path$lang[$nblang]$dirsep$dirdate$dirsep$taboldmonth$htmlext");
		 print TABMONTH "$oldyear $oldmonth ";
		 print TABMONTH "</A>";
#		 print TABMONTH "</A>" if (-f "$path$lang[$nblang]$dirsep$dirdate$dirsep$taboldmonth$htmlext");
		 print TABMONTH "</TD>";
		 print TABMONTH "<TD CLASS=\"right\">$machine_tot</td>";
		 print TABMONTH "<TD CLASS=\"right\">$machine_new</TD>";
		 print TABMONTH "<TD CLASS=\"right\">$machine_dom</TD>";
		 print TABMONTH "<TD CLASS=\"right\">$requete_tot</TD>";
		 print TABMONTH "<TD CLASS=\"right\">$access_tot</TD>" if ($mail_format == 0 && $ftp_format == 0);
		 print TABMONTH "<TD CLASS=\"right\">$requete_dom</TD>";
		 print TABMONTH "</TR>\n";
		 close(TABMONTH);
	     }


	     print OUT "\"$oldyear $oldmonth\";\"$machine_tot\";\"$machine_new\";\"$machine_dom\"";
	     print OUT ";\"$requete_tot\"";
	     print OUT ";\"$access_tot\"" if ($mail_format == 0 && $ftp_format == 0);
	     print OUT ";\"$requete_dom\"\n";

#	     $taboldmonth = $oldyear."-".$oldmonth;

#	     $graphline[$count_month] = $taboldmonth;

	     $machine_tot = 0;
	     $machine_new = 0;
	     $machine_dom = 0;
	     $requete_tot = 0;
	     $access_tot = 0;
	     $requete_dom = 0;
	     $totsize = 0;
	     $size_tot = 0;
	     $count_month++;
#	     print "TT $count_month\n";
#	     $line++;
#	 }

	 $date_last = $year."-".$oldmonth;

	 if ($enable_pdf == 1) {
	     if (-d "$path$lang[0]$dirsep$dirdate$dirsep$dirresume") {
		 $filepdf = $path.$dirpdf.$dirsep.$date_last.$pdfext;
		 &generate_pdf_cmd($date_last,$statnamemonth,$filepdf) if (!(-f $filepdf));
	     }
	 }

	$dirresume = $dirresume_old;

#	&LoadDailyData;

#        $machine_tot = $m_tot;
#        $machine_new = $m_new;
#        $machine_dom = $m_dom;
#        $requete_tot = $req_tot;
#        $access_tot = $access;
#        $requete_dom = $req_dom;
#	$size_tot = $totsize;


#        $oldmonth = $month;
#	 print "RR $oldmonth - $month\n";
#	$oldyear = $year;
#        $line++;
        }
}

close(INFILE);

#

$monthindex = $month_equiv{$month};
#$month_over = 0;

#if ($month_of_year{$month} == $jour) {
#    $month_over = 1;

#    $machmaxtot{$count_month} = $machine_tot;
#    $newmaxtot{$count_month} = $machine_new;
#    $dommaxtot{$count_month} = $machine_dom;

#    $machmax = $machine_tot if ($machine_tot > $machmax);

#    $reqmaxtot{$count_month} = $requete_tot;
#    $accessmaxtot{$count_month} = $access_tot;
#    $reqdommaxtot{$count_month} = $requete_dom;
    
#    $reqmax = $requete_tot if ($requete_tot > $reqmax);

#    for ($nblang=0;$nblang<=$#lang;$nblang++) {
#	$tabmonth = $path.$lang[$nblang].$dirsep.$dirdate.$dirsep.$tabnamemonth;
#	$taboldmonth = $oldyear."-".$oldmonth;

#	$graphline[$count_month] = $taboldmonth if ($nblang == 0);
##   $graphline[$count_month] = $taboldmonth;
          
#	open(TABMONTH,">>$tabmonth") || die "Error, unable to open $filemonth\n";
#	print TABMONTH "<TR><TD CLASS=\"left\">";
#	print TABMONTH "<A HREF=\"$taboldmonth$htmlext\">" if (-f "$path$lang[$nblang]$dirsep$dirdate$dirsep$taboldmonth$htmlext");
#	print TABMONTH "$oldyear $oldmonth ";
#	print TABMONTH "</A>" if (-f "$path$lang[$nblang]$dirsep$dirdate$dirsep$taboldmonth$htmlext");
#	print TABMONTH "</TD>";
#	print TABMONTH "<TD CLASS=\"right\">$machine_tot</TD>";
#	print TABMONTH "<TD CLASS=\"right\">$machine_new</TD>";
#	print TABMONTH "<TD CLASS=\"right\">$machine_dom</TD>";
#	print TABMONTH "<TD CLASS=\"right\">$requete_tot</TD>";
#	print TABMONTH "<TD CLASS=\"right\">$access_tot</TD>" if ($mail_format == 0 && $ftp_format == 0);
#	print TABMONTH "<TD CLASS=\"right\">$requete_dom</TD>";
#	print TABMONTH "</TR>\n";
#	close(TABMONTH);
#    }
#    print OUT "\"$oldyear $oldmonth\",\"$machine_tot\",\"$machine_new\",\"$machine_dom\",\"$requete_tot\",\"$access_tot\",\"$requete_dom\"\n";
#    $count_month++;

    # Last day of the current month => sending email and generate PDF

#    if ($enable_pdf == 1) {

#	     if (-d "$path$lang[0]$dirsep$dirdate$dirsep$dirresume") {
#	     }
#	$filepdf = $path.$dirpdf.$dirsep.$year."-".$month.$pdfext;
#	$pdfdate = $year."-".$month;
#	&generate_pdf_cmd($pdfdate,$filemonth,$filepdf);
#    }
    
#}

close(OUT);
        
# fermeture de la page HTML du tableau sur les mois

for ($nblang=0;$nblang<=$#lang;$nblang++) {
  $tabmonth = $path.$lang[$nblang].$dirsep.$dirdate.$dirsep.$tabnamemonth;
  
  open(TABMONTH,">>$tabmonth") || &error_exit("Error, unable to open $tabmonth",1);
  &MonthFooter(*TABMONTH, eval($Lang{$lang[$nblang]}));
  close (TABMONTH);
}
$count_month--;

#################################################################
#####           hosts and requests graphs                 #######
#################################################################

if ($precision > 2) {

#################################################################
# Fly

  if (-x $FLY) {
    
    $map ='';
    $num = 0;
    $num2 = 0;
    $it = length($count_month)-1;
    $div = 10**$it;
    $factx = ($div*(int($count_month/$div)+1))/$grad;
    
    $factx = 1 if ($it == 0);
    
    $it = length($machmax)-1;
    $div = 10**$it;
    $facty = ($div*(int(($machmax+$perspec)/$div)+1))/$grad;
    
    $fymax = $ymax-1;

   if ($maxtot > (1024*1024*1024) && $maxtot <= (1024*1024*1024*1024)) {
	$tmp4 = 1024*1024*1024;
	$unit = "Gb";
    }

    if ($maxtot > (1024*1024) && $maxtot <= (1024*1024*1024)) {
	$tmp4 = 1024*1024;
	$unit = "Mb";
    }
    if ($maxtot > 1024 && $maxtot <= (1024*1024)) {
	$tmp4 = 1024;
	$unit = "Kb";
    }

    if ($maxtot <= 1024) {
	$tmp4 = 1;
	$unit = "bytes";
	$unit = "" if ($maxtot == 0);
    }

    $perspec = $xstep/$factx if (($perspec > $xstep/$factx) && ($tridim == 1));
   
    # Compute USEMAP
    for ($i=1;$i<($count_month+$bargraph);$i++) {

	if ($listdate[$num] ne '') {

	    $x1 = ($i-1+$linegraph+$tridim)*$xstep/$factx;
	    $x2 = ($i+$linegraph+$tridim)*$xstep/$factx;
      
	    $x1 = $x1 - $xstep/$factx if ($x2-$x1 > $xstep && $tridim == 1);
	    $x2 = $x2 - $xstep/$factx if ($x2-$x1 > $xstep && $tridim == 1);

	    ($tmp1,$tmp2) = split(/\s+/,$listdate[$num]);
	    $tmp = $tmp1."-".$tmp2;
	    $tmp6 = $tmp2." ".$tmp1;
	    $linkjour = "..".$dirsepurl.$dirdate.$dirsepurl.$tmp.$dirsepurl.$menu;
	    $fulljour = $path.$lang[0].$dirsep.$dirdate.$dirsep.$tmp.$dirsep.$menu;
	    
	    $num++;
	    $num2 = $num-1;
	    if (-e $fulljour) {
		$list[$num2] = "$tmp";
	    }

	    $tmp2 =  int($sizemaxtot{$i}*100/$tmp4)/100;
	    $tmp5 = "Requests : $reqmaxtot{$i}|";
	    $tmp5 .= "Accesses : $accessmaxtot{$i}|" if ($ftp_format == 0 && $squid_format == 0);
	    $tmp5 .= "Hosts : $machmaxtot{$i}|Traffic : $tmp2 $unit";

	    $wday = '';

	    $map .= "<AREA SHAPE=\"rect\" COORDS=\"$x1,0,$x2,$ymax\" HREF=\"$tabnamemonth#$num\" ALT=\"$tmp\" onMouseOver=\"popLayer('$tmp6','$tmp5','','$tabnamedays#$num',1,'','$popup_graph_width')\">\n" if (!(-e $fulljour) && $reqmaxtot{$i} != 0);
	    $map .= "<AREA SHAPE=\"rect\" COORDS=\"$x1,0,$x2,$ymax\" HREF=\"$linkjour\" ALT=\"$tmp\" onMouseOver=\"popLayer('$tmp6','$tmp5','','$linkjour',1,'','$popup_graph_width')\">\n" if (-e $fulljour);
	    
	    if ($i > ($count_month-$rss_month)) {
		&BuildRSS($filerss,$tmp5,$tmp6,$linkjour);
	    }
	}
    }

    open(FLY,">$tmpfly$vtmp");
    print FLY "new\n";
    print FLY "size $xmax,$ymax\n";
    print FLY "frect 0,0,0,0,200,200,200\n";
    for ($i=1;$i<=($count_month+$bargraph);$i++) {
      $x1 = ($i-1+$linegraph+$tridim)*$xstep/$factx;
      $x2 = ($i+$linegraph+$tridim)*$xstep/$factx;
      
      $x1 = $x1 - $xstep/$factx if ($x2-$x1 > $xstep && $tridim == 1);
      $x2 = $x2 - $xstep/$factx if ($x2-$x1 > $xstep && $tridim == 1);
      
      $y2 = $ymax - ($ystep/$facty * $machmaxtot{$i});
#      $y2ppp = $ymax - ($ystep/$facty * $machmaxtot{$i-1});

      if ($bargraph == 1) {
        $x2 -= $perspec if ($tridim == 1);
        $x1 -= $perspec if ($tridim == 1);
        print FLY "frect $x1,$y2,$x2,$ymax,$red[0],$green[0],$blue[0]\n";
        print FLY "rect $x1,$y2,$x2,$ymax,0,0,0\n";
#        print FLY "rect $x1,$y2,$x1,$y2ppp,0,0,0\n";
        if ($tridim == 1 && $y2 != $ymax) {
          
          $x1plus = $x1+$perspec;
          $x2plus = $x2+$perspec;
          $y2plus = $y2-$perspec;
          $y1plus = $ymax - $perspec;
          
          print FLY "fpoly $red[0],$green[0],$blue[0],$x1,$y2,$x1plus,$y2plus,$x2plus,$y2plus,$x2,$y2\n";
          print FLY "poly 0,0,0,$x1,$y2,$x1plus,$y2plus,$x2plus,$y2plus,$x2,$y2\n";
          
          print FLY "fpoly $red[0],$green[0],$blue[0],$x2,$ymax,$x2,$y2,$x2plus,$y2plus,$x2plus,$y1plus\n";
          print FLY "poly 0,0,0,$x2,$ymax,$x2,$y2,$x2plus,$y2plus,$x2plus,$y1plus\n";
          
        }
      }
      
      if ($linegraph == 1) {
        $y1 = $ymax - ($ystep/$facty * $machmaxtot{$i+1});
        print FLY "line $x1,$y2,$x2,$y1,$red[0],$green[0],$blue[0]\n";
        
        if ($fillgraph == 1) {
          if ($y1 != $y2 || $y1 != $ymax) {
            print FLY "line $x1,$ymax,$x1,$y2,$red[0],$green[0],$blue[0]\n";
            print FLY "line $x2,$ymax,$x2,$y1,$red[0],$green[0],$blue[0]\n";
            print FLY "line $x1,$ymax,$x2,$ymax,$red[0],$green[0],$blue[0]\n";
            $fx1 = $x1+1;
            
            print FLY "fill $fx1,$fymax,$red[0],$green[0],$blue[0]\n";
          }
        }
      }
      
      $x1 -= $factx*$shift_factor;
      $x2 -= $factx*$shift_factor;
      
      $y2 = $ymax - ($ystep/$facty * $newmaxtot{$i});
#      $y2ppp = $ymax - ($ystep/$facty * $newmaxtot{$i-1});
      
      if ($bargraph == 1) {
        $x2 -= $perspec if ($tridim == 1);
        $x1 -= $perspec if ($tridim == 1);
        print FLY "frect $x1,$y2,$x2,$ymax,$red[1],$green[1],$blue[1]\n";
        print FLY "rect $x1,$y2,$x2,$ymax,0,0,0\n";
#        print FLY "rect $x1,$y2,$x1,$y2ppp,0,0,0\n";
        if ($tridim == 1 && $y2 != $ymax) {
          
          $x1plus = $x1+$perspec;
          $x2plus = $x2+$perspec;
          $y2plus = $y2-$perspec;
          
          print FLY "fpoly $red[1],$green[1],$blue[1],$x1,$y2,$x1plus,$y2plus,$x2plus,$y2plus,$x2,$y2\n";
          print FLY "poly 0,0,0,$x1,$y2,$x1plus,$y2plus,$x2plus,$y2plus,$x2,$y2\n";
          
          print FLY "fpoly $red[1],$green[1],$blue[1],$x2,$ymax,$x2,$y2,$x2plus,$y2plus,$x2plus,$ymax\n";
          print FLY "poly 0,0,0,$x2,$ymax,$x2,$y2,$x2plus,$y2plus,$x2plus,$ymax\n";
          
        }
      }
      
      if ($linegraph == 1) {
        $y1 = $ymax - ($ystep/$facty * $newmaxtot{$i+1});
        print FLY "line $x1,$y2,$x2,$y1,$red[1],$green[1],$blue[1]\n";
        
        if ($fillgraph == 1) {
          if ($y1 != $y2 || $y1 != $ymax) {
            print FLY "line $x1,$ymax,$x1,$y2,$red[1],$green[1],$blue[1]\n";
            print FLY "line $x2,$ymax,$x2,$y1,$red[1],$green[1],$blue[1]\n";
            print FLY "line $x1,$ymax,$x2,$ymax,$red[1],$green[1],$blue[1]\n";
            $fx1 = $x1+1;
            
            print FLY "fill $fx1,$fymax,$red[1],$green[1],$blue[1]\n";
          }
        }
      }
      
      $x1 -= $factx*2*$shift_factor;
      $x2 -= $factx*2*$shift_factor;
      
      $y2 = $ymax - ($ystep/$facty * $dommaxtot{$i});
      $y2ppp = $ymax - ($ystep/$facty * $dommaxtot{$i-1});
      
      if ($bargraph == 1) {
        $x2 -= $perspec if ($tridim == 1);
        $x1 -= $perspec if ($tridim == 1);
        print FLY "frect $x1,$y2,$x2,$ymax,$red[2],$green[2],$blue[2]\n";
        print FLY "rect $x1,$y2,$x2,$ymax,0,0,0\n";
#        print FLY "rect $x1,$y2,$x1,$y2ppp,0,0,0\n";
        if ($tridim == 1 && $y2 != $ymax) {
          
          $x1plus = $x1+$perspec;
          $x2plus = $x2+$perspec;
          $y2plus = $y2-$perspec;
          
          print FLY "fpoly $red[2],$green[2],$blue[2],$x1,$y2,$x1plus,$y2plus,$x2plus,$y2plus,$x2,$y2\n";
          print FLY "poly 0,0,0,$x1,$y2,$x1plus,$y2plus,$x2plus,$y2plus,$x2,$y2\n";
          
          print FLY "fpoly $red[2],$green[2],$blue[2],$x2,$ymax,$x2,$y2,$x2plus,$y2plus,$x2plus,$ymax\n";
          print FLY "poly 0,0,0,$x2,$ymax,$x2,$y2,$x2plus,$y2plus,$x2plus,$ymax\n";
          
        }
      }
      
      if ($linegraph == 1) {
        $y1 = $ymax - ($ystep/$facty * $dommaxtot{$i+1});
        print FLY "line $x1,$y2,$x2,$y1,$red[2],$green[2],$blue[2]\n";
        
        if ($fillgraph == 1) {
          if ($y1 != $y2 || $y1 != $ymax) {
            print FLY "line $x1,$ymax,$x1,$y2,$red[2],$green[2],$blue[2]\n";
            print FLY "line $x2,$ymax,$x2,$y1,$red[2],$green[2],$blue[2]\n";
            print FLY "line $x1,$ymax,$x2,$ymax,$red[2],$green[2],$blue[2]\n";
            $fx1 = $x1+1;
            
            print FLY "fill $fx1,$fymax,$red[2],$green[2],$blue[2]\n";
          }
        }
      }
      
    }
    print FLY "transparent 200,200,200\n";
    close (FLY);
    
    open(FOO,"$FLY -q -i $tmpfly$vtmp -o $outfile1 |");
    while( <FOO> ) {print;}
    close(FOO);
    #unlink($tmpfly$vtmp);
    
    ### image pour les abscisses
    
    $xlegend = "$count_month month";
    $xlegend .= "s" if ($count_month > 1);
    $xlegend .= " (starting $start_date)";
    
    open(FLY,">$tmpfly$vtmp");
    print FLY "new\n";
    print FLY "size $xmax,$ydecal\n";
    print FLY "frect 0,0,0,0,200,200,200\n";
    $posx = (($xmax/2)-(length($xlegend)*7/2));
    print FLY "string 0,0,0,$posx,$ydecalm,medium,$xlegend\n";
    for ($i=$xstep;$i<$xmax;$i+=$xstep) {
#      $val = ($monthindex -1 - $count_month) + ($i*$factx/$xstep);
      $val = ($monthindex  - $count_month) + ($i*$factx/$xstep);
      $val--;
      $val += 12 if ($val < 0);
      $val -= 12 if ($val > 11);
      # print "$val $monthindex $count_month\n";
      $posx = $i - 8;
      print FLY "line $i,0,$i,5,0,0,0\n";
      print FLY "string 0,0,0,$posx,10,small,$month_nb[$val]\n";
    }
    print FLY "transparent 200,200,200\n";
    close (FLY);
    
    open(FOO,"$FLY -q -i $tmpfly$vtmp -o $outfile1x |");
    while( <FOO> ) {print;}
    close(FOO);
    #unlink($tmpfly$vtmp);
    
    ### image pour les ordonnees
    
    open(FLY,">$tmpfly$vtmp");
    print FLY "new\n";
    print FLY "size $xdecal,$ymax\n";
    print FLY "frect 0,0,0,0,200,200,200\n";
    $posy = $ymax - (($ymax/2)-(length("Hosts")/2));
    print FLY "stringup 0,0,0,5,$posy,medium,Hosts\n";
    for ($i=$ystep;$i<$ymax;$i+=$ystep) {
      $valstep = int(($ymax - $i) * ($facty/$ystep));
      # $valstep = "1E6" if ($valstep > 10E+6);
      $pos = ($xdecal - length($valstep)*9);
 $posy = $i-5;
 print FLY "line $xdecalm,$i,$xdecal,$i,0,0,0\n";
 print FLY "string 0,0,0,$pos,$posy,small,$valstep\n";
 }
print FLY "transparent 200,200,200\n";
close (FLY);

open(FOO,"$FLY -q -i $tmpfly$vtmp -o $outfile1y |");
while( <FOO> ) {print;}
close(FOO);
#unlink($tmpfly$vtmp);
}
}


#####################  2 ieme GIF  #################################


#################################################################
# Fly

if (-x $FLY) {
  $it = length($count_month)-1;
  $div = 10**$it;
  $factx = ($div*(int($count_month/$div)+1))/$grad;
  
  $factx = 1 if ($it == 0);
  
  $it = length($reqmax)-1;
  $div = 10**$it;
  $facty = ($div*(int(($reqmax+$perspec)/$div)+1))/$grad;
  
  $perspec = $xstep/$factx if (($perspec > $xstep/$factx) && ($tridim == 1));

  ### image pour les abscisses
  
  $xlegend = "$count_month month";
  $xlegend .= "s" if ($count_month > 1);
  $xlegend .= " (starting $start_date)";
  
  open(FLY,">$tmpfly$vtmp");
  print FLY "new\n";
  print FLY "size $xmax,$ydecal\n";
  print FLY "frect 0,0,0,0,200,200,200\n";
  $posx = (($xmax/2)-(length($xlegend)*7/2));
  print FLY "string 0,0,0,$posx,$ydecalm,medium,$xlegend\n";
  for ($i=$xstep;$i<$xmax;$i+=$xstep) {
#    $val = ($monthindex - 1 - $count_month) + ($i*$factx/$xstep);
    $val = ($monthindex - $count_month) + ($i*$factx/$xstep);
    $val--;
    $val += 12 if ($val < 0);
    $val -= 12 if ($val > 11);
    $posx = $i - 8;
    print FLY "line $i,0,$i,5,0,0,0\n";
    print FLY "string 0,0,0,$posx,10,small,$month_nb[$val]\n";
  }
  print FLY "transparent 200,200,200\n";
  close (FLY);
  
  open(FOO,"$FLY -q -i $tmpfly$vtmp -o $outfile2x |");
  while( <FOO> ) {print;}
  close(FOO);
  #unlink($tmpfly$vtmp);

#

  ### image pour les ordonnees
  
  open(FLY,">$tmpfly$vtmp");
  print FLY "new\n";
  print FLY "size $xdecal,$ymax\n";
  print FLY "frect 0,0,0,0,200,200,200\n";
  $posy = $ymax - (($ymax/2)-(length("Requests")/2));
  print FLY "stringup 0,0,0,5,$posy,medium,Requests\n";
  
  for ($i=$ystep;$i<$ymax;$i+=$ystep) {
    $valstep = int(($ymax - $i) * ($facty/$ystep));
 $pos = ($xdecal - length($valstep)*9);
 $posy = $i-5;
 print FLY "line $xdecalm,$i,$xdecal,$i,0,0,0\n";
 print FLY "string 0,0,0,$pos,$posy,small,$valstep\n";
 }

print FLY "transparent 200,200,200\n";
close (FLY);

open(FOO,"$FLY -q -i $tmpfly$vtmp -o $outfile2y |");
while( <FOO> ) {print;}
close(FOO);

###
  
  open(FLY,">$tmpfly$vtmp");
  print FLY "new\n";
  print FLY "size $xmax,$ymax\n";
  print FLY "frect 0,0,0,0,200,200,200\n";
  for ($i=1;$i<=($count_month+$bargraph);$i++) {
    $x1 = ($i-1+$linegraph+$tridim)*$xstep/$factx;
    $x2 = ($i+$linegraph+$tridim)*$xstep/$factx;
    
    $x1 = $x1 - $xstep/$factx if ($x2-$x1 > $xstep && $tridim == 1);
    $x2 = $x2 - $xstep/$factx if ($x2-$x1 > $xstep && $tridim == 1);
    
    $y2 = $ymax - ($ystep/$facty * $reqmaxtot{$i});
    
    if ($bargraph == 1) {
      $x2 = int($x2 - $perspec) if ($tridim == 1);
      $x1 = int($x1 - $perspec) if ($tridim == 1);
      print FLY "frect $x1,$y2,$x2,$ymax,$red[0],$green[0],$blue[0]\n";
      print FLY "rect $x1,$y2,$x2,$ymax,0,0,0\n";
      if ($tridim == 1 && $y2 != $ymax) {
        
        $x1plus = int($x1+$perspec);
        $x2plus = int($x2+$perspec);
        $y2plus = int($y2-$perspec);
        $y1plus = int($ymax - $perspec);
        
        print FLY "fpoly $red[0],$green[0],$blue[0],$x1,$y2,$x1plus,$y2plus,$x2plus,$y2plus,$x2,$y2\n";
        print FLY "poly 0,0,0,$x1,$y2,$x1plus,$y2plus,$x2plus,$y2plus,$x2,$y2\n";
        
        print FLY "fpoly $red[0],$green[0],$blue[0],$x2,$ymax,$x2,$y2,$x2plus,$y2plus,$x2plus,$y1plus\n";
        print FLY "poly 0,0,0,$x2,$ymax,$x2,$y2,$x2plus,$y2plus,$x2plus,$y1plus\n";
        
      }
    }
    
    if ($linegraph == 1) {
      $y1 = $ymax - ($ystep/$facty * $reqmaxtot{$i+1});
      print FLY "line $x1,$y2,$x2,$y1,$red[0],$green[0],$blue[0]\n";
      
      if ($fillgraph == 1) {
        if ($y1 != $y2 || $y1 != $ymax) {
          print FLY "line $x1,$ymax,$x1,$y2,$red[0],$green[0],$blue[0]\n";
          print FLY "line $x2,$ymax,$x2,$y1,$red[0],$green[0],$blue[0]\n";
          print FLY "line $x1,$ymax,$x2,$ymax,$red[0],$green[0],$blue[0]\n";
          $fx1 = $x1+1;
          
          print FLY "fill $fx1,$fymax,$red[0],$green[0],$blue[0]\n";
        }
      }
    }

    if ($mail_format == 0 && $ftp_format == 0) {
    $x1 -= $factx*$shift_factor;
    $x2 -= $factx*$shift_factor;
    
    $y2 = $ymax - ($ystep/$facty * $accessmaxtot{$i});
    
    if ($bargraph == 1) {
      $x2 = int($x2 - $perspec) if ($tridim == 1);
      $x1 = int($x1 - $perspec) if ($tridim == 1);
      print FLY "frect $x1,$y2,$x2,$ymax,$red[1],$green[1],$blue[1]\n";
      print FLY "rect $x1,$y2,$x2,$ymax,0,0,0\n";
      if ($tridim == 1 && $y2 != $ymax) {
        
        $x1plus = int($x1+$perspec);
        $x2plus = int($x2+$perspec);
        $y2plus = int($y2-$perspec);
        
        print FLY "fpoly $red[1],$green[1],$blue[1],$x1,$y2,$x1plus,$y2plus,$x2plus,$y2plus,$x2,$y2\n";
        print FLY "poly 0,0,0,$x1,$y2,$x1plus,$y2plus,$x2plus,$y2plus,$x2,$y2\n";
        
        print FLY "fpoly $red[1],$green[1],$blue[1],$x2,$ymax,$x2,$y2,$x2plus,$y2plus,$x2plus,$ymax\n";
        print FLY "poly 0,0,0,$x2,$ymax,$x2,$y2,$x2plus,$y2plus,$x2plus,$ymax\n";
      }
    }
    
    if ($linegraph == 1) {
      $y1 = $ymax - ($ystep/$facty * $accessmaxtot{$i+1});
      print FLY "line $x1,$y2,$x2,$y1,$red[1],$green[1],$blue[1]\n";
      
      if ($fillgraph == 1) {
        if ($y1 != $y2 || $y1 != $ymax) {
          print FLY "line $x1,$ymax,$x1,$y2,$red[1],$green[1],$blue[1]\n";
          print FLY "line $x2,$ymax,$x2,$y1,$red[1],$green[1],$blue[1]\n";
          print FLY "line $x1,$ymax,$x2,$ymax,$red[1],$green[1],$blue[1]\n";
          $fx1 = $x1+1;
          
          print FLY "fill $fx1,$fymax,$red[1],$green[1],$blue[1]\n";
        }
      }
      
    }
}

    $x1 -= $factx*2*$shift_factor;
    $x2 -= $factx*2*$shift_factor;
    
    $y2 = $ymax - ($ystep/$facty * $reqdommaxtot{$i});
    
    if ($bargraph == 1) {
      $x2 = int($x2 - $perspec) if ($tridim == 1);
      $x1 = int($x1 - $perspec) if ($tridim == 1);
      print FLY "frect $x1,$y2,$x2,$ymax,$red[2],$green[2],$blue[2]\n";
      print FLY "rect $x1,$y2,$x2,$ymax,0,0,0\n";
      if ($tridim == 1 && $y2 != $ymax) {
        
        $x1plus = int($x1+$perspec);
        $x2plus = int($x2+$perspec);
        $y2plus = int($y2-$perspec);
        
        print FLY "fpoly $red[2],$green[2],$blue[2],$x1,$y2,$x1plus,$y2plus,$x2plus,$y2plus,$x2,$y2\n";
        print FLY "poly 0,0,0,$x1,$y2,$x1plus,$y2plus,$x2plus,$y2plus,$x2,$y2\n";
        
        print FLY "fpoly $red[2],$green[2],$blue[2],$x2,$ymax,$x2,$y2,$x2plus,$y2plus,$x2plus,$ymax\n";
        print FLY "poly 0,0,0,$x2,$ymax,$x2,$y2,$x2plus,$y2plus,$x2plus,$ymax\n";
      }
    }
    
    if ($linegraph == 1) {
      $y1 = $ymax - ($ystep/$facty * $reqdommaxtot{$i+1});
      print FLY "line $x1,$y2,$x2,$y1,$red[2],$green[2],$blue[2]\n";
      
      if ($fillgraph == 1) {
        if ($y1 != $y2 || $y1 != $ymax) {
          print FLY "line $x1,$ymax,$x1,$y2,$red[2],$green[2],$blue[2]\n";
          print FLY "line $x2,$ymax,$x2,$y1,$red[2],$green[2],$blue[2]\n";
          print FLY "line $x1,$ymax,$x2,$ymax,$red[2],$green[2],$blue[2]\n";
          $fx1 = $x1+1;
          
          print FLY "fill $fx1,$fymax,$red[2],$green[2],$blue[2]\n";
        }
      }
    }
    
  }
  print FLY "transparent 200,200,200\n";
  close (FLY);
  
  open(FOO,"$FLY -q -i $tmpfly$vtmp -o $outfile2 |");
  while( <FOO> ) {print;}
  close(FOO);
  #unlink($tmpfly$vtmp);
}

#############################################################################

if ($count_month != 0) {
for ($nblang=0;$nblang<=$#lang;$nblang++) {

        $statmonth = $path.$lang[$nblang].$dirsep.$dirdate.$dirsep.$statnamemonth;
        open(STATMONTH,">$statmonth") || &error_exit("Error, unable to open $statmonth",1);
        &MonthStats(*STATMONTH, eval($Lang{$lang[$nblang]}), $count_month);
	close(STATMONTH);
}
}

unlink("$tmpfly$vtmp");

#################################################################
#####              computing monthly stats                 ######
#################################################################

$yesterday = "$jour $month $year";
&update_homepage;

# PDF report

&export_pdf(@list_cmd) if ($enable_pdf == 1);

if ($enable_email == 1 && $emailadr ne '' && $email_monthly == 1 && $month_over == 1) {

    $subject = "W3Perl Monthly Report - $year/$lastmonth";
    $from = "webmaster\@".$localdomainename;

    &export_html($date_last,eval($Lang{$lang[0]})) if ($email_html == 1);

    # MIME::Lite module

    &send_email($emailadr,$subject,$html,$filepdf);

    print "Email monthly report sent to $emailadr";
    print " : $filepdf" if ($email_pdf == 1);
    print "\n";
    print "<BR>" if ($ENV{'REQUEST_METHOD'} eq "GET"); 
}


# calculer le temps mis pour le calcul

$datesyst = &ctime(time);
($dayletter,$month,$day,$hourdate,$a,$year) = split(/[ \t\n\[]+/,$datesyst);
($hour,$minute,$second) = split(/:/,$hourdate);

$endrun = "$hour:$minute:$second";

($hour,$min,$sec) = &timetaken($startrun,$endrun);

$endtime = time();
print "Computing took";
print " $hour h" if ($hour > 0);
print " $min min $sec sec\n\n";
print "<P>" if ($ENV{'REQUEST_METHOD'} eq "GET");

&admin_goback if ($ENV{'REQUEST_METHOD'} eq "GET" && $opt_y eq '');

open(FILE,">>$history");
#print FILE "cron-month\t$today\t$startrun\t$endrun\t$min:$sec\t$loglines\n";
printf FILE "$scriptname\t%s\t%s\t%s\t%d:%d:%d\t%d\n",$today,$startrun,$endrun,$hour,$min,$sec,$loglines;
close(FILE);


########################################################################################
sub MonthHeader {
  local(*FOUT,*L) = @_;

  print FOUT "$doctype\n";
  print FOUT "<HTML><HEAD>\n";
  print FOUT "$charset\n";
  print FOUT "<TITLE>$L{'About_months'}</TITLE>\n";
  print FOUT "<!-- Page generated by w3perl - $scriptname $version - $today $hourdate -->\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$helpjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$sorttablejs\"></script>\n";
  print FOUT "<link rel=\"stylesheet\" type=\"text/css\" href=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dircss$dirsepurl$css_w3perl\">\n";
  print FOUT "<link rel=\"stylesheet\" type=\"text/css\" href=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dircss$dirsepurl$css_help\">\n";
  print FOUT "</HEAD>\n";
  print FOUT "<BODY $backgrd TEXT=\"$custom_text\"  LINK=\"$custom_link\" VLINK=\"$custom_vlink\">\n";
  print FOUT "<H2> $L{'About_months'}</H2><P>\n";
  print FOUT "<P><HR><P>\n";
  print FOUT "<A HREF=\"..$dirsepurl..$dirsepurl$dircsv$dirsepurl$tabnamecsv$csvext\" TITLE=\"Export in CSV\"><IMG WIDTH=\"40\" HEIGHT=\"40\" SRC=\"..$dirsepurl..$dirsepurl$homeicons$dirsepurl$icon_csv\" BORDER=0 ALT=\"CSV\"></A>" if (-f "$path$dircsv$dirsep$tabnamecsv$csvext");
  print FOUT "<TABLE CLASS=\"sortable\" ID=\"month_list\">\n";
  print FOUT "<TR>\n";
  print FOUT "<TH>$L{'Date'}</TH>\n";
  print FOUT "<TH>$L{'Hosts'}</TH>\n";
  print FOUT "<TH>$L{'New_Hosts'}&nbsp;<I>(From start)</I></TH>\n";
  print FOUT "<TH>$L{'Domain_Hosts'}</TH>\n";
  print FOUT "<TH>$L{'Requests'}</TH>\n" if ($mail_format == 0 && $ftp_format == 0);
  print FOUT "<TH>$L{'Files'}</TH>\n" if ($ftp_format == 1);
  print FOUT "<TH>$L{'Email'}</TH>\n" if ($mail_format == 1);
  print FOUT "<TH>$L{'Accesses'}</TH>\n" if ($mail_format == 0 && $ftp_format == 0);
#  print FOUT "<TH>$L{'Requests'}</TH>\n";
#  print FOUT "<TH>$L{'Accesses'}</TH>\n";
  print FOUT "<TH>$L{'DomReq'}</TH>\n";
  print FOUT "</TR>\n";
}

sub MonthFooter {
  local(*FOUT) = $_[0];
  print FOUT "</TABLE>\n";
  print FOUT "<P><HR><P>\n";
  print FOUT "</BODY></HTML>\n";
}

sub MonthStats {
  local(*FOUT,*L, $count_month) = @_;

  print FOUT "$doctype\n";
  print FOUT "<HTML><HEAD>\n";
  print FOUT "$charset\n";
  print FOUT "<TITLE>$L{'Stats_about_months'}</TITLE>\n";
  print FOUT "<!-- Page generated by w3perl - $scriptname $version - $today $hourdate -->\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$helpjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$calendarmonthjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$sorttablejs\"></script>\n";
  print FOUT "<SCRIPT LANGUAGE=\"JavaScript\" type=\"text/javascript\">\n";
  print FOUT "var todaydate=new Date()\n";
  print FOUT "var curmonth=todaydate.getMonth()+1 //get current month (1-12)\n";
  print FOUT "var curyear=todaydate.getFullYear() //get current year\n";
  print FOUT "</SCRIPT>\n";
  print FOUT "<link rel=\"stylesheet\" type=\"text/css\" href=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dircss$dirsepurl$css_calendar\">\n";
  print FOUT "<link rel=\"stylesheet\" type=\"text/css\" href=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dircss$dirsepurl$css_w3perl\">\n";
  print FOUT "<link rel=\"stylesheet\" type=\"text/css\" href=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dircss$dirsepurl$css_help\">\n";
  print FOUT "</HEAD>\n";
  print FOUT "<BODY $backgrd TEXT=\"$custom_text\"  LINK=\"$custom_link\" VLINK=\"$custom_vlink\">\n";
  
  &help_div(*FOUT);

  print FOUT "<CENTER>\n";
  print FOUT "<TABLE BORDER=0 WIDTH=\"100%\">\n";
  print FOUT "<TR>\n";
  print FOUT "<TD ALIGN=LEFT VALIGN=MIDDLE WIDTH=\"20%\">\n";

  print FOUT "<DIV ID=\"calendarspace\">\n";
  print FOUT "<SCRIPT LANGUAGE=\"JavaScript\" type=\"text/javascript\">\n";
  print FOUT "document.write(buildCal(curmonth ,curyear, \"main\", \"month\", \"daysofweek\", \"weeks\", 1,1,'index','@list'));\n";
  print FOUT "</SCRIPT>\n";
  print FOUT "</DIV>\n";


  print FOUT "</TD>\n";
  print FOUT "<TD ALIGN=CENTER WIDTH=\"60%\">\n";

  print FOUT "<TABLE BORDER=1 BGCOLOR=\"#000000\">\n<TR>\n<TD BGCOLOR=\"#FFEECC\" ALIGN=CENTER>\n";
  print FOUT "<H1>".uc(&noaccentinhtml($L{'Stats'}))." ".uc(&noaccentinhtml($L{'about'}))." ".uc(&noaccentinhtml($L{'Months'}))."</H1>\n";
  print FOUT "</TD>\n</TR>\n</TABLE>\n";
  
  print FOUT "</TD>\n";
  print FOUT "<TD ALIGN=RIGHT VALIGN=MIDDLE WIDTH=\"20%\">\n";

  print FOUT "<A HREF=\"$oldyear2-$affmois$htmlext\">$L{'Month_of'}$affmois $oldyear2</A><br><br>\n" if ($precision > 2 && $oldyear2 ne '' && $affmois ne '');
  print FOUT "<A HREF=\"$tabnamemonth\">$L{'Table'} $L{'of_months'}</A><br><br>\n";

  print FOUT "</TD>\n";
  print FOUT "</TR>\n";
  print FOUT "</TABLE>\n";
  print FOUT "</CENTER>\n";

  if ($precision > 2) {
      print FOUT "<A NAME=\"utilisateur\"></A>\n";
    
      if  (-x $FLY) {
	  print FOUT "<CENTER><TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0>\n";
	  print FOUT "<TR>\n";
	  print FOUT "<TD><IMG WIDTH=$xdecal HEIGHT=$ymax SRC=\"$linkoutfile1y\" ALT=\"ylabel\"></TD>\n";
	  print FOUT "<TD><IMG WIDTH=$xmax HEIGHT=$ymax SRC=\"$linkoutfile1\" BORDER=0 USEMAP=\"#month1\" ALT=\"month_hosts\"></TD>\n";
	  print FOUT "</TR><TR><TD></TD>\n";
	  print FOUT "<TD><IMG WIDTH=$xmax HEIGHT=$ydecal SRC=\"$linkoutfile1x\" ALT=\"xlabel\"></TD>\n";
	  print FOUT "</TR><TR><TD></TD>\n";
	  print FOUT "<TD ALIGN=CENTER>\n";
	  
	  print FOUT "<TABLE CELLPADDING=0 CELLSPACING=0 BORDER=0><TR>\n";
	  print FOUT "<TD><IMG WIDTH=$square HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[0]\" ALT=\"$gcolor[0]\"></TD>\n";
	  print FOUT "<TD>&nbsp; $L{'Number_of'} $L{'Conn_Mach'}</TD>\n";
	  print FOUT "</TR><TR>\n";
	  print FOUT "<TD><IMG WIDTH=$square HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\"></TD>\n";
	  print FOUT "<TD>&nbsp; $L{'Number_of'} $L{'New_Mach'}</TD>\n";
	  print FOUT "</TR><TR>\n";    
	  print FOUT "<TD><IMG WIDTH=$square HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[2]\" ALT=\"$gcolor[2]\"></TD>\n";
	  print FOUT "<TD>&nbsp; $L{'Number_of'} $L{'Mach_Dom'} $localdomainename</TD>\n";
	  print FOUT "</TR></TABLE>\n";
    
	  print FOUT "</TD></TR></TABLE></CENTER>\n";
      }
  }
  
  print FOUT "<A NAME=\"requete\"></A>\n";
  
  if (-x $FLY)  {
      print FOUT "<CENTER><TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0>\n";
      print FOUT "<TR>\n";
      print FOUT "<TD><IMG WIDTH=$xdecal HEIGHT=$ymax SRC=\"$linkoutfile2y\" ALT=\"ylabel\"></TD>\n";
      print FOUT "<TD><IMG WIDTH=$xmax HEIGHT=$ymax SRC=\"$linkoutfile2\" BORDER=0 USEMAP=\"#month2\" ALT=\"month_requests\"></TD>\n";
      print FOUT "</TR><TR><TD></TD>\n";
      print FOUT "<TD><IMG WIDTH=$xmax HEIGHT=$ydecal SRC=\"$linkoutfile2x\" ALT=\"xlabel\"></TD>\n";

      print FOUT "</TR><TR><TD></TD>\n";
      print FOUT "<TD ALIGN=CENTER>\n";

      print FOUT "<TABLE CELLPADDING=0 CELLSPACING=0 BORDER=0><TR>\n";
      print FOUT "<TD><IMG WIDTH=$square HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[0]\" ALT=\"$gcolor[0]\"></TD>\n";
#      print FOUT "<TD>&nbsp; $L{'No_Ttl_Req_Mnth'}</TD>\n";

#      print FOUT "<TD>&nbsp; $L{'Number_of'} ";
      print FOUT "<TD>&nbsp;";
      print FOUT "$L{'Requests'}" if ($mail_format == 0 && $ftp_format == 0);
      print FOUT "$L{'File'}" if ($ftp_format == 1);
      print FOUT "$L{'Email'}" if ($mail_format == 1);
      print FOUT "</TD>\n";
      print FOUT "</TR>\n"; 

      if ($mail_format == 0 && $ftp_format == 0) {
	  print FOUT "<TR>";
	  print FOUT "<TD><IMG WIDTH=$square HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\"></TD>\n";
	  print FOUT "<TD>&nbsp; $L{'Number_of'} $L{'accesses'}</TD>\n";
	  print FOUT "</TR>\n";
      }
      print FOUT "<TR>\n";                
      print FOUT "<TD><IMG WIDTH=$square HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[2]\" ALT=\"$gcolor[2]\"></TD>\n";
#      print FOUT "<TD>&nbsp; $L{'NoReq'} ";
      print FOUT "<TD>&nbsp;";
      print FOUT "$L{'Requests'}" if ($mail_format == 0 && $ftp_format == 0);
      print FOUT "$L{'File'}" if ($ftp_format == 1);
      print FOUT "$L{'Email'}" if ($mail_format == 1);
      print FOUT " $L{'from_dom'} $localdomainename</TD>\n";      
      print FOUT "</TR></TABLE>\n";
    
      print FOUT "</TD></TR></TABLE></CENTER>\n";   
  }
  
  $map2 = $map;
  $map2 =~ s/\/\//\/$lang[$nblang]\//g;
  $map2 =~ s/Requests/$L{'Requests'}/g;
  $map2 =~ s/Accesses/$L{'Accesses'}/g;
  $map2 =~ s/Hosts/$L{'Hosts'}/g;
  $map2 =~ s/Traffic/$L{'Traffic'}/g;

  print FOUT "<MAP NAME=\"month1\">\n";
  print FOUT "$map2\n";
  print FOUT "</MAP>\n";

  print FOUT "<MAP NAME=\"month2\">\n";
  print FOUT "$map2\n";
  print FOUT "</MAP>\n";

  print FOUT "</BODY></HTML>\n";
  close FOUT;
}


sub LoadDailyData {
    local($i);

    $file_daily = "$path$lang[0]$dirsep$dirdate$dirsep$dirresume$dirsep$listdailysites$txtext";

    if (-f $file_daily) {
	
	open(FILEDAILY,"$file_daily") || &error_exit("Error, unable to open $file_daily",1);
	while (<FILEDAILY>) {
	    chop;
	    ($adresse,$val1,$val2,$val3) = split(/\t/);
	    $serverjour{$adresse} += $val1;
	    $hostluesday{$adresse} += $val2;
	    $serversizejour{$adresse} += $val3;
	    $domsizejour += $val3 if ($adresse =~ /$localdomaine$/);
	}
	close(FILEDAILY);
	
	$found = 0;
	$file_daily = "$path$lang[0]$dirsep$dirdate$dirsep$dirresume$dirsep$listdailypages$txtext";
	open(FILEDAILY,"$file_daily") || &error_exit("Error, unable to open $file_daily",1);
	while (<FILEDAILY>) {
	    chop;
	    ($page,$val1) = split(/\t/);
	    $found = 1 if ($val1 eq '');
	    if ($found == 0) {
		$pagesluesday{$page} += $val1;
		$pageuniquejour++ unless ($seen_server{$page}++);
	    } else {
		$filetypejour{$page} += $val1;
	    }
	}
	close(FILEDAILY);
	
	$found = 0;
	$file_daily = "$path$lang[0]$dirsep$dirdate$dirsep$dirresume$dirsep$listdailyscripts$txtext";
	open(FILEDAILY,"$file_daily") || &error_exit("Error, unable to open $file_daily",1);
	while (<FILEDAILY>) {
	    chop;
	    ($page,$val1,$val2) = split(/\t/);
	    $found = 1 if ($val1 eq '');
	    if ($found == 0) {
		$scriptday{$page} += $val1;
		$scriptuniquejour++ unless ($seen_server{$page}++);
		$script_day += $val1; # unless ($seen_server{$page}++);
	    } else {
		$client_day_error{$page} += $val1;
		$client_day_refer{$page} = $val2;
	    }
	}
	close(FILEDAILY);
	
	$file_daily = "$path$lang[0]$dirsep$dirdate$dirsep$dirresume$dirsep$listdailytrafic$txtext";
	if (-f $file_daily) {
	    open(FILEDAILY,"$file_daily") || &error_exit("Error, unable to open $file_daily",1);
	    while (<FILEDAILY>) {
		chop;
		($page,$val1) = split(/\t/);
		$dailysizepage{$page} += $val1;
	    }
	    close(FILEDAILY);
	}

	$file_daily = "$path$lang[0]$dirsep$dirdate$dirsep$dirresume$dirsep$listdailydir$txtext";
	open(FILEDAILY,"$file_daily") || &error_exit("Error, unable to open $file_daily",1);
	while (<FILEDAILY>) {
	    chop;
	    ($rootrepert,$val1,$val2,$val3) = split(/\t/);
	    $freqjourrac{$rootrepert} += $val1;
	    $freqjourrachtml{$rootrepert} += $val2;
	    $sizejourrachtml{$rootrepert} += $val3;
	    $tothtmlsizejour += $val3;
	}
	close(FILEDAILY);
	
	$file_daily = "$path$lang[0]$dirsep$dirdate$dirsep$dirresume$dirsep$listdailycountries$txtext";
	open(FILEDAILY,"$file_daily") || &error_exit("Error, unable to open $file_daily",1);
	while (<FILEDAILY>) {
	    chop;
	    ($pays,$val1,$val2,$val3) = split(/\t/);
	    $paysjour{$pays} += $val1;
	    $payshtmljour{$pays} += $val2;
	    $paysjourlist{$pays} += $val3;
	    $paysuniquejour++ unless ($seen_server{$pays}++);
	}
	close(FILEDAILY);
	
	$file_daily = "$path$lang[0]$dirsep$dirdate$dirsep$dirresume$dirsep$listdailyfiletype$txtext";
	open(FILEDAILY,"$file_daily") || &error_exit("Error, unable to open $file_daily",1);
	while (<FILEDAILY>) {
	    chop;
	    ($val1,$val2,$val3,$val4) = split(/\t/);
	    $extfilenb{$val1} = $val3;
	    $tmp = $extfilenb{$val1};
	    $tmp = 0 if ($extfilenb{$val1} eq '');
	    $zoneextjour[$tmp] += $val4;
#	    $zoneextjour[$extfilenb{$val1}] += $val3;
	    $downloadjour{$val1} += $val4;
	    $filetypenb{$val1} += $val2;
	    push(@listext,$val1) unless ($seen_server{$val1}++);
	}
	close(FILEDAILY);
    }


    $file_daily = "$path$lang[0]$dirsep$dirdate$dirsep$dirresume$dirsep$listdailyrefer$txtext";
    if (-f $file_daily) {
	open(FILEDAILY,"$file_daily");
	while (<FILEDAILY>) {
	    chop;
	    ($val1,$val2,$val3) = split(/\t/);
	    
	    if ($val1 eq "A") {
		$nbredayref{$val2} += $val3;
#		    $uniqueday++;
	    }
	    
	    if ($val1 eq "B") {
		$nbrefullday{$val2} += $val3;
		    $uniquenbrefullday++;
	    }
	    
	    if ($val1 eq "C") {
		$occurday{$val2} += $val3;
		    $uniqueurlday++;
	    }
	    
	    if ($val1 eq "D") {
		push(@wordsday,$val2) unless ($seen_server{$val2}++);
		$wday{$val2} += $val3;
	    }
		    
	    if ($val1 eq "E") {
		$keyshday{$val2} += $val3;
	    }
	}
	close(FILEDAILY);
    }


    $file_daily = "$path$lang[0]$dirsep$dirdate$dirsep$dirresume$dirsep$listdailyagent$txtext";
    if (-f $file_daily) {
	open(FILEDAILY,"$file_daily") || &error_exit("Error, unable to open $file_daily",1);
	$tmp = <FILEDAILY>;
	chop($tmp);
	
	($val1,$val2) = split(/\t/,$tmp);
	$countday += $val2;

	while (<FILEDAILY>) {
	    chop;
	    ($val1,$val2,$val3) = split(/\t/);
	    if ($val1 eq "A") {
		$nbrebrowserday{$val2} += $val3;
		$uniqueday++ unless ($seen_server{"A $val2"}++);
	    }
	    
	    if ($val1 eq "B") {
		$nbreosday{$val2} += $val3;
		$uniqueosday++ unless ($seen_server{"B $val2"}++);
	    }

	    if ($val1 eq "C") {
		$nbagent++;
		if ($idx_browser{$val2} eq '') {
		    $idx_browser{$val2} = $nbagent;
		} else {
		    $nbagent = $idx_browser{$val2};
		}
		$browserday[$nbagent] = $val2;
		$nbreday{$browserday[$nbagent]} += $val3;
#		print "ZZ $nbagent - $browserday[$nbagent] - $nbreday{$browserday[$nbagent]} - $val2 - $val3\n" if ($browserday[$nbagent] =~ /Opera/i);
	    }
	}
	
	close(FILEDAILY);
    }
}
