#!/usr/bin/perl
# <plaintext>  just in case you look at this via a browser

#########################################################################
####                                                                #####
####                     WEEKLY STATS                               #####
####                                                                #####
####                                                                #####
####    domisse@w3perl.com                   version 19/11/2007     #####
####                                                                #####
#########################################################################

$version = "3.01";
$verdate = "19/11/07";

$shift_factor = 0.3;

# Things to improve
# Calendar to select weeks
# Sorting weekly date
# Starting week on monday or sunday

$dirjs = "js";
$dircss = "css";

$sorttablejs = "sorttable.js";
$calendarjs = "basiccalendar.js";
$helpjs = "help.js";

$css_w3perl = "w3perl.css";
$css_help = "help.css";
$css_calendar = "calendar.css";

$scriptname = "cron-week.pl";

############ script to launch at 00 hours 01 minutes every monday ##########

require "/var/www/cgi-bin/w3perl/libw3perl.pl";

$pos = rindex($conf_file,$dirsep);
$vtmp = substr($conf_file,$pos+1,length($conf_file));
$pos = rindex($0,"-");
$vtmp .= substr($0,$pos+1,length($0));
$vtmp =~ s/$plext//g;

$vtmp2 = $vtmp;
$vtmp2 = $vtmp."-map";
$week_over = 0;
$rss_week = int($nb_rss_item/7)+1;

$tabnamecsv = $tabnameweek;
$tabnamecsv =~ s/$htmlext//;

$starttime = time();
print "Weekly stats : $version\n";
print "<P>" if ($ENV{'REQUEST_METHOD'} eq "GET");

# default line graph

$bargraph = 0;
$linegraph = 1;

### today date

#$yesterday = &yesterday_date($day,$countmonth,$year);

$datesyst = &ctime(time);
($dayletter,$month,$day,$hourdate,$a,$year) = split(/[ \t\n\[]+/,$datesyst);
$year = $a if ($year eq '');
$day = "0".$day if (length($day) == 1);
$today = $day."/".$month."/".$year;
($hour,$minute,$second) = split(/:/,$hourdate);

# calculer le temps mis pour le calcul
$startrun = "$hour:$minute:$second";

$listdailysites = "liste_daily_sites";
$listdailypages = "liste_daily_pages";
$listdailyscripts = "liste_daily_scripts";
$listdailytrafic = "liste_daily_trafic";
$listdailydir = "liste_daily_dir";
$listdailycountries = "liste_daily_country";
$listdailyfiletype = "liste_daily_filetype";

$listdailyrefer = "liste_daily_refer";
$listdailykeyword = "liste_daily_keyword";
$listdailyagent = "liste_daily_agent";

#################################################################
###            parsing the command line option                ###
#################################################################

if ($opt_h) {
      print STDOUT "Usage : \n";
      print STDOUT "        -c <file>             : load configuration file\n";
      print STDOUT "        -g <";
      for ($i=0;$i<$#graphic;$i++) {
      print STDOUT "$graphic[$i] ";
      } 
      print STDOUT "$graphic[$#graphic]";
      print STDOUT "> : graphic output (choose one)\n";
      print STDOUT "        -l <";
      for ($i=0;$i<$#lang;$i++) {
      print STDOUT "$lang[$i],";
      } 
      print STDOUT "$lang[$#lang]";
      print STDOUT ">            : language output (comma split)\n";      
      print STDOUT "        -p <level>            : precision level (from 1 to 4)\n";
      print STDOUT "        -x                    : show default value for flag options\n";
      print STDOUT "        -v                    : version\n";
      print STDOUT "\n";
      exit;
}

if ($opt_v) {
      print STDOUT "$scriptname version $version $verdate\n";
      exit;
}

if ($opt_x) {
      print STDOUT "Default : \n";
      print STDOUT "          -c            : $configfile\n";
      print STDOUT "          -g <graphic>  : $graphic[0]\n";
      print STDOUT "          -l <language> : ";
      for ($i=0;$i<$#lang;$i++) {
      print STDOUT "$lang[$i],";
      }
      print STDOUT "$lang[$#lang]\n";      
      print STDOUT "          -p <level>    : $precision\n";
      print STDOUT "          -v            : $version\n";
      exit;
}

if ($opt_l) {
  @lang = split(/, /,$opt_l);
  for ($i=0;$i<=$#lang;$i++) {
      $tmp = $dirress.$dirsep."lang".$dirsep.$lang[$i].$plext;
      $tmp = $pathinit.$tmp;
      require "$tmp";
  }
  if ($lang[0] eq '') {
      &error_exit("\nNone of your language choices have been yet translated !",1);
      }
}

if ($opt_g) {
  if ($opt_g eq "3d")  {
      $bargraph = 1;
      $linegraph = 0;
      $tridim = 1;
  }
  if ($opt_g eq "fill") {
      $bargraph = 0;
      $linegraph = 1;
      $fillgraph = 1;
  }
  if ($opt_g eq "line") {
      $bargraph = 0;
      $linegraph = 1;
      $tridim = 0;
  }
  if ($opt_g eq "bar") {
      $bargraph = 1;
      $linegraph = 0;
      $tridim = 0;
  }
}

# argument cmds line

if ($opt_p) {
$precision = $opt_p;
}

#################################################################
####          debut de l'initialisation                   #######
#################################################################

&MakeDirectories;

$outfile1 = $path.$dirgraph.$dirsep."week_mach".$gifext;
$outfile1x = $path.$dirgraph.$dirsep."week_machx".$gifext;
$outfile1y = $path.$dirgraph.$dirsep."week_machy".$gifext;

$linkoutfile1 = "..".$dirsepurl."..".$dirsepurl.$dirgraph.$dirsepurl."week_mach".$gifext;
$linkoutfile1x = "..".$dirsepurl."..".$dirsepurl.$dirgraph.$dirsepurl."week_machx".$gifext;
$linkoutfile1y = "..".$dirsepurl."..".$dirsepurl.$dirgraph.$dirsepurl."week_machy".$gifext;

$outfile2 = $path.$dirgraph.$dirsep."week_req".$gifext;
$outfile2x = $path.$dirgraph.$dirsep."week_reqx".$gifext;
$outfile2y = $path.$dirgraph.$dirsep."week_reqy".$gifext;

$linkoutfile2 = "..".$dirsepurl."..".$dirsepurl.$dirgraph.$dirsepurl."week_req".$gifext;
$linkoutfile2x = "..".$dirsepurl."..".$dirsepurl.$dirgraph.$dirsepurl."week_reqx".$gifext;
$linkoutfile2y = "..".$dirsepurl."..".$dirsepurl.$dirgraph.$dirsepurl."week_reqy".$gifext;

$file3 = $path.$dirgraph.$dirsep.$statweekrepert.$gifext;
$file3x = $path.$dirgraph.$dirsep.$statweekrepert."x".$gifext;
$file3y = $path.$dirgraph.$dirsep.$statweekrepert."y".$gifext;

$linkfile3 = "..".$dirsepurl."..".$dirsepurl.$dirgraph.$dirsepurl.$statweekrepert.$gifext;
$linkfile3x = "..".$dirsepurl."..".$dirsepurl.$dirgraph.$dirsepurl.$statweekrepert."x".$gifext;
$linkfile3y = "..".$dirsepurl."..".$dirsepurl.$dirgraph.$dirsepurl.$statweekrepert."y".$gifext;

&load_fileext;

&load_countries_map;

&load_url_map if ($titlename == 1);

# Find last day

$line = 0;
open(INFILE, "$path$dirdata$dirsep$datafile") || &error_exit("Error, unable to open $path$dirdata$dirsep$datafile",1);
while (<INFILE>) {
    $line++;
    next if ($line <= 3);

    ($lastjour,$lastmonth,$lastyear) = split('\s+');
 }
close(INFILE);

$tmp = $line-3;
if ($lastjour eq '' || $tmp < 7) {
    $msg = "Not enough data to compute weekly stats.\n";
    $msg .= "File $path$dirdata$dirsep$datafile is empty\n" if ($lastjour eq '');
    $msg .= "Only $tmp days found\n" if ($tmp < 7 && $lastjour ne '');
    &error_exit("$msg",0);
}

$last_nbday = &nbday("$lastjour $lastmonth $lastyear");

#print "Last day : $lastjour - $lastmonth - $lastyear - $last_nbday\n";

#################################################################
#####               computing weekly stats                 ######
#################################################################

open(OUT, ">$path$dircsv$dirsep$tabnamecsv$csvext");
print OUT "#\"Date\";\"Hosts\";\"New_Hosts\";\"Domain_Hosts\";\"Requests\"";
print OUT ";\"Accesses\"" if ($ftp_format == 0 && $mail_format == 0);
print OUT ";\"DomReq\"\n";
close(OUT);

for ($nblang=0;$nblang<=$#lang;$nblang++) {

    $tabweek = $path.$lang[$nblang].$dirsep.$dirdate.$dirsep.$tabnameweek;

    open(TABWEEKS,">$tabweek") || &error_exit("Error, unable to open $tabweek",1);
    &WeekHeader(*TABWEEKS, eval($Lang{$lang[$nblang]}));
    close(TABWEEKS);
}


open(OUT, ">>$path$dircsv$dirsep$tabnamecsv$csvext");
open(INFILE, "$path$dirdata$dirsep$datafile") || &error_exit("Error, unable to open $path$dirdata$dirsep$datafile",1);

$line = 0;
$count_day = 0;
$count_week = 1;

while (<INFILE>) {
    $line++;
    next unless ($line > 3);

    $count++;

    $oldjour = $jour;
    $oldyear = $year;
    $old_date = $current_date;
    $oldmonth = $month;
    
    $count_day++;

    ($jour,$month,$year,$m_tot,$m_new,$m_dom,$req_tot,$req_dom,$access,$totsize,$tothtmlsize,$domsize,$script,$pays) = split('\s+');


    $start_date = $jour." ".$month." ".$year if ($line == 4);
    $past_date = $jour." ".$month." ".$year if ($past_date eq '');
    $current_date = $jour." ".$month." ".$year;
    $dirresume = $year."-".$month."-".$jour;
    $lastweek_found = 0; # if set to 1 , no next link

    ### test sur le jour suivant

    $intervalle = &nbday($current_date) - &nbday($old_date) if ($old_date ne '');

    ### Intervalle > 8
    if ($intervalle != 1 && $line > 4) {

	while (($count_day+$intervalle-1) > 8) {

#	    &LoadDailyData;
	    $lastweek_found = 1;

	    @oldyear = split(/[\s+\/]/,$pre_date);
	    $tmp3 = $past_date." $oldyear[2]";
	    $pre_date = &date_intervalle($tmp3,6);
	    $tmpdate = "$past_date - $pre_date";
	    
	    ($val1,$val2,$val3) = split(/\s+/,$past_date);
	    $dirresume = $val3."-".$val2."-".$val1."_";
	    ($val1,$val2,$val3) = split(/\s+/,$pre_date);
	    $dirresume .= $val3."-".$val2."-".$val1;
	    print "Week : $tmpdate\n";
	    print "<BR>" if ($ENV{'REQUEST_METHOD'} eq "GET"); 
	    $reqtotjour = $requete_tot;
	    $accessjour = $access_tot;
	    $totsizejour = $size_tot;
	    $domreq = $requete_dom;
	    $serveruniquejour = $machine_tot;
	    $locserverjour = $machine_dom;
#	    $scriptuniquejour = $script_day;
	    $newhost = $machine_new;


	    if ($mail_format == 0) {

#	    for ($k=0;$k<=$#listext;$k++) {
#		next if ($listext[$k] =~ /$extension/ && $ftp_format == 0);
#		$tmp2 = $downloadjour{$listext[$k]};
#		$zoneextjour[$extfilenb{$listext[$k]}] += $tmp2;
#	    }

	    for ($k=0;$k<=$nbzonefile;$k++) {
		$zoneextbis[$k] = $zoneextjour[$k];
	    }

	    for ($j=0;$j<=$nbzonefile;$j++) {
		$max = 0;
		$filetypejourmax[$j] = 0;
		for ($k=0;$k<=$nbzonefile;$k++) {
		    if ($zoneextbis[$k] > $max) {
			$max = $zoneextbis[$k];
			$filetypejourmax[$j] = $k;
		    }
		}
		$zoneextbis[$filetypejourmax[$j]] = 0;      
	    }

	}

	    if ($ftp_format == 0 && $mail_format == 0) {

	    # OS

	    $unique_new_osday = $uniqueosday;
	    foreach $osday (keys(%nbreosday)) {
		$ok = 0;
		for ($j=0;$j<=$#os;$j++) {
		    if ($osday eq $os[$j]) {
			$tmp = $os[$j];
			$tmp1 = $translate_os{$tmp};
			$new_osday{$tmp1} += $nbreosday{$tmp} if ($ok == 0);
			$ok = 1;
			$unique_new_osday-- if ($seen_serveur{"$tmp1 $oldjour"}++);
		    }
		}
		$new_osday{$osday} = $nbreosday{$osday} if ($ok != 1);
	    }


	    # Browser

	    $unique_new_browserday = 0;

	    for ($l=1;$l<=$uniqueday;$l++) {	       
		for ($j=0;$j<=$#agent;$j++) {
		    if ($browserday[$l] =~ /$agent[$j]/) {
			$tmp = $agent[$j];
			$tmp1 = $translate_agent{$tmp};
			$bro_ver = $browserday[$l];
			$bro_ver =~ /(\d)+/;
			$bro_ver = int($1);
			$new_browserday{$tmp1} += $nbreday{$browserday[$l]};
			$browser_versionday{$tmp1,$bro_ver} += $nbreday{$browserday[$l]};
			$browser_version_nbday{$tmp1} = $bro_ver if ($bro_ver > $browser_version_nbday{$tmp1});
			$browserday[$l] = '';
			$unique_new_browserday++ if (!($seen_serveur{"$tmp1 $oldjour"}++));
		    }
		}
		$new_browserday{$browserday[$l]} += $nbreday{$browserday[$l]} if ($browserday[$l] ne '');
		$unique_new_browserday++ if ($browserday[$l] ne '');
	    }
	    
	    for ($i=0;$i<$unique_new_browserday;$i++) {
		$maxi = 0;
		foreach $browser (keys(%new_browserday)) {
		    if ($new_browserday{$browser} > $maxi) {
			$maxi = $new_browserday{$browser};
			$bestbrowserday[$i] = $browser;
			$occurbrowserday[$i] = $new_browserday{$browser};                 
		    }
		}
		$new_browserday{$bestbrowserday[$i]} = 0;
	    }

	    for ($i=0;$i<$unique_new_browser;$i++) {
		for ($j=0;$j<=$#agent;$j++) {
		    if ($bestbrowserday[$i] =~ /$agent[$j]/) {
			$tmp = $agent[$j];
			$tmp1 = $translate_agent{$tmp};
		    }
		}
		$bestbrowserday[$i] =~ s/$tmp/$tmp1/ if ($tmp1 ne '');
	    }
	}

	    &BuildRequestsGraph("$past_date-$pre_date",7,$past_date,\@date_value,\@req_value,\@acc_value,\@host_value,\@traffic_value);
	    &BuildDailyResume($scriptname,$lastweek_found);
	    if ($ftp_format == 0 && $mail_format == 0) {
		&BuildDailyReferResume($scriptname) if (keys(%nbredayref) != 0);
		&BuildDailyAgentResume($scriptname) if ($uniqueosday != 0);
	    }
	    &UpdatePageResumeMenu($scriptname,$lastweek_found);


	    undef @req_value;
	    undef @acc_value;
	    undef @host_value;
	    undef @date_value;
	    undef @traffic_value;

	    if ($mail_format == 0) {
		undef @zoneextjour;
		undef @filetypejourmax;
		undef @listext;
		undef %downloadjour;
		undef %filetypejour;
	    }

	    if ($ftp_format == 0 && $mail_format == 0) {

		for ($i=0;$i<=$unique_new_browserday;$i++) {
		    for ($l=$browser_version_nbday{$bestbrowserday[$i]};$l>0;$l--) {
			$browser_versionday{$bestbrowserday[$i],$l} = '';
		    }
		}

		undef %browser_versionday;
		undef %browser_version_nbday;
		undef %new_browserday;
		undef %nbrebrowserday;
		undef %nbreosday;
		undef @browserday;
		undef %new_osday;
		undef @bestbrowserday;
		undef @occurbrowserday;
		undef %nbreday;
		undef %idx_browser;

		undef $bestbrowserday;
		undef $occurbrowserday;

		$unique_new_browserday = 0;
		$nbagent = 0;

		undef %nbredayref;
		undef %nbrefullday;
		undef %occurday;
		undef %wday;
		undef %keyshday;
		undef @wordsday;

	    }


	    $countday = 0;
	    $uniqueday = 0;

	    $uniquenbrefullday = 0;
	    $uniqueurlday = 0;
	    
	    undef %seen_server;
	    undef %freqjourrac;
	    undef %freqjourrachtml;
	    undef %sizejourrachtml;
	    undef %dailysizepage;
	    undef %serverjour;
	    undef %hostluesday;
	    undef %serversizejour;
	    undef %pagesluesday;
	    undef %paysjour;
	    undef %payshtmljour;
	    undef %paysjourlist;
	    undef %scriptday;
	    undef %client_day_error;
	    undef %client_day_refer;
#	    undef %downloadjour;
#	    undef %filetypejour;

#	$scriptuniquejour = 0;
	    $domsizejour = 0;
	    $script_day = 0;
	    $scriptuniquejour = 0;
	    $pageuniquejour = 0;
	    $paysuniquejour = 0;
	    $tothtmlsizejour = 0;

	    push(@listhost,$machine_tot);
	    push(@listreq,$requete_tot);
	    push(@listacc,$access_tot);
	    push(@listsize,$size_tot);
	    push(@listdate,$tmpdate);

	    $machmaxtot{$count_week} = $machine_tot;
	    $newmaxtot{$count_week} = $machine_new;
	    $dommaxtot{$count_week} = $machine_dom;
	    
	    $machmax = $machine_tot if ($machine_tot > $machmax);
	    $maxtot = $size_tot if ($size_tot > $maxtot);

	    $reqmaxtot{$count_week} = $requete_tot;
	    $accessmaxtot{$count_week} = $access_tot;
	    $reqdommaxtot{$count_week} = $requete_dom;
	    $sizemaxtot{$count_week} = $size_tot;

	    $reqmax = $requete_tot if ($requete_tot > $reqmax);

	    for ($nblang=0;$nblang<=$#lang;$nblang++) {
		$tabweek = $path.$lang[$nblang].$dirsep.$dirdate.$dirsep.$tabnameweek;
		
		open(TABWEEK,">>$tabweek") || &error_exit("Error, unable to open $tabweek",1);
		print TABWEEK "<TR>\n";
		print TABWEEK "<TD CLASS=\"left\">";
		print TABWEEK "<A NAME=\"$count_week\"><I>$tmpdate</I></A></TD>\n";
		$past_date = $current_date;
#		$past_date =~ s/ $year//;
		print TABWEEK "<TD CLASS=\"right\">$machine_tot</TD>\n";
		print TABWEEK "<TD CLASS=\"right\">$machine_new</TD>\n";
		print TABWEEK "<TD CLASS=\"right\">$machine_dom</TD>\n";
		print TABWEEK "<TD CLASS=\"right\">$requete_tot</TD>\n";
		print TABWEEK "<TD CLASS=\"right\">$access_tot</TD>\n" if ($ftp_format == 0 && $mail_format == 0);
		print TABWEEK "<TD CLASS=\"right\">$requete_dom</TD>\n";
		print TABWEEK "</TR>\n";
		close(TABWEEK);
	    }
	    print OUT "\"$tmpdate\";\"$machine_tot\";\"$machine_new\";\"$machine_dom\";\"$requete_tot\";\"$access_tot\";\"$requete_dom\"\n";

	    $machine_tot = 0;
	    $machine_new = 0;
	    $machine_dom = 0;
	    $requete_tot = 0;
	    $access_tot = 0;
	    $requete_dom = 0;
#	     $size_tot = 0;
	    $intervalle = 0;
#	    $intervalle -= 7;   # suppose un intervalle inferieur a 7 !
#	    $past_date = substr($pre_date,0,rindex($pre_date,' '));
	    $count_week++;
	    $line ++;
	}

	while ($intervalle > 8) {
	    $machine_tot = $m_tot;
	    $machine_new = $m_new;
	    $machine_dom = $m_dom;
	    $requete_tot = $req_tot;
	    $access_tot = $access;
	    $requete_dom = $req_dom;
	    $size_tot = $totsize;
	    push(@req_value,$req_tot);
	    push(@acc_value,$access);
	    push(@host_value,$m_tot);
	    push(@traffic_value,$totsize);
	    push(@date_value,$dirresume);
	}

	$count+=$intervalle-1;
	$count_day += $intervalle-1;
    }

    ### Intervalle next day
    if (($count_day+$intervalle-1) <= 7) {
#    if ($count_day <  8) {

#	print "A - $jour $month\n";

	&LoadDailyData;

	$machine_tot = $machine_tot + $m_tot;
	$machine_dom = $machine_dom + $m_dom;
	$machine_new = $machine_new + $m_new;
	$requete_tot = $requete_tot + $req_tot;
	$access_tot = $access_tot + $access;
	$requete_dom = $requete_dom + $req_dom;
	$size_tot = $size_tot + $totsize;
	$pre_date = $current_date;

	push(@req_value,$req_tot);
	push(@acc_value,$access);
	push(@host_value,$m_tot);
	push(@date_value,$dirresume);
	push(@traffic_value,$totsize);


    } else {

	$current_nbday = &nbday($pre_date);
	$lastweek_found = 1 if ($current_nbday+7 >= $last_nbday);

#	$week_over = 1 if ($lastweek_found == 1);
#	print "TOTO - $current_nbday == $last_nbday - $lastweek_found\n";
	$week_over = 1 if ($current_nbday == ($last_nbday-1));

	$dirresume_old = $dirresume;
	$tmpdate = "$past_date - $pre_date";
	($val1,$val2,$val3) = split(/\s+/,$past_date);
	$dirresume = $val3."-".$val2."-".$val1."_";
	($val1,$val2,$val3) = split(/\s+/,$pre_date);
	$dirresume .= $val3."-".$val2."-".$val1;
	print "Week : $tmpdate\n";
	print "<BR>" if ($ENV{'REQUEST_METHOD'} eq "GET"); 

	$dirresumefull = "$path$lang[0]$dirsep$dirdate$dirsep$dirresume";

	$reqtotjour = $requete_tot;
	$accessjour = $access_tot;
	$totsizejour = $size_tot;
	$domreq = $requete_dom;
	$serveruniquejour = $machine_tot;
	$locserverjour = $machine_dom;
#	$scriptuniquejour = $script_day;
	$newhost = $machine_new;

	if ($mail_format == 0) {
	# Filetype

#	    for ($k=0;$k<=$#listext;$k++) {
#		next if ($listext[$k] =~ /$extension/ && $ftp_format == 0);
#		$tmp2 = $downloadjour{$listext[$k]};
#		print "A1 - $zoneextjour[2]\n";
#		$zoneextjour[$extfilenb{$listext[$k]}] += $tmp2;
#		print "A2 - $zoneextjour[2]\n";
#		print "UU - $tmp2 - $listext[$k] - $extfilenb{$listext[$k]} - $zoneextjour[$extfilenb{$listext[$k]}]\n";
#	    }

	    for ($k=0;$k<=$nbzonefile;$k++) {
		$zoneextbis[$k] = $zoneextjour[$k];
	    }

	    for ($j=0;$j<=$nbzonefile;$j++) {
		$max = 0;
		$filetypejourmax[$j] = 0;
		for ($k=0;$k<=$nbzonefile;$k++) {
		    if ($zoneextbis[$k] > $max) {
			$max = $zoneextbis[$k];
			$filetypejourmax[$j] = $k;
		    }
		}
		$zoneextbis[$filetypejourmax[$j]] = 0;      
	    }
	}


	if ($ftp_format == 0 && $mail_format == 0) {
	# OS

	$unique_new_osday = $uniqueosday;
	foreach $osday (keys(%nbreosday)) {
	    $ok = 0;
	    for ($j=0;$j<=$#os;$j++) {
		if ($osday eq $os[$j]) {
		    $tmp = $os[$j];
		    $tmp1 = $translate_os{$tmp};
		    $new_osday{$tmp1} += $nbreosday{$tmp} if ($ok == 0);
		    $ok = 1;
		    $unique_new_osday-- if ($seen_serveur{"$tmp1 $oldjour"}++);
		}
	    }
	    $new_osday{$osday} = $nbreosday{$osday} if ($ok != 1);
	}


       # Browser

	$unique_new_browserday = 0;

	for ($l=1;$l<=$uniqueday;$l++) {	       
	    for ($j=0;$j<=$#agent;$j++) {
		if ($browserday[$l] =~ /$agent[$j]/) {
		    $tmp = $agent[$j];
		    $tmp1 = $translate_agent{$tmp};
		    $bro_ver = $browserday[$l];
		    $bro_ver =~ /(\d)+/;
		    $bro_ver = int($1);
		    $new_browserday{$tmp1} += $nbreday{$browserday[$l]};
		    $browser_versionday{$tmp1,$bro_ver} += $nbreday{$browserday[$l]};
		    $browser_version_nbday{$tmp1} = $bro_ver if ($bro_ver > $browser_version_nbday{$tmp1});
		    $browserday[$l] = '';
		    $unique_new_browserday++ if (!($seen_serveur{"$tmp1 $oldjour"}++));
		}
	    }
	    $new_browserday{$browserday[$l]} += $nbreday{$browserday[$l]} if ($browserday[$l] ne '');
	    $unique_new_browserday++ if ($browserday[$l] ne '');
	}
	
	for ($i=0;$i<$unique_new_browserday;$i++) {
	    $maxi = 0;
	    foreach $browser (keys(%new_browserday)) {
		if ($new_browserday{$browser} > $maxi) {
		    $maxi = $new_browserday{$browser};
		    $bestbrowserday[$i] = $browser;
		    $occurbrowserday[$i] = $new_browserday{$browser};                 
		}
	    }
	    $new_browserday{$bestbrowserday[$i]} = 0;
	}

	for ($i=0;$i<$unique_new_browser;$i++) {
	    for ($j=0;$j<=$#agent;$j++) {
		if ($bestbrowserday[$i] =~ /$agent[$j]/) {
		    $tmp = $agent[$j];
		    $tmp1 = $translate_agent{$tmp};
		}
	    }
	    $bestbrowserday[$i] =~ s/$tmp/$tmp1/ if ($tmp1 ne '');
	}
    }

	&BuildRequestsGraph("$past_date-$pre_date",7,$past_date,\@date_value,\@req_value,\@acc_value,\@host_value,\@traffic_value);
	&BuildDailyResume($scriptname,$lastweek_found);
	if ($ftp_format == 0 && $mail_format == 0) {
	    &BuildDailyReferResume($scriptname) if (keys(%nbredayref) != 0);
	    &BuildDailyAgentResume($scriptname) if ($uniqueosday != 0);
	}
	&UpdatePageResumeMenu($scriptname,$lastweek_found);

	undef @req_value;
	undef @acc_value;
	undef @host_value;
	undef @date_value;
	undef @traffic_value;

	if ($mail_format == 0) {
	    undef @zoneextjour;
	    undef @filetypejourmax;
	    undef @listext;
	    undef %downloadjour;
	    undef %filetypejour;
	}

	if ($ftp_format == 0 && $mail_format == 0) {

	    for ($i=0;$i<=$unique_new_browserday;$i++) {
		for ($l=$browser_version_nbday{$bestbrowserday[$i]};$l>0;$l--) {
		    $browser_versionday{$bestbrowserday[$i],$l} = '';
		}
	    }

	    undef %browser_versionday;
	    undef %browser_version_nbday;
	    undef %new_browserday;
	    undef %nbrebrowserday;
	    undef %nbreosday;
	    undef @browserday;
	    undef %new_osday;
	    undef @bestbrowserday;
	    undef @occurbrowserday;
	    undef %nbreday;
	    undef %idx_browser;

	    $unique_new_browserday = 0;
	    $nbagent = 0;

	    undef %nbredayref;
	    undef %nbrefullday;
	    undef %occurday;
	    undef %wday;
	    undef %keyshday;
	    undef @wordsday;

	}

	$countday = 0;
	$uniqueday = 0;

	$uniquenbrefullday = 0;
	$uniqueurlday = 0;

	undef %seen_server;
	undef %freqjourrac;
	undef %freqjourrachtml;
	undef %sizejourrachtml;
	undef %dailysizepage;
	undef %serverjour;
	undef %hostluesday;
	undef %serversizejour;
	undef %pagesluesday;
	undef %paysjour;
	undef %payshtmljour;
	undef %paysjourlist;
	undef %scriptday;
	undef %client_day_error;
	undef %client_day_refer;

	$domsizejour = 0;
	$script_day = 0;
	$scriptuniquejour = 0;
	$pageuniquejour = 0;
	$paysuniquejour = 0;
	$tothtmlsizejour = 0;

	push(@listhost,$machine_tot);
	push(@listreq,$requete_tot);
	push(@listacc,$access_tot);
	push(@listsize,$size_tot);
	push(@listdate,$tmpdate);
	
        $machmaxtot{$count_week} = $machine_tot;
        $newmaxtot{$count_week} = $machine_new;
        $dommaxtot{$count_week} = $machine_dom;

#	print "$count_week - $machine_tot\n";

        $machmax = $machine_tot if ($machine_tot > $machmax);
	$maxtot = $size_tot if ($size_tot > $maxtot);

        $reqmaxtot{$count_week} = $requete_tot;
        $accessmaxtot{$count_week} = $access_tot;
        $reqdommaxtot{$count_week} = $requete_dom;
	$sizemaxtot{$count_week} = $size_tot;

        $reqmax = $requete_tot if ($requete_tot > $reqmax);

	($val1,$val2) = split(/\s-\s/,$tmpdate);
	($tmp1,$tmp2,$tmp3) = split(/\s+/,$val1);
	$tmp = $tmp3."-".$tmp2."-".$tmp1."_";
	($tmp1,$tmp2,$tmp3) = split(/\s+/,$val2);
	$tmp .= $tmp3."-".$tmp2."-".$tmp1;
	$linkjour = "..".$dirsepurl.$dirdate.$dirsepurl.$tmp.$dirsepurl.$menu;
	$fulljour = $path.$lang[0].$dirsep.$dirdate.$dirsep.$tmp.$dirsep.$menu;

        for ($nblang=0;$nblang<=$#lang;$nblang++) {
                $tabweek = $path.$lang[$nblang].$dirsep.$dirdate.$dirsep.$tabnameweek;
          
                open(TABWEEK,">>$tabweek") || &error_exit("Error, unable to open $tabweek",1);
		print TABWEEK "<TR>\n";
		print TABWEEK "<TD CLASS=\"left\">";
                print TABWEEK "<A NAME=\"$count_week\"></A>";
		print TABWEEK "<A HREF=\"$linkjour\">";
		print TABWEEK "<I>$tmpdate</I>";
		print TABWEEK "</A>";
		print TABWEEK "</TD>\n";
		$past_date = $current_date;
#		$past_date =~ s/ $year//;
		print TABWEEK "<TD CLASS=\"right\">$machine_tot</TD>\n";
		print TABWEEK "<TD  CLASS=\"right\">$machine_new</TD>\n";
		print TABWEEK "<TD CLASS=\"right\">$machine_dom</TD>\n";
		print TABWEEK "<TD CLASS=\"right\">$requete_tot</TD>\n";
		print TABWEEK "<TD CLASS=\"right\">$access_tot</TD>\n" if ($ftp_format == 0 && $mail_format == 0);
		print TABWEEK "<TD CLASS=\"right\">$requete_dom</TD>\n";
		print TABWEEK "</TR>\n";
                close(TABWEEK);
        }
	print OUT "\"$tmpdate\";\"$machine_tot\";\"$machine_new\";\"$machine_dom\";\"$requete_tot\"";
	print OUT ";\"$access_tot\"" if ($ftp_format == 0 && $mail_format == 0);
	print OUT ";\"$requete_dom\"\n";
        
	$machine_tot = $m_tot;
	$machine_new = $m_new;
	$machine_dom = $m_dom;
	$requete_tot = $req_tot;
	$access_tot = $access;
	$requete_dom = $req_dom;
	$size_tot = $totsize;
	$count_day -= 7;   # suppose un intervalle inferieur a 7 !
	
	$count_week++;
#	$line++;

	$date_last = $dirresume;

	if ($enable_pdf == 1) {
	    if (-d "$path$lang[0]$dirsep$dirdate$dirsep$dirresume") {
		$filepdf = $path.$dirpdf.$dirsep.$date_last.$pdfext;
		&generate_pdf_cmd($date_last,$statnameweek,$filepdf) if (!(-f $filepdf));
	    }
	}

	$dirresume = $dirresume_old;

	&LoadDailyData;

	$machine_tot = $machine_tot + $m_tot;
	$machine_dom = $machine_dom + $m_dom;
	$machine_new = $machine_new + $m_new;
	$requete_tot = $requete_tot + $req_tot;
	$access_tot = $access_tot + $access;
	$requete_dom = $requete_dom + $req_dom;
	$size_tot = $size_tot + $totsize;
	$pre_date = $current_date;
	push(@req_value,$req_tot);
	push(@acc_value,$access);
	push(@host_value,$m_tot);
	push(@date_value,$dirresume);
	push(@traffic_value,$totsize);
    }
}


close(INFILE);
close(OUT);

# fermeture de la page HTML du tableau sur les jours
for ($nblang=0;$nblang<=$#lang;$nblang++) {
  $tabweek = $path.$lang[$nblang].$dirsep.$dirdate.$dirsep.$tabnameweek;
  
  open(TABWEEK,">>$tabweek") || &error_exit("Error, unable to open $tabweek",1);
  &WeekFooter(*TABWEEK, eval($Lang{$lang[$nblang]}));
  close (TABWEEK);
}

$count_week--;

#print "COUNT WEEK $count_week\n";

#################################################################
#####           hosts and requests graphs                 #######
#################################################################

#################################################################
# Fly

if ($precision > 2) {
if ($count > 7) {
#if (-x $FLY) {

    $map = '';
    $num = 0;
    $num2 = 0;

    $it = length($count_week)-1;
    $div = 10**$it;
    $factx = ($div*(int($count_week/$div)+1))/$grad;

    $perspec = $xstep/$factx if (($perspec > $xstep/$factx) && ($tridim == 1));

    $it = length($machmax)-1;
    $div = 10**$it;
    $facty = ($div*(int(($machmax+$perspec)/$div)+1))/$grad;

    if ($maxtot > (1024*1024*1024) && $maxtot <= (1024*1024*1024*1024)) {
	$tmp4 = 1024*1024*1024;
	$unit = "Gb";
    }

    if ($maxtot > (1024*1024) && $maxtot <= (1024*1024*1024)) {
	$tmp4 = 1024*1024;
	$unit = "Mb";
    }
    if ($maxtot > 1024 && $maxtot <= (1024*1024)) {
	$tmp4 = 1024;
	$unit = "Kb";
    }

    if ($maxtot <= 1024) {
	$tmp4 = 1;
	$unit = "bytes";
	$unit = "" if ($maxtot == 0);
    }

    # Compute USEMAP WEEK

    for ($i=0;$i<($count_week+$bargraph);$i++) {

	if ($listdate[$num] ne '') {

	    $x1 = ($i-1+$linegraph+$tridim)*$xstep/$factx;
	    $x2 = ($i+$linegraph+$tridim)*$xstep/$factx;

	    ($val1,$val2) = split(/\s-\s/,$listdate[$num]);
	    ($tmp1,$tmp2,$tmp3) = split(/\s+/,$val1);
	    $tmp = $tmp3."-".$tmp2."-".$tmp1."_";
	    $tmp6 = $tmp1."-".$tmp2."-".$tmp3."&nbsp;/&nbsp;";
	    $tmp7 = $tmp1." ".$tmp2." ".$tmp3." / ";
	    
	    ($tmp1,$tmp2,$tmp3) = split(/\s+/,$val2);
	    $tmp .= $tmp3."-".$tmp2."-".$tmp1;
	    $tmp6 .= $tmp1."-".$tmp2."-".$tmp3;
	    $tmp7 .= $tmp1." ".$tmp2." ".$tmp3;
	    $linkjour = "..".$dirsepurl.$dirdate.$dirsepurl.$tmp.$dirsepurl.$menu;
	    $fulljour = $path.$lang[0].$dirsep.$dirdate.$dirsep.$tmp.$dirsep.$menu;

	    $wday = $day_of_week[(localtime(&nbday("$tmp7")*86400))[6]];

	    $num++;
	    $num2 = $num-1;
	    if (-e $fulljour) {
		$list[$num2] = "$tmp";
	    }

	    $tmp2 =  int($sizemaxtot{$i+1}*100/$tmp4)/100;
	    $tmp5 = "Requests : $reqmaxtot{$i+1}|";
	    $tmp5 .= "Accesses : $accessmaxtot{$i+1}|" if ($ftp_format == 0 && $squid_format == 0);
	    $tmp5 .= "Hosts : $machmaxtot{$i+1}|Traffic : $tmp2 $unit";
	    
	    $map .= "<AREA SHAPE=\"rect\" COORDS=\"$x1,0,$x2,$ymax\" HREF=\"$tabnameweek#$num\" ALT=\"$tmp\" onMouseOver=\"popLayer('$tmp6','$tmp5','','$tabnamedays#$num',1,'','$popup_graph_width')\">\n" if (!(-e $fulljour) && $reqmaxtot{$i} != 0);
	    $map .= "<AREA SHAPE=\"rect\" COORDS=\"$x1,0,$x2,$ymax\" HREF=\"$linkjour\" ALT=\"$tmp\" onMouseOver=\"popLayer('$tmp6','$tmp5','','$linkjour',1,'','$popup_graph_width')\">\n" if (-e $fulljour);
	    
	    if ($i > ($count_week-$rss_week)) {
		&BuildRSS($filerss,$tmp5,$tmp7,$linkjour);
	    }
	}
    }


    ###

    open(FLY,">$tmpfly$vtmp2");
    print FLY "new\n";
    print FLY "size $xmax,$ymax\n";
    print FLY "frect 0,0,0,0,200,200,200\n";
    for ($i=1;$i<($count_week+$bargraph);$i++) {
	$x1 = ($i-1+$linegraph+$tridim)*$xstep/$factx;
	$x2 = ($i+$linegraph+$tridim)*$xstep/$factx;

	$y2 = $ymax - ($ystep/$facty * $machmaxtot{$i});
	$y2db = $ymax - ($ystep/$facty * $machmaxtot{$i})+1;
# $y2ppp = $ymax - ($ystep/$facty * $machmaxtot{$i-1});

	$x1 = $x1 - $xstep/$factx if ($x2-$x1 > $xstep && $tridim == 1);
	$x2 = $x2 - $xstep/$factx if ($x2-$x1 > $xstep && $tridim == 1);

	if ($bargraph == 1) {
	    $x2 -= $perspec if ($tridim == 1);
	    $x1 -= $perspec if ($tridim == 1);
	    print FLY "frect $x1,$y2,$x2,$ymax,$red[0],$green[0],$blue[0]\n";
	    print FLY "rect $x1,$y2,$x2,$ymax,0,0,0\n";
	    
	    if ($tridim == 1 && $y2 != $ymax) {

		$x1plus = $x1+$perspec;
		$x2plus = $x2+$perspec;
		$y2plus = $y2-$perspec;
		$y1plus = $ymax - $perspec;
		
		print FLY "fpoly $red[0],$green[0],$blue[0],$x1,$y2,$x1plus,$y2plus,$x2plus,$y2plus,$x2,$y2\n";
		print FLY "poly 0,0,0,$x1,$y2,$x1plus,$y2plus,$x2plus,$y2plus,$x2,$y2\n";

		print FLY "fpoly $red[0],$green[0],$blue[0],$x2,$ymax,$x2,$y2,$x2plus,$y2plus,$x2plus,$y1plus\n";
		print FLY "poly 0,0,0,$x2,$ymax,$x2,$y2,$x2plus,$y2plus,$x2plus,$y1plus\n";
	    }
	}

 if ($linegraph == 1) {
    $y1 = $ymax - ($ystep/$facty * $machmaxtot{$i+1});
    $y1db = $ymax - ($ystep/$facty * $machmaxtot{$i+1})+1;
    print FLY "line $x1,$y2,$x2,$y1,$red[0],$green[0],$blue[0]\n";
    print FLY "line $x1,$y2db,$x2,$y1db,$red[0],$green[0],$blue[0]\n";

    if ($fillgraph == 1) {
       if ($y1 != $y2 || $y1 != $ymax) {
         print FLY "line $x1,$ymax,$x1,$y2,$red[0],$green[0],$blue[0]\n";
         print FLY "line $x2,$ymax,$x2,$y1,$red[0],$green[0],$blue[0]\n";
         print FLY "line $x1,$ymax,$x2,$ymax,$red[0],$green[0],$blue[0]\n";
         $fx1 = $x1+1;
         $fymax = $ymax-1;
         print FLY "fill $fx1,$fymax,$red[0],$green[0],$blue[0]\n";
       }
     }

  }

 $x1 -= $factx*$shift_factor;
 $x2 -= $factx*$shift_factor;

 $y2 = $ymax - ($ystep/$facty * $newmaxtot{$i});
 $y2db = $ymax - ($ystep/$facty * $newmaxtot{$i})+1;
# $y2ppp = $ymax - ($ystep/$facty * $newmaxtot{$i-1});

 if ($bargraph == 1) {
   $x2 -= $perspec if ($tridim == 1);
   $x1 -= $perspec if ($tridim == 1);
    print FLY "frect $x1,$y2,$x2,$ymax,$red[1],$green[1],$blue[1]\n";
    print FLY "rect $x1,$y2,$x2,$ymax,0,0,0\n";
#     print FLY "rect $x1,$y2,$x1,$y2ppp,0,0,0\n";
   if ($tridim == 1 && $y2 != $ymax) {

        $x1plus = $x1+$perspec;
        $x2plus = $x2+$perspec;
        $y2plus = $y2-$perspec;
      
        print FLY "fpoly $red[1],$green[1],$blue[1],$x1,$y2,$x1plus,$y2plus,$x2plus,$y2plus,$x2,$y2\n";
        print FLY "poly 0,0,0,$x1,$y2,$x1plus,$y2plus,$x2plus,$y2plus,$x2,$y2\n";

        print FLY "fpoly $red[1],$green[1],$blue[1],$x2,$ymax,$x2,$y2,$x2plus,$y2plus,$x2plus,$ymax\n";
        print FLY "poly 0,0,0,$x2,$ymax,$x2,$y2,$x2plus,$y2plus,$x2plus,$ymax\n";

   }
 }

 if ($linegraph == 1) {
    $y1 = $ymax - ($ystep/$facty * $newmaxtot{$i+1});
    $y1db = $ymax - ($ystep/$facty * $newmaxtot{$i+1})+1;
    print FLY "line $x1,$y2,$x2,$y1,$red[1],$green[1],$blue[1]\n";
    print FLY "line $x1,$y2db,$x2,$y1db,$red[1],$green[1],$blue[1]\n";


    if ($fillgraph == 1) {
       if ($y1 != $y2 || $y1 != $ymax) {
         print FLY "line $x1,$ymax,$x1,$y2,$red[1],$green[1],$blue[1]\n";
         print FLY "line $x2,$ymax,$x2,$y1,$red[1],$green[1],$blue[1]\n";
         print FLY "line $x1,$ymax,$x2,$ymax,$red[1],$green[1],$blue[1]\n";
         $fx1 = $x1+1;
         $fymax = $ymax-1;
         print FLY "fill $fx1,$fymax,$red[1],$green[1],$blue[1]\n";
       }
    }

 }

 $x1 -= $factx*2*$shift_factor;
 $x2 -= $factx*2*$shift_factor;

 $y2 = $ymax - ($ystep/$facty * $dommaxtot{$i});
 $y2db = $ymax - ($ystep/$facty * $dommaxtot{$i})+1;
# $y2ppp = $ymax - ($ystep/$facty * $dommaxtot{$i-1});

 if ($bargraph == 1) {
   $x2 -= $perspec if ($tridim == 1);
   $x1 -= $perspec if ($tridim == 1);
   print FLY "frect $x1,$y2,$x2,$ymax,$red[2],$green[2],$blue[2]\n";
   print FLY "rect $x1,$y2,$x2,$ymax,0,0,0\n";
#     print FLY "rect $x1,$y2,$x1,$y2ppp,0,0,0\n";
   if ($tridim == 1 && $y2 != $ymax) {

        $x1plus = $x1+$perspec;
        $x2plus = $x2+$perspec;
        $y2plus = $y2-$perspec;

        print FLY "fpoly $red[2],$green[2],$blue[2],$x1,$y2,$x1plus,$y2plus,$x2plus,$y2plus,$x2,$y2\n";
        print FLY "poly 0,0,0,$x1,$y2,$x1plus,$y2plus,$x2plus,$y2plus,$x2,$y2\n";

        print FLY "fpoly $red[2],$green[2],$blue[2],$x2,$ymax,$x2,$y2,$x2plus,$y2plus,$x2plus,$ymax\n";
        print FLY "poly 0,0,0,$x2,$ymax,$x2,$y2,$x2plus,$y2plus,$x2plus,$ymax\n";

   }
 }

 if ($linegraph == 1) {
    $y1 = $ymax - ($ystep/$facty * $dommaxtot{$i+1});
    $y1db = $ymax - ($ystep/$facty * $dommaxtot{$i+1})+1;
    print FLY "line $x1,$y2,$x2,$y1,$red[2],$green[2],$blue[2]\n";
    print FLY "line $x1,$y2db,$x2,$y1db,$red[2],$green[2],$blue[2]\n";

    if ($fillgraph == 1) {
       if ($y1 != $y2 || $y1 != $ymax) {
          print FLY "line $x1,$ymax,$x1,$y2,$red[2],$green[2],$blue[2]\n";
          print FLY "line $x2,$ymax,$x2,$y1,$red[2],$green[2],$blue[2]\n";
          print FLY "line $x1,$ymax,$x2,$ymax,$red[2],$green[2],$blue[2]\n";
          $fx1 = $x1+1;
          $fymax = $ymax-1;
          print FLY "fill $fx1,$fymax,$red[2],$green[2],$blue[2]\n";
       }
     }
 }


}

print FLY "transparent 200,200,200\n";
close (FLY);

open(FOO,"$FLY -q -i $tmpfly$vtmp2 -o $outfile1 |");
while( <FOO> ) {print;}
close(FOO);

#unlink($tmpfly$vtmp);

### image pour les abscisses

($startday, $startmonth) = split(/ /,$start_date);

$moischiffre = $month_equiv{$startmonth};
$moischiffre--;
$moisvar = $startmonth;
$valmois = $moischiffre;

$valstep = $startday;
$valstep = "0".$valstep if (length($valstep) == 1);

$xlegend = "$count_week week";
$xlegend .= "s" if ($count_week > 1);
$xlegend .= " (starting $start_date)";

open(FLY,">$tmpfly$vtmp");
print FLY "new\n";
print FLY "size $xmax,$ydecal\n";
 print FLY "frect 0,0,0,0,200,200,200\n";
 $posx = (($xmax/2)-(length($xlegend)*7/2));
 print FLY "string 0,0,0,$posx,$ydecalm,medium,$xlegend\n";
 for ($i=$xstep;$i<$xmax;$i+=$xstep) {

 $valstep = int(($i/$xmax)*(($xmax*$factx/$xstep)*7))+$startday;

 $moisvar = $startmonth;
 $valmois = $moischiffre;

 while  ($valstep > $month_of_year{$moisvar}) {
     $valstep = ($valstep - $month_of_year{$moisvar});
     $valmois++;
     $valmois = 0 if ($valmois > 11);
     $moisvar = $month_nb[$valmois];
 }

 $valstep = "0".$valstep if (length($valstep) == 1);
 $val = "$moisvar/$valstep";
 $posx = $i - length($valstep)*10;
 print FLY "line $i,0,$i,5,0,0,0\n";
 print FLY "string 0,0,0,$posx,10,small,$val\n";

 }
print FLY "transparent 200,200,200\n";
close (FLY);

open(FOO,"$FLY -q -i $tmpfly$vtmp -o $outfile1x |");
while( <FOO> ) {print;}
close(FOO);
#unlink($tmpfly$vtmp);

### image pour les ordonnees

open(FLY,">$tmpfly$vtmp");
print FLY "new\n";
print FLY "size $xdecal,$ymax\n";
 print FLY "frect 0,0,0,0,200,200,200\n";
 $posy = $ymax - (($ymax/2)-(length("Hosts")/2));
 print FLY "stringup 0,0,0,5,$posy,medium,Hosts\n";
 for ($i=$ystep;$i<$ymax;$i+=$ystep) {
 $valstep = int(($ymax - $i) * ($facty/$ystep));
 $pos = ($xdecal - length($valstep)*9);
 $posy = $i-5;
 print FLY "line $xdecalm,$i,$xdecal,$i,0,0,0\n";
 print FLY "string 0,0,0,$pos,$posy,small,$valstep\n";
 }
print FLY "transparent 200,200,200\n";
close (FLY);

open(FOO,"$FLY -q -i $tmpfly$vtmp -o $outfile1y |");
while( <FOO> ) {print;}
close(FOO);
#unlink($tmpfly$vtmp);
#}

}

#####################  2 ieme GIF  #################################

#################################################################
# Fly

#if (-x $FLY) {

$it = length($count_week)-1;
$div = 10**$it;
$factx = ($div*(int($count_week/$div)+1))/$grad;

$perspec = $xstep/$factx if (($perspec > $xstep/$factx) && ($tridim == 1));

$it = length($reqmax)-1;
$div = 10**$it;
$facty = ($div*(int(($reqmax+$perspec)/$div)+1))/$grad;


### image pour les ordonnees

open(FLY,">$tmpfly$vtmp");
print FLY "new\n";
print FLY "size $xdecal,$ymax\n";
 print FLY "frect 0,0,0,0,200,200,200\n";
 $posy = $ymax - (($ymax/2)-(length("Requests")/2));
 print FLY "stringup 0,0,0,5,$posy,medium,Requests\n";

 for ($i=$ystep;$i<$ymax;$i+=$ystep) {
 $valstep = int(($ymax - $i) * ($facty/$ystep));
 $pos = ($xdecal - length($valstep)*9);
 $posy = $i-5;
 print FLY "line $xdecalm,$i,$xdecal,$i,0,0,0\n";
 print FLY "string 0,0,0,$pos,$posy,small,$valstep\n";
 }

print FLY "transparent 200,200,200\n";
close (FLY);

open(FOO,"$FLY -q -i $tmpfly$vtmp -o $outfile2y |");
while( <FOO> ) {print;}
close(FOO);

##

### image pour les abscisses

$xlegend = "$count_week week";
$xlegend .= "s" if ($count_week > 1);
$xlegend .= " (starting $start_date)";

($startday, $startmonth) = split(/ /,$start_date);

$moischiffre = $month_equiv{$startmonth};
$moischiffre--;
$moisvar = $startmonth;
$valmois = $moischiffre;

$valstep = $startday;
$valstep = "0".$valstep if (length($valstep) == 1);

open(FLY,">$tmpfly$vtmp");
print FLY "new\n";
print FLY "size $xmax,$ydecal\n";
 print FLY "frect 0,0,0,0,200,200,200\n";
 $posx = (($xmax/2)-(length($xlegend)*7/2));
 print FLY "string 0,0,0,$posx,$ydecalm,medium,$xlegend\n";
 for ($i=$xstep;$i<$xmax;$i+=$xstep) {

 $valstep = int(($i/$xmax)*(($xmax*$factx/$xstep)*7))+$startday;

 $moisvar = $startmonth;
 $valmois = $moischiffre;

 while  ($valstep > $month_of_year{$moisvar}) {
     $valstep = ($valstep - $month_of_year{$moisvar});
     $valmois++;
     $valmois = 0 if ($valmois > 11);
     $moisvar = $month_nb[$valmois];
 }

 $valstep = "0".$valstep if (length($valstep) == 1);
 $val = "$moisvar/$valstep";
 $posx = $i - length($valstep)*10;
 print FLY "line $i,0,$i,5,0,0,0\n";
 print FLY "string 0,0,0,$posx,10,small,$val\n";

 }
print FLY "transparent 200,200,200\n";
close (FLY);

open(FOO,"$FLY -q -i $tmpfly$vtmp -o $outfile2x |");
while( <FOO> ) {print;}
close(FOO);
#unlink($tmpfly$vtmp);

##

 open(FLY,">$tmpfly$vtmp");
 print FLY "new\n";
 print FLY "size $xmax,$ymax\n";
 print FLY "frect 0,0,0,0,200,200,200\n";
 for ($i=1;$i<($count_week+$bargraph);$i++) {
 $x1 = ($i-1+$linegraph+$tridim)*$xstep/$factx;
 $x2 = ($i+$linegraph+$tridim)*$xstep/$factx;

 $x1 = $x1 - $xstep/$factx if ($x2-$x1 > $xstep && $tridim == 1);
 $x2 = $x2 - $xstep/$factx if ($x2-$x1 > $xstep && $tridim == 1);

 $y2 = $ymax - ($ystep/$facty * $reqmaxtot{$i});
 $y2db = $ymax - ($ystep/$facty * $reqmaxtot{$i})+1;
# $y2ppp = $ymax - ($ystep/$facty * $reqmaxtot{$i-1});

 if ($bargraph == 1) {
   $x2 -= $perspec if ($tridim == 1);
   $x1 -= $perspec if ($tridim == 1);
   print FLY "frect $x1,$y2,$x2,$ymax,$red[0],$green[0],$blue[0]\n";
   print FLY "rect $x1,$y2,$x2,$ymax,0,0,0\n";
#   print FLY "rect $x1,$y2,$x1,$y2ppp,0,0,0\n";
   if ($tridim == 1 && $y2 != $ymax) {

        $x1plus = $x1+$perspec;
        $x2plus = $x2+$perspec;
        $y2plus = $y2-$perspec;
        $y1plus = $ymax - $perspec;

        print FLY "fpoly $red[0],$green[0],$blue[0],$x1,$y2,$x1plus,$y2plus,$x2plus,$y2plus,$x2,$y2\n";
        print FLY "poly 0,0,0,$x1,$y2,$x1plus,$y2plus,$x2plus,$y2plus,$x2,$y2\n";

        print FLY "fpoly $red[0],$green[0],$blue[0],$x2,$ymax,$x2,$y2,$x2plus,$y2plus,$x2plus,$y1plus\n";
        print FLY "poly 0,0,0,$x2,$ymax,$x2,$y2,$x2plus,$y2plus,$x2plus,$y1plus\n";

   }
 }

 if ($linegraph == 1) {
    $y1 = $ymax - ($ystep/$facty * $reqmaxtot{$i+1});
    $y1db = $ymax - ($ystep/$facty * $reqmaxtot{$i+1})+1;
    print FLY "line $x1,$y2,$x2,$y1,$red[0],$green[0],$blue[0]\n";
    print FLY "line $x1,$y2db,$x2,$y1db,$red[0],$green[0],$blue[0]\n";

    if ($fillgraph == 1) {
      if ($y1 != $y2 || $y1 != $ymax) {
        print FLY "line $x1,$ymax,$x1,$y2,$red[0],$green[0],$blue[0]\n";
        print FLY "line $x2,$ymax,$x2,$y1,$red[0],$green[0],$blue[0]\n";
        print FLY "line $x1,$ymax,$x2,$ymax,$red[0],$green[0],$blue[0]\n";
        $fx1 = $x1+1;
        $fymax = $ymax-1;
        print FLY "fill $fx1,$fymax,$red[0],$green[0],$blue[0]\n";
      }
    }

 }

 if ($ftp_format == 0 && $mail_format == 0) {
 $x1 -= $factx*$shift_factor;
 $x2 -= $factx*$shift_factor;

 $y2 = $ymax - ($ystep/$facty * $accessmaxtot{$i});
 $y2db = $ymax - ($ystep/$facty * $accessmaxtot{$i})+1;
# $y2ppp = $ymax - ($ystep/$facty * $accessmaxtot{$i-1});

 if ($bargraph == 1) {
   $x2 -= $perspec if ($tridim == 1);
   $x1 -= $perspec if ($tridim == 1);
   print FLY "frect $x1,$y2,$x2,$ymax,$red[1],$green[1],$blue[1]\n";
   print FLY "rect $x1,$y2,$x2,$ymax,0,0,0\n";
#   print FLY "rect $x1,$y2,$x1,$y2ppp,0,0,0\n";
   if ($tridim == 1 && $y2 != $ymax) {

        $x1plus = $x1+$perspec;
        $x2plus = $x2+$perspec;
        $y2plus = $y2-$perspec;
      
        print FLY "fpoly $red[1],$green[1],$blue[1],$x1,$y2,$x1plus,$y2plus,$x2plus,$y2plus,$x2,$y2\n";
        print FLY "poly 0,0,0,$x1,$y2,$x1plus,$y2plus,$x2plus,$y2plus,$x2,$y2\n";

        print FLY "fpoly $red[1],$green[1],$blue[1],$x2,$ymax,$x2,$y2,$x2plus,$y2plus,$x2plus,$ymax\n";
        print FLY "poly 0,0,0,$x2,$ymax,$x2,$y2,$x2plus,$y2plus,$x2plus,$ymax\n";
   }
 }

 if ($linegraph == 1) {
    $y1 = $ymax - ($ystep/$facty * $accessmaxtot{$i+1});
    $y1db = $ymax - ($ystep/$facty * $accessmaxtot{$i+1})+1;
    print FLY "line $x1,$y2,$x2,$y1,$red[1],$green[1],$blue[1]\n";
    print FLY "line $x1,$y2db,$x2,$y1db,$red[1],$green[1],$blue[1]\n";

    if ($fillgraph == 1) {
      if ($y1 != $y2 || $y1 != $ymax) {
        print FLY "line $x1,$ymax,$x1,$y2,$red[1],$green[1],$blue[1]\n";
        print FLY "line $x2,$ymax,$x2,$y1,$red[1],$green[1],$blue[1]\n";
        print FLY "line $x1,$ymax,$x2,$ymax,$red[1],$green[1],$blue[1]\n";
        $fx1 = $x1+1;
        $fymax = $ymax-1;
        print FLY "fill $fx1,$fymax,$red[1],$green[1],$blue[1]\n";
      }
    }

 }
}

 $x1 -= $factx*2*$shift_factor;
 $x2 -= $factx*2*$shift_factor;

 $y2 = $ymax - ($ystep/$facty * $reqdommaxtot{$i});
 $y2db = $ymax - ($ystep/$facty * $reqdommaxtot{$i})+1;
# $y2ppp = $ymax - ($ystep/$facty * $reqdommaxtot{$i-1});

 if ($bargraph == 1) {
   $x2 -= $perspec if ($tridim == 1);
   $x1 -= $perspec if ($tridim == 1);
   print FLY "frect $x1,$y2,$x2,$ymax,$red[2],$green[2],$blue[2]\n";
   print FLY "rect $x1,$y2,$x2,$ymax,0,0,0\n";
#   print FLY "rect $x1,$y2,$x1,$y2ppp,0,0,0\n";
   if ($tridim == 1 && $y2 != $ymax) {

        $x1plus = $x1+$perspec;
        $x2plus = $x2+$perspec;
        $y2plus = $y2-$perspec;

        print FLY "fpoly $red[2],$green[2],$blue[2],$x1,$y2,$x1plus,$y2plus,$x2plus,$y2plus,$x2,$y2\n";
        print FLY "poly 0,0,0,$x1,$y2,$x1plus,$y2plus,$x2plus,$y2plus,$x2,$y2\n";

        print FLY "fpoly $red[2],$green[2],$blue[2],$x2,$ymax,$x2,$y2,$x2plus,$y2plus,$x2plus,$ymax\n";
        print FLY "poly 0,0,0,$x2,$ymax,$x2,$y2,$x2plus,$y2plus,$x2plus,$ymax\n";
   }
 }

 if ($linegraph == 1) {
    $y1 = $ymax - ($ystep/$facty * $reqdommaxtot{$i+1});
    $y1db = $ymax - ($ystep/$facty * $reqdommaxtot{$i+1})+1;
    print FLY "line $x1,$y2,$x2,$y1,$red[2],$green[2],$blue[2]\n";
    print FLY "line $x1,$y2db,$x2,$y1db,$red[2],$green[2],$blue[2]\n";

    if ($fillgraph == 1) {
     if ($y1 != $y2 || $y1 != $ymax) {
       print FLY "line $x1,$ymax,$x1,$y2,$red[2],$green[2],$blue[2]\n";
       print FLY "line $x2,$ymax,$x2,$y1,$red[2],$green[2],$blue[2]\n";
       print FLY "line $x1,$ymax,$x2,$ymax,$red[2],$green[2],$blue[2]\n";
       $fx1 = $x1+1;
       $fymax = $ymax-1;
       print FLY "fill $fx1,$fymax,$red[2],$green[2],$blue[2]\n";
     }
    }

 }

}
print FLY "transparent 200,200,200\n";
close (FLY);

open(FOO,"$FLY -q -i $tmpfly$vtmp -o $outfile2 |");
while( <FOO> ) {print;}
close(FOO);
#unlink($tmpfly$vtmp);

#}
}

### Tri sur les peaks

@trireq = reverse sort bynumber @listreq;


for ($i=0;$i<=$topten;$i++) {
    for ($j=0;$j<=$#listreq;$j++) {
	if ($trireq[$i] eq $listreq[$j]) {
	    $trireqdate[$i] = $listdate[$j];
	    $listreq[$j] = 0;
	    last;
	}
    }
}

@triacc = reverse sort bynumber @listacc;

for ($i=0;$i<=$topten;$i++) {
    for ($j=0;$j<=$#listacc;$j++) {
	if ($triacc[$i] eq $listacc[$j]) {
	    $triaccdate[$i] = $listdate[$j];
	    $listacc[$j] = 0;
	    last;
	}
    }
}

@trihost = reverse sort bynumber @listhost;

for ($i=0;$i<=$topten;$i++) {
    for ($j=0;$j<=$#listhost;$j++) {
	if ($trihost[$i] eq $listhost[$j]) {
	    $trihostdate[$i] = $listdate[$j];
	    $listhost[$j] = 0;
	    last;
	}
    }
}

@trisize = reverse sort bynumber @listsize;

for ($i=0;$i<=$topten;$i++) {
    for ($j=0;$j<=$#listsize;$j++) {
	if ($trisize[$i] eq $listsize[$j]) {
	    $trisizedate[$i] = $listdate[$j];
	    $listsize[$j] = 0;
	    last;
	}
    }
}

#

for ($nblang=0;$nblang<=$#lang;$nblang++) {

        $statweek = $path.$lang[$nblang].$dirsep.$dirdate.$dirsep.$statnameweek;
#        $datpath = $linkpath.$lang[$nblang].$dirsepurl.$dirdate;

        open(STATWEEK,">$statweek") || &error_exit("Error, unable to open $statweek",1);
        &WeekStats(*STATWEEK, eval($Lang{$lang[$nblang]}),$nblang);
close(STATWEEK);
}

#unlink("$tmpfly$vtmp");

###################################################################
# date de ce jour

$month = '';
$jour = '';


# # # # # # # # # # # #    directories stats    # # # # # # # # # # # #

#####
#######################################################################
#####            graphs for the selected directories            #######
#######################################################################
#####

# page HTML pour le tableau de donnees

open(OUT, ">$path$dircsv$dirsep$statrepert$csvext");
print OUT "#\"Date\";\"Hosts\";\"New_Hosts\";\"Domain_Hosts\";\"Requests\";\"Accesses\";\"DomReq\"\n";

open(INFILE, "$path$dirdata$dirsep$statrepert") || &error_exit("Error, unable to open $path$dirdata$dirsep$statrepert",1);

 $line = 0;
 $count_day = 0;
 $count_week = 1;
 $count = 0;

 while (<INFILE>) {
     @dirname = split(/\s+/) unless ($line != 0);
     $line++;
     $count++;
     $count-- unless ($line > 3);
     next unless ($line > 3);

     $oldjour = $jour;
     $oldyear = $year;
     $old_date = $current_date;
     $oldmonth = $month;

     $count_day++;

     ($jour,$month,$year,@dir) = split('\s+');
     $current_date = $jour." ".$month." ".$year;
     if ( $line == 4) {
       $start_date = $jour." ".$month." ".$year;
     }
     ### test sur le jour suivant

     $intervalle = &nbday($current_date) - &nbday($old_date) if ($old_date ne '');
#     $intervalle = $jour - $oldjour;
     if ($intervalle != 1 && $line > 4) {
#        if ($oldmonth ne $month) {
#        $intervalle = $month_of_year{$oldmonth} - $oldjour; # suppose le mois suivant
#        $intervalle += $jour;
#             }

	 while (($count_day+$intervalle-1) > 8) {

	     @oldyear = split(/[\s+\/]/,$pre_date);
#	     $tmp3 = $past_date." $oldyear[2]";
#	     $pre_date = &date_intervalle($tmp3,7);
#	     $tmp = "$past_date - $pre_date";

	     $intervalle -= 7;   # suppose un intervalle inferieur a 7 !
#	     $past_date = substr($pre_date,0,rindex($pre_date,' '));

	     for ($i=0;$i<=($#dir);$i++) {
		 $maxdir_tot{$count_week,$i} = $dir_tot[$i];
		 $maxdir_acc{$count_week,$i} = $dir_acc[$i];
		 $repmax = $dir_tot[$i] if ($dir_tot[$i] > $repmax);
	     }
	     for ($i=0;$i<=($#dir);$i++) {
		 ($tmp1,$tmp2) = split(/\|/,$dir[$i]);
		 $dir_tot[$i] = $tmp1;
		 $dir_acc[$i] = $tmp2;
#		 $dir_tot[$i] = $dir[$i];
	     }
	     $count_week++;
	     $line ++;
	 }

	 while ($intervalle > 8) {
	     for ($i=0;$i<=($#dir);$i++) {
		 ($tmp1,$tmp2) = split(/\|/,$dir[$i]);
#	       $dir_tot[$i] += $dir[$i];
		 $dir_tot[$i] += $tmp1;
		 $dir_acc[$i] += $tmp2;
	     }
	 }

	 $count+=$intervalle-1;
	 $count_day += $intervalle-1;
     }

     if ( $count_day <  8) {
           for ($i=0;$i<=($#dir);$i++) {
	       ($tmp1,$tmp2) = split(/\|/,$dir[$i]);
#	       $dir_tot[$i] += $dir[$i];
	       $dir_tot[$i] += $tmp1;
	       $dir_acc[$i] += $tmp2;
           }
          }
      else {
           for ($i=0;$i<=($#dir);$i++) {
	       $maxdir_tot{$count_week,$i} = $dir_tot[$i];
	       $maxdir_acc{$count_week,$i} = $dir_acc[$i];
	       $repmax = $dir_tot[$i] if ($dir_tot[$i] > $repmax);
	   }
           for ($i=0;$i<=($#dir);$i++) {
	       ($tmp1,$tmp2) = split(/\|/,$dir[$i]);
#	       $dir_tot[$i] = $dir[$i];
	       $dir_tot[$i] = $tmp1;
	       $dir_acc[$i] = $tmp2;
	   }
	   $count_day -= 7;   # suppose un intervalle inferieur a 7 !

	   $count_week++;
	   $line ++;
       }

}


close(INFILE);
close(OUT);

exit if ($precision < 3);

$count_week--;

#################################################################
#####                     graphs                          #######
#################################################################

#################################################################
# Fly

if ($count > 14) {

    $it = length($repmax)-1;
$div = 10**$it;
$facty = ($div*(int($repmax/$div)+1))/$grad;

$fymax = $ymax-1;

   $map_dir_all = '';
    $num = 0;

    $it = length($count_week)-1;
    $div = 10**$it;
    $factx = ($div*(int($count_week/$div)+1))/$grad;

    $perspec = $xstep/$factx if (($perspec > $xstep/$factx) && ($tridim == 1));

    if ($maxtot > (1024*1024*1024) && $maxtot <= (1024*1024*1024*1024)) {
	$tmp4 = 1024*1024*1024;
	$unit = "Gb";
    }

    if ($maxtot > (1024*1024) && $maxtot <= (1024*1024*1024)) {
	$tmp4 = 1024*1024;
	$unit = "Mb";
    }
    if ($maxtot > 1024 && $maxtot <= (1024*1024)) {
	$tmp4 = 1024;
	$unit = "Kb";
    }

    if ($maxtot <= 1024) {
	$tmp4 = 1;
	$unit = "bytes";
	$unit = "" if ($maxtot == 0);
    }

    # Compute USEMAP DIR ALL

    for ($i=0;$i<($count_week+$bargraph);$i++) {

	if ($listdate[$num] ne '') {

	    $x1 = ($i-1+$linegraph+$tridim)*$xstep/$factx;
	    $x2 = ($i+$linegraph+$tridim)*$xstep/$factx;

	    ($val1,$val2) = split(/\s-\s/,$listdate[$num]);
	    ($tmp1,$tmp2,$tmp3) = split(/\s+/,$val1);
	    $tmp = $tmp3."-".$tmp2."-".$tmp1."_";
	    $tmp6 = $tmp1."-".$tmp2."-".$tmp3."&nbsp;/&nbsp;";
	    $tmp7 = $tmp1." ".$tmp2." ".$tmp3." / ";
	    
	    ($tmp1,$tmp2,$tmp3) = split(/\s+/,$val2);
	    $tmp .= $tmp3."-".$tmp2."-".$tmp1;
	    $tmp6 .= $tmp1."-".$tmp2."-".$tmp3;
	    $tmp7 .= $tmp1." ".$tmp2." ".$tmp3;
	    $linkjour = "..".$dirsepurl.$dirdate.$dirsepurl.$tmp.$dirsepurl.$menu;
	    $fulljour = $path.$lang[0].$dirsep.$dirdate.$dirsep.$tmp.$dirsep.$menu;

	    $wday = $day_of_week[(localtime(&nbday("$tmp7")*86400))[6]];

	    $num++;

	    $tmp2 =  int($sizemaxtot{$i+1}*100/$tmp4)/100;
	    $tmp5 = "Requests : $reqmaxtot{$i+1}|";
	    $tmp5 .= "Accesses : $accessmaxtot{$i+1}|" if ($ftp_format == 0 && $squid_format == 0);
	    $tmp5 .= "Hosts : $machmaxtot{$i+1}|Traffic : $tmp2 $unit";
	    
	    $map_dir_all .= "<AREA SHAPE=\"rect\" COORDS=\"$x1,0,$x2,$ymax\" HREF=\"$tabnameweek#$num\" ALT=\"$tmp\" onMouseOver=\"popLayer('$tmp6','$tmp5','','$tabnamedays#$num',1,'','$popup_graph_width')\">\n" if (!(-e $fulljour) && $reqmaxtot{$i} != 0);
	    $map_dir_all .= "<AREA SHAPE=\"rect\" COORDS=\"$x1,0,$x2,$ymax\" HREF=\"$linkjour\" ALT=\"$tmp\" onMouseOver=\"popLayer('$tmp6','$tmp5','','$linkjour',1,'','$popup_graph_width')\">\n" if (-e $fulljour);
	    
	}
    }

 open(FLY,">$tmpfly$vtmp");
 print FLY "new\n";
 print FLY "size $xmax,$ymax\n";
 print FLY "frect 0,0,0,0,200,200,200\n";


 for ($i=1;$i<$count_week;$i++) {
   for ($j=0;$j<=($#dir);$j++) {
         $newtabtmp{$i,$j} = $maxdir_tot{$i,$j};
    }
  }

# calculez le max des 3 colonnes pour les 2 premiers points consecutifs

$i = 1;
$maxval = $ymax;
for ($k=$i;$k<=$i+1;$k++) {
for ($l=0;$l<=($#dir);$l++) {
   $y2 = $maxdir_tot{$k,$l};
        if ($y2 < $maxval) {
            $maxval = $y2;
            $maxiplus = $k;
         }
     }
}


# calculez le max des 3 colonnes pour le point selectione
# $maxdir_tot{$i,$j} de $j a $#dir

   for ($l=0;$l<=($#dir);$l++) {
      $maxval = 0;

      for ($j=0;$j<=($#dir);$j++) {

         if ($newtabtmp{$maxiplus,$j} > $maxval) {
            $maxval = $newtabtmp{$maxiplus,$j};
            $maxvalidx[$l] = $j;
#	    print "$l - $j\n";
         }
      }
      $newtabtmp{$maxiplus,$maxvalidx[$l]} = 0;
#	    print "A : $l - $maxvalidx[$l]\n";

   }

undef %newtabtmp;

if ($maxvalidx[$#dir] eq '') {
      for ($j=0;$j<=($#dir);$j++) {
            $maxvalidx[$j] = $j;
   }
}

for ($i=1;$i<($count_week+$bargraph);$i++) {

 $x1 = ($i-1+$linegraph)*$xstep/$factx;
 $x2 = ($i+$linegraph)*$xstep/$factx;

#for ($j=0;$j<=($#dir);$j++) {
for ($l=0;$l<=($#dir);$l++) {
$j = $maxvalidx[$l];
#print "J : $j\n";

   if ($bargraph == 1) {
      $y2 = $ymax - ($ystep/$facty * $maxdir_tot{$i,$maxvalidx[$j]});
      print FLY "frect $x1,$y2,$x2,$ymax,$red[$maxvalidx[$j]],$green[$maxvalidx[$j]],$blue[$maxvalidx[$j]]\n";
      print FLY "rect $x1,$y2,$x2,$ymax,0,0,0\n";
      if ($tridim == 1 && $y2 != $ymax) {

        $x1plus = $x1+$perspec;
        $x2plus = $x2+$perspec;
        $y2plus = $y2-$perspec;
        $y1plus = $ymax-$perspec;

        print FLY "fpoly $red[$maxvalidx[$j]],$green[$maxvalidx[$j]],$blue[$maxvalidx[$j]],$x2,$ymax,$x2,$y2,$x2plus,$y2plus,$x2plus,$y1plus\n";
        print FLY "poly 0,0,0,$x2,$ymax,$x2,$y2,$x2plus,$y2plus,$x2plus,$y1plus\n";

        if ($l == $j) {
        print FLY "fpoly $red[$maxvalidx[$j]],$green[$maxvalidx[$j]],$blue[$maxvalidx[$j]],$x1,$y2,$x1plus,$y2plus,$x2plus,$y2plus,$x2,$y2\n";
        print FLY "poly 0,0,0,$x1,$y2,$x1plus,$y2plus,$x2plus,$y2plus,$x2,$y2\n";
        }
      }
   }

  if ($linegraph == 1) {

#
     $y2 = $ymax - ($ystep/$facty * $maxdir_tot{$i,$j});
     $y1 = $ymax - ($ystep/$facty * $maxdir_tot{$i+1,$j});
     print FLY "line $x1,$y2,$x2,$y1,$red[$j],$green[$j],$blue[$j]\n";
#
     $y2db = $ymax - ($ystep/$facty * $maxdir_tot{$i,$j}) + 1 ;
     $y1db = $ymax - ($ystep/$facty * $maxdir_tot{$i+1,$j}) + 1;
     print FLY "line $x1,$y2db,$x2,$y1db,$red[$j],$green[$j],$blue[$j]\n";

     if ($fillgraph == 1) {
       if ($y2old > $y2 && $y1old > $y1) {
       if ($y2 < ($ymax-1) && $y1 < ($ymax-1)) {
         print FLY "line $x1,$ymax,$x1,$y2,$red[$j],$green[$j],$blue[$j]\n";
         print FLY "line $x2,$ymax,$x2,$y1,$red[$j],$green[$j],$blue[$j]\n";
         print FLY "line $x1,$ymax,$x2,$ymax,$red[$j],$green[$j],$blue[$j]\n";
         $fx1 = $x2-1 if ($y2 > $y1);
         $fx1 = $x1+1 if ($y2 < $y1);
         $fymax = int($y1+1) if ($y2 < $y1);
         $fymax = int($y2+1) if ($y2 > $y1);
#         print STDERR "$x1 $x2 $fx1 $y2 $y1 $fymax $j\n";


#
        print FLY "fpoly $red[$j],$green[$j],$blue[$j],$x1,$ymax,$x1,$y2,$x2,$y1,$x2,$ymax\n";
#

         print FLY "fill $fx1,$fymax,$red[$j],$green[$j],$blue[$j]\n";
          }
       }
     }
  }
   $y2old = $y2;
   $y1old = $y1;


}
}
print FLY "transparent 200,200,200\n";
close (FLY);

open(FOO,"$FLY -q -i $tmpfly$vtmp -o $file3 |");
while( <FOO> ) {print;}
close(FOO);
#unlink($tmpfly$vtmp);


### image pour les abscisses

$xlegend = "$count_week week";
$xlegend .= "s" if ($count_week > 1);
$xlegend .= " (starting $start_date)";

($startday, $startmonth) = split(/ /,$start_date);

$moischiffre = $month_equiv{$startmonth};
$moischiffre--;
$moisvar = $startmonth;
$valmois = $moischiffre;

$valstep = $startday;
$valstep = "0".$valstep if (length($valstep) == 1);

open(FLY,">$tmpfly$vtmp");
print FLY "new\n";
print FLY "size $xmax,$ydecal\n";
 print FLY "frect 0,0,0,0,200,200,200\n";
 $posx = (($xmax/2)-(length($xlegend)*7/2));
 print FLY "string 0,0,0,$posx,$ydecalm,medium,$xlegend\n";
 for ($i=$xstep;$i<$xmax;$i+=$xstep) {

 $valstep = int(($i/$xmax)*(($xmax*$factx/$xstep)*7))+$startday;

 $moisvar = $startmonth;
 $valmois = $moischiffre;

 while  ($valstep > $month_of_year{$moisvar}) {
     $valstep = ($valstep - $month_of_year{$moisvar});
     $valmois++;
     $valmois = 0 if ($valmois > 11);
     $moisvar = $month_nb[$valmois];
 }

 $valstep = "0".$valstep if (length($valstep) == 1);
 $val = "$moisvar/$valstep";
 $posx = $i - length($valstep)*10;
 print FLY "line $i,0,$i,5,0,0,0\n";
 print FLY "string 0,0,0,$posx,10,small,$val\n";

 }
print FLY "transparent 200,200,200\n";
close (FLY);

open(FOO,"$FLY -q -i $tmpfly$vtmp -o $file3x |");
while( <FOO> ) {print;}
close(FOO);
#unlink($tmpfly$vtmp);

### image pour les ordonnees

open(FLY,">$tmpfly$vtmp");
print FLY "new\n";
print FLY "size $xdecal,$ymax\n";
 print FLY "frect 0,0,0,0,200,200,200\n";
 $posy = $ymax - (($ymax/2)-(length("Request by directory")*3));
 print FLY "stringup 0,0,0,5,$posy,medium,Requests by directory\n";

 for ($i=$ystep;$i<$ymax;$i+=$ystep) {
 $valstep = int(($ymax - $i) * ($facty/$ystep));
 $pos = ($xdecal - length($valstep)*9);
 $posy = $i-5;
 print FLY "line $xdecalm,$i,$xdecal,$i,0,0,0\n";
 print FLY "string 0,0,0,$pos,$posy,small,$valstep\n";
 }

print FLY "transparent 200,200,200\n";
close (FLY);

open(FOO,"$FLY -q -i $tmpfly$vtmp -o $file3y |");
while( <FOO> ) {print;}
close(FOO);
#unlink($tmpfly$vtmp);
#}

#####
####################################################################
###  requests and data traffic for each selected directories  ######
####################################################################
#####


####################################################################
####     requests graphs for each selected directories         #####
####################################################################

for ($i=0;$i<=($#dir);$i++) {
 $range = $i +2;
# $dirname[$i] =~ s/\///g;
# $dirname[$i] =~ s/~/_/g;
 $dirname[$i] = "dir".$i;
 $namerepert = $dirname[$i];
 $dirnamex[$i] = $dirname[$i]."x".$gifext;
 $dirnamey[$i] = $dirname[$i]."y".$gifext;
 $dirname[$i] .= $gifext;

#################################################################
# Fly


#if (-x $FLY) {

$it = length($count_week)-1;
$div = 10**$it;
$factx = ($div*(int($count_week/$div)+1))/$grad;

$repmax = 0;
 $num = 0;

 for ($j=1;$j<=$count_week;$j++) {
$repmax = $maxdir_tot{$j,$i} if ($maxdir_tot{$j,$i} > $repmax);
}

$it = length($repmax)-1;
$div = 10**$it;
$facty = ($div*(int($repmax/$div)+1))/$grad;


 open(FLY,">$tmpfly$vtmp");
 print FLY "new\n";
 print FLY "size $xmax,$ymax\n";
 print FLY "frect 0,0,0,0,200,200,200\n";

 for ($j=1;$j<($count_week+$bargraph);$j++) {

     $tmp_maxdir{$j,$i} = $maxdir_tot{$j,$i};

     $x1 = ($j-1+$linegraph)*$xstep/$factx;
     $x2 = ($j+$linegraph)*$xstep/$factx;

     $y2 = $ymax - ($ystep/$facty * $maxdir_tot{$j,$i});
     $y2db = $ymax - ($ystep/$facty * $maxdir_tot{$j,$i})+1;

     $y3 = $ymax - ($ystep/$facty * $maxdir_acc{$j,$i});
     $y3db = $ymax - ($ystep/$facty * $maxdir_acc{$j,$i})+1;

     if ($bargraph == 1) {
	 print FLY "frect $x1,$y2,$x2,$ymax,$red[0],$green[0],$blue[0]\n";
	 print FLY "rect $x1,$y2,$x2,$ymax,0,0,0\n";
	 print FLY "frect $x1,$y3,$x2,$ymax,$red[1],$green[1],$blue[1]\n";
	 print FLY "rect $x1,$y3,$x2,$ymax,0,0,0\n";
	 if ($tridim == 1 && $y2 != $ymax) {

	     $x1plus = $x1+$perspec;
	     $x2plus = $x2+$perspec;
	     $y2plus = $y2-$perspec;
	     $y3plus = $y3-$perspec;
	     $y1plus = $ymax - $perspec;

	     print FLY "fpoly $red[0],$green[0],$blue[0],$x1,$y2,$x1plus,$y2plus,$x2plus,$y2plus,$x2,$y2\n";
	     print FLY "poly 0,0,0,$x1,$y2,$x1plus,$y2plus,$x2plus,$y2plus,$x2,$y2\n";
	     print FLY "fpoly $red[1],$green[1],$blue[1],$x1,$y3,$x1plus,$y3plus,$x2plus,$y3plus,$x2,$y3\n";
	     print FLY "poly 0,0,0,$x1,$y3,$x1plus,$y3plus,$x2plus,$y3plus,$x2,$y3\n";

	     print FLY "fpoly $red[0],$green[0],$blue[0],$x2,$ymax,$x2,$y2,$x2plus,$y2plus,$x2plus,$y1plus\n";
	     print FLY "poly 0,0,0,$x2,$ymax,$x2,$y2,$x2plus,$y2plus,$x2plus,$y1plus\n";
	     print FLY "fpoly $red[1],$green[1],$blue[1],$x2,$ymax,$x2,$y3,$x2plus,$y3plus,$x2plus,$y1plus\n";
	     print FLY "poly 0,0,0,$x2,$ymax,$x2,$y3,$x2plus,$y3plus,$x2plus,$y1plus\n";
	 }
     }

     if ($linegraph == 1) {
	 $y1a = $ymax - ($ystep/$facty * $maxdir_acc{$j+1,$i});
	 $y1db = $ymax - ($ystep/$facty * $maxdir_acc{$j+1,$i})+1;
	 print FLY "line $x1,$y3,$x2,$y1a,$red[1],$green[1],$blue[1]\n";
	 print FLY "line $x1,$y3db,$x2,$y1db,$red[1],$green[1],$blue[1]\n";

	 $y1 = $ymax - ($ystep/$facty * $maxdir_tot{$j+1,$i});
	 $y1db = $ymax - ($ystep/$facty * $maxdir_tot{$j+1,$i})+1;
	 print FLY "line $x1,$y2,$x2,$y1,$red[0],$green[0],$blue[0]\n";
	 print FLY "line $x1,$y2db,$x2,$y1db,$red[0],$green[0],$blue[0]\n";

	 if ($fillgraph == 1) {
	     if ($y1 != $y2 || $y1 != $ymax) {
		 print FLY "line $x1,$ymax,$x1,$y3,$red[1],$green[1],$blue[1]\n";
		 print FLY "line $x2,$ymax,$x2,$y1,$red[1],$green[1],$blue[1]\n";
		 print FLY "line $x1,$ymax,$x2,$ymax,$red[1],$green[1],$blue[1]\n";

		 print FLY "line $x1,$ymax,$x1,$y2,$red[0],$green[0],$blue[0]\n";
		 print FLY "line $x2,$ymax,$x2,$y1a,$red[0],$green[0],$blue[0]\n";
		 print FLY "line $x1,$ymax,$x2,$ymax,$red[0],$green[0],$blue[0]\n";
		 $fx1 = $x1+1;
		 $fymax = $ymax-1;
		 print FLY "fill $fx1,$fymax,$red[0],$green[0],$blue[0]\n";
#		 print FLY "fill $fx1,$fymax,$red[1],$green[1],$blue[1]\n";
	     }
	 }
     }
     
 }

print FLY "transparent 200,200,200\n";
close (FLY);

open(FOO,"$FLY -q -i $tmpfly$vtmp -o $path$dirgraph$dirsep$dirname[$i] |");
while( <FOO> ) {print;}
close(FOO);
#unlink($tmpfly$vtmp);

### image pour les abscisses

$xlegend = "$count_week week";
$xlegend .= "s" if ($count_week > 1);
$xlegend .= " (starting $start_date)";

($startday, $startmonth) = split(/ /,$start_date);

$moischiffre = $month_equiv{$startmonth};
$moischiffre--;
$moisvar = $startmonth;
$valmois = $moischiffre;

$valstep = $startday;
$valstep = "0".$valstep if (length($valstep) == 1);


open(FLY,">$tmpfly$vtmp");
print FLY "new\n";
print FLY "size $xmax,$ydecal\n";
 print FLY "frect 0,0,0,0,200,200,200\n";
 $posx = (($xmax/2)-(length($xlegend)*7/2));
 print FLY "string 0,0,0,$posx,$ydecalm,medium,$xlegend\n";

 for ($j=$xstep;$j<$xmax;$j+=$xstep) {

 $valstep = int(($j/$xmax)*(($xmax*$factx/$xstep)*7))+$startday;

 $moisvar = $startmonth;
 $valmois = $moischiffre;

 while  ($valstep > $month_of_year{$moisvar}) {
     $valstep = ($valstep - $month_of_year{$moisvar});
     $valmois++;
     $valmois = 0 if ($valmois > 11);
     $moisvar = $month_nb[$valmois];
 }

 $valstep = "0".$valstep if (length($valstep) == 1);
 $val = "$moisvar/$valstep";
 $posx = $j - length($valstep)*10;
 print FLY "line $j,0,$j,5,0,0,0\n";
 print FLY "string 0,0,0,$posx,10,small,$val\n";

 }

print FLY "transparent 200,200,200\n";
close (FLY);

open(FOO,"$FLY -q -i $tmpfly$vtmp -o $path$dirgraph$dirsep$dirnamex[$i] |");
while( <FOO> ) {print;}
close(FOO);
#unlink($tmpfly$vtmp);


### image pour les ordonnees

open(FLY,">$tmpfly$vtmp");
print FLY "new\n";
print FLY "size $xdecal,$ymax\n";
 print FLY "frect 0,0,0,0,200,200,200\n";
 $posy = $ymax - (($ymax/2)-(length("Requests")));
 print FLY "stringup 0,0,0,5,$posy,medium,Requests\n";

 for ($j=$ystep;$j<$ymax;$j+=$ystep) {
 $valstep = int(($ymax - $j) * ($facty/$ystep));
 $pos = ($xdecal - length($valstep)*9);
 $posy = $j-5;
 print FLY "line $xdecalm,$j,$xdecal,$j,0,0,0\n";
 print FLY "string 0,0,0,$pos,$posy,small,$valstep\n";
 }

print FLY "transparent 200,200,200\n";
close (FLY);

open(FOO,"$FLY -q -i $tmpfly$vtmp -o $path$dirgraph$dirsep$dirnamey[$i] |");
while( <FOO> ) {print;}
close(FOO);
#unlink($tmpfly$vtmp);
#}
}
}

#################################################################
####       data traffic for each selected directories       #####
#################################################################

$line = 0;
$count_day = 0;
$count_week = 1;
$count = 0;

open(INFILE, "$path$dirdata$dirsep$filerepertsize") || &error_exit("Error, unable to open sizerepert $path$dirdata$dirsep$filerepertsize",1);

 while (<INFILE>) {
     @dirname = split(/\s+/) unless ($line != 0);
     $line++;
     $count++;
     $count-- unless ($line > 3);
     next unless ($line > 3);

     $oldjour = $jour;
     $oldmonth = $month;

     $count_day++;

     ($jour,$month,$year,@dir) = split('\s+');
     if ( $line == 4) {
       $start_date = $jour." ".$month." ".$year;
     }
     ### test sur le jour suivant

     $intervalle = $jour - $oldjour;
     if ($intervalle != 1 && $line > 4) {
        if ($oldmonth ne $month) {
        $intervalle = $month_of_year{$oldmonth} - $oldjour; # suppose le mois suivant
        $intervalle += $jour;
             }
     $count+=$intervalle-1;
     $count_day += $intervalle-1;
     }

     if ( $count_day <  8) {
           for ($i=0;$i<=($#dir);$i++) {
              $dir_tot[$i] += $dir[$i];
           }
          }
      else {
            for ($i=0;$i<=($#dir);$i++) {
	          $maxdir_tot{$count_week,$i} = $dir_tot[$i];
            }
            for ($i=0;$i<=($#dir);$i++) {
                  $dir_tot[$i] = $dir[$i];
             }
        $count_day -= 7;   # suppose un intervalle inferieur a 7 !

        $count_week++;
        $line ++;
        }

}



close (INFILE);

$count_week--;

########################################################################
###             data traffic graphs and the HTML pages            ######
########################################################################

for ($i=0;$i<=($#dirname);$i++) {
 $range = $i*6 +2;
 $namerepert = $dirname[$i];
# $dirname[$i] =~ s/\///g;
# $dirname[$i] =~ s/~/_/g;
 $dirname[$i] = "dir".$i;
 $dirsizename[$i] = $dirname[$i];
 $dirsizename[$i] .= "-size".$gifext;
 $dirsizenamex[$i] = $dirname[$i]."-sizex".$gifext;
 $dirsizenamey[$i] = $dirname[$i]."-sizey".$gifext;
# $dirname[$i] .= $htmlext;

#### leave dirname[$i] in the state it had before ML support ####

#$dirname[$i] =~ s/$htmlext/$gifext/;

if ($count > 14) {

#################################################################
# Fly

#if (-x $FLY) {

    $it = length($count_week)-1;
$div = 10**$it;
$factx = ($div*(int($count_week/$div)+1))/$grad;

$repmax = 0;

 for ($j=1;$j<=$count_week;$j++) {
     $repmax = $maxdir_tot{$j,6*$i} if ($maxdir_tot{$j,6*$i} > $repmax);
 }

$it = length($repmax)-1;
$div = 10**$it;
$facty = ($div*(int($repmax/$div)+1))/$grad;

    if ($repmax > (1024*1024*1024) && $repmax <= (1024*1024*1024*1024)) {
	$tmp4 = 1024*1024*1024;
	$unit = "Gb";
    }

    if ($repmax > (1024*1024) && $repmax <= (1024*1024*1024)) {
	$tmp4 = 1024*1024;
	$unit = "Mb";
    }
    if ($repmax > 1024 && $repmax <= (1024*1024)) {
	$tmp4 = 1024;
	$unit = "Kb";
    }

    if ($repmax <= 1024) {
	$tmp4 = 1;
	$unit = "bytes";
	$unit = "" if ($repmax == 0);
    }


    # Compute USEMAP DIR

$num = 0;

 for ($j=1;$j<($count_week+$bargraph);$j++) {

     if ($listdate[$num] ne '') {

	 $x1 = ($j-1+$linegraph)*$xstep/$factx;
	 $x2 = ($j+$linegraph)*$xstep/$factx;

	 ($val1,$val2) = split(/\s-\s/,$listdate[$num]);
	 ($tmp1,$tmp2,$tmp3) = split(/\s+/,$val1);
	 $tmp = $tmp3."-".$tmp2."-".$tmp1."_";
	 $tmp6 = $tmp1."-".$tmp2."-".$tmp3."&nbsp;/&nbsp;";
	 $tmp7 = $tmp1." ".$tmp2." ".$tmp3." / ";
	    
	 ($tmp1,$tmp2,$tmp3) = split(/\s+/,$val2);
	 $tmp .= $tmp3."-".$tmp2."-".$tmp1;
	 $tmp6 .= $tmp1."-".$tmp2."-".$tmp3;
	 $tmp7 .= $tmp1." ".$tmp2." ".$tmp3;
	 $linkjour = "..".$dirsepurl.$dirdate.$dirsepurl.$tmp.$dirsepurl.$menu;
	 $fulljour = $path.$lang[0].$dirsep.$dirdate.$dirsep.$tmp.$dirsep.$menu;

	 $wday = $day_of_week[(localtime(&nbday("$tmp7")*86400))[6]];

	 $num++;

	 $tmp2 =  int($maxdir_tot{$j,6*$i}*100/$tmp4)/100;
	 $tmp5 = "Requests : $tmp_maxdir{$j,$i}|";
	 $tmp5 .= "Accesses : $maxdir_acc{$j,$i}|";
	 $tmp5 .= "Traffic : $tmp2 $unit";
	 
#	 $map_dir[$i] .= "<AREA SHAPE=\"rect\" COORDS=\"$x1,0,$x2,$ymax\" HREF=\"$tabnameweek#$num\" ALT=\"$tmp\" onMouseOver=\"popLayer('$tmp6','$tmp5','','$tabnamedays#$num',1,'$popup_graph_width')\">\n" if (!(-e $fulljour) && $reqmaxtot{$i} != 0);
	 $map_dir[$i] .= "<AREA SHAPE=\"rect\" COORDS=\"$x1,0,$x2,$ymax\" HREF=\"$linkjour\" ALT=\"$tmp\" onMouseOver=\"popLayer('$tmp6','$tmp5','','$linkjour',1,'','$popup_graph_width')\">\n" if (-e $fulljour);
     }
 }

 open(FLY,">$tmpfly$vtmp");
 print FLY "new\n";
 print FLY "size $xmax,$ymax\n";
 print FLY "frect 0,0,0,0,200,200,200\n";

 for ($j=1;$j<($count_week+$bargraph);$j++) {

 $x1 = ($j-1+$linegraph)*$xstep/$factx;
 $x2 = ($j+$linegraph)*$xstep/$factx;

 $y2 = $ymax - ($ystep/$facty * $maxdir_tot{$j,6*$i});
 $y2db = $ymax - ($ystep/$facty * $maxdir_tot{$j,6*$i})+1;

 if ($bargraph == 1) {
    print FLY "frect $x1,$y2,$x2,$ymax,$red[0],$green[0],$blue[0]\n";
    print FLY "rect $x1,$y2,$x2,$ymax,0,0,0\n";
    if ($tridim == 1 && $y2 != $ymax) {

        $x1plus = $x1+$perspec;
        $x2plus = $x2+$perspec;
        $y2plus = $y2-$perspec;
        $y1plus = $ymax - $perspec;

        print FLY "fpoly $red[0],$green[0],$blue[0],$x1,$y2,$x1plus,$y2plus,$x2plus,$y2plus,$x2,$y2\n";
        print FLY "poly 0,0,0,$x1,$y2,$x1plus,$y2plus,$x2plus,$y2plus,$x2,$y2\n";

        print FLY "fpoly $red[0],$green[0],$blue[0],$x2,$ymax,$x2,$y2,$x2plus,$y2plus,$x2plus,$y1plus\n";
        print FLY "poly 0,0,0,$x2,$ymax,$x2,$y2,$x2plus,$y2plus,$x2plus,$y1plus\n";
   }
 }

 if ($linegraph == 1) {
    $y1 = $ymax - ($ystep/$facty * $maxdir_tot{$j+1,6*$i});
    $y1db = $ymax - ($ystep/$facty * $maxdir_tot{$j+1,6*$i})+1;
    print FLY "line $x1,$y2,$x2,$y1,$red[0],$green[0],$blue[0]\n";
    print FLY "line $x1,$y2db,$x2,$y1db,$red[0],$green[0],$blue[0]\n";

    if ($fillgraph == 1) {
      if ($y1 != $y2 || $y1 != $ymax) {
         print FLY "line $x1,$ymax,$x1,$y2,$red[0],$green[0],$blue[0]\n";
         print FLY "line $x2,$ymax,$x2,$y1,$red[0],$green[0],$blue[0]\n";
         print FLY "line $x1,$ymax,$x2,$ymax,$red[0],$green[0],$blue[0]\n";
         $fx1 = $x1+1;
         $fymax = $ymax-1;
         print FLY "fill $fx1,$fymax,$red[0],$green[0],$blue[0]\n";
       }
    }
 }

}

print FLY "transparent 200,200,200\n";
close (FLY);

open(FOO,"$FLY -q -i $tmpfly$vtmp -o $path$dirgraph$dirsep$dirsizename[$i] |");
while( <FOO> ) {print;}
close(FOO);
#unlink($tmpfly$vtmp);

### image pour les abscisses

$xlegend = "$count_week week";
$xlegend .= "s" if ($count_week > 1);
$xlegend .= " (starting $start_date)";

($startday, $startmonth) = split(/ /,$start_date);

$moischiffre = $month_equiv{$startmonth};
$moischiffre--;
$moisvar = $startmonth;
$valmois = $moischiffre;

$valstep = $startday;
$valstep = "0".$valstep if (length($valstep) == 1);


open(FLY,">$tmpfly$vtmp");
print FLY "new\n";
print FLY "size $xmax,$ydecal\n";
 print FLY "frect 0,0,0,0,200,200,200\n";
 $posx = (($xmax/2)-(length($xlegend)*7/2));
 print FLY "string 0,0,0,$posx,$ydecalm,medium,$xlegend\n";

 for ($j=$xstep;$j<$xmax;$j+=$xstep) {

 $valstep = int(($j/$xmax)*(($xmax*$factx/$xstep)*7))+$startday;

 $moisvar = $startmonth;
 $valmois = $moischiffre;

 while  ($valstep > $month_of_year{$moisvar}) {
     $valstep = ($valstep - $month_of_year{$moisvar});
     $valmois++;
     $valmois = 0 if ($valmois > 11);
     $moisvar = $month_nb[$valmois];
 }

 $valstep = "0".$valstep if (length($valstep) == 1);
 $val = "$moisvar/$valstep";
 $posx = $j - length($valstep)*10;
 print FLY "line $j,0,$j,5,0,0,0\n";
 print FLY "string 0,0,0,$posx,10,small,$val\n";

 }

print FLY "transparent 200,200,200\n";
close (FLY);

open(FOO,"$FLY -q -i $tmpfly$vtmp -o $path$dirgraph$dirsep$dirsizenamex[$i] |");
while( <FOO> ) {print;}
close(FOO);
#unlink($tmpfly$vtmp);

### image pour les ordonnees

open(FLY,">$tmpfly$vtmp");
print FLY "new\n";
print FLY "size $xdecal,$ymax\n";
 print FLY "frect 0,0,0,0,200,200,200\n";
 $posy = $ymax - (($ymax/2)-(length("Kbytes")));

 if ($repmax > 1024*1024) {
 print FLY "stringup 0,0,0,5,$posy,medium,Mbytes\n";
 } else {
 print FLY "stringup 0,0,0,5,$posy,medium,Kbytes\n";
 }
 for ($j=$ystep;$j<$ymax;$j+=$ystep) {
 $valstep = int(($ymax - $j) * ($facty/$ystep));
 $valstep /= 1024; # in Kb
 $valstep /= 1024 if ($repmax > 1024*1024);
 $valstep = int($valstep*10)/10;
 $valstep .= ".0" if ($valstep !~ /\./);
 $pos = ($xdecal - length($valstep)*9);
 $posy = $j-5;
 print FLY "line $xdecalm,$j,$xdecal,$j,0,0,0\n";
 print FLY "string 0,0,0,$pos,$posy,small,$valstep\n";
 }

print FLY "transparent 200,200,200\n";
close (FLY);

open(FOO,"$FLY -q -i $tmpfly$vtmp -o $path$dirgraph$dirsep$dirsizenamey[$i] |");
while( <FOO> ) {print;}
close(FOO);
#unlink("$tmpfly$vtmp");

}

#####
for ($nblang=0;$nblang<=$#lang;$nblang++) {

    $tabsize = $path.$lang[$nblang].$dirsep.$dirlist.$dirsep.$dirname[$i].$htmlext;
#    $dirname[$i] =~ s/$htmlext/$gifext/;

    open(SIZEFILE, ">$tabsize") || &error_exit("Error, unable to open $tabsize",1);

        &SizeStats(*SIZEFILE, eval($Lang{$lang[$nblang]}));

#        $dirname[$i] =~ s/$gifext/$htmlext/;
        close(SIZEFILE);
}


}

&update_homepage;

unlink("$tmpfly$vtmp");
#unlink("$tmpfly$vtmp2");

# PDF report

&export_pdf(@list_cmd) if ($enable_pdf == 1);

if ($enable_email == 1 && $emailadr ne '' && $email_weekly == 1 && $week_over == 1) {

    $tmp = $date_last;
    $tmp =~ s/_/ \/ /;

    $subject = "W3Perl Weekly Report - $tmp";
    $from = "webmaster\@".$localdomainename;

    &export_html($date_last,eval($Lang{$lang[0]})) if ($email_html == 1);

    # MIME::Lite module

    &send_email($emailadr,$subject,$html,$filepdf);

    print "Email weekly report sent to $emailadr";
    print " : $filepdf" if ($email_pdf == 1);
    print "\n";
    print "<BR>" if ($ENV{'REQUEST_METHOD'} eq "GET"); 
}


# calculer le temps mis pour le calcul

$datesyst = &ctime(time);
($dayletter,$month,$day,$hourdate,$a,$year) = split(/[ \t\n\[]+/,$datesyst);
($hour,$minute,$second) = split(/:/,$hourdate);

$endrun = "$hour:$minute:$second";

($hour,$min,$sec) = &timetaken($startrun,$endrun);

$endtime = time();

print "Computing took";
print " $hour h" if ($hour > 0);
print " $min min $sec sec\n\n";

print "<P>" if ($ENV{'REQUEST_METHOD'} eq "GET");

&admin_goback if ($ENV{'REQUEST_METHOD'} eq "GET" && $opt_y eq '');

open(FILE,">>$history");
#print FILE "cron-week\t$today\t$startrun\t$endrun\t$min:$sec\n";
printf FILE "$scriptname\t%s\t%s\t%s\t%d:%d:%d\n",$today,$startrun,$endrun,$hour,$min,$sec;
close(FILE);

#################################################################
sub SizeStats {
  local(*FOUT,*L) = @_;

  print FOUT "$doctype\n";
  print FOUT "<HTML><HEAD>\n";
  print FOUT "$charset\n";
  print FOUT "<TITLE>$L{'Graphs_for_dir'} $namerepert</TITLE>\n";
  print FOUT "<!-- Page generated by w3perl - $scriptname $version - $today $hourdate -->\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$sorttablejs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$helpjs\"></script>\n";
  print FOUT "<link rel=\"stylesheet\" type=\"text/css\" href=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dircss$dirsepurl$css_w3perl\">\n";
  print FOUT "<link rel=\"stylesheet\" type=\"text/css\" href=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dircss$dirsepurl$css_help\">\n";

  print FOUT "</HEAD>\n";
  print FOUT "<BODY $backgrd TEXT=\"$custom_text\"  LINK=\"$custom_link\" VLINK=\"$custom_vlink\">\n";
  print FOUT "<H2>$L{'Graphs_for'} $L{'directory'} $namerepert</H2><P>\n";
#  print FOUT "<P><HR><P>\n";

  &help_div(*FOUT);

  $map2 = $map_dir[$i];

  $map2 =~ s/Requests/$L{'Requests'}/g;
  $map2 =~ s/Accesses/$L{'Accesses'}/g;
  $map2 =~ s/Hosts/$L{'Hosts'}/g;
  $map2 =~ s/Traffic/$L{'Traffic'}/g;

  print FOUT "<MAP NAME=\"dir_week\">\n";
  print FOUT "$map2\n";
  print FOUT "</MAP>\n";

  print FOUT "<DIV CLASS=\"item_page\">-&nbsp;$L{'Number_of_req_by_weeks'}</DIV><P>\n";

#if  (-x $FLY) {
  print FOUT "<TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0>\n";
  print FOUT "<TR>\n";
  print FOUT "<TD><IMG WIDTH=$xdecal HEIGHT=$ymax SRC=\"..$dirsepurl..$dirsepurl$dirgraph$dirsepurl$dirnamey[$i]\" ALT=\"$dirnamey[$i]\"></TD>\n";
  print FOUT "<TD><IMG WIDTH=$xmax HEIGHT=$ymax SRC=\"..$dirsepurl..$dirsepurl$dirgraph$dirsepurl$dirname[$i]$gifext\" ALT=\"$dirname[$i]\" USEMAP=\"#dir_week\" BORDER=0></TD>\n";
  print FOUT "</TR><TR><TD></TD>\n";
  print FOUT "<TD><IMG WIDTH=$xmax HEIGHT=$ydecal SRC=\"..$dirsepurl..$dirsepurl$dirgraph$dirsepurl$dirnamex[$i]\" ALT=\"$dirnamex[$i]\"></TD>\n";
  print FOUT "</TR>\n";
  print FOUT "</TABLE>\n";
#}
  
#  print FOUT "<BR><B>$L{'Number_of_req_by_weeks'}</B></CENTER>\n";
#  print FOUT "<P><HR><P>\n";

  print FOUT "<P><DIV CLASS=\"item_page\">-&nbsp;$L{'Data_traffic_by_weeks'}</DIV><P>\n";

#if  (-x $FLY) {
  print FOUT "<TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0>\n";
  print FOUT "<TR>\n";
  print FOUT "<TD><IMG WIDTH=$xdecal HEIGHT=$ymax SRC=\"..$dirsepurl..$dirsepurl$dirgraph$dirsepurl$dirsizenamey[$i]\" ALT=\"$dirsizenamey[$i]\"></TD>\n";
  print FOUT "<TD><IMG WIDTH=$xmax HEIGHT=$ymax SRC=\"..$dirsepurl..$dirsepurl$dirgraph$dirsepurl$dirsizename[$i]\" ALT=\"$dirsizename[$i]\" USEMAP=\"#dir_week\" BORDER=0></TD>\n";
  print FOUT "</TR><TR><TD></TD>\n";
  print FOUT "<TD><IMG WIDTH=$xmax HEIGHT=$ydecal SRC=\"..$dirsepurl..$dirsepurl$dirgraph$dirsepurl$dirsizenamex[$i]\" ALT=\"$dirsizenamex[$i]\"></TD>\n";
  print FOUT "</TR>\n";
  print FOUT "</TABLE>\n";
#}

#  print FOUT "<BR><B>$L{'Data_traffic_by_weeks'}</B></CENTER>\n";
#  print FOUT "<P>\n";
  print FOUT "</BODY></HTML>\n";
}

#################################################################
###                     weekly  HTML page                     ###
#################################################################

sub WeekStats {
  local(*FOUT,*L,$nblang) = @_;
  print FOUT "$doctype\n";
  print FOUT "<HTML><HEAD>\n";
  print FOUT "$charset\n";
  print FOUT "<TITLE>$L{'Stats_about_weeks'}</TITLE>\n";
  print FOUT "<!-- Page generated by w3perl - $scriptname $version - $today $hourdate -->\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$calendarjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$sorttablejs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$helpjs\"></script>\n";
  print FOUT "<SCRIPT LANGUAGE=\"JavaScript\" type=\"text/javascript\">\n";
  print FOUT "var todaydate=new Date()\n";
  print FOUT "var curmonth=todaydate.getMonth()+1 //get current month (1-12)\n";
  print FOUT "var curyear=todaydate.getFullYear() //get current year\n";
  print FOUT "</SCRIPT>\n";
  print FOUT "<link rel=\"stylesheet\" type=\"text/css\" href=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dircss$dirsepurl$css_calendar\">\n";
  print FOUT "<link rel=\"stylesheet\" type=\"text/css\" href=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dircss$dirsepurl$css_w3perl\">\n";
  print FOUT "<link rel=\"stylesheet\" type=\"text/css\" href=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dircss$dirsepurl$css_help\">\n";
  print FOUT "</HEAD>\n";
  print FOUT "<BODY $backgrd TEXT=\"$custom_text\"  LINK=\"$custom_link\" VLINK=\"$custom_vlink\">\n";

  &help_div(*FOUT);

  print FOUT "<CENTER>\n";
  print FOUT "<TABLE BORDER=0 WIDTH=\"100%\">\n";
  print FOUT "<TR>\n";
  print FOUT "<TD ALIGN=LEFT VALIGN=MIDDLE WIDTH=\"20%\">";

  print FOUT "<DIV ID=\"calendarspace\">\n";
  print FOUT "<SCRIPT LANGUAGE=\"JavaScript\" type=\"text/javascript\">\n";
  print FOUT "document.write(buildCal(curmonth ,curyear, \"main\", \"month\", \"daysofweek\", \"weeks\", 1,1,'index','@list'));\n";
  print FOUT "</SCRIPT>\n";
  print FOUT "</DIV>\n";

  print FOUT "</TD>\n";
  print FOUT "<TD ALIGN=CENTER WIDTH=\"60%\">\n";

  print FOUT "<TABLE BORDER=1 BGCOLOR=\"#000000\">\n<TR>\n<TD BGCOLOR=\"#FFEECC\" ALIGN=CENTER>\n";
  print FOUT "<H1>".uc(&noaccentinhtml($L{'Stats'}))." ".uc(&noaccentinhtml($L{'about'}))." ".uc(&noaccentinhtml($L{'Weeks'}))."</H1>\n";
  print FOUT "</TD>\n</TR>\n</TABLE>\n";
  
  print FOUT "</TD>\n";
  print FOUT "<TD ALIGN=RIGHT VALIGN=MIDDLE WIDTH=\"20%\">\n";

  print FOUT "<B><A HREF=\"$tabnameweek\" TITLE=\"$L{'About_weeks'}\">$L{'About_weeks'}</A></B><BR><BR>\n";

  if ($precision > 2 && $#selecrepert != -1) {
      print FOUT "<B><A HREF=\"..$dirsepurl$dirlist$dirsepurl$filereport\" TITLE=\"$L{'Directories_graphs'}\">$L{'Directories_graphs'}</A></B><br><br>\n";
 }
  print FOUT "</TD>\n";
  print FOUT "</TR>\n";
  print FOUT "</TABLE>\n";
  print FOUT "</CENTER>\n";

  print FOUT "<HR SIZE=5><P>\n";

  $map2 = $map;
  $map2 =~ s/\/\//\/$lang[$nblang]\//g;
  $map2 =~ s/Requests/$L{'Requests'}/g;
  $map2 =~ s/Accesses/$L{'Accesses'}/g;
  $map2 =~ s/Hosts/$L{'Hosts'}/g;
  $map2 =~ s/Traffic/$L{'Traffic'}/g;

  print FOUT "<MAP NAME=\"week1\">\n";
  print FOUT "$map2\n";
  print FOUT "</MAP>\n";

  print FOUT "<MAP NAME=\"week2\">\n";
  print FOUT "$map2\n";
  print FOUT "</MAP>\n";

#  print "$map\n";

  if ($precision > 2) {
      print FOUT "<A NAME=\"utilisateur\"></A>\n";

#if  (-x $FLY) {
      if (-f $outfile1) {
	  print FOUT "<CENTER><TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0>\n";
	  print FOUT "<TR>\n";
	  print FOUT "<TD><IMG WIDTH=$xdecal HEIGHT=$ymax SRC=\"$linkoutfile1y\" ALT=\"y\"></TD>\n";
	  print FOUT "<TD><IMG WIDTH=$xmax HEIGHT=$ymax SRC=\"$linkoutfile1\" ALT=\"graph1\" USEMAP=\"#week1\" BORDER=0></TD>\n";
	  print FOUT "</TR><TR><TD></TD>\n";
	  print FOUT "<TD><IMG WIDTH=$xmax HEIGHT=$ydecal SRC=\"$linkoutfile1x\" ALT=\"x\"></TD>\n";
	  print FOUT "</TR>\n";
	  print FOUT "<TR><TD></TD>\n";
	  print FOUT "<TD ALIGN=CENTER>\n";
	  
	  print FOUT "<TABLE CELLPADDING=0 CELLSPACING=0 BORDER=0><TR>\n";
	  print FOUT "<TD><IMG SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[0]\" ALT=\"$gcolor[0]\"></TD>\n";
	  print FOUT "<TD>&nbsp; $L{'Number_of'} $L{'Conn_Mach'}</TD>\n";
	  print FOUT "</TR><TR>\n";
	  print FOUT "<TD><IMG SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\"></TD>\n";
	  print FOUT "<TD>&nbsp; $L{'Number_of'} $L{'New_Mach'}</TD>\n";
	  if ($locallog == 1) {
	      print FOUT "</TR><TR>\n";
	      print FOUT "<TD><IMG SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[2]\" ALT=\"$gcolor[2]\"></TD>\n";
	      print FOUT "<TD>&nbsp;  $L{'Number_of'} $L{'Mach_Dom'} $localdomainename</TD>\n";
	  }
	  print FOUT "</TR></TABLE>\n";
	  
	  print FOUT "</TD></TR>\n";
	  print FOUT "</TABLE></CENTER>\n";
#}
      }
      
      print FOUT "<BR>\n";
  }

  print FOUT "<P><HR><P><CENTER>\n";
  
  print FOUT "<TABLE CLASS=\"sortable_base\" ID=\"day-main\">\n";
  print FOUT "<TR>\n";
  print FOUT "<TH>$L{'Date'}</TH>\n";
  print FOUT "<TH>$L{'Requests'}</TH>\n" if ($mail_format == 0 && $ftp_format == 0);
  print FOUT "<TH>$L{'Files'}</TH>\n" if ($ftp_format == 1);
  print FOUT "<TH>$L{'Email'}</TH>\n" if ($mail_format == 1);
  print FOUT "<TH>$L{'Date'}</TH><TH>$L{'Accesses'}</TH>\n" if ($ftp_format == 0 && $mail_format == 0);
  if ($notrafic == 0) {
      print FOUT "<TH>$L{'Date'}</TH><TH>$L{'Traffic'}";
      if ($trisize[0] > (1024*1024*1024)) {
	  print FOUT "&nbsp;($L{'Gb'})";
      } elsif ($trisize[0] > (1024*1024)) {
	  print FOUT "&nbsp;($L{'Mb'})";
      } elsif ($trisize[0] > 1024) {
	  print FOUT "&nbsp;($L{'Kb'})";
      }
      print FOUT "&nbsp;</TH>\n";
  }
  print FOUT "<TH>$L{'Date'}</TH>\n";
  print FOUT "<TH>$L{'Hosts'}</TH>\n";
  print FOUT "</TR>\n";

  for ($i=0;$i<=$topten;$i++) {
      if ($trireq[$i] ne '') {
	  print FOUT "<TR>\n";
	  print FOUT "<TD><I>";
	  ($val1,$val2) = split(/\s-\s/,$trireqdate[$i]);
	  ($tmp1,$tmp2,$tmp3) = split(/\s+/,$val1);
	  $tmp = $tmp3."-".$tmp2."-".$tmp1."_";
	  ($tmp1,$tmp2,$tmp3) = split(/\s+/,$val2);
	  $tmp .= $tmp3."-".$tmp2."-".$tmp1;
	  $linkjour = "..".$dirsepurl.$dirdate.$dirsepurl.$tmp.$dirsepurl.$menu;
	  $fulljour = $path.$lang[$nblang].$dirsep.$dirdate.$dirsep.$tmp.$dirsep.$menu;
	  $tmp = $trireqdate[$i];
	  $tmp =~ s/\s/&nbsp;/g;
	  print FOUT "<A HREF=\"$linkjour\">" if (-f $fulljour);
	  print FOUT "$tmp";
	  print FOUT "</A>" if (-f $fulljour);
	  print FOUT "</I></TD>\n";
	  $tmp = int(40*$trireq[$i]/$trireq[0]) if ($trireq[0] != 0);
	  $tmp = 1 if ($tmp == 0);
	  print FOUT "<TD CLASS=\"left\"><IMG WIDTH=$tmp SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[0]\" HEIGHT=$square ALT=\"$gcolor[0]\">&nbsp;$trireq[$i]&nbsp;</TD>\n";
#     }
#     if ($triacc[$i] ne '') {
	  if ($ftp_format == 0 && $mail_format == 0) {
	      ($val1,$val2) = split(/\s-\s/,$triaccdate[$i]);
	      ($tmp1,$tmp2,$tmp3) = split(/\s+/,$val1);
	      $tmp = $tmp3."-".$tmp2."-".$tmp1."_";
	      ($tmp1,$tmp2,$tmp3) = split(/\s+/,$val2);
	      $tmp .= $tmp3."-".$tmp2."-".$tmp1;
	      $linkjour = "..".$dirsepurl.$dirdate.$dirsepurl.$tmp.$dirsepurl.$menu;
	      $fulljour = $path.$lang[$nblang].$dirsep.$dirdate.$dirsep.$tmp.$dirsep.$menu;
	      $tmp = $triaccdate[$i];
	      $tmp =~ s/\s/&nbsp;/g;
	      print FOUT "<TD>&nbsp;<I>";
	      print FOUT "<A HREF=\"$linkjour\">" if (-f $fulljour);
	      print FOUT "$tmp\n";
	      print FOUT "</A>" if (-f $fulljour);
	      print FOUT "</I></TD>\n";
	      $tmp = int(40*$triacc[$i]/$triacc[0]) if ($triacc[0] != 0);
	      $tmp = 1 if ($tmp == 0);
	      print FOUT "<TD CLASS=\"left\"><IMG WIDTH=$tmp SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" HEIGHT=$square ALT=\"$gcolor[1]\">&nbsp;$triacc[$i]&nbsp;</TD>\n";
	  }
	  if ($notrafic == 0) {
	      ($val1,$val2) = split(/\s-\s/,$trisizedate[$i]);
	      ($tmp1,$tmp2,$tmp3) = split(/\s+/,$val1);
	      $tmp = $tmp3."-".$tmp2."-".$tmp1."_";
	      ($tmp1,$tmp2,$tmp3) = split(/\s+/,$val2);
	      $tmp .= $tmp3."-".$tmp2."-".$tmp1;
	      $linkjour = "..".$dirsepurl.$dirdate.$dirsepurl.$tmp.$dirsepurl.$menu;
	      $fulljour = $path.$lang[$nblang].$dirsep.$dirdate.$dirsep.$tmp.$dirsep.$menu;
	      $tmp = $trisizedate[$i];
	      $tmp =~ s/\s/&nbsp;/g;
	      print FOUT "<TD>&nbsp;<I>";
	      print FOUT "<A HREF=\"$linkjour\">" if (-f $fulljour);
	      print FOUT "$tmp";
	      print FOUT "</A>" if (-f $fulljour);
	      print FOUT "</I></TD>\n";
	      $tmp2 = $trisize[$i];
	      $tmp2 = $tmp2/(1024*1024*1024) if ($trisize[0] > (1024*1024*1024));
	      $tmp2 = $tmp2/(1024*1024) if ($trisize[0] > (1024*1024) && $trisize[0] <= (1024*1024*1024));
	      $tmp2 = $tmp2/1024 if ($trisize[0] > 1024 && $trisize[0] <= (1024*1024));
	      $tmp = int(40*$trisize[$i]/$trisize[0]) if ($trisize[0] != 0);
	      $tmp = 1 if ($tmp == 0);
	      $tmp2 = int($tmp2*10)/10;
	      print FOUT "<TD CLASS=\"left\"><IMG WIDTH=$tmp SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[3]\" HEIGHT=$square ALT=\"$gcolor[3]\">&nbsp;$tmp2&nbsp;</TD>\n";
	  }

	  ($val1,$val2) = split(/\s-\s/,$trihostdate[$i]);
	  ($tmp1,$tmp2,$tmp3) = split(/\s+/,$val1);
	  $tmp = $tmp3."-".$tmp2."-".$tmp1."_";
	  ($tmp1,$tmp2,$tmp3) = split(/\s+/,$val2);
	  $tmp .= $tmp3."-".$tmp2."-".$tmp1;
	  $linkjour = "..".$dirsepurl.$dirdate.$dirsepurl.$tmp.$dirsepurl.$menu;
	  $fulljour = $path.$lang[$nblang].$dirsep.$dirdate.$dirsep.$tmp.$dirsep.$menu;
	  $tmp = $trihostdate[$i];
	  $tmp =~ s/\s/&nbsp;/g;
	  print FOUT "<TD>&nbsp;<I>";
	  print FOUT "<A HREF=\"$linkjour\">" if (-f $fulljour);
	  print FOUT "$tmp";
	  print FOUT "</A>" if (-f $fulljour);
	  print FOUT "</I></TD>\n";
	  $tmp = int(40*$trihost[$i]/$trihost[0]) if ($trihost[0] != 0);
	  $tmp = 1 if ($tmp == 0);
	  print FOUT "<TD CLASS=\"left\"><IMG WIDTH=$tmp SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[4]\" HEIGHT=$square ALT=\"$gcolor[4]\">&nbsp;$trihost[$i]&nbsp;</TD>\n";
	  
	  print FOUT "</TR>\n";
      }
  }
  
  print FOUT "</TABLE></CENTER><P><HR><P>\n";

  print FOUT "<A NAME=\"requete\"></A>\n";

  if (-f $outfile2) {
#if (-x $FLY)  {
      print FOUT "<CENTER><TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0>\n";
      print FOUT "<TR>\n";
      print FOUT "<TD><IMG WIDTH=$xdecal HEIGHT=$ymax SRC=\"$linkoutfile2y\" ALT=\"y\"></TD>\n";
      print FOUT "<TD><IMG WIDTH=$xmax HEIGHT=$ymax SRC=\"$linkoutfile2\" ALT=\"graph2\" USEMAP=\"#week2\" BORDER=0></TD>\n";
      print FOUT "</TR><TR><TD></TD>\n";
      print FOUT "<TD><IMG WIDTH=$xmax HEIGHT=$ydecal SRC=\"$linkoutfile2x\" ALT=\"x\"></TD>\n";
      print FOUT "</TR>\n";
      print FOUT "<TR><TD></TD>\n";
      print FOUT "<TD ALIGN=CENTER>\n";

      print FOUT "<TABLE CELLPADDING=0 CELLSPACING=0 BORDER=0><TR>\n";
      print FOUT "<TD><IMG SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[0]\" ALT=\"$gcolor[0]\"></TD>\n";

#  print FOUT "<TD>&nbsp; $L{'Number_of'} ";
      print FOUT "<TD>&nbsp;";
      print FOUT "$L{'requests'}" if ($mail_format == 0 && $ftp_format == 0);
      print FOUT "$L{'File'}" if ($ftp_format == 1);
      print FOUT "$L{'Email'}" if ($mail_format == 1);
      print FOUT "</TD>\n";
#  print FOUT "<TD>&nbsp; $L{'No_Ttl_Req_Week'}</TD>\n";
      print FOUT "</TR>\n";
      if ($mail_format == 0 && $ftp_format == 0) {
	  print FOUT "<TR>";
	  print FOUT "<TD><IMG SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\"></TD>\n";
	  print FOUT "<TD>&nbsp; $L{'Number_of'} $L{'accesses'}</TD>\n";
	  print FOUT "</TR>";
      }
      if ($locallog == 1) {
	  print FOUT "<TR>\n";
	  print FOUT "<TD><IMG SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[2]\" ALT=\"$gcolor[2]\"></TD>\n";
#      print FOUT "<TD>&nbsp; $L{'NoReq'} ";
	  print FOUT "<TD>&nbsp;";
	  print FOUT "$L{'Requests'}" if ($mail_format == 0 && $ftp_format == 0);
	  print FOUT "$L{'File'}" if ($ftp_format == 1);
	  print FOUT "$L{'Email'}" if ($mail_format == 1);
	  print FOUT " $L{'from_dom'} $localdomainename</TD>\n";
      print FOUT "</TR>\n";
      }
      print FOUT "</TABLE>\n";
  
      print FOUT "</TD></TR>\n";
      print FOUT "</TABLE></CENTER>\n";
  }

  print FOUT "</BODY></HTML>\n";
  close FOUT;
}

#############################################################################

sub WeekHeader {
  local(*FOUT,*L) = @_;
  
  print FOUT "$doctype\n";
  print FOUT "<HTML><HEAD>\n";
  print FOUT "$charset\n";
  print FOUT "<TITLE>$L{'About_weeks'}</TITLE>\n";
  print FOUT "<!-- Page generated by w3perl - $scriptname $version - $today $hourdate -->\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$sorttablejs\"></script>\n";
  print FOUT "<link rel=\"stylesheet\" type=\"text/css\" href=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dircss$dirsepurl$css_w3perl\">\n";
  print FOUT "<link rel=\"stylesheet\" type=\"text/css\" href=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dircss$dirsepurl$css_help\">\n";

  print FOUT "</HEAD>\n";
  print FOUT "<BODY $backgrd TEXT=\"$custom_text\"  LINK=\"$custom_link\" VLINK=\"$custom_vlink\">\n";
  print FOUT "<H2> $L{'About_weeks'}</H2><P>\n";
  print FOUT "<P><HR><P>\n";
  print FOUT "<A HREF=\"..$dirsepurl..$dirsepurl$dircsv$dirsepurl$tabnamecsv$csvext\" TITLE=\"Export in CSV\"><IMG WIDTH=\"40\" HEIGHT=\"40\" SRC=\"..$dirsepurl..$dirsepurl$homeicons$dirsepurl$icon_csv\" BORDER=0 ALT=\"CSV\"></A>" if (-f "$path$dircsv$dirsep$tabnamecsv$csvext");
  print FOUT "<TABLE CLASS=\"sortable\" ID=\"week-size\">\n";
  print FOUT "<TR>\n";
  print FOUT "<TH>$L{'Date'}</TH>\n";
  print FOUT "<TH>$L{'Hosts'}</th>\n";
  print FOUT "<TH>$L{'New_Hosts'}</th>\n";
  print FOUT "<TH>$L{'Domain_Hosts'}</th>\n";
  print FOUT "<TH>$L{'Requests'}</th>\n";
  print FOUT "<TH>$L{'Accesses'}</th>\n" if ($ftp_format == 0 && $mail_format == 0);
  print FOUT "<TH>$L{'DomReq'}</th>\n";
  print FOUT "</TR>\n";
}

##############################################################################


sub LoadDailyData {
    local($i);

    $file_daily = "$path$lang[0]$dirsep$dirdate$dirsep$dirresume$dirsep$listdailysites$txtext";

    if (-f $file_daily) {
	open(FILEDAILY,"$file_daily") || &error_exit("Error, unable to open $file_daily",1);
	while (<FILEDAILY>) {
	    chop;
	    ($adresse,$val1,$val2,$val3) = split(/\t/);
	    $serverjour{$adresse} += $val1;
	    $hostluesday{$adresse} += $val2;
	    $serversizejour{$adresse} += $val3;
	    $domsizejour += $val3 if ($adresse =~ /$localdomaine$/);
	}
	close(FILEDAILY);
	
	$found = 0;
	$file_daily = "$path$lang[0]$dirsep$dirdate$dirsep$dirresume$dirsep$listdailypages$txtext";
	open(FILEDAILY,"$file_daily") || &error_exit("Error, unable to open $file_daily",1);
	while (<FILEDAILY>) {
	    chop;
	    ($page,$val1) = split(/\t/);
	    $found = 1 if ($val1 eq '');
	    if ($found == 0) {
		$pagesluesday{$page} += $val1;
		$pageuniquejour++ unless ($seen_server{$page}++);
	    } else {
		$filetypejour{$page} += $val1;
	    }
	}
	close(FILEDAILY);
	
	$found = 0;

	$file_daily = "$path$lang[0]$dirsep$dirdate$dirsep$dirresume$dirsep$listdailyscripts$txtext";
	open(FILEDAILY,"$file_daily") || &error_exit("Error, unable to open $file_daily",1);
	while (<FILEDAILY>) {
	    chop;
	    ($page,$val1,$val2) = split(/\t/);
	    $found = 1 if ($val1 eq '');
	    if ($found == 0) {
		$scriptday{$page} += $val1;
		$scriptuniquejour++ unless ($seen_server{$page}++);
		$script_day += $val1; # unless ($seen_server{$page}++);
#		print "$page - $val1 - $val2 : $scriptday{$page} - $scriptuniquejour - $script_day\n";
	    } else {
		$client_day_error{$page} += $val1;
		$client_day_refer{$page} = $val2;
	    }
	}
	close(FILEDAILY);
	
	$file_daily = "$path$lang[0]$dirsep$dirdate$dirsep$dirresume$dirsep$listdailytrafic$txtext";
	if (-f $file_daily) {
	    open(FILEDAILY,"$file_daily") || &error_exit("Error, unable to open $file_daily",1);
	    while (<FILEDAILY>) {
		chop;
		($page,$val1) = split(/\t/);
		$dailysizepage{$page} += $val1;
	    }
	    close(FILEDAILY);
	}

	$file_daily = "$path$lang[0]$dirsep$dirdate$dirsep$dirresume$dirsep$listdailydir$txtext";
	open(FILEDAILY,"$file_daily") || &error_exit("Error, unable to open $file_daily",1);
	while (<FILEDAILY>) {
	    chop;
	    ($rootrepert,$val1,$val2,$val3) = split(/\t/);
	    $freqjourrac{$rootrepert} += $val1;
	    $freqjourrachtml{$rootrepert} += $val2;
	    $sizejourrachtml{$rootrepert} += $val3;
	    $tothtmlsizejour += $val3;
	}
	close(FILEDAILY);

	$file_daily = "$path$lang[0]$dirsep$dirdate$dirsep$dirresume$dirsep$listdailycountries$txtext";
	open(FILEDAILY,"$file_daily") || &error_exit("Error, unable to open $file_daily",1);
	while (<FILEDAILY>) {
	    chop;
	    ($pays,$val1,$val2,$val3) = split(/\t/);
	    $paysjour{$pays} += $val1;
	    $payshtmljour{$pays} += $val2;
	    $paysjourlist{$pays} += $val3;
	    $paysuniquejour++ unless ($seen_server{$pays}++);
	}
	close(FILEDAILY);
	
	$file_daily = "$path$lang[0]$dirsep$dirdate$dirsep$dirresume$dirsep$listdailyfiletype$txtext";
	open(FILEDAILY,"$file_daily") || &error_exit("Error, unable to open $file_daily",1);
	while (<FILEDAILY>) {
	    chop;
	    ($val1,$val2,$val3,$val4) = split(/\t/);
	    $extfilenb{$val1} = $val3;
	    $tmp = $extfilenb{$val1};
	    $tmp = 0 if ($extfilenb{$val1} eq '');
	    $zoneextjour[$tmp] += $val4;
#	    $zoneextjour[$extfilenb{$val1}] += $val3;
	    $downloadjour{$val1} += $val4;
	    $filetypenb{$val1} += $val2;
	    push(@listext,$val1) unless ($seen_server{$val1}++);
	}
	close(FILEDAILY);
    }
	    
    $file_daily = "$path$lang[0]$dirsep$dirdate$dirsep$dirresume$dirsep$listdailyrefer$txtext";
    if (-f $file_daily) {
	open(FILEDAILY,"$file_daily");
	while (<FILEDAILY>) {
	    chop;
	    ($val1,$val2,$val3) = split(/\t/);
	    if ($val1 eq "A") {
		$nbredayref{$val2} += $val3;
#		    $uniqueday++;
	    }
	    
	    if ($val1 eq "B") {
		$nbrefullday{$val2} += $val3;
		    $uniquenbrefullday++;
	    }
	    
	    if ($val1 eq "C") {
		$occurday{$val2} += $val3;
		    $uniqueurlday++;
	    }
	    
	    if ($val1 eq "D") {
		push(@wordsday,$val2) unless ($seen_server{$val2}++);
		$wday{$val2} += $val3;
	    }
		    
	    if ($val1 eq "E") {
		$keyshday{$val2} += $val3;
	    }
	}
	close(FILEDAILY);
    }

    $file_daily = "$path$lang[0]$dirsep$dirdate$dirsep$dirresume$dirsep$listdailyagent$txtext";
    if (-f $file_daily) {
#	print "$file_daily\n";
	open(FILEDAILY,"$file_daily") || &error_exit("Error, unable to open $file_daily",1);
	$tmp = <FILEDAILY>;
	chop($tmp);
	
	($val1,$val2) = split(/\t/,$tmp);
	$countday += $val2;

	while (<FILEDAILY>) {
	    chop;
	    ($val1,$val2,$val3) = split(/\t/);
	    if ($val1 eq "A") {
		$nbrebrowserday{$val2} += $val3;
		$uniqueday++ unless ($seen_server{"A $val2"}++);
	    }
	    
	    if ($val1 eq "B") {
		$nbreosday{$val2} += $val3;
		$uniqueosday++ unless ($seen_server{"B $val2"}++);
	    }

	    if ($val1 eq "C") {
		$nbagent++;
		if ($idx_browser{$val2} eq '') {
		    $idx_browser{$val2} = $nbagent;
		} else {
		    $nbagent = $idx_browser{$val2};
		}
		$browserday[$nbagent] = $val2;
		$nbreday{$browserday[$nbagent]} += $val3;
#		print "ZZ $nbagent - $browserday[$nbagent] - $nbreday{$browserday[$nbagent]} - $val2 - $val3\n" if ($browserday[$nbagent] =~ /Opera/i);
	    }
	}
	
	close(FILEDAILY);
    }
}


##############################################################################

sub WeekFooter {
  local(*FOUT) = $_[0];
  print FOUT "</TABLE>\n";
  print FOUT "<P><HR><P>\n";
  print FOUT "</BODY></HTML>\n";
}
