#!/usr/bin/perl
# <plaintext>  just in case you look at this via a browser

#########################################################################
####                                                                #####
####                    REFERER STATS                               #####
####                                                                #####
####                                                                #####
####    domisse@w3perl.com                   version 28/10/2007     #####
####                                                                #####
#########################################################################

$version = "3.01";
$verdate = "28/10/07";

# grtot no more displayed => to remove ?

## valeur a modifier par fixperlpath.pl

require "flush.pl";
require "/home/web/cgi-bin/w3perl/libw3perl.pl";

$filerefday = $path.$dirinc.$dirsep."refday";
$datafile = "time-refer";
$fullday = 1;
$bookmark_url = "favicon.ico";
$increfbookmark = "refbookmark";

$dirjs = "js";
$dircss = "css";

$sorttablejs = "sorttable.js";
$helpjs = "help.js";

$css_w3perl = "w3perl.css";
$css_help = "help.css";


# Check upgrade have been done
# 3.00
#&CheckConfigUpgrade("icon_destination");
&CheckConfigUpgrade("dirxml");

print "Referer stats : $version\n";
print "<P>" if ($ENV{'REQUEST_METHOD'} eq "GET");

if ($logfile_format eq "FTP" || $logfile_format eq "Exim" || $logfile_format eq "Sendmail" || $logfile_format eq "Postfix") {
    &error_exit("No referer stats can be done for FTP logfile\n",1);
}

# Retrieve external log
&retrieve_external_logfile($fileroot,$remote_host_log) if ($retrieve_external_log == 1 && $opt_w eq '');

#$server_ip = gethostbyname($localserver);

# debut de l'initialisation

if ($logfile_format ne "W3C") {
    if ($struct_logfile !~ /\%refer/ || $referlog eq '') {
        $msg = "The logfile format you have defined ($logfile_format) don't have agent data\n";
        $msg .= "If your logfile contain agent stat, use a format which include such data (like ECLF)\n";
	&error_exit($msg,0);
    }
}

if (($zipcut == 3) || ($struct_compressed_logfile =~ /\%hour/ && $struct_compressed_logfile =~ /\%min/ && $struct_compressed_logfile =~ /\%sec/)) {
    $filetmpzip = &find_last_log($fileroot,$prefixlog);
    $first_logfile = &find_first_log($fileroot,$prefixlog);
   if ($filetmpzip == -1 || $first_logfile == -1) {
	if (!(-f "$fileroot$prefixlog")) {
	    &error_exit("No file found in $fileroot\n",1);
	} else {
	    $zip = 0;
	    $zipcut = 0;
	}
    }
    if ($zipcut == 3) {
	$tmp = $filetmpzip;
	$filetmpzip =  $first_logfile;
	$first_logfile = $tmp;
    }
    $rotate_index = $max_rotate_index;
   if ($rotate_index !~ /^\d+$/) {
	&error_exit("Found a logfile I don't understand $prefixlog$rotate_index. Index should be a number",1);
    }
}

### NEWNEW
$prefixlog = $referlog if ($file ne $filerefer && $referlog ne '');

$starttime = time();

# calculer le temps mis pour le calcul
$startrun = "$hour:$minute:$second";

#$yesterday = &yesterday_date($day,$countmonth,$year);

$localrefer = 0;
$year_now = $year;
$timesec = time;
#&get_time($timesec);
($date,$datehour,$datemisc) = &get_time($timesec);
($jour_of_year_end) = split(/ /,$datemisc);

if ($struct_compressed_logfile !~ /\%hour/ && $struct_compressed_logfile !~ /\%min/ && $struct_compressed_logfile !~ /\%sec/) {
if ($zipcut == 2) {
$monthtmp = $month;
#$filetmpzip = $fileroot;
$month = $month_equiv{$month};
$month = "0".$month if (length($month) == 1 && $struct_compressed_logfile !~ /\%smallmonth/);
   $lettermonth = $month_nb[$month-1];
$smallyear = $year - int($year/100)*100;       
$smallyear = "0".$smallyear if (length($smallyear) == 1);
$smallday = $day;
$smallday = substr($smallday,1,2) if ($smallday < 10);
$smallmonth = $month;
$datetmpzip = $year.$month.$day;
$date_filename = $day.$dirsepurl.$lettermonth.$dirsepurl.$year; # Format XX/Mmm/YYYY
$filetmpzip = &Get_LogfileName($fileroot);
#for ($i=1;$i<=$#compressed_logfile_fields;$i++) {

#    $compressed_logfile_fields[$i] =~ s/\%/\$/;
#    $filetmpzip .= eval($compressed_logfile_fields[$i]).$compressed_sep_fields[$i];
#}
    $filetmpzip_day .= &nbday($date_filename);
$filetmpzip = $filetmpzip.$zipext if ($zip == 1);
$month = $monthtmp;
}
}

$listdailyrefer = "liste_daily_refer";
$listdailykeyword = "liste_daily_keyword";
$w3c_refer = 0;
$add_fields_logfile = 0;

#################################################################
###            parsing the command line option                ###
#################################################################

if ($opt_h == 1) {
      print STDOUT "Usage : \n";
      print STDOUT "        -b           : don't run incremental mode\n";
      print STDOUT "        -c <file>    : load configuration file\n";
      print STDOUT "        -d <nbdays>  : number of days to scan (Extended NCSA logifle only)\n"; 
      print STDOUT "        -l <";
      for ($i=0;$i<$#lang;$i++) {
      print STDOUT "$lang[$i],";
      } 
      print STDOUT "$lang[$#lang]";
      print STDOUT ">   : language output (comma split)\n";          
      print STDOUT "        -i <file>    : input logfile\n";
      print STDOUT "        -f           : local reference include\n";
      print STDOUT "        -p <page>    : referer for this page\n";
      print STDOUT "        -t <toplist> : display only toplist files\n";
      print STDOUT "        -x           : show default value for flag options\n";
      print STDOUT "        -v           : version\n";
      print STDOUT "        -z           : zip logfiles\n";        
      print STDOUT "\n";
      exit;
}


if ($opt_v == 1) {
      print STDOUT "cron-refer.pl version $version $verdate\n";
      exit;
}

#if ($opt_p ne '') {
#$pageselect = $opt_p;

#if (index($pageselect,'/') != 0) {
#print STDERR "Your page $opt_p should start from your root server\n";
#print STDERR "Try /$pageselect instead of $pageselect\n";
#exit;
#}
#$pageselect .= $defaulthomepage if (substr($pageselect,length($pageselect)-1) eq "/");
#}

if ($opt_x == 1) {
      print STDOUT "Default : \n";
      print STDOUT "          -b            : ";
      &id($opt_b);
      print STDOUT "          -c            : $configfile\n";
      print STDOUT "          -d <nbdays>   : $nbdays\n"; 
      print STDOUT "          -l <language> : ";
      for ($i=0;$i<$#lang;$i++) {
      print STDOUT "$lang[$i],";
      }
      print STDOUT "$lang[$#lang]\n";      
      print STDOUT "          -i <file>     : $filerefer\n";
      print STDOUT "          -f            : ";
      &id($localrefer);
      print STDOUT "          -p <page>     : <none>\n";
      print STDOUT "          -t <toplist>  : $topten\n";
      print STDOUT "          -v            : $version\n";
      print STDOUT "          -z            : ";
      &id($opt_z);      
      exit;
}

if ($opt_z ne '') {
$zip = $opt_z;
}

if ($opt_d ne '') {
$nbdays = $opt_d;
print "Only extended NSCA logfile !!!\nThis switch \"-d\" has no effect.\n" if ($file ne $fileagent);
}

if ($opt_l ne '') {
  @lang = split(/, /,$opt_l);
  for ($i=0;$i<=$#lang;$i++) {
      $tmp = $dirress.$dirsep."lang".$dirsep.$lang[$i].$plext;
      $tmp = $pathinit.$tmp;
      require "$tmp";
  }
  if ($lang[0] eq '') {
      &error_exit("\nNone of your language choices have been yet translated !\n",1);
      }
}

if ($opt_f == 1) {
$localrefer = 1;
}

# argument cmds line

if ($opt_i ne '') {
$filerefer = $opt_i;
}

if ($opt_t ne '') {
$topten = $opt_t;
}

if ($opt_p ne '') {
    $pageselect = $opt_p;
    if (index($pageselect,'/') != 0) {
	&error_exit("Your page should start from your root server\n. Try /$pageselect instead of $pageselect\n",1);
    }
    $pageselect .= $defaulthomepage if (substr($pageselect,length($pageselect)-1) eq "/" && $pageselect !~ /\?/);
}

&MakeDirectories;

### URL to title conversion

chop($pathserver);

if (!(-e "$path$dirdata$dirsep$fileurl")) {
$titlename = 0;
}

&load_url_map if ($titlename == 1);

$month_number = $month_equiv{$month};
$month_number--;

### date il y a $nbdays jours

if ($nbdays != 0) {

$pastday = $day  - $nbdays; 
$pastyear = $year;
$pastmonth = $month_nb[$month_number];

while ($pastday < 1) {
  $month_number--;
  if ($month_number < 0) {
      $pastyear--;
      $month_number = 11;
   }
   $pastmonth = $month_nb[$month_number];
   $pastday = $pastday + $month_of_year{$pastmonth};
}

$pasttoday = $pastday." ".$pastmonth." ".$pastyear;         
}

if ($opt_d ne '') {
$jour = $pasttoday;
$opt_b = 1;
}

###################################################################

if ($zipcut == 0 && $zip == 0) {
&error_exit("Referencelog file $filerefer not found\nAre you sure your server produce one ?\n",1) unless (-f $filerefer);
}
$nbline = 0;

#($size)= (stat("$filerefer")) [7];
$size = -s $filerefer;
if ($size < 0) {
    $msg = "Problem with logfile size\n";
    $msg .= "You should upgrade to the latest Perl version to be able to handle file larger than 2 Gb\n";
    $msg .= "or split your logfile under the 2 Gb limit\n\n";
    &error_exit($msg,1);
}


#$prefixlog = $referlog;


#############################################################################

&load_reverse_dns if ($reverse_dns == 1); # chargement de la table de DNS

if ($exclude_robot == 1) {
    &LoadRobot($opt_w);
}

if ($exclude_refererspam == 1) {
    if ($opt_w == 1) {
	&LoadReferSpamList;
    } else {
#	&LoadReferSpamByIP;
	&LoadReferSpamByDomain;
    }
}

$website = 0;
$direct = 0;
$engine = 0;
$foundrobot = 0;
$exclude_robot_nb = 0;

#################################################################
#######        chargement des anciennes valeurs      ############
#################################################################

$opt_b = 1 if (!(-f "$path$dirinc$dirsep$increfsites"));

if ($opt_b != 1 && $opt_d eq '') {

if (-f "$path$dirinc$dirsep$increfexit") {
open(FILE,"$path$dirinc$dirsep$increfexit") || &error_exit("Error, unable to open $path$dirinc$dirsep$increferexit",1);
while (<FILE>) {
    ($site,$nb) = split;
    $lastentry{$site} = $nb;
}
close(FILE);
}

#if ($file eq $filerefer && (-f "$path$dirinc$dirsep$increfsites")) {
if (-f "$path$dirinc$dirsep$increfsites") {
open(FILE,"$path$dirinc$dirsep$increfsites") || &error_exit("Error, unable to open $path$dirinc$dirsep$increfersites",1);
$a = (<FILE>);
($nbline,$firstday,$jour,$sizeold) = split(/\t/,$a);
chop($sizeold);
while (<FILE>) {
($site,$nb,$tmp) = split;
$nbre{$site} = $nb;
$nbre_site{$site} = $tmp if ($tmp ne '');
$unique++;
}
close(FILE);    

if (-f "$path$dirinc$dirsep$increfbookmark") {
    open(FILE,"$path$dirinc$dirsep$increfbookmark") || &error_exit("Error, unable to open $path$dirinc$dirsep$increferbookmark",1);
$a = (<FILE>);
($direct,$website,$engine) = split(/\s+/,$a);
while (<FILE>) {
($site,$nb) = split;
$bookmark{$site} = $nb;
$uniquebookmark++;
}
close(FILE);
}

$count = -1;
open(FILE,"$path$dirinc$dirsep$increfpages") || &error_exit("Error, unable to open $path$dirinc$dirsep$increfpages",1);
while (<FILE>) {
    chop;
    $tmp = ($site,$nb,$url) = split;
    if ($tmp == 3) {
       $count++;
       $count2 = 0;
       $nb_protoc{$site} = $nb;
       $nb_protoc_unique{$site} = $url;
       $list_protoc[$count] = $site;
    }
    if ($tmp == 2) {
       $count2++;
       $nbrefull{$site} = $nb if ($site =~ /^http/);
       $protoc{$list_protoc[$count],$count2} = $site;
       $protoc_value{$list_protoc[$count],$site} = $nb if ($site !~ /^http/);
    }
}
close(FILE);

open(FILE,"$path$dirinc$dirsep$increfin") || &error_exit("Error, unable to open $path$dirinc$dirsep$increfin",1);
while (<FILE>) {
($url,$nb) = split;
$occur{$url} = $nb;
$uniqueurl++;
}
close(FILE);

open(FILE,"$path$dirinc$dirsep$increfkey") || &error_exit("Error, unable to open $path$dirinc$dirsep$increfkey",1);
while (<FILE>) {
    chop;
($url,$nb) = split(/\t/);
#@smallwords = split(/\s+/,$url);
#for ($i=0;$i<=$#smallwords;$i++) {
#    $sw{$smallwords[$i]}++;
#}
push(@words,$url);
$w{$url} = $nb;
}
close(FILE);

open(FILE,"$path$dirinc$dirsep$increfengine") || &error_exit("Error, unable to open $path$dirinc$dirsep$increfengine",1);
while (<FILE>) {
chop;
($url,$nb,@fields) = split(/\t/);
if ($nb != 0) {
push(@postring,$url);
#print  "PUSH $url\n";
$seen{$url}++;
$keysh{$url} = $nb;

$grnb{$url} = $nb;

#print STDERR "$url $keysh{$url}\n";
for ($i=0;$i<=$#fields;$i+=2) {
$pagerobot{$url,(($i+2)/2)} = $fields[$i];
$seen{"$url $fields[$i]"}++;
$full{$url,$fields[$i]} = $fields[$i+1];
#print STDERR "$pagerobot{$url,($i/2)} $full{$url,$fields[$i]}\n";
}
} else {

$grnbtot{$url} = (($#fields+1)/2);
for ($i=0;$i<=$#fields;$i+=2) {
$seen{"$fields[$i] $url"}++;
#print STDERR "WWW $url $fields[$i]\n";
$grtot{$url,(($i+2)/2)} = $fields[$i];
$keysh{$grtot{$url,(($i+2)/2)}} = $fields[$i+1];
#print STDERR "$grnbtot{$url} : ($i+2/2) $grtot{$url,(($i+2)/2)} $keysh{$grtot{$url,(($i+2)/2)}}\n";

$gr{$url,($i+2)/2} = $fields[$i];

}
}
}
close(FILE);

if ($opt_p ne '' && -f "$path$dirinc$dirsep$increfselec") {
    open(FILE,"$path$dirinc$dirsep$increfselec") || &error_exit("Error, unable to open $path$dirinc$dirsep$increfselec",1); 
$a = (<FILE>);
($pageselect2) = split(/\t/,$a);
chop($pageselect2);
while (<FILE>) {
    ($site,$nb,$nbdate,$tmp) = split(/\t/);
    chop($tmp);

    if ($pageselect2 eq $pageselect) {
	$page{$site} = $nb;
	$pagedate{$site} = $nbdate;
	$pagequery{$site} = $tmp;
    }
}
close(FILE);
}

}
}

# load inc day data

#if (-f $filerefday && $opt_d eq '' && $opt_b != 1 && $struct_logfile =~ /\%refer/) {
if (-f $filerefday && $opt_b != 1 && $opt_d eq  '' && $referlog eq $prefixlog) {
#print "Loading daily incremental data : $filerefday\n";
#print "<BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");

open(FILEDAYREF,"$filerefday") || &error_exit("Error, unable to open $filerefday",1);
$oldjour = <FILEDAYREF>;
#$oldjour =~ s/ /\//g;
chop($oldjour);
$yesterday = $oldjour;

#if ($today eq $checkdate) {

while (<FILEDAYREF>) {

    ($tmp,$tmp1,$tmp2) = split(/\t/,$_);
chop($tmp2);

if ($tmp eq "A") {
    $nbredayref{$tmp1} = $tmp2;
$uniqueday++;
}

if ($tmp eq "B") {
    $nbrefullday{$tmp1} = $tmp2;
$uniquenbrefullday++;
}

if ($tmp eq "C") {
    $occurday{$tmp1} = $tmp2;
$uniqueurlday++;
}

if ($tmp eq "D") {
    push(@wordsday,$tmp1);
    $wday{$tmp1} = $tmp2;
}

if ($tmp eq "E") {
    $keyshday{$tmp1} = $tmp2;
}
#}

}

close (FILEDAYREF);
}

if (($opt_b == 1 && $referlog eq $prefixlog) || (!(-f "$path$dirdata$dirsep$datafile"))) {
open(FILEDATE, ">$path$dirdata$dirsep$datafile") || &error_exit("Error, unable to open $path$dirdata$dirsep$datafile",1);
print FILEDATE "    Date       Hosts:   Refer:   URL:  Keywords:\n";
print FILEDATE "    ----       -----    -----    ----  --------\n\n";
} else {
open(FILEDATE, ">>$path$dirdata$dirsep$datafile") || &error_exit("Error, unable to open $path$dirdata$dirsep$datafile",1);
}

#################################################################
###                     gzip log file                         ###
#################################################################

if (($zip == 1 || $zipcut != 0) && (($opt_b == 1) || ($nbline == 0))) {

$month = $monthindex;
$monthprev = $month-1;
$yyear = $year;
$year = $fyear;

   # detection du premier mois de log zipe

while ($out == 0) {
    $tmp++;
#     while (!(-e $filezip) || !(-e $filerefer)) {
#     do {
	if ($zipcut == 2) {
		$day++;
		$day = "0".$day if (length($day) == 1 && $struct_compressed_logfile !~ /\%smallday/);
		if ($day > $month_of_year{$month_nb[$monthprev]}) {
			$month++;
			$monthprev++;
			$day = "1" if ($struct_compressed_logfile =~ /\%smallday/);
                        $day = "01" if ($struct_compressed_logfile !~ /\%smallday/);
			}
		}
       $month++ if ($zipcut == 1);
       $monthprev++ if ($zipcut == 1);       
       $year++ if ($month == 13);
       $month = "1" if ($month == 13);
$month = "0".$month if (length($month) == 1 && $struct_compressed_logfile !~ /\%smallmonth/);
       $monthprev = 0 if ($month == 1);       
       $lettermonth = $month_nb[$monthprev];
       if ($year ==  $fullyear && $month > $monthindex && $zipcut != 0) {
            $msg = "No gziped files found !\n\n" if ($zip == 1);
            $msg = "No log files found !\n\n" if ($zip != 1);
            &error_exit($msg,1);
            }
#       $filerefer = $fileroot;

        $smallyear = $year - int($year/100)*100;       
        $smallyear = "0".$smallyear if (length($smallyear) == 1);
$smallday = $day;
$smallmonth = $month;
$date_filename = $day.$dirsepurl.$lettermonth.$dirsepurl.$year; # Format XX/Mmm/YYYY
$filerefer = &Get_LogfileName($fileroot);
#	for ($i=1;$i<=$#compressed_logfile_fields;$i++) {

#		$compressed_logfile_fields[$i] =~ s/\%/\$/;
#		$filerefer .= eval($compressed_logfile_fields[$i]).$compressed_sep_fields[$i];
#	}
       $real_deb = 1 if ($filerefer eq $filetmpzip);
$out = 1 if (-e $filerefer && $zip == 0);
#       $filezip = $filerefer.$zipext if (!(-f $filerefer) && ($zip == 1));
       $filezip = $filerefer.$zipext if ($zip == 1);
	$out = 1 if (-e $filezip && $zip == 1);
	if ($zipcut == 3 && $filetmpzip eq $filerefer) {
	    $out = 1;
	    $zip = 0;
	    $filezip = $filerefer;
	}
	# if larger then (today-1996)*366 for daily logfiles
	if ($tmp > 5000) {
	    $msg = "No logfile found\n";
	    $msg .= "Are you sure you are using compressed logfile ?\n" if ($zip == 1);
	    &error_exit($msg,1);
	}
     }
#        until (-e $filezip || -e $filerefer);

   $lastfile = $filerefer;
   $lastfilezip = $filezip;
   $stop = 0;
   $fyear = $year;
   $year = $yyear;
}

###################################################################
###             computing referer stats                         ###
###################################################################

$line_parsed = 0;
$no_refer = 0;

if (($zip == 1 || $zipcut != 0) && ($opt_b != 1 || $opt_d ne '')) {
	($day,$month2,$year) = split(' ',$oldjour) if ($opt_d eq '');	
	($day,$month2,$year) = split(' ',$pasttoday) if ($opt_d ne '');	
$day = "0".$day if (length($day) == 1 && $struct_compressed_logfile !~ /\%smallday/);
        $month = $month_equiv{$month2};
$month = "0".$month if (length($month) == 1 && $struct_compressed_logfile !~ /\%smallmonth/);
        $lettermonth = $month2;
        $out = 0 if (!(-f $filerefer));
#	if (!(-f $filerefer)) {

        while ($out == 0 && (($year <=  $fullyear) || (($year == $fullyear) && $month <= $monthindex))) {
    $fyear = $year;
        $smallyear = $year - int($year/100)*100;
        $smallyear = "0".$smallyear if (length($smallyear) == 1);

$smallday = $day;
$smallmonth = $month;
#        $filerefer = $fileroot; 
$date_filename = $day.$dirsepurl.$lettermonth.$dirsepurl.$year; # Format XX/Mmm/YYYY
$filerefer = &Get_LogfileName($fileroot);
#    	for ($i=1;$i<=$#compressed_logfile_fields;$i++) {

#		$compressed_logfile_fields[$i] =~ s/\%/\$/;
#		$filerefer .= eval($compressed_logfile_fields[$i]).$compressed_sep_fields[$i];
#	        }
	$filezip = $filerefer.$zipext if ((!(-f $filerefer)) && $zip == 1);
	$filezip = $filerefer.$zipext if ($retrieve_external_log == 1 && $zip == 1); # NEW
       $real_deb = 1 if ($filerefer eq $filetmpzip);
        $out = 1 if (-f $filerefer || -f $filezip);
        if (!(-f $filezip) && !(-f $filerefer)) {
        if ($zipcut == 2) {
                $day++;
		$day = "0".$day if (length($day) == 1 && $struct_compressed_logfile !~ /\%smallday/);
                if ($day > $month_of_year{$month_nb[$month-1]}) {
                        $month++;
			$day = "1" if ($struct_compressed_logfile =~ /\%smallday/);
                        $day = "01" if ($struct_compressed_logfile !~ /\%smallday/);
                        }
                }
	$month++ if ($zipcut == 1);
	$year++ if ($month == 13);
	$month = "1" if ($month == 13);
	$month = "0".$month if (length($month) == 1 && $struct_compressed_logfile !~ /\%smallmonth/);
	$lettermonth =  $month_nb[$month-1];
    }

	}   

}      

   if ($zipcut == 3 && $opt_b eq '') {
	$filerefer = &find_index_log($fileroot,$prefixlog,$pasttoday);
	$filezip = $file.$zipext if ($zip == 1);
    }

$filerefer = $fileroot.$prefixlog if (!(-f $filezip) && !(-f $filerefer));
if ($opt_b != 1 && $opt_d eq '' && $zipcut == 3 && -f "$path$dirinc$dirsep$increfsites") {
    $filerefer = $fileroot.$prefixlog;
    $filezip = $filerefer;
    $zip = 0;
}


if ($size < $sizeold) {
    $nbline = 0;
    print "Your logfile $filerefer have been cut\n";
    print "<BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");
}

#print "TEST REMOVAL $filezip - $filerefer - $retrieve_external_log\n";
if (-f $filezip && -f $filerefer && $retrieve_external_log == 1) {
    unlink($filerefer);
#    print "Removing $filerefer\n";
}

&flush(STDOUT);
$|=1;

while ($stop == 0) {


if (($zip == 1) && (-f $filezip) && ((($filerefer ne $filezip) && ($nbline == 0 || $opt_b == 0)) || ($zipcut == 2))) {
    if ($zipcut != 3) {
#            &retrieve_external_logfile($fileroot,$remote_host_log,$filezip) if ($retrieve_external_log == 1);
            &error_open($filezip) if (!(-r $filezip));
	    open(INFILE, "$GZIP $filezip |") || &error_exit("Error, unable to open $filezip",1);
	    print STDOUT "Scanning $filezip\n";
	} else {
	    # Apache rotate, trying uncompressed file
#            &retrieve_external_logfile($fileroot,$remote_host_log,$filezip) if ($retrieve_external_log == 1);
	    if (-r $filezip) {
		open(INFILE, "$GZIP $filezip |") || &error_exit("Error, unable to open $filezip",1);
		print STDOUT "Scanning $filezip\n";
	    } else {
#            &retrieve_external_logfile($fileroot,$remote_host_log,$filerefer) if ($retrieve_external_log == 1);
		&error_open($filerefer) if (!(-r $filerefer));
		open(INFILE,$filerefer) || &error_exit("Error, unable to open $filerefer",1);
		print STDOUT "Scanning $filerefer\n";
	    }
	}
#       print STDOUT "Scanning $filezip file...\n";
#       open(INFILE, "$GZIP $filezip |") || die "Error, unable to open $filezip\n";
    } else {
#	&retrieve_external_logfile($fileroot,$remote_host_log,$filerefer) if ($retrieve_external_log == 1);
    &error_open($filerefer) if (!(-r $filerefer));
print STDOUT "Scanning $filerefer\n";
open(INFILE,$filerefer) || &error_exit("Error, unable to open $filerefer",1);
      }
      
print "<BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");


$line = 0;
$year = $fyear if ($opt_d eq '' && $fields_logfile{'%date'} eq '');

BOUCLE:
while (<INFILE>) {

$line++;

next BOUCLE if (-f "$path$dirinc$dirsep$increfsites" && $opt_b != 1 && $line <= $nbline);

#if ($struct_logfile =~ /\%refer/) {
if ($struct_logfile =~ /\%/) {

    @line_log = split(/$logfile_sep/);
if ($line_log[$#line_log] =~ /\r\n$/) {
    $dos_format = 1;
    chop($line_log[$#line_log]);
}
    chomp($line_log[$#line_log]);
    if ($line_log[0] =~ /^\#Fields:/) {
	$struct_logfile = &detect_w3c_logformat($_);
	last BOUCLE if ($struct_logfile !~ /\%referer/);
	$w3c_refer = 1;
    }
    next if ($line_log[0] =~ /^\#/);
$add_fields_logfile = 0;
$add_fields_logfile = &LoginWithSpace(@line_log) if ($line_log[$fields_logfile{'%login'}] =~ /^\"/);

    $date = $line_log[$fields_logfile{'%date'}+$add_fields_logfile];
    $date =~ s/\[//;
    $date = &date_squid($date) if ($date =~ /\d{9}\.\d{3}/);
    $date = &date_common($line_log[$fields_logfile{'%date'}+$add_fields_logfile],$line_log[$fields_logfile{'%hour'}+$add_fields_logfile]) if ($iis_format == 1 && $fields_logfile{'%date'} ne '');
    $date = $date_filename.":".$line_log[$fields_logfile{'%hour'}+$add_fields_logfile] if ($fields_logfile{'%date'} eq '');
    next if ($date !~ m/^((\d+)\/(\w+)\/(\d\d\d\d):)(.*)/);
    
    $adresse = $line_log[$fields_logfile{'%host'}];
    $adresse =~ s/::ffff://; # Ipv6
    $url = $line_log[$fields_logfile{'%page'}+$add_fields_logfile];
    $url =~ s/$ftpserver// if ($ftp_format == 1);
    $url =~ s/\/\//\// if ($url !~ /^http:\/\//);
    $url =~ s/\%3C.*\%3E//g;

    if ($url =~ /\/\.\.\//) {
	while ($url =~ /\/\.\.\//) {
	    $url =~ s/\.\.\///;
	    $pos = index($url,$dirsepurl,1);
	    $url = substr($url,$pos,length($url));
     }
    }

    $d = $line_log[$fields_logfile{'%method'}+$add_fields_logfile];
    $status = $line_log[$fields_logfile{'%status'}+$add_fields_logfile];
if ($notrafic == 0) {
    $requetesize = $line_log[$fields_logfile{'%requetesize'}+$add_fields_logfile] if ($mail_format == 0);
    next if ($requetesize !~ /^\d+/ && $requetesize ne "-" && $ftp_format == 0);
}
    $vserver = $line_log[$fields_logfile{'%virtualhost'}+$add_fields_logfile] if ($fields_logfile{'%virtualhost'} ne '');
    $vserver = $1 if ($url =~ /^\/\/([-.0-9a-z]+)\//i && $virtualCLF != 0);
    $vserver = $line_log[$#line_log] if ($#logfile_fields == $fields_logfile{'%virtualhost'});
    $url =~ s/\/\/$virtualfilter// if (($virtualCLF != 0 && $virtualfilter ne '') || ($d =~ /$localserver/));     
    $url =~ s/^http:\/// if ($squid_format == 1);
$fullsite = $line_log[$fields_logfile{'%referer'}+$add_fields_logfile] if ($fields_logfile{'%referer'} ne '');

$line_parsed++;
    if ($fullsite eq '') {
	$no_refer++;
	next BOUCLE;
    }
    next if ($status !~ /^(\d+)$/);

    $reverse_dns = 0 if ($reverse_dns == 1 && $adresse !~ /[0-9]+$/);

#    $adresse = $nis{$adresse} if ($nis{$adresse} ne '');
    $adresse = &reversedns($adresse) if ($reverse_dns == 1 && $adresse =~ /[0-9]+$/);
    $adresse = $adresse.".".$localdomainename if (split(/[.]/,$adresse) == 1);
    $adresse =~ tr/[A-Z]/[a-z]/;
    $domadresse = substr($adresse,(rindex(substr($adresse,0,rindex($adresse,'.')),'.')+1),length($adresse));

    next if (($adresse =~ /$localdomaine$/o) && ($locallog == 0));
    next if (($adresse !~ /$localdomaine$/o) && ($localonly == 1));    
    next if (($adresse =~ /$nolog/i) && ($nolog ne ''));

    if ($squid_format != 1) {
	next if ($url =~ /\"$/ && $iis_format != 1); # all format should be %page %protocol
	next if ($d !~ /^\"/ && $iis_format != 1 && $ftp_format != 1); # all format should be %page %protocol
    }

    next if ($url =~ /^http:\/\//i || $url eq ''); # (proxy)

    ($tmp) = split(/:/,$date);
    ($daytoday,$monthtoday,$yeartoday) = split(/\//,$tmp);
    $yesterday = "$daytoday $monthtoday $yeartoday";
    next if ($month_equiv{$monthtoday} !~ /(\d+)/);
    next if (length($yeartoday) != 4);
    next if ($adresse eq '');

    if ($adresse =~ /\//) {
	($tmp,$adresse) = split(/:/,$adresse);
	print "Problem : found $tmp ... fixing done\n";
    }

    if ($exclude_robot == 1) {
	$foundrobot = 0;
	if ($opt_w eq '') {
	    if ($struct_logfile =~ "%agent") {
		$i = $fields_logfile{'%agent'};
		$f = $line_log[$i+$add_fields_logfile];
		next if ($f =~ /^\d+/);
		
		$f = &GetAgentString($f,$i);
		$foundrobot = &ExcludeRobot($f);
	    }
	} else {
	    if ($robot_list ne '') {
		$foundrobot = 0;
		$foundrobot = 1 if ($adresse =~ /$robot_list/);
	    }
	}
	if ($foundrobot == 1) { 
	    $exclude_robot_nb++;
	    next BOUCLE;
	    }
    }

    if ($fullsite !~ m/\"/) {
	$i = $fields_logfile{'%referer'};
	$tmpi = $i+1;
	$f = $fullsite;
#	chop($f);
	chop($f) if ($f =~ /\"$/);
	while ($f ne "-" && $f !~ m/http:\/\//i && $f ne '') {
	    $f = $line_log[$tmpi+$add_fields_logfile];
	    $tmpi++;
	}
	$fullsite = $f;
    }

    if ($url =~ /$tri$bookmark_url/i) {
	$bookmark{$url}++;
	$uniquebookmark++ if ($bookmark{$url} == 1);
    }

    if ($fullsite =~ m/^\"([A-Za-z]*):\/\/(.*)/i) {
	if ($fullsite !~ m/\"http:\/\//i) {
	    $tmp = $1;
	    $tmp =~ tr/[A-Z]/[a-z]/;
	    $tmp =~ s/\"//g;
	    $nb_protoc{$tmp}++;
	    $tmp2 = $2;
	    $tmp2 =~ s/\"//g;
	    push(@list_protoc,$tmp) if ($nb_protoc{$tmp} == 1);
	    $protoc_value{$tmp,$tmp2}++;
	    $nb_protoc_unique{$tmp}++ if ($protoc_value{$tmp,$tmp2} == 1);
	    $protoc{$tmp,$nb_protoc_unique{$tmp}} = $tmp2 if ($protoc_value{$tmp,$tmp2} == 1);
	}
    }

    $direct++ if ($fullsite eq "\"-\"");

    next if ($fullsite !~ m/http:\/\//i);
    next if ($fullsite =~ m/[<>;}{\]\[|!]/);

    if ($fullsite =~ /\n/ && $type_serveur == 1) {
	chop($fullsite); # si referer is last field
    }

    $status = $1 if ($query =~ /(\d\d\d);http:\/\// && $type_serveur == 1);
    if ($squid_format == 1) {
	$codestatus = $line_log[$fields_logfile{'%codestatus'}];
	($code_squid,$status) = split(/\//,$codestatus);
    }

    next if (($status >= 400) && ($status < 599));
    next if ($status =~ /$excludestatuscode/ && $excludestatuscode ne '');
    
    $url =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
    $url =~ tr/[A-Z]/[a-z]/ if ($type_serveur == 1);
    
    next if ($url =~ /$excluderepert/i && $excluderepert ne '');

    next if ($url !~ m#$tri#i && $tri ne '/'); # stats sur une partie du serveur
    next if ($url =~ /$dirsepurl[_]/ && $type_serveur == 1 && $mail_format == 0);

    next if ($d =~ /$localserver/ && $vserver ne '');
    next if ($vserver =~ /$excludevirtual/i && $excludevirtual ne '');   
    next if ($vserver !~ /$virtualfilter/i && $virtualfilter ne '' && $vserver ne '');

    next if ($requetesize == 0 && $notrafic == 0) ; #ote les pages ne contenant rien
    next if ($url =~ /$dirsepurl[_]/ && $type_serveur == 1);    
    

    if ($opt_d ne '') {
	($fa) = split(':',$date);
	($fa1,$fa2,$fa3) = split('/',$fa);
	next if ($fa3 < $pastyear);
	$mequiv = $month_equiv{$fa2};
	next if ($fa3 == $pastyear && $mequiv < $pastmonthnb);
	next if ($fa3 == $pastyear && $mequiv == $pastmonthnb && $fa1 < $pastday);
    }

    if ($fullsite eq '') {
       print "Not a extented common log file !!!\n";
       $fullsite = "-";
       print "This line may have problem : $_";
       next BOUCLE;
       }

    $fullsite =~ s/\"//g;	     

    if ($exclude_refererspam == 1 && $fullsite ne "-" && $fullsite !~ /$localdomainename$/) {
	if ($opt_w eq '') {
		$site = $fullsite;
		$site =~ s/http:\/\///i;
		$site = substr($site,0,index($site,'/'));
		$sitesh = substr($site,(rindex(substr($site,0,rindex($site,'.')),'.')+1),length($site));
		$foundreferspam = &ExcludeRefererSpamByDomain($sitesh);
	} else {
	    $foundreferspam = 0;
	    $foundreferspam = 1 if ($adresse =~ /$spam_list/);
	}
	if ($foundreferspam == 1) { next BOUCLE }
    }

    ($jour) = split(/:/,$date);
    $jour =~ s/[\/]/ /g;
    $firstday = $jour if ($firstday eq '');
    $oldjour = $firstday if ($firstday eq $jour);

    $fullsite =~ s/^R://g;
    $fullsite =~ s/#.*//;    
    next if ($fullsite eq '');

   } else {

   if ($type_serveur == 2) {
   ($date,$fullsite) = split(/\"/);
   chop($fullsite);
    ($jour) = split(/:/,$date);
    $jour =~ s/[\/\[]/ /g;

    $firstday = $jour if ($firstday eq '');
    $oldjour = $firstday if ($firstday eq $jour);
   }
   
   ($fullsite,$separateur,$url) = split if ($type_serveur != 2);
#   print "$fullsite\n";

   next if ($fullsite !~ m/http:\/\//i);

}

if ($jour ne $oldjour) {

       ($var1,$var2,$var3) = split(' ',$jour);
       ($oldvar1,$oldvar2,$oldvar3) = split(' ',$oldjour);

       if ($zip == 0) {
	   print "$oldjour done\n";
	   print "<BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");
       }
       $skipout = 0;

       if ($var3 < $oldvar3) {
	   unless ($seen_problem_date{$jour}++) {
	       print "1 - Problem found (date) : $var1$dirsep$var2$dirsep$var3 - should be $oldvar1$dirsep$oldvar2$dirsep$oldvar3 (skipping...)\n";
	       print "<BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");
	   }
	   $skipout = 1;
	   $jour = $oldjour;
	   next BOUCLE;
       }

       if ($oldvar3 == $var3 && $month_equiv{$var2} < $month_equiv{$oldvar2} && $skipout == 0) {
	   unless ($seen_problem_date{$jour}++) {
	       print "2 - Problem found (date) : $var1$dirsep$var2$dirsep$var3 - should be $oldvar1$dirsep$oldvar2$dirsep$oldvar3 (skipping...)\n";
	       print "<BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");
	   }
	   $skipout = 1;
	   $jour = $oldjour;
	   next BOUCLE;
       }

       if (($var2 eq $oldvar2) && ($var1 < $oldvar1) && $skipout == 0) {
	   unless ($seen_problem_date{$jour}++) {
	       print "3 - Problem found (date) : $var1$dirsep$var2$dirsep$var3 - should be $oldvar1$dirsep$oldvar2$dirsep$oldvar3 (skipping...)\n";
	       print "<BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");
	   }
	   $skipout = 1;
	   $jour = $oldjour;
	   next BOUCLE;
       }

       if ($skipout == 0) {    
       if ($fullday == 1) {

       ## Tri Refer

	   $oldjour =~ s/ /\//g;

	   $oldjour =~ s/[\/]/ /g;

	   print FILEDATE "$oldjour\t$uniqueday\t$uniquenbrefullday\t$uniqueurlday\t$#wordsday\n" if ($prefixlog eq $referlog && $uniqueday ne '');

	   ($tmp1,$tmp2,$tmp3) = split(/ /,$oldjour);
	   $dirresume = $tmp3."-".$tmp2."-".$tmp1;

	   &BuildDailyReferResume;

	   &save_daily_refer if ($uniqueday != 0);

	   $oldjour = $jour;
#undef %bestnbreday;
#undef %bestnbrefullday;
#undef %bestoccurday;

	   undef %nbredayref;
	   undef %nbrefullday;
	   undef %occurday;

	   $tmp1 = $#wordsday;
	   for ($i=0;$i<=$tmp1;$i++) {
	       $site = shift(@wordsday);
	       undef $wday{$site};
	   }
	   
	   undef @wordsday;
	   undef %keyshday;	   
       }
#

       $uniqueurlday = 0;
       $uniqueday = 0;
       $uniquenbrefullday = 0;
   }
   }


$url =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
$url .= $defaulthomepage if (substr($url,length($url)-1) eq "/" && $url !~ /\?/);

next if ($url !~ m#$tri#i);

$site = $fullsite;
$site =~ s/http:\/\///i;

$sitesh = substr($site,0,index($site,'/')) if ($site =~ /\//);

#next if ($site =~ /$localdomaine$/ && $localrefer == 0 && $vserver eq '');

$sitesh = $site if ($site !~ /\//);
#print "AA $sitesh - $site\n";
$sitesh =~ tr/[A-Z]/[a-z]/;
#print "BB $site - $sitesh\n" if ($sitesh =~ /\//);

	 if ($sitesh =~ /$localdomaine$/) {
#	     $internal{$url}++ if (substr($url,rindex($url,$carext)) =~ /$extension/i);
	     $internal{$url}++ if (($nohtmlext == 1 && $url !~ /[$carext]/) || ($extension ne '' && $url =~ /$extension/i));
	     $uniqueinternal++ if ($internal{$url} == 1);
	 }

next if ($sitesh =~ /$localdomaine$/ && $localrefer == 0 && $vserver eq '');


($f1,$f2,$f3) = split(/\//,$fullsite);

next if ($f3 !~ m/\./);

# uncomment this if your host have several domain name alias
#$site_ip = gethostbyname($f3);
#next if ($site_ip eq $server_ip && $localrefer == 0);

($tmp,$query) = split(/\?/,$url);

#$out = 1;
if ($type_serveur != 2) {
    $out = 0;
#    $out = 1 if (substr($tmp,rindex($tmp,$carext)) =~ m/$extension/i);
    $out = 1 if (($nohtmlext == 1 && $tmp !~ /[$carext]/) || ($extension ne '' && $tmp =~ /$extension/i));
}

if ($type_serveur == 2) {
    $out = 1;
    for ($i=0;$i<=($#extensionimage);$i++) {
	$out = 0 if (substr($tmp,rindex($tmp,$carext)+1) =~ m/^$extensionimage[$i]$/i);
    }
}

next BOUCLE if ($out == 0);

#$fullsite =~ tr/A-Z/a-z/;

next if ($sitesh eq $virtualfilter && $localrefer == 0 && $virtualfilter ne '');
next if ($sitesh eq $vserver && $localrefer == 0 && $vserver ne '');

#print "$sitesh - $localdomaine - \n";

if ($site =~ /\?/i) {
#print STDERR "$site\n";
# les sites les plus rares en premier
    $b = '';
    ($a,$b) = split(/[&?]rdata=/,$site) if ($site =~ m/[&?]rdata=/i);
    ($a,$b) = split(/[&?]qs=/,$site) if ($site =~ m/[&?]qs=/i);
    ($a,$b) = split(/[&?]qt=/,$site) if ($site =~ m/[&?]qt=/i);
    ($a,$b) = split(/[&?]query=/,$site) if ($site =~ m/[&?]query=/);
    ($a,$b) = split(/[&?]QUERY=/,$site) if ($site =~ m/[&?]QUERY=/); # split sur min/maj /i ?
    ($a,$b) = split(/[&?]s=/,$site) if ($site =~ m/[&?]s=/i);
    ($a,$b) = split(/[&?]general=/,$site) if ($site =~ m/[&?]general=/i);
    ($a,$b) = split(/[&?]search=/,$site) if ($site =~ m/[&?]search=/i);
    ($a,$b) = split(/[&?]MT=/,$site) if ($site =~ m/[&?]MT=/i);
    ($a,$b) = split(/[&?]text=/,$site) if ($site =~ m/[&?]text=/i);
    ($a,$b) = split(/[&?]searchText=/,$site) if ($site =~ m/[&?]searchText=/i);
    ($a,$b) = split(/[&?]KW=/,$site) if ($site =~ m/[&?]KW=/i);
    ($a,$b) = split(/[&?]p=/,$site) if ($site =~ m/[&?]p=/i);
    ($a,$b) = split(/[&?]q=/,$site) if ($site =~ m/[&?]q=/i);
    next if ($a =~ /forum/);
    $b =~ s/\&.*//;
    $b =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
    $b =~ tr/[A-Z]/[a-z]/;
#$b =~ s/(.*)"(\+)"(.*)/$1""$3/g;  # supprimer les + entre les ""
    next if ($b eq "search");
    next if (length($b) == 1);
    $b =~ s/%(..)/pack("c",hex($1))/ge;
    $b = &noaccent($b);
    $b =~ tr/[A-Z]/[a-z]/;
    $b =~ s/\'/ /g;
    $b =~ s/\s+/\+/g;
    $b =~ s/[\"]//g;
    $engine++;
    @string = split(/\+/,$b);
    for ($k=0;$k<=$#string;$k++) {
	if (length($string[$k]) > 2) {
	    $w{$string[$k]}++;
	    $wday{$string[$k]}++;
	    if ($w{$string[$k]} == 1) {
		push(@words,$string[$k]);
	    }
	    push(@wordsday,$string[$k]) if ($wday{$string[$k]} == 1);
	}
    }
    $b =~ s/\+/ /g;
    $b =~ s/\"//g;

    $pospoint2 = rindex($sitesh,'.');
    $tmp = substr($sitesh,0,$pospoint2);
    $pospoint1 = rindex($tmp,'.')+1;
    
    while ($pospoint1 > 1) {
	$tmp2 = substr($tmp,0,$pospoint1-1);
	$tmp = substr($tmp,$pospoint1,$pospoint2);
	$pospoint2 = length($tmp2);
	$pospoint1 = rindex($tmp2,'.')+1;
	
	if (length($tmp) > 2 && $tmp ne "search") {
	    $grnb{$tmp}++;
	    
	    if (!($seen{"$sitesh $tmp"}++)) {
		$grnbtot{$tmp}++;
		$grtot{$tmp,$grnbtot{$tmp}} = $sitesh;
	    }

	    $gr{$tmp,$grnb{$tmp}} = $sitesh;
	    unless ($seen{$tmp}++) {
		push(@postring,$tmp) if ($tmp !~ /^\d+$/ && $tmp !~ /forum/);
	    }
	    $keysh{$tmp}++;
	    $pagerobot{$tmp,$keysh{$tmp}} = $b unless ($seen{"$tmp $b"}++);
	    $full{$tmp,$b}++;
	    $tmp = $tmp2;
	}
    }
    
    $tmp = substr($tmp,0,$pospoint2);

    if ($tmp ne "www" && length($tmp) > 2 && $tmp ne "search") {
	$grnb{$tmp}++;
	$gr{$tmp,$grnb{$tmp}} = $sitesh;
	
	if (!($seen{"$sitesh $tmp"}++)) {
	    $grnbtot{$tmp}++;
	    $grtot{$tmp,$grnbtot{$tmp}} = $sitesh;
	}
	$keysh{$tmp}++;
	$pagerobot{$tmp,$keysh{$tmp}} = $b unless ($seen{"$tmp $b"}++);
	$full{$tmp,$b}++;
	    unless ($seen{$tmp}++) {
		push(@postring,$tmp) if ($tmp !~ /^\d+$/ && $tmp !~ /forum/);
	    }
    }
    $keysh{$sitesh}++;
    $keyshday{$sitesh}++;
#    print "A - $tmp - $sitesh - $keysh{$tmp} - $keysh{$sitesh}\n";

} else {
    $website++;
    $nbre_site{$sitesh}++;

    $nbrefullday{$fullsite}++;
    $uniquenbrefullday++ if ($nbrefullday{$fullsite} == 1);
    $nbredayref{$sitesh}++;
    $occurday{$url}++;
    $uniqueurlday++ if ($occurday{$url} == 1);
    $uniqueday++ if ($nbredayref{$sitesh} == 1);
}

if ($opt_p ne '' && $url =~ /$pageselect/) {
    $pagequery{$site} = $query if ($query ne '');
    $page{$site}++;
    $pagedate{$site} = $jour;
}

#$site = substr($site,0,index($site,'/'));
$tmp = "http";
$nb_protoc{$tmp}++;
push(@list_protoc,$tmp) if ($nb_protoc{$tmp} == 1);

$nbre{$sitesh}++;
$nbrefull{$fullsite}++;

$url =~ s/^\/\/[-.0-9a-z]+\//\//i;
#$loc{$url} = $fullsite;
#$locday{$url} = $fullsite;
$occur{$url}++;
$uniqueurl++ if ($occur{$url} == 1);
$unique++ if ($nbre{$sitesh} == 1);

### NEW
#$lastentry{$sitesh} = $url if (substr($url,rindex($url,$carext)) =~ /$extension/i);
$lastentry{$sitesh} = $url if (($nohtmlext == 1 && $url !~ /[$carext]/) || ($extension ne '' && $url =~ /$extension/i));
#print "A - $fullsite - $url - $sitesh\n";
}

close (INFILE); 

#if (($line_parsed == $no_refer && $line_parsed != 0 && $zipcut == 0) || ($firstday eq '' && $exclude_robot == 1 && ($exclude_robot_nb != $line))) {
#    $msg = "\nYour logfile have no data about referer informations\n";
#    $msg .= "Check either your logfile format from the web admin or \n";
#    $msg .= "rectify your w3perl configuration file by removing the %referer string in \$struct_logfile\n\n";
#    &error_exit($msg);
#}

### derniere journee

if ($struct_logfile =~ /\%refer/) {
#if ($prefixlog eq $referlog) {

($tmp1,$tmp2,$tmp3) = split(/ /,$jour);
$dirresume = $tmp3."-".$tmp2."-".$tmp1;

#print "Saving daily incremental data : $filerefday\n";
#print "<BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");

open(FILEDAYREFER,">$filerefday") || &error_exit("Error, unable to open $filerefday",1);
$jour = $oldjour if ($jour eq '');
print FILEDAYREFER "$jour\n";

foreach $site (keys(%nbredayref)) {
    print FILEDAYREFER "A\t$site\t$nbredayref{$site}\n" if ($nbredayref{$site} != 0);
}

foreach $site (keys(%nbrefullday)) {
    print FILEDAYREFER "B\t$site\t$nbrefullday{$site}\n" if ($nbrefullday{$site} != 0);
}

foreach $site (keys(%occurday)) {
    print FILEDAYREFER "C\t$site\t$occurday{$site}\n" if ($occurday{$site} != 0);
}

for ($i=0;$i<=$#wordsday;$i++) {
    $site = $wordsday[$i];
    print FILEDAYREFER "D\t$site\t$wday{$site}\n";
}

foreach $site (keys(%keyshday)) {
    print FILEDAYREFER "E\t$site\t$keyshday{$site}\n";
}

close (FILEDAYREFER);

}

# mois gzip suivant

$stop = 1 if (($zip != 1 && $zipcut == 0) || ($filerefer eq $filezip));
$stop = 1 if ($rotate_index == 0 && $zipcut == 3);
$stop = 0 if ($zipcut == 3 && $max_rotate_index == 1 && $rotate_index == 1 && (-f "$fileroot$prefixlog"));

if (($zip == 1 || $zipcut != 0) && $stop == 0) {

    $stop = 1 if ($filerefer eq "$fileroot$prefixlog" && $file eq $filerefer);

$nbline = 0;
$yyear = $year;
$year = $fyear; # if ($opt_d ne '');

&nextlog;

if ($rotate_index == 0 && $zipcut == 3) {
    $filezip = $fileroot.$prefixlog if ($file eq $filerefer);
    $filerefer = $fileroot.$prefixlog if ($file eq $filerefer);
    $filezip = $fileroot.$referlog if ($file ne $filerefer);
    $filerefer = $fileroot.$referlog if ($file ne $filerefer);       
}

if ($zip == 0) {
    if ($zipcut == 2) {
	&nextlog while (!(-f $filerefer) && $datezip lt $datetmpzip);
	$stop = 1 if ($filerefer eq $filetmpzip);
    }
    if ($zipcut == 3) {
	&nextlog while ((!(-f $filerefer)) && $rotate_index > 0);
	$stop = 1 if (!(-f "$fileroot$prefixlog") && $rotate_index == 0);
    }
}

if ($zip == 1) {
    if (-e $filezip) {
    } else {
	if ($zipcut == 2) {
	    &nextlog while (!(-f $filezip) && $datezip lt $datetmpzip);
	    $stop = 1 if ($filezip eq $filetmpzip);
	    } elsif ($zipcut == 3) {
		&nextlog while ((!(-f $filezip) && (!(-f $filerefer))) && $rotate_index > 0);
		$stop = 1 if ($filezip eq $filetmpzip);	
		$stop = 1 if (!(-f "$fileroot$prefixlog") && $rotate_index == 0);
	    } else {
		$filezip = $fileroot.$prefixlog if ($file eq $filerefer);
		$filerefer = $fileroot.$prefixlog if ($file eq $filerefer);
		$filezip = $fileroot.$referlog if ($file ne $filerefer);
		$filerefer = $fileroot.$referlog if ($file ne $filerefer);       
		$stop = 1 if (!(-f $filerefer));
	    }
    }
} else {
    if (-e $filerefer && $zipcut != 0) {
    } else {
	$stop = 1 if (!(-f $filerefer));
    }
}
$fyear = $year;
$year = $yyear;   
}
}

##### Last day

## Tri Refer

    $oldjour =~ s/ /\//g;

foreach $tmp (sort (keys(%nbredayref))) {
    $countnbre[$nbredayref{$tmp}]++;
    push(@counternbre,$nbredayref{$tmp}) if ($countnbre[$nbredayref{$tmp}] == 1);
    $occur_counternbre{$nbredayref{$tmp},$countnbre[$nbredayref{$tmp}]} = $tmp;
}

@bestnbreday = reverse sort bynumber @counternbre;

#

foreach $tmp (sort (keys(%nbrefullday))) {
    $countnbrefull[$nbrefullday{$tmp}]++;
    push(@counternbrefull,$nbrefullday{$tmp}) if ($countnbrefull[$nbrefullday{$tmp}] == 1);
    $occur_counternbrefull{$nbrefullday{$tmp},$countnbrefull[$nbrefullday{$tmp}]} = $tmp;
}

@bestnbrefullday = reverse sort bynumber @counternbrefull;

#

foreach $tmp (sort (keys(%occurday))) {
    $countoccur[$occurday{$tmp}]++;
    push(@counteroccur,$occurday{$tmp}) if ($countoccur[$occurday{$tmp}] == 1);
    $occur_counteroccur{$occurday{$tmp},$countoccur[$occurday{$tmp}]} = $tmp;
}

@bestoccurday = reverse sort bynumber @counteroccur;


    $oldjour =~ s/[\/]/ /g;
#


#print FILEDATE "$oldjour\t$uniqueday\t$uniquenbrefullday\t$uniqueurlday\t$#wordsday\n" if ($prefixlog eq $referlog && $uniqueday ne '');
print FILEDATE "$oldjour\t$uniqueday\t$uniquenbrefullday\t$uniqueurlday\t$#wordsday\n" if ($struct_logfile =~ /\%refer/ && $uniqueday ne '');

($tmp1,$tmp2,$tmp3) = split(/ /,$oldjour);
$dirresume = $tmp3."-".$tmp2."-".$tmp1;

&BuildDailyReferResume;

&save_daily_refer if ($uniqueday != 0);
#&save_daily_refer;

$jourfin = $jour;
if ($struct_logfile =~ /\%refer/) {
#close(FILEDATE) if ($prefixlog eq $referlog);
close(FILEDATE);
}

#################################################################
####             sauvegarde des donnees                   #######
#################################################################

open(FILE,">$path$dirinc$dirsep$increfexit") || &error_exit("Error, unable to open $path$dirinc$dirsep$increferexit",1);
foreach $site (keys(%lastentry)) {
    print FILE "$site $lastentry{$site}\n";
}
close(FILE);

open(FILE,">$path$dirinc$dirsep$increfsites") || &error_exit("Error, unable to open $path$dirinc$dirsep$increfersites",1);
print FILE "$line\t$firstday\t$jour\t$size\n";
foreach $site (keys(%nbre)) {
    print FILE "$site $nbre{$site} $nbre_site{$site}\n";
}
close(FILE);

$tmp3 = 0;
foreach $fullsite (keys(%nbrefull)) {
    $tmp3++;
}

open(FILE,">$path$dirinc$dirsep$increfpages") || &error_exit("Error, unable to open $path$dirinc$dirsep$increfpages",1);
for ($i=0;$i<=$#list_protoc;$i++) {
    $tmp = $list_protoc[$i];

    if ($tmp ne "http") {
	print FILE "$tmp $nb_protoc{$tmp} $nb_protoc_unique{$tmp}\n";
	for ($j=1;$j<=$nb_protoc_unique{$tmp};$j++) {
	    $tmp2 = $protoc{$tmp,$j};
	    print FILE "$tmp2 $protoc_value{$tmp,$tmp2}\n";
	}
    }
    if ($tmp eq "http") {
	print FILE "$tmp $nb_protoc{$tmp} $tmp3\n";
	foreach $fullsite (keys(%nbrefull)) {
	    print FILE "$fullsite $nbrefull{$fullsite}\n";
	}
    }
}
close(FILE);

open(FILE,">$path$dirinc$dirsep$increfbookmark") || &error_exit("Error, unable to open $path$dirinc$dirsep$increferbookmark",1);
print FILE "$direct $website $engine\n";
foreach $url (keys(%bookmark)) {
    print FILE "$url $bookmark{$url}\n";
}
close(FILE);

open(FILE,">$path$dirinc$dirsep$increfin") || &error_exit("Error, unable to open $path$dirinc$dirsep$increfin",1);
foreach $url (keys(%occur)) {
print FILE "$url $occur{$url}\n";
}
close(FILE);

open(FILE,">$path$dirinc$dirsep$increfkey") || &error_exit("Error, unable to open $path$dirinc$dirsep$increfkey",1);
for ($j=0;$j<=$#words;$j++) {
print FILE "$words[$j]\t$w{$words[$j]}\n";
}
close(FILE);

open(FILE,">$path$dirinc$dirsep$increfengine") || &error_exit("Error, unable to open $path$dirinc$dirsep$increfengine",1);
for ($i=0;$i<=$#postring;$i++) {
print FILE "$postring[$i]\t$keysh{$postring[$i]}\t";
for ($j=1;$j<=$keysh{$postring[$i]};$j++) {
print FILE "$pagerobot{$postring[$i],$j}\t$full{$postring[$i],$pagerobot{$postring[$i],$j}}\t" if ($pagerobot{$postring[$i],$j} ne '');; 
}
print FILE "\n";
print FILE "$postring[$i]\t0\t";
for ($j=1;$j<=$grnbtot{$postring[$i]};$j++) {
print FILE "$grtot{$postring[$i],$j}\t$keysh{$grtot{$postring[$i],$j}}\t";
}
print FILE "\n";
}
close(FILE);

if ($opt_p ne '') {
open(FILE,">$path$dirinc$dirsep$increfselec") || &error_exit("Error, unable to open $path$dirinc$dirsep$increfselec",1);
print FILE "$pageselect\n";
foreach $site (keys(%page)) {
    print FILE "$site\t$page{$site}\t$pagedate{$site}\t$pagequery{$site}\n";
}

close(FILE);
}

#############################################################################

&save_reverse_dns if ($reverse_dns == 1); # sauvegarde de la table de DNS

if (($w3c_refer == 0 && $logfile_format eq "W3C") || ($line_parsed == $no_refer && $line_parsed != 0) || ($firstday eq '' && $exclude_robot == 1 && ($exclude_robot_nb != $line))) {
    $msg = "\nYour logfile have no data about referer informations\n";
    $msg .= "You can : \n";
    $msg .= " - Check your logfile format contains refer from the web admin\n";
    $msg .= " - Modify your w3perl configuration file by removing the %referer string in \$struct_logfile\n";
    $msg .= " - Disable running this script from the web interface\n";
    $msg .= "\n";
    &error_exit($msg,0);
}

    if ($line == $nbline) {
	&error_exit("Nothing new\n",0);
    }

sub nextlog {

    $day++ if ($zipcut == 2);
    $day = 1 if ($zipcut == 1);

    if ($day > $month_of_year{$month_nb[$monthprev]}) {
	$month++;
	$monthprev++;
	$day = "1";
    } else {
	$month++ if ($zipcut == 1);
	$monthprev = $month-1;
    }

    if ($month == 2) {
	if (($year%4 == 0 && $year%100 != 0) || $year%400 == 0) {
	    $month_of_year{'Feb'} = "29";
	    $bisextil = 1;
	} else {
	    $month_of_year{'Feb'} = "28";
	    $bisextil = 0;
	}
    }

    $year++ if ($month == 13);
    $month = "1" if ($month == 13);
    $day = "0".$day if (length($day) == 1 && $struct_compressed_logfile !~ /\%smallday/);
    $month = "0".$month if (length($month) == 1 && $struct_compressed_logfile !~ /\%smallmonth/);
    $monthprev = 0 if ($month == 1);
    $lettermonth = $month_nb[$monthprev];
#    $filerefer = $fileroot;
    $smallyear = $year - int($year/100)*100;
    $smallyear = "0".$smallyear if (length($smallyear) == 1);
    $smallday = $day;
    $smallmonth = $month;

    $rotate_index-- if ($zipcut == 3);
    if ($rotate_index < 0) {
	&error_exit("Problem with apache rotating file",1);
    }
    
    if ($real_deb == 0) {
	$date_filename = $day.$dirsepurl.$lettermonth.$dirsepurl.$year; # Format XX/Mmm/YYYY
	$filerefer = &Get_LogfileName($fileroot);
#	for ($i=1;$i<=$#compressed_logfile_fields;$i++) {

#	    $compressed_logfile_fields[$i] =~ s/\%/\$/;
#	    $filerefer .= eval($compressed_logfile_fields[$i]).$compressed_sep_fields[$i];
#	}
    }

    
    if ($real_deb == 1) {    
	if ($struct_compressed_logfile =~ /\%hour/ && $struct_compressed_logfile =~ /\%min/ && $struct_compressed_logfile =~ /\%sec/) {
	    
	    $abort = 1;
	    for ($j=0;$j<$re;$j++) {
		$abort = 0 if ($tab_re[$j] eq "$day $month $year");
	    }

	    if ($abort == 0) {
		$sec = 60;
		$min = 59;
		$hour = 23;
		for ($k=0;$k<86400;$k++) {
		    
		    $filerefer = $fileroot;
		    $sec--;
		    if ($sec < 0) {
			$min--;
			if ($min < 0) {
			    $hour--;
			    $min = 59;
			}
			$sec = 59;
		    }
		    
		    $hour = "0".$hour if (length($hour) == 1);
		    $min = "0".$min if (length($min) == 1);
		    $sec = "0".$sec if (length($sec) == 1);
		    $filerefer = &Get_LogfileName($fileroot);
#		    for ($i=1;$i<=$#compressed_logfile_fields;$i++) {
#			$filerefer .= eval($compressed_logfile_fields[$i]).$compressed_sep_fields[$i];
#		    }
		    last if (-f $filerefer);
		}
	    }
	}
    }
    
    $filezip = $filerefer.$zipext if ($zip == 1);
    $datezip = $year.$month.$day;    
}

###################################################################

if ($struct_logfile =~ /\%refer/) {
#if ($prefixlog eq $referlog) {
    for ($nblang=0;$nblang<=$#lang;$nblang++) {

        $tabdays = $path.$lang[$nblang].$dirsep.$dirdate.$dirsep.$refer;

        open(TABOUT, ">$tabdays") || &error_exit("Error, unable to open $tabdays",1);
        &TableReferHeader(*TABOUT, eval($Lang{$lang[$nblang]}));
        &TableReferDays(*TABOUT, eval($Lang{$lang[$nblang]}));

        print TABOUT "</TABLE>\n";
        print TABOUT "<P><HR><P>\n";    
        print TABOUT "</BODY></HTML>\n";
        close(TABOUT);
    }
}

## NEW
foreach $site (keys(%lastentry)) {
    $exitpage{$lastentry{$site}}++;
    $exitpage2{$lastentry{$site}}++;
    $uniqueexit++ if ($exitpage{$lastentry{$site}} == 1);
}

$boucleexit = $topten if ($uniqueexit > $topten);
$boucleexit = $uniqueexit if ($uniqueexit <= ($topten-1));

for ($i=0;$i < $boucleexit;$i++) {
    $maxi = 0;
    foreach $url (keys(%exitpage)) {
	if ($exitpage{$url} > $maxi) {
	    $maxi = $exitpage{$url};
	    $bestexit[$i] = $url;
	    $occurexit[$i] = $maxi;
	}
    }
    $exitpage{$bestexit[$i]} = 0;
}

#################################################################
####                  tri des meilleurs                   #######
#################################################################


# tri des $topten meilleurs sites de referer
$boucle = $topten unless ($unique < $topten);
$boucle = $unique unless ($unique > ($topten-1));
$bouclep = 0;
$tmp = 0;

for ($i=0;$i < $boucle;$i++) {
$maxi = 0;
foreach $site (keys(%nbre)) {
    if ($nbre{$site} > $maxi) {
         $maxi = $nbre{$site};
         $bestsite[$i] = $site;
	 $occursite[$i] = $nbre{$site};
         }
    }
$nbre{$bestsite[$i]} = 0;
}

for ($i=0;$i < $boucle;$i++) {
$maxi = 0;
foreach $site (keys(%nbre_site)) {
    if ($nbre_site{$site} > $maxi) {
         $maxi = $nbre_site{$site};
         $bestsite_site[$i] = $site;
	 $occursite_site[$i] = $nbre_site{$site};
         }
    }
$nbre_site{$bestsite_site[$i]} = 0;
}


# tri des $topten meilleurs pages de referer

foreach $fullsite (keys(%nbrefull)) {
    $tmp++;
    $bouclep++ if ($fullsite =~ /\?/);
}

#for ($i=0;$i < $boucle;$i++) {
#$maxi = 0;
#foreach $fullsite (keys(%nbrefull)) {

#   if ($nbrefull{$fullsite} > $maxi && $fullsite !~ /\?/) {
#         $maxi = $nbrefull{$fullsite};
#         $bestfullsite[$i] = $fullsite;
#         $occurfullsite[$i] = $nbrefull{$fullsite};
##	 print "$i - $bestfullsite[$i] - $nbrefull{$fullsite}\n";
#         }
#    }
#$nbrefull{$bestfullsite[$i]} = 0;
#}

#print STDERR "B - $tmp - $bouclep - $boucle\n";

$bouclep = $bouclep/$boucle if ($boucle != 0);

#print STDERR "B - $tmp - $bouclep\n";

$bouclep = $tmp - $bouclep;
$bouclep = $boucle if ($bouclep > $boucle);

#print STDERR "B - $tmp - $bouclep\n";

# On retire les acces doubles (repertoire + racine)
$tmp = 0;
$url2 = "$dirsepurl$bookmark_url";
foreach $url (keys(%bookmark)) {
    $tmp += $bookmark{$url} if ($url ne $url2);
}

$bookmark{$url2} -= $tmp;

# tri des $topten meilleurs bookmarks
$bouclebookmark = $topten if ($uniquebookmark > $topten);
$bouclebookmark = $uniquebookmark if ($uniquebookmark <= $topten);

for ($i=0;$i < $bouclebookmark;$i++) {
    $maxi = 0;
    foreach $url (keys(%bookmark)) {
	if ($bookmark{$url} > $maxi) {
	    $maxi = $bookmark{$url};
	    $bestbookmark[$i] = $url;
	    $occurbookmark[$i] = $maxi;
	}
    }
    $bookmark{$bestbookmark[$i]} = 0;
}

for ($i=0;$i < $bouclebookmark;$i++) {
    $bestbookmark[$i] =~ s/$bookmark_url/$defaulthomepage/;
}

# tri des $topten meilleurs mailto:// file://


#	    $nb_protoc{$tmp}++;
#	    $protoc_value{$tmp,$tmp2}++;
#	    $nb_protoc_unique{$tmp}++ if ($protoc_value{$tmp,$tmp2} == 1);
#	    $protoc{$tmp,$nb_protoc_unique{$tmp}} = $tmp2 if ($protoc_value{$tmp,$tmp2} == 1);


@bestlist_protoc = sort bynumber @list_protoc;

for ($j=0;$j<=$#bestlist_protoc;$j++) {
    $tmp = $bestlist_protoc[$j];
    next if ($tmp eq "http");
    $boucle_protoc{$tmp} = $topten unless ($nb_protoc_unique{$tmp} < $topten);
    $boucle_protoc{$tmp} = $nb_protoc_unique{$tmp} unless ($nb_protoc_unique{$tmp} > ($topten-1));

    for ($i=0;$i < $boucle_protoc{$tmp};$i++) {
	$maxi = 0;
	for ($k=0;$k <=$nb_protoc_unique{$tmp};$k++) {
	    $url = $protoc{$tmp,$k};
	    if ($protoc_value{$tmp,$url}> $maxi) {
		$maxi = $protoc_value{$tmp,$url};
		$bestprotoc{$tmp,$i} = $url;
		$occurprotoc{$tmp,$i} = $protoc_value{$tmp,$url};
	    }
	}
	$protoc_value{$tmp,$bestprotoc{$tmp,$i}} = 0;
    }
}

# tri des $topten meilleures references internes

$boucle3 = $topten unless ($uniqueinternal < $topten);
$boucle3 = $uniqueinternal unless ($uniqueinternal > ($topten-1));

for ($i=0;$i < $boucle3;$i++) {
$maxi = 0;
foreach $url (keys(%internal)) {
    if ($internal{$url} > $maxi) {
         $maxi = $internal{$url};
         $bestinternal[$i] = $url;
         $occurinternal[$i] = $internal{$url};
         }
    }
$internal{$bestinternal[$i]} = 0;
}

# tri des $topten meilleures pages d'arrivee de referee

$boucle2 = $topten unless ($uniqueurl < $topten);
$boucle2 = $uniqueurl unless ($uniqueurl > ($topten-1));

foreach $url (keys(%occur)) {
    $occur2{$url} = $occur{$url};
}

for ($i=0;$i < $boucle2;$i++) {
$maxi = 0;
foreach $url (keys(%occur)) {
    if ($occur{$url} > $maxi) {
         $maxi = $occur{$url};
         $besturl[$i] = $url;
         $timeurl[$i] = $occur{$url};
         }
    }
$occur{$besturl[$i]} = 0;
}

# tri des $topten meilleurs keywords from engine search

#$bouclewords = $topten unless (($#words+1) < $topten);
#$bouclewords = ($#words+1) unless (($#words+1) > ($topten-1));

#for ($i=0;$i < $bouclewords;$i++) {
#	$maxi = 0;
#	for ($j=0;$j<=$#words;$j++) {
#	if ($w{$words[$j]} > $maxi) {
#		$maxi = $w{$words[$j]};
#		$bestwords[$i] = $words[$j];
#		$occurwords[$i] = $w{$words[$j]};
#		}
#	}
#        $w{$bestwords[$i]} = 0;
#	}
	
# tri des $topten meilleurs search engine site

#for ($i=0;$i<=$#postring;$i++) {
#for ($j=1;$j<=$grnb{$postring[$i]};$j++) {
#print  "AAZ - $i $postring[$i] - $grnb{$postring[$i]}\n";
#print STDERR "AA - $i $j $postring[$i] $gr{$postring[$i],$j} $grnb{$postring[$i]}\n";
#}
#}
#print STDERR "\n";


for ($i=0;$i<=$#postring;$i++) {
    $match = 0;
#$doublon++ if (length($postring[$i]) < 3);
#if ($match == 0) {
  LABEL:
    for ($k=0;$k<=$#postring;$k++) {
	next LABEL if ($i == $k);
	$match = 0; # if (length($postring[$i]) > 2);
      LABEL2:
	for ($j=1;$j<=$grnb{$postring[$i]};$j++) {
	    $match++ if ($gr{$postring[$k],1} eq $gr{$postring[$i],$j} && $postring[$k] ne '' && $postring[$i] ne '');
#print STDERR "$i $postring[$i] $k $postring[$k] $j $gr{$postring[$k],1} $gr{$postring[$i],$j}\n" if ($match > 0);
	    last LABEL2 if ($match > 0);
	}
#}

	if ($match > 0) {
#print STDERR "B : $match - $postring[$i] $postring[$k]\n";
	    if ($grnb{$postring[$i]} < $grnb{$postring[$k]}) {
#print STDERR "$postring[$i] $grnb{$postring[$i]} $grnb{$postring[$k]} est un doublon\n";
		$grnb{$postring[$i]} = 0;
		$postring[$i] = '';
	    }

	    if ($grnb{$postring[$i]} >= $grnb{$postring[$k]}) {
#print STDERR "$postring[$k] $grnb{$postring[$i]} $grnb{$postring[$k]} est un doublon\n";
		$grnb{$postring[$k]} = 0;
		$postring[$k] = '';
	    }
	    $doublon++;
	}
    }

}

$bouclerobot = $topten unless (($#postring+1-$doublon) < $topten);
$bouclerobot = ($#postring+1-$doublon) unless (($#postring+1-$doublon) > ($topten-1));

for ($i=0;$i<=$bouclerobot;$i++) {
    $maxi = 0;
    for ($j=0;$j<=$#postring;$j++) {
	if ($grnb{$postring[$j]} > $maxi) {
	    $maxi = $grnb{$postring[$j]};
	    $bestrobot[$i] = $postring[$j];
	    $occurrobot[$i] = $grnb{$postring[$j]};

	}

    }
    $grnb{$bestrobot[$i]} = 0;
}
		

#

for ($i=0;$i<$bouclerobot;$i++) {

    $tmpbou[$i] = $topten if ($occurrobot[$i] > $topten);
    $tmpbou[$i] = $occurrobot[$i] if ($occurrobot[$i] <= $topten);

    for ($k=1;$k <= $tmpbou[$i];$k++) {
	$maxi = 0;
	for ($j=0;$j<=$occurrobot[$i];$j++) {
	    $tmp2 = $full{$bestrobot[$i],$pagerobot{$bestrobot[$i],$j}};
	    if ($tmp2 > $maxi) {
		$maxi = $tmp2;
		$aa = $k;
		$pagerobot2{$bestrobot[$i],$k} = $pagerobot{$bestrobot[$i],$j};
		$full2{$bestrobot[$i],$pagerobot2{$bestrobot[$i],$k}} = $tmp2;
	    }
	}
	$full{$bestrobot[$i],$pagerobot2{$bestrobot[$i],$aa}} = 0;
    }
}

#

#for ($i=0;$i<=$#postring;$i++) {
    for ($i=0;$i<$bouclerobot;$i++) {
	for ($j=1;$j<=$grnbtot{$bestrobot[$i]};$j++) {
#	    print "A - $bestrobot[$i] - $j - $grtot{$bestrobot[$i],$j} - $keysh{$grtot{$bestrobot[$i],$j}}\n" if ($bestrobot[$i] eq "google");    
	    $tmp_max = 0;
	    for ($k=1;$k<=$grnbtot{$bestrobot[$i]};$k++) {
		if ($keysh{$grtot{$bestrobot[$i],$k}} > $tmp_max) {
		    $tmp3 = $k;
		    $tmp_max = $keysh{$grtot{$bestrobot[$i],$k}};
#		    print "Found max $keysh{$grtot{$bestrobot[$i],$k}} - $tmp_max - $tmp3\n";
		}
	    }
#	    print "MAX : $j - $bestrobot[$i] - $tmp_max pour $tmp3\n" if ($bestrobot[$i] eq "google");  
	    $grtot_sorted{$bestrobot[$i],$j} = $grtot{$bestrobot[$i],$tmp3};
	    $keysh_sorted{$grtot_sorted{$bestrobot[$i],$j}} = $keysh{$grtot{$bestrobot[$i],$tmp3}};
	    $keysh{$grtot{$bestrobot[$i],$tmp3}} = 0;
	}
    }


############################################
### creation du fichier pour les referer ###
############################################

$nb = 0;
$ydayfirst = &nbday($firstday);
foreach $site (sort keys(%pagedate)) {
	$yday = &nbday($pagedate{$site});
	$intervalle = $yday-$ydayfirst;
#	$intervalle += 365 if ($intervalle < 0);
	$tri[$nb] = $intervalle;
	$pagesort[$nb] = $site;
	$nb++;
}

$nb--;

for ($j=0;$j<=$nb;$j++) {
	for ($i=0;$i<$nb;$i++) {
	if ($tri[$j] > $tri[$i]) {
		$tmp = $tri[$j];
		$tri[$j] = $tri[$i];
		$tri[$i] = $tmp;
		
		$tmp = $pagesort[$j];
		$pagesort[$j] = $pagesort[$i];
		$pagesort[$i] = $tmp;
		}
	}
}


for ($nblang=0;$nblang<=$#lang;$nblang++) {

 $tabrefer = $path.$lang[$nblang].$dirsep.$dirlist.$dirsep.$tabnamerefer;

 open(TABREFER,">$tabrefer") || &error_exit("Error, unable to open $tabrefer",1);
 &ReferHeader(*TABREFER, eval($Lang{$lang[$nblang]}));
 close(TABREFER);

 if ($show_all == 1) {
     $list_refer_all = "liste_refer".$htmlext;
     $tabrefer_all = $path.$lang[$nblang].$dirsep.$dirlist.$dirsep.$list_refer_all;
     open(TABREFERALL,">$tabrefer_all") || &error_exit("Error, unable to open $tabrefer_all",1);
     &ReferHeaderAll(*TABREFERALL, eval($Lang{$lang[$nblang]}));
     close(TABREFERALL);
 }

 $tabkeyword = $path.$lang[$nblang].$dirsep.$dirlist.$dirsep.$tabnamekeyword;

 open(TABKEYWORD,">$tabkeyword") || &error_exit("Error, unable to open $tabkeyword",1);
 &Keyword(*TABKEYWORD, eval($Lang{$lang[$nblang]}));
 close(TABKEYWORD);
}

&update_homepage;

# calculer le temps mis pour le calcul

$datesyst = &ctime(time);
($dayletter,$month,$day,$hourdate,$a,$year) = split(/[ \t\n\[]+/,$datesyst);
($hour,$minute,$second) = split(/:/,$hourdate);

$endrun = "$hour:$minute:$second";

($hour,$min,$sec) = &timetaken($startrun,$endrun);

$endtime = time();
#printf STDOUT "Computing took %d CPU secondes\n",$endtime - $starttime;
#print "<BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");
print "Computing took";
print " $hour h" if ($hour > 0);
print " $min min $sec sec\n\n";
print "<P>" if ($ENV{'REQUEST_METHOD'} eq "GET");

&admin_goback if ($ENV{'REQUEST_METHOD'} eq "GET" && $opt_y eq '');

open(FILE,">>$history");
#print FILE "cron-refer\t$today\t$startrun\t$endrun\t$min:$sec\t$line\n";
printf FILE "cron-refer\t%s\t%s\t%s\t%d:%d:%d\t%d\n",$today,$startrun,$endrun,$hour,$min,$sec,$line;
close(FILE);

#########################################################################

sub ReferHeaderAll {
  local(*FOUT,*L) = @_;

  print FOUT "$doctype\n";
  print FOUT "<HTML><HEAD>\n";
  print FOUT "$charset\n";
  print FOUT "<TITLE>$L{'Referer_about'} $localserver</TITLE>\n" if ($virtualfilter eq '');
  print FOUT "<TITLE>$L{'Referer_about'} $virtualfilter</TITLE>\n" if ($virtualfilter ne ''); 
  print FOUT "<!-- Page generated by w3perl - cron-refer.pl $version - $today $hourdate -->\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$helpjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$sorttablejs\"></script>\n";
  print FOUT "<link rel=\"stylesheet\" type=\"text/css\" href=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dircss$dirsepurl$css_w3perl\">\n";
  print FOUT "<link rel=\"stylesheet\" type=\"text/css\" href=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dircss$dirsepurl$css_help\">\n";
  print FOUT "</HEAD>\n";
  print FOUT "<BODY $backgrd TEXT=\"$custom_text\" LINK=\"$custom_link\" VLINK=\"$custom_vlink\">\n";
  print FOUT "<H3>$L{'Referer_pages2'}</H3>\n<P>\n";

  &PagesExportPDF(*FOUT,"I$dirsep$dirlist$dirsep$list_refer_all",$L{'Referer'},2,0) if ($enable_pdf == 1);

  $tmp = "http";
  print FOUT "<DIV CLASS=\"item_page\">-&nbsp;<I>$L{'The_Top'} $nb_protoc{$tmp} $L{'referer_pages1'} :</I></DIV><P>\n";

  print FOUT "<TABLE CLASS=\"sortable_base\" ID=\"List_refer_all\">\n";
#      print FOUT "<TR><TH>$L{'Referer_pages2'}</TH><TH>$L{'Occurence'}</TH></TR>\n";

  print FOUT "<TR>\n<TH>&nbsp;$L{'Referer_pages2'}&nbsp;</TH>\n<TH>&nbsp;<B>$L{'Occurence'}</B>&nbsp;</TH>\n</TR>\n";

  foreach $fullsite (&reverse_sort_by_value(*nbrefull)) {
#  for ($i=0;$i < $bouclep;$i++) {
#      $newbestfullsite = $bestfullsite[$i];
#      $newbestfullsite =~ s/http:\/\///i;#      

      if ($fullsite !~ /\?/) {
	  $newfullsite = $fullsite;
	  $newfullsite =~ s/http:\/\///i;
	  print FOUT "<TR>\n";
	  print FOUT "<TD CLASS=\"left\">";
	  print FOUT "<A HREF=\"$fullsite\" rel=\"nofollow\">";
#      print FOUT "$newbestfullsite";
	  print FOUT "$newfullsite";
	  print FOUT "</A>";
	  print FOUT "</TD>\n";
#      print FOUT "<TD CLASS=\"right\">$occurfullsite[$i]</TD>\n";
	  print FOUT "<TD CLASS=\"right\">$nbrefull{$fullsite}</TD>\n";
	  print FOUT "</TR>\n";
      }
  }
  print FOUT "</TABLE>\n";
  print FOUT "</BODY></HTML>\n\n";
}

#

sub ReferHeader {
  local(*FOUT,*L) = @_;
  local($count);

  print FOUT "$doctype\n";
  print FOUT "<HTML><HEAD>\n";
  print FOUT "$charset\n";
  print FOUT "<TITLE>$L{'Referer_about'} $localserver</TITLE>\n" if ($virtualfilter eq '');
  print FOUT "<TITLE>$L{'Referer_about'} $virtualfilter</TITLE>\n" if ($virtualfilter ne ''); 
  print FOUT "<!-- Page generated by w3perl - cron-refer.pl $version - $today $hourdate -->\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$helpjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$sorttablejs\"></script>\n";
  print FOUT "<link rel=\"stylesheet\" type=\"text/css\" href=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dircss$dirsepurl$css_w3perl\">\n";
  print FOUT "<link rel=\"stylesheet\" type=\"text/css\" href=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dircss$dirsepurl$css_help\">\n";
  print FOUT "</HEAD>\n";
  print FOUT "<BODY $backgrd TEXT=\"$custom_text\" LINK=\"$custom_link\" VLINK=\"$custom_vlink\">\n";

  print FOUT "<TABLE BORDER=0 WIDTH=\"100%\">\n";
  print FOUT "<TR>\n";
  print FOUT "<TD ALIGN=LEFT VALIGN=MIDDLE WIDTH=\"20%\">";
  
  print FOUT "</TD>\n";
  print FOUT "<TD ALIGN=CENTER WIDTH=\"60%\">\n";

  print FOUT "<TABLE BORDER=1 BGCOLOR=\"#000000\">\n<TR>\n<TD BGCOLOR=\"#FFEECC\" ALIGN=CENTER>\n";
  print FOUT "<H1>".uc(&noaccentinhtml($L{'References_for'}))." $localserver </H1>\n<P>\n" if ($virtualfilter eq '');
  print FOUT "<H1>".uc(&noaccentinhtml($L{'References_for'}))." $virtualfilter </H1>\n<P>\n" if ($virtualfilter ne ''); 
  print FOUT "</TD>\n</TR>\n</TABLE>\n";

  print FOUT "</TD>\n";
  print FOUT "<TD ALIGN=RIGHT VALIGN=MIDDLE WIDTH=\"20%\">\n";

#  print FOUT "<P>\n<A HREF=\"$tabnamekeyword\">$L{'Search_engine'}</A> $L{'on'} $localserver\n" if ($virtualfilter eq '');
#  print FOUT "<P>\n<A HREF=\"$tabnamekeyword\">$L{'Search_engine'}</A> $L{'on'} $virtualfilter\n" if ($virtualfilter ne '');
 
  if ($struct_logfile =~ /\%refer/ && $count_day != 0) { 
      print FOUT "<BR>$L{'Tab_about_lastdays1'} <A HREF=\"..$dirsepurl$dirdate$dirsepurl$refer\">$count_day $L{'Tab_about_lastdays2'}</A>";
  }

  print FOUT "</TD>\n";
  print FOUT "</TR>\n";
  print FOUT "</TABLE>\n";

  print FOUT "<HR SIZE=5>\n";
  if ($struct_logfile =~ /\%refer/) {
      print FOUT "<CENTER><B>$firstday - $jourfin</B></CENTER>\n";
      print FOUT "<HR SIZE=5>\n";
  }

  print FOUT "<P>\n";

  $tmp = $direct+$website+$engine;
  $percentage = int($direct*100/$tmp);
  $tmp2 = $L{'coming_from'};
  $tmp2 = uc(substr($tmp2,0,1)).substr($tmp2,1,length($tmp2));
  print FOUT "<DIV CLASS=\"item_page\">-&nbsp;$tmp2</DIV><p>\n";

  print FOUT "<TABLE CLASS=\"sortable_base\" ID=\"refer_direct\">";
  print FOUT "<TR><TH>&nbsp;$L{'Method'}&nbsp;</TH><TH>&nbsp;$L{'Occurence'}&nbsp;</TH><TH>&nbsp;$L{'Percentage'}&nbsp;</TH></TR>\n";
  print FOUT "<TR><TD CLASS=\"left\">$L{'Unknown'}</TD><TD CLASS=\"right\">$direct</TD><TD CLASS=\"right\">$percentage %</TD></TR>\n";
  $percentage = int($website*100/$tmp);
  print FOUT "<TR><TD CLASS=\"left\">$L{'Hosts'}</TD><TD CLASS=\"right\">$website</TD><TD CLASS=\"right\">$percentage %</TD></TR>\n";
  $percentage = int($engine*100/$tmp);
  print FOUT "<TR><TD CLASS=\"left\">$L{'Search_engine'}</TD><TD CLASS=\"right\">$engine</TD><TD CLASS=\"right\">$percentage %</TD></TR>\n";
  print FOUT "</TABLE>\n";

  print FOUT "<P>";

  print FOUT "<DIV CLASS=\"item_page\">-&nbsp;$L{'The_Top'} $bouclebookmark $L{'most_successful_bookmark'}</DIV><p>\n";
  print FOUT "<TABLE CLASS=\"sortable_base\" ID=\"bookmark\">\n";
  print FOUT "<TR>\n<TH>&nbsp;$L{'Bookmarked_page'}&nbsp;</TH>\n<TH>&nbsp;$L{'Occurence'}&nbsp;</TH>\n</TR>\n";
  for ($i=0;$i < $bouclebookmark;$i++) {
      print FOUT "<TR>\n<TD CLASS=\"left\">";
      print FOUT "$bestbookmark[$i]" if ($titlename == 0 || $urlconv{$bestbookmark[$i]} eq '');
      print FOUT "$urlconv{$bestbookmark[$i]}" if ($titlename == 1 && $urlconv{$bestbookmark[$i]} ne '');
      print FOUT "</TD>\n<TD CLASS=\"right\"><B>$occurbookmark[$i]</B></TD>\n</TR>\n";
  }
  print FOUT "</TABLE>\n\n";
  
  print FOUT "<P><BR>\n\n";

  print FOUT "<TABLE><TR>";
  print FOUT "<TD VALIGN=TOP>";

  print FOUT "<DIV CLASS=\"item_page\">-&nbsp;$L{'The_Top'} $boucle $L{'search_engine'}</DIV><P>\n";
  print FOUT "<TABLE CLASS=\"sortable_base\" ID=\"search_engine\">\n";
  print FOUT "<TR>\n<TH>&nbsp;$L{'Search_engine'}&nbsp;</TH><TH>&nbsp;$L{'Occurence'}&nbsp;</TH>\n</TR>\n";
    for ($i=0;$i < $boucle;$i++) {
      print FOUT "<TR>\n<TD CLASS=\"left\">$bestsite[$i]</TD>\n<TD CLASS=\"right\"><B>$occursite[$i]</B></TD>\n</TR>\n" if ($bestsite[$i] ne '');
  }
  print FOUT "</TABLE>\n\n";

  print FOUT "</TD><TD VALIGN=TOP>";

  print FOUT "<DIV CLASS=\"item_page\">-&nbsp;$L{'The_Top'} $boucle $L{'most_successful_hosts'}</DIV><P>\n";
  print FOUT "<TABLE CLASS=\"sortable_base\" ID=\"hosts\">\n";
  print FOUT "<TR>\n<TH>&nbsp;$L{'Hosts_from'}&nbsp;</TH><TH>&nbsp;$L{'Occurence'}&nbsp;</TH>\n</TR>\n";
  for ($i=0;$i < $boucle;$i++) {
      print FOUT "<TR>\n<TD CLASS=\"left\">$bestsite_site[$i]</TD>\n<TD CLASS=\"right\"><B>$occursite_site[$i]</B></TD>\n</TR>\n" if ($bestsite_site[$i] ne '');
  }
  print FOUT "</TABLE>\n\n";

  print FOUT "</TD></TR></TABLE><P>\n\n";

  $tmp2 = 0;
  for ($j=0;$j<=$#bestlist_protoc;$j++) {
      $tmp = $bestlist_protoc[$j];
      $tmp2 += $nb_protoc{$tmp};
  }

  print FOUT "<DIV CLASS=\"item_page\">-&nbsp;$L{'The_Top'} $bouclep $L{'referer_pages1'} (<A HREF=\"$list_refer_all\">$L{'Full_list'}</A>)</DIV><p>\n" if ($show_all == 1);

  print FOUT "<TABLE>\n";
  print FOUT "<TR><TH COLSPAN=2>&nbsp;$L{'Method'}&nbsp;</TH></TR>\n";
  print FOUT "<TR><TD>\n";
  print FOUT "<TABLE CLASS=\"sortable_base\" ID=\"list_protoc\">\n";
  print FOUT "<TR>\n<TH>&nbsp;$L{'Method'}&nbsp;</TH><TH>&nbsp;$L{'Occurence'}&nbsp;</TH><TH>&nbsp;$L{'Percentage'}&nbsp;</TH>\n</TR>\n";

  for ($j=0;$j<=$#bestlist_protoc;$j++) {
      $tmp = $bestlist_protoc[$j];
      $percentage = ($nb_protoc{$tmp}*100)/$tmp2 if ($tmp2 != 0);
      print FOUT "<TR>\n<TD>&nbsp;$tmp://&nbsp;</TD>\n<TD CLASS=\"right\">&nbsp;$nb_protoc{$tmp}&nbsp;</TD>";
      printf FOUT "<TD CLASS=\"right\">&nbsp;%.1f %&nbsp;</TD>\n",$percentage;
      print FOUT "</TR>\n";
  }
  print FOUT "</TABLE>\n";
  print FOUT "</TD></TR>\n";
  print FOUT "</TABLE>\n";

  print FOUT "<TABLE>\n";
  print FOUT "<TR><TH COLSPAN=2>&nbsp;$L{'Referer_pages2'}&nbsp;</TH></TR>\n";

  for ($j=0;$j<=$#bestlist_protoc;$j++) {
      $tmp = $bestlist_protoc[$j];

      print FOUT "<TR><TD>\n";
      print FOUT "<TABLE CLASS=\"sortable_base\" ID=\"$tmp\">\n";
#      print FOUT "<TR><TH>$L{'Referer_pages2'}</TH><TH>$L{'Occurence'}</TH></TR>\n";

      print FOUT "<TR>\n<TH>&nbsp;$tmp://&nbsp;</TH>\n<TH>&nbsp;<B>$nb_protoc{$tmp}</B>&nbsp;</TH>\n</TR>\n";

      if ($tmp eq "http") {
	  foreach $fullsite (&reverse_sort_by_value(*nbrefull)) {
	      if ($fullsite !~ /\?/) {
#	  for ($i=0;$i < $bouclep;$i++) {
		  if ($count < $bouclep) {
		      $count++;
		      $newbestfullsite = $fullsite;
#	      $newbestfullsite = $bestfullsite[$i];
		      $newbestfullsite =~ s/http:\/\///i;
		      print FOUT "<TR>\n";
		      print FOUT "<TD CLASS=\"left\">";
#	      print FOUT "<A HREF=\"$bestfullsite[$i]\" rel=\"nofollow\">";
		      print FOUT "<A HREF=\"$fullsite\" rel=\"nofollow\">";
		      print FOUT "$newbestfullsite";
		      print FOUT "</A>";
		      print FOUT "</TD>\n";
#	      print FOUT "<TD CLASS=\"right\">$occurfullsite[$i]</TD>\n";
		      print FOUT "<TD CLASS=\"right\">$nbrefull{$fullsite}</TD>\n";
		      print FOUT "</TR>\n";
		  }
	      }
	  }
      } else {
#	  for ($i=1;$i<=$nb_protoc_unique{$tmp};$i++) {
	  for ($i=0;$i <$boucle_protoc{$tmp};$i++) {
#	      $tmp2 = $protoc{$tmp,$i};
	      $tmp2 = $bestprotoc{$tmp,$i};
	      $tmp2 =~ s/\\x([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
	      $tmp2 =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
#	      print FOUT "<TR><TD>$protoc{$tmp,$i}</TD><TD ALIGN=MIDDLE>$protoc_value{$tmp,$protoc{$tmp,$i}}</TD></TR>\n";
#	      print FOUT "<TR><TD>$tmp2</TD><TD ALIGN=RIGHT>$protoc_value{$tmp,$protoc{$tmp,$i}}</TD></TR>\n";
	      print FOUT "<TR>\n<TD CLASS=\"left\">$tmp2</TD><TD CLASS=\"right\">$occurprotoc{$tmp,$i}</TD>\n</TR>\n";
	  }
      }
      print FOUT "</TABLE>\n";
      print FOUT "</TD></TR>\n";
  }
  print FOUT "</TABLE>\n\n";

  if ($type_serveur != 2) {
      print FOUT "<P>\n";

      print FOUT "<DIV CLASS=\"item_page\">-&nbsp;$L{'The_Top'} $boucle3 $L{'internal_pages'}</DIV><p>\n";
      print FOUT "<TABLE CLASS=\"sortable_base\" ID=\"internal\">\n";
      print FOUT "<TR><TH>&nbsp;$L{'Internal_pages'}&nbsp;</TH><TH>&nbsp;$L{'Occurence'}&nbsp;</TH></TR>\n";

      for ($i=0;$i < $boucle3;$i++) {
	  print FOUT "<TR>\n<TD CLASS=\"left\">";
	  if (-f "$pathserver$bestinternal[$i]") {
	      print FOUT "<A HREF=\"$bestinternal[$i]\"";
	      print FOUT " TITLE=\"$bestinternal[$i]\"" if ($titlename == 1 && $urlconv{$bestinternal[$i]} ne '');
	      print FOUT ">";
	  }
	  print FOUT "$bestinternal[$i]" if ($titlename == 0 || $urlconv{$bestinternal[$i]} eq '');
	  print FOUT "$urlconv{$bestinternal[$i]}" if ($titlename == 1 && $urlconv{$bestinternal[$i]} ne '');
	  print FOUT "</A>" if (-f "$pathserver$bestinternal[$i]");
	  print FOUT "</TD>\n<TD CLASS=\"right\"><B>$occurinternal[$i]</B></TD>\n</TR>\n";
      }
      
      print FOUT "</TABLE>\n\n";
  }

  if ($type_serveur != 2) {
      print FOUT "<P>\n\n";

      print FOUT "<DIV CLASS=\"item_page\">-&nbsp;$L{'The_Top'} $boucle $L{'entry_pages'}</DIV><p>\n";
      print FOUT "<TABLE CLASS=\"sortable_base\" ID=\"entry\">\n";
      print FOUT "<TR>\n<TH>&nbsp;$L{'Entry_pages'}&nbsp;</TH>\n<TH>&nbsp;$L{'Occurence'}&nbsp;</TH>\n<TH>&nbsp;$L{'Exit_occurence'}&nbsp;</TH>\n<TH>&nbsp;$L{'Percentage'}&nbsp;</TH>\n</TR>\n";
      
      for ($i=0;$i < $boucle2;$i++) {
	  print FOUT "<TR>\n<TD CLASS=\"left\">";
#print FOUT "<A HREF=\"http://$localserver$besturl[$i]\">";
	  if (-f "$pathserver$besturl[$i]") {
	      print FOUT "<A HREF=\"$besturl[$i]\"";
	      print FOUT " TITLE=\"$besturl[$i]\"" if ($titlename == 1 && $urlconv{$besturl[$i]} ne '');
	      print FOUT ">";
	  }
	  print FOUT "$besturl[$i]" if ($titlename == 0 || $urlconv{$besturl[$i]} eq '');
	  print FOUT "$urlconv{$besturl[$i]}" if ($titlename == 1 && $urlconv{$besturl[$i]} ne '');
	  print FOUT "</A>" if (-f "$pathserver$besturl[$i]");
	  print FOUT "</TD>\n<TD CLASS=\"right\"><B>$timeurl[$i]</B></TD>\n";
	  print FOUT "<TD CLASS=\"right\">";
	  print FOUT "<B>$exitpage2{$besturl[$i]}</B>" if ($exitpage2{$besturl[$i]} ne '');
	  print FOUT "<B>0</B>" if ($exitpage2{$besturl[$i]} eq '');
	  print FOUT "</TD>\n";
	  $percentage = int(100*($timeurl[$i]-$exitpage2{$besturl[$i]})/$timeurl[$i]);
	  print FOUT "<TD CLASS=\"right\">";
	  print FOUT "$percentage %";
	  print FOUT "</TD>\n";
	  print FOUT "</TR>\n";
      }

      print FOUT "</TABLE>\n\n";

      print FOUT "<P>\n\n";

      print FOUT "<DIV CLASS=\"item_page\">-&nbsp;$L{'The_Top'} $boucleexit $L{'exit_pages'}</DIV><p>\n";
      print FOUT "<TABLE CLASS=\"sortable_base\" ID=\"exit\">\n";
      print FOUT "<TR><TH>&nbsp;$L{'Exit_pages'}&nbsp;</TH>\n<TH>&nbsp;$L{'Occurence'}&nbsp;</TH>\n<TH>&nbsp;$L{'Entry_occurence'}&nbsp;</TH><TH>&nbsp;$L{'Percentage'}&nbsp;</TH>\n</TR>\n";
      
      for ($i=0;$i < $boucleexit;$i++) {
	  print FOUT "<TR>\n<TD CLASS=\"left\">";
#print FOUT "<A HREF=\"http://$localserver$besturl[$i]\">";
	  if (-f "$pathserver$bestexit[$i]") {
	      print FOUT "<A HREF=\"$bestexit[$i]\"";
	      print FOUT " TITLE=\"$bestexit[$i]\"" if ($titlename == 1 && $urlconv{$bestexit[$i]} ne '');
	      print FOUT ">";
	  }
	  print FOUT "$bestexit[$i]" if ($titlename == 0 || $urlconv{$bestexit[$i]} eq '');
	  print FOUT "$urlconv{$bestexit[$i]}" if ($titlename == 1 && $urlconv{$bestexit[$i]} ne '');
	  print FOUT "</A>" if (-f "$pathserver$bestexit[$i]");
	  print FOUT "</TD>\n<TD CLASS=\"right\"><B>$occurexit[$i]</B></TD>\n";
	  print FOUT "<TD CLASS=\"right\">";
	  print FOUT "<B>$occur2{$bestexit[$i]}</B>" if ($occur2{$bestexit[$i]} ne '');
	  print FOUT "<B>0</B>" if ($occur2{$bestexit[$i]} eq '');
	  print FOUT "</TD>\n";
	  $percentage = int(100*($occur2{$bestexit[$i]}-$occurexit[$i])/$occur2{$bestexit[$i]});
	  print FOUT "<TD CLASS=\"right\">";
	  print FOUT "$percentage %";
	  print FOUT "</TD>\n";
	  print FOUT "</TR>\n";
      }
      
      print FOUT "</TABLE>\n\n";
  }

  if ($opt_p ne '' && $nb >= 0 && $type_serveur != 2) {

      print FOUT "<P>\n";

      print FOUT "<DIV CLASS=\"item_page\">-&nbsp;$L{'Referer_on'} $pageselect ($firstday - $jourfin)</DIV><p>\n";
    
      print FOUT "<TABLE CLASS=\"sortable_base\" ID=\"refpages\">\n";
      print FOUT "<TR>\n<TH>&nbsp;$L{'Referer_pages2'}&nbsp;</TH>\n<TH>&nbsp;$L{'Occurence'}&nbsp;</TH>\n<TH>&nbsp;$L{'Last_occurence'}&nbsp;</TH>\n</TR>\n";

      for ($i=0;$i<=$nb;$i++) {
	  $site = $pagesort[$i];
	  print FOUT "<TR>\n<TD CLASS=\"left\"><A HREF=\"http://$site\" rel=\"nofollow\">";
	  $tmp = $site;
	  if ($tmp =~ /\?/) {
	      ($tmp,$query) = split(/\?/,$tmp);
	      $tmp = substr($tmp,0,rindex($tmp,$dirsepurl));
	  }
	  print FOUT "$tmp";
	  print FOUT "</A>";
	  print FOUT " <I>[$pagequery{$site}]</I>" if ($pagequery{$site} ne '');
	  print FOUT "</TD>\n";
	  print FOUT "<TD CLASS=\"right\"><B>$page{$site}</B></TD>\n";
	  print FOUT "<TD CLASS=\"right\"><I>$pagedate{$site}</I></TD>\n</TR>\n";
      }

#foreach $site (keys(%page)) {
#print FOUT "<TR>\n<TD><A HREF=\"http://$site\" rel=\"nofollow\">";
#print FOUT "$site";
#print FOUT "</A>";
#print FOUT " <I>[$pagequery{$site}]</I>" if ($pagequery{$site} ne '');
#print FOUT "</TD>\n";
#print FOUT "<TD align=middle><B>$page{$site}</B> $L{'times'}</TD>\n";
#print FOUT "<TD align=middle><I>$pagedate{$site}</I></TD>\n</TR>\n";
#}

      print FOUT "</TABLE>\n\n";
  }

  print FOUT "</BODY></HTML>\n";
}
 
#########################################################################

sub TableReferHeader { 
 local(*FOUT,*L) = @_;

 print FOUT "$doctype\n";
 print FOUT "<HTML><HEAD>\n";
 print FOUT "$charset\n";
 print FOUT "<TITLE>$L{'Referer'} - $L{'Tab_about_lastdays1'} $nbdays $L{'Tab_about_lastdays2'} ($L{'Textual_version'})</TITLE>\n";
 print FOUT "<!-- Page generated by w3perl - cron-refer.pl $version - $today $hourdate -->\n";	 
 print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$helpjs\"></script>\n";
 print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$sorttablejs\"></script>\n";
 print FOUT "<link rel=\"stylesheet\" type=\"text/css\" href=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dircss$dirsepurl$css_w3perl\">\n";
 print FOUT "<link rel=\"stylesheet\" type=\"text/css\" href=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dircss$dirsepurl$css_help\">\n";
 print FOUT "</HEAD>\n";
 print FOUT "<BODY $backgrd TEXT=\"$custom_text\"  LINK=\"$custom_link\" VLINK=\"$custom_vlink\">\n";
 print FOUT "<H3>$L{'Tab_about_lastdays1'} $nbdays $L{'Tab_about_lastdays2'}</H3><P>\n";
 print FOUT "<P><HR><P>\n";
 print FOUT "<TABLE CLASS=\"sortable\" ID=\"refheader\">\n";
 print FOUT "<TR>\n";
 print FOUT "<TH>&nbsp;$L{'Date'}&nbsp;</TH>\n";
 print FOUT "<TH>&nbsp;$L{'Hosts'}&nbsp;</TH>\n";
 print FOUT "<TH>&nbsp;$L{'referer_pages1'}&nbsp;</TH>\n";
 print FOUT "<TH>&nbsp;$L{'entry_pages'}&nbsp;</TH>\n";
 print FOUT "<TH>&nbsp;$L{'engine_keywords_used'}&nbsp;</TH>\n";
 print FOUT "</TR>\n";
}

#########################################################################

sub TableReferDays { 
    local(*FOUT,*L) = @_;
    $line = 0;
    $inc = 0;
    $count_day = 1;
    $count_week = 1;
    $m_total = 0;
    $req_total = 0;
    $access_total = 0;

    open(INFILE, "$path$dirdata$dirsep$datafile") || &error_exit("Error, unable to open $path$dirdata$dirsep$datafile",1);
 
    while (<INFILE>) {
	$line++;
	next unless ($line > 3);
	
	$count++;
	$oldjour = $jour;
	$oldmonth = $month;

	($jour,$month,$year,$uniqueday,$uniquenbrefullday,$uniqueurlday,$words) = split('\s+');

	$words = 0 if ($words < 0);

	if ($nbdays != 0) {

	    # nombre de jour depuis le 1er janvier
	    
	    $jour_of_year = 0;
	    $countmonth = 0;
	    $month_end = $month_nb[$countmonth];
	    
	    while ($month_end ne $month) {
		$jour_of_year += $month_of_year{$month_end};
		$countmonth++;
		$month_end = $month_nb[$countmonth];
	    }
       
	    $jour_of_year += $jour;
	    $jour_ecoule = ($jour_of_year_end+($year_now-$year)*365) - $jour_of_year;

	    if ($jour_ecoule < 1) {
		$jour_ecoule += 365;
		$jour_ecoule += 1 if ($bisextil == 1); 
	    }
	}

	next unless ($jour_ecoule <= $nbdays);

#     print STDERR "JOUR_ECOULE : $jour_ecoule - NBDAYS : $nbdays - $year : $year_now - JOUR_OF_YEAR : $jour_of_year\n";
     
	$inc++;
	$day = $jour." ".$month." ".$year;  
	
	if ( $start_date eq '') {
	    $start_date = $day;
	}

	### test sur le jour suivant
    
	$intervalle = $jour - $oldjour;
	if ($intervalle != 1 && $line > 4) {
	    if ($oldmonth ne $month) {
		$intervalle = $month_of_year{$oldmonth} - $oldjour; # suppose le mois suivant
		$intervalle += $jour;
	    }
	    $affmonth = $oldmonth;
	    for ($i=$count;$i<($intervalle+$count-1);$i++) {
		$oldjour++;
		if ($oldjour > $month_of_year{$oldmonth}) {
		    $oldjour = 1;
		    $affmonth = $month;
		} 
          
#          $oldjour = "0".$oldjour unless (length($oldjour) == 2);
		$oldjour = "0".$oldjour if (length($oldjour) == 1 && $struct_compressed_logfile !~ /\%smallday/);
		$day = $oldjour." ".$affmonth." ".$year;
		
#                print FOUT "<TR>\n<TD CLASS=\"left\"><A NAME=\"$count_day\">$day</TD>\n";
                print FOUT "<TR>\n<TD><A NAME=\"$count_day\">$day</TD>\n";
                print FOUT "<TD CLASS=\"right\">0</TD>\n<TD CLASS=\"right\">0</TD>\n<TD CLASS=\"right\">0</TD>\n<TD CLASS=\"right\">0</TD>\n</TR>\n";

		if ($enable_weekly == 1) {        
		    if ($inc == 7) {
                        print FOUT "<TR><TD></TD>\n<TD>";
                        print FOUT "-" x (2 + length($m_total));
                        print FOUT "</TD>\n<TD>";
                        print FOUT "-" x (2 + length($req_total));
                        print FOUT "</TD><TD>";
                        print FOUT "-" x (2 + length($access_total));
                        print FOUT "</TD>\n</TR>\n";
                        print FOUT "<TR>\n<TD></TD>\n";
                        print FOUT "<TD><B>$m_total</B></TD>\n";
                        print FOUT "\n";
                        print FOUT "<TD><B>$req_total</B></TD>\n";
                        print FOUT "<TD><B>$access_total</B></TD>\n";
                        print FOUT "<TD></TD>\n</TR>\n";
                        print FOUT "<TR>\n<TD COLSPAN=5>&nbsp;</TD>\n</TR>\n";

			$m_total = 0;
			$req_total = 0;
			$access_total = 0;
			$inc -= 7;
		    }
		}
		$inc++;
	    }
	    $count+=$intervalle-1;
	    $count_day += $intervalle-1;
	    $line = $count;
	}
	
	$access_total += $uniqueurlday;
	$m_total += $uniqueday;
	$req_total += $uniquenbrefullday;
	
	$day = $jour." ".$month." ".$year;
	
	$linkjour = "..".$dirsepurl.$dirdate.$dirsepurl.$year."-".$month."-".$jour.$dirsepurl.$refer;
	
	$fulljour = $path.$lang[$nblang].$dirsep.$dirdate.$dirsep.$year."-".$month."-".$jour.$dirsep.$refer;
	
	if (-e $fulljour){
	    $writeday = '<A HREF="'.$linkjour.'">'.$day;
	    $writeday .= "</A>";
	} else {
	    $writeday = $day;
        }
    
	$previousday = $day;

        print FOUT "<TR>\n<TD><A NAME=\"$count_day\">$writeday</TD>\n<TD CLASS=\"right\">$uniqueday</TD>\n<TD CLASS=\"right\">$uniquenbrefullday</TD>\n<TD CLASS=\"right\">$uniqueurlday</TD>\n<TD CLASS=\"right\">$words</TD>\n</TR>\n";
     
	if ($enable_weekly == 1) {
	    if ($inc == 7) {
		
		print FOUT "<TR>\n<TD></TD>\n<TD>";
		print FOUT "-" x (2 + length($m_total));
		print FOUT "</TD>\n<TD>";
		print FOUT "-" x (2 + length($req_total));
		print FOUT "</TD>\n<TD>";
		print FOUT "-" x (2 + length($access_total));
		print FOUT "</TD>\n</TR>\n";
		print FOUT "<TR><TD></TD>\n";
		print FOUT "<TD><B>$m_total</B></TD>\n";
                print FOUT "\n";
                print FOUT "<TD><B>$req_total</B></TD>\n";
                print FOUT "<TD><B>$access_total</B></TD>\n";
                print FOUT "</TR>\n";

                print FOUT "<TR>\n<TD COLSPAN=5>&nbsp;</TD>\n</TR>\n";

		$m_total = 0;
		$req_total = 0;
		$access_total = 0;
		$inc -= 7;
	    }
	}
        
     $count_day++;
	
    }

    $count_day--;
    close(INFILE);
    
}

#########################################################################

sub Keyword {
  local(*FOUT,*L) = @_;
  local($tmp);

  print FOUT "$doctype\n";
  print FOUT "<HTML><HEAD>\n";
  print FOUT "$charset\n";
  print FOUT "<TITLE>$L{'Search_engine'} $L{'on'} $localserver</TITLE>\n";
  print FOUT "<!-- Page generated by w3perl - cron-refer.pl $version - $today $hourdate -->\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$helpjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$sorttablejs\"></script>\n";
  print FOUT "<link rel=\"stylesheet\" type=\"text/css\" href=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dircss$dirsepurl$css_w3perl\">\n";
  print FOUT "<link rel=\"stylesheet\" type=\"text/css\" href=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dircss$dirsepurl$css_help\">\n";
  print FOUT "</HEAD>\n";
  print FOUT "<BODY $backgrd TEXT=\"$custom_text\" LINK=\"$custom_link\" VLINK=\"$custom_vlink\">\n";

  print FOUT "<TABLE BORDER=0 WIDTH=\"100%\">\n";
  print FOUT "<TR>\n";
  print FOUT "<TD ALIGN=LEFT VALIGN=MIDDLE WIDTH=\"20%\">";

  print FOUT "</TD>\n";
  print FOUT "<TD ALIGN=CENTER WIDTH=\"60%\">\n";

  print FOUT "<TABLE BORDER=1 BGCOLOR=\"#000000\">\n<TR>\n<TD BGCOLOR=\"#FFEECC\" ALIGN=CENTER>\n";
  print FOUT "<H1>".uc(&noaccentinhtml($L{'Search_engine'}))." ".uc(&noaccentinhtml($L{'on'}))." $localserver</H1>\n<P>\n";
  print FOUT "</TD>\n</TR>\n</TABLE>\n";

  print FOUT "</TD>\n";
  print FOUT "<TD ALIGN=RIGHT VALIGN=MIDDLE WIDTH=\"20%\">\n";

  print FOUT "</TD>\n";
  print FOUT "</TR>\n";
  print FOUT "</TABLE>\n";

  print FOUT "<HR size=5>\n";
  print FOUT "<CENTER><B>$firstday - $jourfin</B></CENTER>\n\n";
  print FOUT "<HR SIZE=5><P>\n\n";
 
  print FOUT "<DIV CLASS=\"item_page\">-&nbsp;$L{'The_Top'} $bouclewords $L{'engine_keywords_used'}</DIV><p>\n";

  print FOUT "<TABLE CLASS=\"sortable_base\" ID=\"engine\">\n";
  print FOUT "<TR>\n<TH>&nbsp;$L{'Keywords'}&nbsp;</TH><TH>&nbsp;$L{'Occurence'}&nbsp;</TH></TR>\n";


    $i = 0;
    foreach $site (&reverse_sort_by_value(*w)) {
	print FOUT "<TR>\n<TD CLASS=\"left\">$site</TD><TD CLASS=\"right\"><B>$w{$site}</B></TD>\n</TR>\n";
#	print FOUT "<TR>\n<TD CLASS=\"left\">$bestwords[$i]</TD><TD CLASS=\"right\"><B>$occurwords[$i]</B></TD>\n</TR>\n";	    
	$i++;
	last if ($i == $topten);
    }

#  for ($i=0;$i<$bouclewords;$i++) {
#      print FOUT "<TR>\n<TD CLASS=\"left\">$bestwords[$i]</TD><TD CLASS=\"right\"><B>$occurwords[$i]</B></TD>\n</TR>\n";
#  }
  print FOUT "</TABLE>\n";

  print FOUT "<P>\n";

  print FOUT "<DIV CLASS=\"item_page\">-&nbsp;$L{'The_Top'} $bouclerobot $L{'search_engine'}</DIV><p>\n";

  print FOUT "<TABLE CLASS=\"sortable_base\" ID=\"Best_search_engine\">\n";
  print FOUT "<TR>\n<TH>&nbsp;$L{'Search_engine'}&nbsp;</TH><TH>&nbsp;$L{'Occurence'}&nbsp;</TH><TH>&nbsp;$L{'Percentage'}&nbsp;</TH></TR>\n";

  $tmp = 0;
  for ($i=0;$i<$bouclerobot;$i++) {
      $tmp += $occurrobot[$i];
  }

  for ($i=0;$i<$bouclerobot;$i++) {
      if ($occurrobot[$i] > $seuilsite && $tmpbou[$i] != 0) {
	  $percentage = int(($occurrobot[$i]*100/$tmp)*10)/10;
	  print FOUT "<TR>\n";
	  print FOUT "<TD CLASS=\"left\">$bestrobot[$i]</TD>\n";
	  print FOUT "<TD CLASS=\"right\">$occurrobot[$i]</TD>\n";
	  print FOUT "<TD CLASS=\"right\">$percentage %</TD>\n";
	  print FOUT "</TR>\n";
      }
  }
  print FOUT "</TABLE>\n";
  print FOUT "<P>\n";

  print FOUT "<DIV CLASS=\"item_page\">-&nbsp;$L{'Search_engine'}</DIV><p>\n";


  print FOUT "<TABLE BORDER=0>\n";

  for ($i=0;$i<$bouclerobot;$i++) {

      $tmp = '';
      if ($occurrobot[$i] > $seuilsite && $tmpbou[$i] != 0) {
	  
	  print FOUT "<TR><TD WIDTH=\"100%\">\n";

	  print FOUT "<TABLE BORDER=0 WIDTH=\"100%\"><TR><TH ALIGN=CENTER COLSPAN=2><DIV CLASS=\"item_page\"><B>$bestrobot[$i]</B></DIV></TH></TR>\n";
	  print FOUT "<TR><TD VALIGN=TOP WIDTH=\"50%\">\n";

	  print FOUT "<TABLE CLASS=\"sortable_base\" ID=\"$bestrobot[$i]\">\n";
	  print FOUT "<TR><TH>&nbsp;$L{'Hosts'}&nbsp;</TH>\n<TH>&nbsp;$L{'Occurence'}&nbsp;</TH>\n<TH>&nbsp;$L{'Percentage'}&nbsp;</TH></TR>\n";

	  $tmp2 = 0;
	  for ($j=1;$j<=$grnbtot{$bestrobot[$i]};$j++) {
	      $percentage = $keysh_sorted{$grtot_sorted{$bestrobot[$i],$j}}*100/$occurrobot[$i];
	      if ($keysh_sorted{$grtot_sorted{$bestrobot[$i],$j}} > $seuilsite && $tmp2 < $topten) {
		  $tmp2++;
		  print FOUT "<TR>";
		  print FOUT "<TD CLASS=\"left\"><I>$grtot_sorted{$bestrobot[$i],$j}</I></TD>\n";
		  print FOUT "<TD CLASS=\"right\">$keysh_sorted{$grtot_sorted{$bestrobot[$i],$j}}</TD>\n";
		  printf FOUT "<TD CLASS=\"right\">%.1f %</TD>\n",$percentage;
		  print FOUT "</TR>\n";
	      }
	  }
	  print FOUT "</TABLE>\n";

	  print FOUT "</TD><TD VALIGN=TOP WIDTH=\"50%\">\n";

	  $tmp = "<TABLE CLASS=\"sortable_base\" ID=\"String_$bestrobot[$i]\">\n";
	  $tmp .= "<TR><TH>&nbsp;$L{'String'}&nbsp;</TH>\n<TH>&nbsp;$L{'Occurence'}&nbsp;</TH>\n<TH>&nbsp;$L{'Percentage'}&nbsp;</TH></TR>\n";
	  $tmp2 = 0;
	  for ($j=1;$j<=$tmpbou[$i];$j++) {
	      if ($pagerobot2{$bestrobot[$i],$j} ne '' && $full2{$bestrobot[$i],$pagerobot2{$bestrobot[$i],$j}} > 0) {
		  $percentage = int(($full2{$bestrobot[$i],$pagerobot2{$bestrobot[$i],$j}}*100/$occurrobot[$i])*10)/10;
		  $tmp .= "<TR>\n<TD CLASS=\"left\">$pagerobot2{$bestrobot[$i],$j}</TD>\n<TD CLASS=\"right\">$full2{$bestrobot[$i],$pagerobot2{$bestrobot[$i],$j}} $L{'times'}</TD><TD CLASS=\"right\">$percentage %</TD>\n</TR>\n";
		  $tmp2++;
	      }
	  }
	  $tmp .= "</TABLE>\n";

	  print FOUT "$tmp" if ($tmp2 != 0);
	  print FOUT "</TD></TR>\n";
	  print FOUT "</TABLE><P>\n";

	  print FOUT "</TD></TR>";
      }
  }
  print FOUT "</TABLE>\n";
  print FOUT "<P><BR>\n";
  print FOUT "</BODY></HTML>\n";
}
