function clean() {
		document.ajax.search_value.value="";
}

function createRequestObject() {

   var req;

   if(window.XMLHttpRequest){
      req = new XMLHttpRequest();
   } else if(window.ActiveXObject) {
      req = new ActiveXObject("Microsoft.XMLHTTP");
   } else {
      alert('Problem creating the XMLHttpRequest object');
   }

   return req;

}

// check to see if input is number
function isNumber(val)
{
if (isNaN(val))
{
return false;
}
else
{
return true;
} 
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////

function SearchVirtual() { 

	var req = null; 
	var count = 0;

	var search_value = document.ajax.search_value.value;
	var search_value_ini = search_value;
	var datafile = document.ajax.datafile.value;

	var seuilsite = parseInt(document.ajax.seuilsite.value);
//	var precision = parseInt(document.ajax.precision.value);
	var string_th = document.ajax.string_th.value;
	var string_title = document.ajax.string_title.value;
	var threshold = parseInt(document.ajax.search_threshold.value);
	var string_sep = document.ajax.string_sep.value;
	var stats_type = document.ajax.stats.value;

	// Check is a number
	if (!(isNumber(threshold))) {
	   alert("Threshold is not a number, assuming 0");
	   threshold = 0;
	}

	if (threshold == '') threshold = 0;
	var string_tab = string_th.split(":");
	var string_title = string_title.split(":");

	if (search_value) {

	var search_value_lower = search_value.toLowerCase();


	///////////////////////////////////////////////////////////////
	// Datafile

	var req = createRequestObject();

	req.onreadystatechange = function() { 
	if (req.readyState == 4) {
		if (req.status == 200) {

			var results = req.responseText;
			var lines = results.split("\n");

			var data = new Array();
			var page_occur = new Array();
			var result_print;

			var header_str = string_title[1]+" '"+search_value+"'\n<P>";
			var link_page;

			for (i = 0; (i < lines.length); i++) {
			  var line_string = lines[i].split("\n");
			  var line_val = unescape(line_string);

			  if ((line_val.split(string_sep)[0].toLowerCase()).match(search_value_lower)
  				 && parseInt((line_val.split(string_sep)[1])) >= threshold) {

				 data[count] = line_val.split(string_sep)[0];
				 var hit = line_val.split(string_sep)[1];
				 if (stats_type == "repert") {
				 // Repert
				 var access = line_val.split(string_sep)[2];
				 var traffic = line_val.split(string_sep)[4];
				 traffic = parseInt(traffic*100/(1024*1024))/100;
				 page_occur[count] = hit+"|"+access+"|"+traffic;

				 var hit2 = line_val.split(string_sep)[7];
				 var access2 = line_val.split(string_sep)[8];
				 var traffic2 = line_val.split(string_sep)[9];
				 traffic2 = parseInt(traffic2*100/(1024*1024))/100;
				 page_occur[count] += "|"+hit2+"|"+access2+"|"+traffic2;
				 } else {
				 // Users/Virtual
				 var traffic = line_val.split(string_sep)[2];
				 traffic = parseInt(traffic*100/(1024*1024))/100;

				 page_occur[count] = hit+"|"+traffic;

				 if (line_val.split(string_sep)[3] != undefined) {
				 var host = line_val.split(string_sep)[3];
				 var date = line_val.split(string_sep)[4];
				 page_occur[count] += "|"+host+"|"+date;
				 }
				 }

				 count++;
			   }
			 }

			if (count != 0) {

		        // Number of items

			result_print = "Here are the "+count+" result";
			if (count > 1) result_print += "s";
			result_print += " :<P>\n";
			 if (stats_type == "repert") {	
			result_print += "<TABLE CLASS=\"sortable_base\" ID=\"dir_search\">\n";
			} else {
			result_print += "<TABLE CLASS=\"sortable_base\" ID=\"VirtualSearch\">\n";
			}
			result_print += "<TR>\n";
			 if (stats_type == "repert") {	
			result_print += "<TH>&nbsp;</TH>\n";
			result_print += "<TH COLSPAN=3>&nbsp;"+string_tab[5]+"&nbsp;</TH>\n";
			result_print += "<TH COLSPAN=3>&nbsp;"+string_tab[6]+"&nbsp;</TH>\n";
			result_print += "</TR><TR>\n";
			}
			result_print += "<TH>&nbsp;"+string_tab[0]+"&nbsp;</TH>\n";
			result_print += "<TH>&nbsp;"+string_tab[1]+"&nbsp;</TH>\n";
			 if (stats_type == "repert") {	
			result_print += "<TH>&nbsp;"+string_tab[2]+"&nbsp;</TH>\n";
			result_print += "<TH>&nbsp;"+string_tab[3]+"&nbsp;("+string_tab[4]+")</TH>\n";
			result_print += "<TH>&nbsp;"+string_tab[1]+"&nbsp;</TH>\n";
			result_print += "<TH>&nbsp;"+string_tab[2]+"&nbsp;</TH>\n";
			result_print += "<TH>&nbsp;"+string_tab[3]+"&nbsp;("+string_tab[4]+")</TH>\n";
			 } else {
			result_print += "<TH>&nbsp;"+string_tab[2]+"&nbsp;("+string_tab[3]+")</TH>\n";
			if (string_tab[4] != undefined) {
			result_print += "<TH>&nbsp;"+string_tab[4]+"&nbsp;</TH>\n";
			result_print += "<TH>&nbsp;"+string_tab[5]+"&nbsp;</TH>\n";	
			}
			}
			result_print += "</TR>\n";

            		for (i = 0; (i < count); i++) {

			   var obj_occur = page_occur[i].split("|");
	  		   var tmp;

//			   if (obj_occur[0] > seuilsite) {

			   result_print += "<TR>\n";
 
                           result_print += "<TD CLASS=\"left\">";
			   result_print += data[i];
			   result_print += "</TD>\n";

			   for (j = 0; (j < obj_occur.length); j++) {
			       	result_print += "<TD CLASS=\"right\">";
			       	result_print += obj_occur[j];
				result_print += "</TD>\n";
			    }
			    result_print += "</TR>\n";
			   }
//			  }
			  } else {
				 result_print = string_title[2]+"\n<P>";
				 }
			   result_print += "</TABLE>\n";

			   document.getElementById("search_header").innerHTML = header_str;
			   document.getElementById("search_results").innerHTML = result_print;
	
			   var foobar = new domFunction(function() {
					sortTable();
					colorTableRows();
				});

			} else {
                                var header_str = string_title[1]+" '"+search_value+"'\n<P>";
                                var result_print = "Error: returned status code " + req.status + " " + req.statusText;
                                document.getElementById("search_header").innerHTML = header_str;
                                document.getElementById("search_results").innerHTML = result_print;
//			      document.ajax.search_value.value="Error: returned status code " + req.status + " " + req.statusText;
			}

			document.ajax.search_button.value=string_title[0];
			}

			}

	req.open("GET", datafile, true); 
	req.send(null); 

}

	if (search_value != '') document.ajax.search_button.value=string_title[3];
	document.ajax.search_value.focus();
	document.ajax.search_value.value = search_value_ini;

}

////////////////////////////////////////////////////////////////////////////////////////////////////////////

function SearchHosts() { 

	var req = null; 
	var count = 0;

	var search_value = document.ajax.search_value.value;
	var search_value_ini = search_value;
	var datafile = document.ajax.datafile.value;

	var seuilsite = parseInt(document.ajax.seuilsite.value);
	var seuil_auto = parseInt(document.ajax.seuil_auto.value);
	var aff_access = parseInt(document.ajax.aff_access.value);
	var precision = parseInt(document.ajax.precision.value);
	var string_th = document.ajax.string_th.value;
	var string_title = document.ajax.string_title.value;	
	var threshold = parseInt(document.ajax.search_threshold.value);

	// Check is a number
	if (!(isNumber(threshold))) {
	   alert("Threshold is not a number, assuming 0");
	   threshold = 0;
	}

	if (threshold == '') threshold = 0;
	var string_tab = string_th.split(":");
	var string_title = string_title.split(":");

	var mode_local;
	for (var i=0; i<document.ajax.mode_local.length;i++) {
	         if (document.ajax.mode_local[i].checked) {
        	    mode_local = document.ajax.mode_local[i].value;
        	}
	}

	if (mode_local == undefined) mode_local = parseInt(document.ajax.mode_local.value);

	if (mode_local == 1) {
		var datafile_local = document.ajax.datafile_local.value;
		datafile = datafile_local;
	}

	if (search_value) {

	var search_value_lower = search_value.toLowerCase();

	///////////////////////////////////////////////////////////////
	// Datafile

	var req = createRequestObject();

	req.onreadystatechange = function() { 
	if (req.readyState == 4) {
		if (req.status == 200) {

			var results = req.responseText;
			var lines = results.split("\n");

			var data = new Array();
			var page_occur = new Array();
			var result_print;

			var header_str = string_title[1]+" '"+search_value+"'\n<P>";
			var link_page;

			for (i = 0; (i < lines.length); i++) {
			  var line_string = lines[i].split("\n");
			  var line_val = unescape(line_string);

			  if ((line_val.split("\t")[0].toLowerCase()).match(search_value_lower)
  				 && parseInt((line_val.split("\t")[1])) >= threshold) {
  				 var pairs = line_val.split("\t");
				 var name = unescape(pairs[0]);
				 var hit = unescape(pairs[1]);
				 var access = unescape(pairs[2]);
				 var traffic = unescape(pairs[3]);
				 if (precision > 3) var lastdate = unescape(pairs[4]);
				 traffic = parseInt(traffic/1024);
				 data[count] = name;
				 page_occur[count] = hit+"|";
				 if (aff_access == 1) page_occur[count] += access+"|";
				 page_occur[count] += traffic;
				 if (precision > 3) page_occur[count] += "|"+lastdate;
				 count++;
			   }
			 }


			if (count != 0) {

		        // Number of items

			result_print = "Here are the "+count+"result";
			if (count > 1) result_print += "s";
			result_print += " :<P>\n";
			result_print += "<TABLE CLASS=\"sortable_base\" ID=\"HostsSearch\">\n";
			result_print += "<TR>\n<TH>&nbsp;"+string_tab[0]+"&nbsp;</TH>\n";
			result_print += "<TH>&nbsp;"+string_tab[1]+"&nbsp;</TH>\n";
			if (aff_access == 1) result_print += "<TH>&nbsp;"+string_tab[2]+"&nbsp;</TH>\n";
			result_print += "<TH>&nbsp;"+string_tab[3]+"&nbsp;("+string_tab[4]+")</TH>\n";
			if (precision > 3) result_print += "<TH>&nbsp;"+string_tab[5]+"&nbsp;</TH>\n";
			result_print += "</TR>\n";

            		for (i = 0; (i < count); i++) {

			   var obj_occur = page_occur[i].split("|");
	  		   var tmp;

			   result_print += "<TR>\n";

			   if (data[i].match(/\d$/)) {
			   if (precision > 3 && obj_occur[0] > seuil_auto) {
			   var domain = data[i].replace(/\./g,"_");
			   domain += ".html";

			   link_page = "<A HREF=\"";
			   link_page += domain;
			   link_page += "\">";
			   tmp = 1;
			   }
			   } else {
			   if (precision > 3 && obj_occur[0] > seuilsite) {
			   var domain = (data[i].substr(data[i].indexOf('.',0)+1,data[i].length)).replace(/\./g,"_");
			   domain += ".html#"+data[i];

			   link_page = "<A HREF=\"";
			   link_page += domain;
			   link_page += "\">";
			   tmp = 1;
			   }
			   }
 
			   // Link
                           result_print += "<TD CLASS=\"left\">";
			   if (tmp == 1) result_print += link_page;
			   result_print += data[i];
			   if (tmp == 1) result_print += "</A>";
			   result_print += "</TD>\n";

			   link_page = "";

			   for (j = 0; (j < obj_occur.length); j++) {
			       	result_print += "<TD CLASS=\"right\">";
			       	result_print += obj_occur[j];
				result_print += "</TD>\n";
			    }
			    result_print += "</TR>\n";
			   }
			  } else {
				 result_print = string_title[2]+"\n<P>";
				 }
			   result_print += "</TABLE>\n";

			   document.getElementById("search_header").innerHTML = header_str;
			   document.getElementById("search_results").innerHTML = result_print;
	
			   var foobar = new domFunction(function() {
					sortTable();
					colorTableRows();
				});

			} else {
                                var header_str = string_title[1]+" '"+search_value+"'\n<P>";
                                var result_print = "Error: returned status code " + req.status + " " + req.statusText;
                                document.getElementById("search_header").innerHTML = header_str;
                                document.getElementById("search_results").innerHTML = result_print;
			}

			document.ajax.search_button.value=string_title[0];
			}

			}

	req.open("GET", datafile, true); 
	req.send(null); 

}

	if (search_value != '') document.ajax.search_button.value=string_title[3];
	document.ajax.search_value.focus();
	document.ajax.search_value.value = search_value_ini;
}


////////////////////////////////////////////////////////////////////////////////////////////////////////////

function SearchPages() { 

		// TODO
		// search_item at least 3 characters long
		// Pagination to avoid long list
		// Test if datafile exist ?

		var mn=['Jan','Feb','Mar','Apr','May','Jun','Jul','Aug','Sep','Oct','Nov','Dec'];
		var mn_month = new Array();
		mn_month['Jan'] = 1;
		mn_month['Feb'] = 2;
		mn_month['Mar'] = 3;
		mn_month['Apr'] = 4;
		mn_month['May'] = 5;
		mn_month['Jun'] = 6;
		mn_month['Jul'] = 7;
		mn_month['Aug'] = 8;
		mn_month['Sep'] = 9;
		mn_month['Oct'] = 10;
		mn_month['Nov'] = 11;
		mn_month['Dec'] = 12;
		var dim=[31,0,31,30,31,30,31,31,30,31,30,31];

		var yesterday = document.ajax.yesterday.value;
		var date_tab = yesterday.split(" ");
		var d = date_tab[0]; 
		var m = mn_month[date_tab[1]];
		var y = date_tab[2];

		dim[1]=(((y%100!=0)&&(y%4==0))||(y%400==0))?29:28;

		var req = null; 
		var count = 0;
		var mode_search;
		var mode_fast = 0;
		var data_url = new Array();	

		var search_value = document.ajax.search_value.value;
		var search_value_ini = search_value;
		for (var i=0; i<document.ajax.mode_search.length;i++) {
		         if (document.ajax.mode_search[i].checked) {
        		    mode_search = document.ajax.mode_search[i].value;
         		}
		}

		for (var i=0; i<document.ajax.mode_fast.length;i++) {
		         if (document.ajax.mode_fast[i].checked) {
        		    mode_fast = document.ajax.mode_fast[i].value;
         		}
		}

		if (mode_search == undefined) {
			mode_search = parseInt(document.ajax.mode_search.value);
		}

		var xmax = document.ajax.xmax.value;
		var ymax = document.ajax.ymax.value;
		var lang = document.ajax.lang.value;
		var diffmax = document.ajax.diffmax.value;
		var datafile = document.ajax.datafile.value;
		var linkpage = parseInt(document.ajax.linkpage.value);
		var precision = parseInt(document.ajax.precision.value);
		var datafile_url = document.ajax.datafile_url.value;

		var config = document.ajax.config.value;
		var string_th = document.ajax.string_th.value;
		var string_title = document.ajax.string_title.value;
		var threshold = parseInt(document.ajax.search_threshold.value);
		var cgipagegraph = document.ajax.cgipagegraph.value;

		// Check is a number
		if (!(isNumber(threshold))) {
		alert("Threshold is not a number, assuming 0");
		threshold = 0;
		}

		if (threshold == '') threshold = 0;
		var string_tab = string_th.split(":");
		var string_title = string_title.split(":");

		if (search_value) {

		var search_value_lower = search_value.toLowerCase();

		var req = createRequestObject();

		var mode_url_map = 0;
		if (mode_search == 1 || mode_fast == 0) {
			mode_url_map = 1;
		}

		if (mode_search == 1) {
			document.ajax.mode_fast[0].checked = true;
			mode_url_map = 1;
			mode_fast = 0;
		}

		///////////////////////////////////////////////////////////////
		// URL Mapping
		if (mode_url_map == 1 && datafile_url != '') {

			var url = createRequestObject();  

			var string_end_file = "###";
			var data_url_match = new Array();
			var count_url_match = 0;

			url.open("GET", datafile_url, false); 
			url.send(null);
			if (url.readyState == 4) {
				if (url.status == 200) {

					var results_url = url.responseText;
					var lines_url = results_url.split("\n");

					// search on url
					if (mode_search == 0) {
						for (i = 0; (i < lines_url.length); i++) {
						  var line_string_url = lines_url[i].split("\n");
						  var line_val_url = unescape(line_string_url);
//						  if (line_val_url.match(string_end_file)) break;
						         if ((line_val_url.split(" ")[0].toLowerCase()).match(search_value_lower)) {
								data_url[line_val_url.split(" ")[0]] = line_val_url.split("\"")[1];
							  }
						}
					}

					// search on title
					if (mode_search == 1) {
						for (i = 0; (i < lines_url.length); i++) {
						  var line_string_url = lines_url[i].split("\n");
						  var line_val_url = unescape(line_string_url);
						  if (line_val_url.match(string_end_file)) break;
						         if ((line_val_url.split("\"")[1].toLowerCase()).match(search_value_lower)) {
								data_url[line_val_url.split(" ")[0]] = line_val_url.split("\"")[1];
								data_url_match[count_url_match] = line_val_url.split(" ")[0];
								count_url_match++;

							  }
						}
					}


				}
			}
		}

		///////////////////////////////////////////////////////////////
		// Datafile

		req.open("GET", datafile, false); 
		req.send(null); 

		///////////////////////////////////////////////////////////////

//		req.onreadystatechange = function() { 
			if (req.readyState == 4) {
				if (req.status == 200) {

				var results = req.responseText;
				var lines = results.split("\n");

				var data = new Array();
				var url_id = new Array();
				var page_occur = new Array();
				var page_host = new Array();
				var data_match_url = new Array();
				var result_print;

				var header_str = string_title[1]+" '"+search_value+"'\n<P>";
				var link_page;

				// URL
				if (mode_search == 0) {

				for (i = 0; (i < lines.length); i++) {
				  var line_string = lines[i].split("\n");
				  var line_val = unescape(line_string);

			          if ((line_val.split("\t")[0].toLowerCase()).match(search_value_lower) && parseInt((line_val.split(" ")[0]).split("\t")[2]) >= threshold) {
  				        var pairs = line_val.split("\t");
					    var name = unescape(pairs[0]);
				            var value = unescape(pairs[1]);
					    if (precision > 3) {
				            var val_host = unescape(pairs[2]);
				            var val_occur = unescape(pairs[3]);
					    } else {
				            var val_occur = unescape(pairs[2]);
					    }
				            data[count] = name;
				            url_id[name] = value;
				            page_occur[count] = val_occur;
				            page_host[count] = val_host;
				            count++;
			            }
				}    
				}

				// Title

				if (mode_search == 1) {
				for (i = 0; (i < lines.length); i++) {
				  var line_string = lines[i].split("\n");
				  var line_val = unescape(line_string);

				for (k = 0; (k< count_url_match); k++) {
//			          if ((line_val.split("\t")[0] == data_url_match[k])) {
			          if ((line_val.split("\t")[0] == data_url_match[k]) && parseInt((line_val.split(" ")[0]).split("\t")[2]) >= threshold) {
  				        var pairs = line_val.split("\t");
					    var name = unescape(pairs[0]);
				            var value = unescape(pairs[1]);
				            var val_host = unescape(pairs[2]);
				            var val_occur = unescape(pairs[3]);
				            data[count] = name;
				            url_id[name] = value;
				            page_host[count] = val_host;
				            page_occur[count] = val_occur;
				            count++;
			            }
				}    
				}    
				}

				if (count != 0) {

				        // Number of items
	   				var obj_occur = page_occur[0].split(" ");
					
					var max_display = obj_occur.length;
					if (obj_occur.length > diffmax) max_display = diffmax;

					result_print = "Here are the "+count+" result";
					if (count > 1) result_print += "s";
					result_print += " :<P>\n";
					result_print += "<TABLE CLASS=\"sortable_base\" ID=\"PagesSearch\">\n";
					result_print += "<TR>\n<TH>&nbsp;"+string_tab[0]+"&nbsp;</TH>\n";
					if (precision > 3) result_print += "<TH>&nbsp;"+string_tab[2]+"&nbsp;</TH>\n";
					result_print += "<TH>&nbsp;"+string_tab[1]+"&nbsp;</TH>\n";
					var m2 = m-1;

	    				for (j = 0; (j < max_display-1); j++) {
					   var x = d-j;
					   if (x < 1) {
					    m2 = m-2;
					    if (m2 < 1) m2 = 11;
					     x += dim[m2];
					   }
					   x = x+'';
					   if (x.length == 1) x = "0"+x;
//					   result_print += "<TH>&nbsp;"+mn[m2].substr(0,3)+"/"+x+"&nbsp;</TH>\n";
					   result_print += "<TH>&nbsp;"+mn[m2]+"/"+x+"&nbsp;</TH>\n";
					}
					result_print += "</TR>\n";


            				for (i = 0; (i < count); i++) {
					   result_print += "<TR>\n";

		   			   if (linkpage == 1) {
					   	link_page = "<A HREF=\"";
						if (mode_url_map == 0 || data_url[i] == undefined) link_page += data[i];
					   	if (mode_url_map == 1 && data_url[data[i]] != undefined) {
	 				   		link_page += "\" TITLE=\""+data[i];
					   	}
					   	link_page += "\">";
					   } else {
						link_page = "";
					   }
					   // Link

                                           result_print += "<TD CLASS=\"left\">"+link_page;

					   if (data_url[data[i]] == undefined || mode_url_map == 0) { 
						result_print += data[i];
					   } else {
						result_print += data_url[data[i]];
					   }
					   if (linkpage == 1) result_print += "</A>";
					   result_print += "</TD>\n";

                                           if (precision > 3) result_print += "<TD CLASS=\"right\"><A HREF=\""+url_id[data[i]]+".html\">"+page_host[i]+"</A></TD>";

					   if (cgipagegraph != '') {
					   link_page = "<A HREF=\"javascript:PopIt('"+cgipagegraph+"?";
					   link_page +=	"c=\\\'"+config+"\\\'&amp;";
					   link_page +=	"k="+url_id[data[i]]+"&amp;";
					   link_page += "l="+lang;
					   link_page += "',"+xmax+","+ymax+")\">";
					   }

	   				   var obj_occur = page_occur[i].split(" ");
	    				   for (j = 0; (j < max_display); j++) {
					      var tmp = obj_occur[j].split(" ");
                                              result_print += "<TD CLASS=\"right\">";
					      if (j == 0 && cgipagegraph != '') result_print += link_page;
					      result_print += obj_occur[j];
					      if (j == 0 && cgipagegraph != '') result_print += "</A>";
					      result_print += "</TD>\n";
					   }

					   result_print += "</TR>\n";
					}
				} else {
					 result_print = string_title[2]+"\n<P>";
				}
				result_print += "</TABLE>\n";

				document.getElementById("search_header").innerHTML = header_str;
				document.getElementById("search_results").innerHTML = result_print;
	
				var foobar = new domFunction(function() {
					sortTable();
					colorTableRows();
				});


			} else {
                                var header_str = string_title[1]+" '"+search_value+"'\n<P>";
                                var result_print = "Error: returned status code " + req.status + " " + req.statusText;
                                document.getElementById("search_header").innerHTML = header_str;
                                document.getElementById("search_results").innerHTML = result_print;
			}	

		} 
	}
	document.ajax.search_button.value=string_title[0];
	document.ajax.search_value.focus();
	document.ajax.search_value.value = search_value_ini;

}
