/* http://www.w3perl.com/
**************************************************************************/

var month_number2letter = new Array('Jan','Feb','Mar','Apr','May','Jun','Jul','Aug','Sep','Oct','Nov','Dec');
var month_letter2number = new Array(12);

for (i=0; i < month_number2letter.length; ++i) {
 var tmp2 = i;
 tmp2++;
 if (tmp2 < 10) tmp2 = '0'+tmp2;
 tmp = month_number2letter[i];
 month_letter2number[tmp] = tmp2;
}


/* http://brothercake.com/site/resources/scripts/domready/
**************************************************************************/

function domFunction(f, a) {
	var n = 0;
	var t = setInterval(function() {
		var c = true;
		n++;
		if(typeof document.getElementsByTagName != 'undefined' && (document.getElementsByTagName('body')[0] != null || document.body != null)) {
			c = false;
			if(typeof a == 'object') {
				for(var i in a) {
					if((a[i] == 'id' && document.getElementById(i) == null) || (a[i] == 'tag' && document.getElementsByTagName(i).length < 1)) { 
						c = true; 
						break; 
					}
				}
			}
			if(!c) { f(); clearInterval(t); }
		}
		if(n >= 60) {
			clearInterval(t);
		}
	}, 250);
};

/* http://kryogenix.org/code/browser/sorttable/
**************************************************************************/

var sci;

function sortTable() {
	 var k = 0;
	if (!document.getElementsByTagName) return;
	tbls = document.getElementsByTagName('table');
	for (ti=0; ti<tbls.length; ti++) {
		thisTbl = tbls[ti];
		k = 0;
		if (thisTbl.id == "dir_search") k = 1;
		if (thisTbl.id == "dir_list") k = 1;
		if (thisTbl.id == "dir_full") k = 1;
		if (thisTbl.id == "docrepert") k = 1;
		if ((thisTbl.id).indexOf("NO_") == -1) first_col = 0;
		if ((thisTbl.id).indexOf("NO_") != -1) first_col = 1;
		if (((' '+thisTbl.className+' ').indexOf("sortable") != -1) && (thisTbl.id)) {
		st_makeSortable(k,thisTbl,first_col);
		}
	}
}

function st_makeSortable(k,table,first_col) {
//	 var k = 1;
	if (table.rows && table.rows.length > 0) {
//		var firstRow = table.rows[0];
		var firstRow = table.rows[k];
	}
	if (!firstRow) return;
	for (var i=first_col; i<firstRow.cells.length; i++) {
		var cell = firstRow.cells[i];
		var txt = st_getInnerText(cell);
		cell.innerHTML = '<a href="#" class="sortheader" onclick="st_resortTable(this);return false;">'+txt+'<span class="sortarrow"></span></a>';
	}
}

function st_getInnerText(el) {
	if (typeof el == 'string') return el;
	if (typeof el == 'undefined') return el;
	if (el.innerText) return el.innerText;
	var str = '';
	var cs = el.childNodes;
	var l = cs.length;
	for (var i = 0; i < l; i++) {
		switch (cs[i].nodeType) {
			case 1:
				str += st_getInnerText(cs[i]);
				break;
			case 3:
				str += cs[i].nodeValue;
				break;
		}
	}
	return str;
}

function st_resortTable(lnk) {
	var span;
	var k = 0;
	tbls = document.getElementsByTagName('table');
	for (ti=0; ti<tbls.length; ti++) {
		thisTbl = tbls[ti];
		if (thisTbl.id == "dir_list") k = 1;
		if (thisTbl.id == "dir_full") k = 1;
		if (thisTbl.id == "docrepert") k = 1;
	}
//	var k = 1;
	var k2 = k+1;
	for (var ci=0; ci<lnk.childNodes.length; ci++) {
		if (lnk.childNodes[ci].tagName && lnk.childNodes[ci].tagName.toLowerCase() == 'span') span = lnk.childNodes[ci];
	}
	var spantext = st_getInnerText(span);
	var td = lnk.parentNode;
	var column = td.cellIndex;
	var table = st_getParent(td, 'TABLE');
	if (table.rows.length <= 1) return;
	var notDate = 0;
	var notCurrency = 0;
	var notNumerical = 0;

//	for (var itmc=1; itmc<table.rows.length; itmc++) {
	for (var itmc=k2; itmc<table.rows.length; itmc++) {
		var itm = st_getInnerText(table.rows[itmc].cells[column]);
		if (!(itm.match(/^\d\d[\/-]\d\d[\/-]\d\d\d\d$/) || (itm.match(/^\d\d[\/-]\d\d[\/-]\d\d$/) || (itm.match(/^\d\d\s\w\w\w\s\d\d\d\d/)) || (itm.match(/^\d\d\d\d\s\w\w\w\s/)) )))
			notDate++;
		if (!(itm.match(/^[?$]/)))
			notCurrency++;
		if (!(itm.match(/^\s*[\+-]?[\d\.,]+/)))
			notNumerical++;
	}
	   switch (0) {
	   	case notDate: sortfn = st_sortDate; break;
	   	case notCurrency: sortfn = st_sortCurrency; break;
	   	case notNumerical: sortfn = st_sortNumeric; break;
	   	default: sortfn = st_sortCaseInsensitive;
	   }
	sci = column;
	var firstRow = new Array();
	var newRows = new Array();
//	for (i=0; i<table.rows[0].length; i++) { firstRow[i] = table.rows[0][i]; }
	for (i=0; i<table.rows[k].length; i++) { firstRow[i] = table.rows[k][i]; }
//	for (j=1; j<table.rows.length; j++) { newRows[j-1] = table.rows[j]; }
	for (j=k2; j<table.rows.length; j++) { newRows[j-k2] = table.rows[j]; }
	newRows.sort(sortfn);
	if (span.getAttribute('sortdir') == 'up') {
		ARROW = '&nbsp;&nbsp;&darr;';
		newRows.reverse();
		span.setAttribute('sortdir', 'down');
	} else {
		ARROW = '&nbsp;&nbsp;&uarr;';
		span.setAttribute('sortdir', 'up');
	}
	for (i=0; i<newRows.length; i++) { if (!newRows[i].className || (newRows[i].className && (newRows[i].className.indexOf('sortbottom') == -1))) table.tBodies[0].appendChild(newRows[i]); }
	for (i=0; i<newRows.length; i++) { if (newRows[i].className && (newRows[i].className.indexOf('sortbottom') != -1)) table.tBodies[0].appendChild(newRows[i]); }
	var allspans = document.getElementsByTagName('span');
	for (var ci=0; ci<allspans.length; ci++) {
		if (allspans[ci].className == 'sortarrow') {
			if (st_getParent(allspans[ci], 'table') == st_getParent(lnk, 'table')) {
				allspans[ci].innerHTML = '';
			}
		}
	}
	span.innerHTML = ARROW;
	colorTableRows();
}

function st_getParent(el, pTagName) {
	if (el == null) return null;
	else if (el.nodeType == 1 && el.tagName.toLowerCase() == pTagName.toLowerCase())
		return el;
	else
		return st_getParent(el.parentNode, pTagName);
}

function st_sortDate(a, b) {
	aa = st_getInnerText(a.cells[sci]);
	bb = st_getInnerText(b.cells[sci]);
	if (aa.length >= 11) {
	     dt1 = aa.substr(7,4)+month_letter2number[aa.substr(3,3)]+aa.substr(0,2);
	     }	    
	if (aa.length == 10) {
	   dt1 = aa.substr(6,4)+aa.substr(3,2)+aa.substr(0,2);
	   } 
	if (aa.length == 8) {
	   yr = aa.substr(6,2);
	   if (parseInt(yr) < 50) { yr = '20'+yr; } else { yr = '19'+yr; }
	   dt1 = yr+aa.substr(3,2)+aa.substr(0,2);
	   }
        if (aa.length == 9) {
          dt1 = aa.substr(0,4)+month_letter2number[aa.substr(5,3)];
           }

	if (bb.length >= 11) {
	   dt2 = bb.substr(7,4)+month_letter2number[bb.substr(3,3)]+bb.substr(0,2);
	   }
	if (bb.length == 10) {
	   dt2 = bb.substr(6,4)+bb.substr(3,2)+bb.substr(0,2);
	   }
	if (bb.length == 8) {
	   yr = bb.substr(6,2);
	   if (parseInt(yr) < 50) { yr = '20'+yr; } else { yr = '19'+yr; }
	   dt2 = yr+bb.substr(3,2)+bb.substr(0,2);
	   }
       if (bb.length == 9) {
           dt2 = bb.substr(0,4)+month_letter2number[bb.substr(5,3)];
           }

	if (dt1==dt2) return 0;
//	if (dt1<dt2) return -1;
	if (dt1>dt2) return -1;
	return 1;
}

function st_sortCurrency(a, b) { 
	aa = st_getInnerText(a.cells[sci]).replace(/[^0-9.]/g, '');
	bb = st_getInnerText(b.cells[sci]).replace(/[^0-9.]/g, '');
//	return parseFloat(aa) - parseFloat(bb);
	return parseFloat(bb) - parseFloat(aa);
}

function st_sortNumeric(a, b) { 
        aa = parseFloat(st_getInnerText(a.cells[sci]).replace(/[h\'\s]/g,''));
//	aa = parseFloat(st_getInnerText(a.cells[sci]));
	if (isNaN(aa)) aa = 0;
        bb = parseFloat(st_getInnerText(b.cells[sci]).replace(/[h\'\s]/g,''));
//	bb = parseFloat(st_getInnerText(b.cells[sci])); 
	if (isNaN(bb)) bb = 0;
//	return aa-bb;
	return bb-aa;
}

function st_sortCaseInsensitive(a, b) {
	aa = st_getInnerText(a.cells[sci]).toLowerCase();
	bb = st_getInnerText(b.cells[sci]).toLowerCase();
	if (aa==bb) return 0;
	if (aa<bb) return -1;
//	if (aa>bb) return -1;
	return 1;
}

function st_sortDefault(a, b) {
	aa = st_getInnerText(a.cells[sci]);
	bb = st_getInnerText(b.cells[sci]);
	if (aa==bb) return 0;
	if (aa<bb) return -1;
//	if (aa>bb) return -1;
	return 1;
}

/* http://ktk.xs4all.nl/stuff/javascript/table-row-alternate/
**************************************************************************/

function colorTableRows() {
	if (document.getElementsByTagName) {
		var tables = document.getElementsByTagName('table');
		for (var i = 0; i < tables.length; i++) {
		        thisTbl = tables[i];
//			if (((' '+thisTbl.className+' ').indexOf("sortable") != -1) && (thisTbl.id)) {
			if (((' '+thisTbl.className+' ').indexOf("sortable") != -1) && ((thisTbl.id).indexOf("NO_") == -1)) {
			var trs = tables[i].getElementsByTagName('tr');
			for (var j = 1; j < trs.length; j++) {
				trs[j].className = (j % 2 == 0 ? '' : 'alternate');
				// column color
				//var tds = trs[j].getElementsByTagName('td');
				//for (var k = 0; k < tds.length; k++) {
				//	tds[k].className = (k==sci ? 'sortCol' : '');
				//}
				//
			}
			}
		}
	}
}

/* Load the scripts
**************************************************************************/

var foobar = new domFunction(function() {
	sortTable();
	colorTableRows();
	});
